/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ie=function($){for(var t=[],T=0,P=$.length;T<P;T++)t[T]=te[$[T]];return t};define(te[58],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(P,b){if(!P)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=T}),define(te[46],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(D){return(R,c,d)=>{let g=null,I=null;if(typeof d.value=="function"?(g="value",I=d.value):typeof d.get=="function"&&(g="get",I=d.get),!I)throw new Error("not supported");d[g]=D(I,c)}}t.createDecorator=T;function P(D,R,c){let d=null,g=null;if(typeof c.value=="function"?(d="value",g=c.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",g=c.get),!g)throw new Error("not supported");const I=`$memoize$${R}`;c[d]=function(...f){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,f)}),this[I]}}t.memoize=P;function b(D,R,c){return T((d,g)=>{const I=`$debounce$${g}`,f=`$debounce$result$${g}`;return function(...E){this[f]||(this[f]=c?c():void 0),clearTimeout(this[I]),R&&(this[f]=R(this[f],...E),E=[this[f]]),this[I]=setTimeout(()=>{d.apply(this,E),this[f]=c?c():void 0},D)}})}t.debounce=b;function L(D,R,c){return T((d,g)=>{const I=`$throttle$timer$${g}`,f=`$throttle$result$${g}`,E=`$throttle$lastRun$${g}`,l=`$throttle$pending$${g}`;return function(...u){if(this[f]||(this[f]=c?c():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...u)),this[l])return;const v=this[E]+D;v<=Date.now()?(this[E]=Date.now(),d.apply(this,[this[f]]),this[f]=c?c():void 0):(this[l]=!0,this[I]=setTimeout(()=>{this[l]=!1,this[E]=Date.now(),d.apply(this,[this[f]]),this[f]=c?c():void 0},v-Date.now()))}})}t.throttle=L}),define(te[59],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function D(e,i=!1){let n=0,s=e.length,a="",y=0,S=16,A=0;function p(ee){let G=0,Y=0;for(;G<ee;){const Z=e.charCodeAt(n);if(Z>=48&&Z<=57)Y=Y*16+Z-48;else if(Z>=65&&Z<=70)Y=Y*16+Z-65+10;else if(Z>=97&&Z<=102)Y=Y*16+Z-97+10;else break;n++,G++}return G<ee&&(Y=-1),Y}function C(ee){n=ee,a="",y=0,S=16,A=0}function N(){const ee=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return A=3,e.substring(ee,n);let G=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;G=n}else A=3;return e.substring(ee,G)}function V(){let ee="",G=n;for(;;){if(n>=s){ee+=e.substring(G,n),A=2;break}const Y=e.charCodeAt(n);if(Y===34){ee+=e.substring(G,n),n++;break}if(Y===92){if(ee+=e.substring(G,n),n++,n>=s){A=2;break}switch(e.charCodeAt(n++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const re=p(4);re>=0?ee+=String.fromCharCode(re):A=4;break;default:A=5}G=n;continue}if(Y>=0&&Y<=31)if(c(Y)){ee+=e.substring(G,n),A=2;break}else A=6;n++}return ee}function J(){if(a="",A=0,y=n,n>=s)return y=s,S=17;let ee=e.charCodeAt(n);if(R(ee)){do n++,a+=String.fromCharCode(ee),ee=e.charCodeAt(n);while(R(ee));return S=15}if(c(ee))return n++,a+=String.fromCharCode(ee),ee===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),S=14;switch(ee){case 123:return n++,S=1;case 125:return n++,S=2;case 91:return n++,S=3;case 93:return n++,S=4;case 58:return n++,S=6;case 44:return n++,S=5;case 34:return n++,a=V(),S=10;case 47:const G=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!c(e.charCodeAt(n));)n++;return a=e.substring(G,n),S=12}if(e.charCodeAt(n+1)===42){n+=2;const Y=s-1;let Z=!1;for(;n<Y;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,Z=!0;break}n++}return Z||(n++,A=1),a=e.substring(G,n),S=13}return a+=String.fromCharCode(ee),n++,S=16;case 45:if(a+=String.fromCharCode(ee),n++,n===s||!d(e.charCodeAt(n)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),S=11;default:for(;n<s&&ne(ee);)n++,ee=e.charCodeAt(n);if(y!==n){switch(a=e.substring(y,n),a){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return a+=String.fromCharCode(ee),n++,S=16}}function ne(ee){if(R(ee)||c(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ee;do ee=J();while(ee>=12&&ee<=15);return ee}return{setPosition:C,getPosition:()=>n,scan:i?se:J,getToken:()=>S,getTokenValue:()=>a,getTokenOffset:()=>y,getTokenLength:()=>n-y,getTokenError:()=>A}}t.createScanner=D;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var g;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(g||(g={}));function I(e,i){const n=[],s=new Object;let a;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function A(p,C,N,V){y.value=p,y.offset=C,y.length=N,y.type=V,y.colonOffset=void 0,a=y}try{h(e,{onObjectBegin:(p,C)=>{if(i<=p)throw s;a=void 0,S=i>p,n.push("")},onObjectProperty:(p,C,N)=>{if(i<C||(A(p,C,N,"property"),n[n.length-1]=p,i<=C+N))throw s},onObjectEnd:(p,C)=>{if(i<=p)throw s;a=void 0,n.pop()},onArrayBegin:(p,C)=>{if(i<=p)throw s;a=void 0,n.push(0)},onArrayEnd:(p,C)=>{if(i<=p)throw s;a=void 0,n.pop()},onLiteralValue:(p,C,N)=>{if(i<C||(A(p,C,N,r(p)),i<=C+N))throw s},onSeparator:(p,C,N)=>{if(i<=C)throw s;if(p===":"&&a&&a.type==="property")a.colonOffset=C,S=!1,a=void 0;else if(p===","){const V=n[n.length-1];typeof V=="number"?n[n.length-1]=V+1:(S=!0,n[n.length-1]=""),a=void 0}}})}catch(p){if(p!==s)throw p}return{path:n,previousNode:a,isAtPropertyKey:S,matches:p=>{let C=0;for(let N=0;C<p.length&&N<n.length;N++)if(p[C]===n[N]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}t.getLocation=I;function f(e,i=[],n=L.DEFAULT){let s=null,a=[];const y=[];function S(p){Array.isArray(a)?a.push(p):s!==null&&(a[s]=p)}return h(e,{onObjectBegin:()=>{const p={};S(p),y.push(a),a=p,s=null},onObjectProperty:p=>{s=p},onObjectEnd:()=>{a=y.pop()},onArrayBegin:()=>{const p=[];S(p),y.push(a),a=p,s=null},onArrayEnd:()=>{a=y.pop()},onLiteralValue:S,onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},n),a[0]}t.parse=f;function E(e,i=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){s.type==="property"&&(s.length=p-s.offset,s=s.parent)}function y(p){return s.children.push(p),p}h(e,{onObjectBegin:p=>{s=y({type:"object",offset:p,length:-1,parent:s,children:[]})},onObjectProperty:(p,C,N)=>{s=y({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:p,offset:C,length:N,parent:s})},onObjectEnd:(p,C)=>{s.length=p+C-s.offset,s=s.parent,a(p+C)},onArrayBegin:(p,C)=>{s=y({type:"array",offset:p,length:-1,parent:s,children:[]})},onArrayEnd:(p,C)=>{s.length=p+C-s.offset,s=s.parent,a(p+C)},onLiteralValue:(p,C,N)=>{y({type:r(p),offset:C,length:N,parent:s,value:p}),a(C+N)},onSeparator:(p,C,N)=>{s.type==="property"&&(p===":"?s.colonOffset=C:p===","&&a(C))},onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},n);const A=s.children[0];return A&&delete A.parent,A}t.parseTree=E;function l(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const y of n.children)if(Array.isArray(y.children)&&y.children[0].value===s){n=y.children[1],a=!0;break}if(!a)return}else{const a=s;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=l;function u(e){if(!e.parent||!e.parent.children)return[];const i=u(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=u;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=v(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function m(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=m;function w(e,i,n=!1){if(m(e,i,n)){const s=e.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=i;a++){const y=w(s[a],i,n);if(y)return y}return e}}t.findNodeAtOffset=w;function h(e,i,n=L.DEFAULT){const s=D(e,!1);function a(k){return k?()=>k(s.getTokenOffset(),s.getTokenLength()):()=>!0}function y(k){return k?F=>k(F,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=a(i.onObjectBegin),A=y(i.onObjectProperty),p=a(i.onObjectEnd),C=a(i.onArrayBegin),N=a(i.onArrayEnd),V=y(i.onLiteralValue),J=y(i.onSeparator),ne=a(i.onComment),se=y(i.onError),ee=n&&n.disallowComments,G=n&&n.allowTrailingComma;function Y(){for(;;){const k=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:ee||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(k){case 12:case 13:ee?Z(10):ne();break;case 16:Z(1);break;case 15:case 14:break;default:return k}}}function Z(k,F=[],M=[]){if(se(k),F.length+M.length>0){let x=s.getToken();for(;x!==17;){if(F.indexOf(x)!==-1){Y();break}else if(M.indexOf(x)!==-1)break;x=Y()}}}function re(k){const F=s.getTokenValue();return k?V(F):A(F),Y(),!0}function j(){switch(s.getToken()){case 11:let k=0;try{k=JSON.parse(s.getTokenValue()),typeof k!="number"&&(Z(2),k=0)}catch(F){Z(2)}V(k);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return Y(),!0}function O(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(re(!1),s.getToken()===6?(J(":"),Y(),H()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function z(){S(),Y();let k=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(k||Z(4,[],[]),J(","),Y(),s.getToken()===2&&G)break}else k&&Z(6,[],[]);O()||Z(4,[],[2,5]),k=!0}return p(),s.getToken()!==2?Z(7,[2],[]):Y(),!0}function W(){C(),Y();let k=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(k||Z(4,[],[]),J(","),Y(),s.getToken()===4&&G)break}else k&&Z(6,[],[]);H()||Z(4,[],[4,5]),k=!0}return N(),s.getToken()!==4?Z(8,[4],[]):Y(),!0}function H(){switch(s.getToken()){case 3:return W();case 1:return z();case 10:return re(!0);default:return j()}}return Y(),s.getToken()===17?n.allowEmptyContent?!0:(Z(4,[],[]),!1):H()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}t.visit=h;function o(e,i){let n=D(e),s=[],a,y=0,S;do switch(S=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:y!==S&&s.push(e.substring(y,S)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),y=n.getPosition();break}while(a!==17);return s.join("")}t.stripComments=o;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r}),function(){function $(b){const L=[];typeof b=="number"&&L.push("code/timeOrigin",b);function D(c){L.push(c,Date.now())}function R(){const c=[];for(let d=0;d<L.length;d+=2)c.push({name:L[d],startTime:L[d+1]});return c}return{mark:D,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(b+D.startTime)});return L}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var P in T)(typeof exports=="object"?exports:$)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function T(P){if(t[P])return t[P].exports;var b=t[P]={i:P,l:!1,exports:{}};return $[P].call(b.exports,b,b.exports,T),b.l=!0,b.exports}return T.m=$,T.c=t,T.d=function(P,b,L){T.o(P,b)||Object.defineProperty(P,b,{enumerable:!0,get:L})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,b){if(1&b&&(P=T(P)),8&b||4&b&&typeof P=="object"&&P&&P.__esModule)return P;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:P}),2&b&&typeof P!="string")for(var D in P)T.d(L,D,function(R){return P[R]}.bind(null,D));return L},T.n=function(P){var b=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(b,"a",b),b},T.o=function(P,b){return Object.prototype.hasOwnProperty.call(P,b)},T.p="",T(T.s=0)}([function($,t,T){(function(P){var b;t=$.exports=M,b=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],c=t.src=[],d=0,g=d++;c[g]="0|[1-9]\\d*";var I=d++;c[I]="[0-9]+";var f=d++;c[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=d++;c[E]="("+c[g]+")\\.("+c[g]+")\\.("+c[g]+")";var l=d++;c[l]="("+c[I]+")\\.("+c[I]+")\\.("+c[I]+")";var u=d++;c[u]="(?:"+c[g]+"|"+c[f]+")";var v=d++;c[v]="(?:"+c[I]+"|"+c[f]+")";var m=d++;c[m]="(?:-("+c[u]+"(?:\\."+c[u]+")*))";var w=d++;c[w]="(?:-?("+c[v]+"(?:\\."+c[v]+")*))";var h=d++;c[h]="[0-9A-Za-z-]+";var o=d++;c[o]="(?:\\+("+c[h]+"(?:\\."+c[h]+")*))";var r=d++,e="v?"+c[E]+c[m]+"?"+c[o]+"?";c[r]="^"+e+"$";var i="[v=\\s]*"+c[l]+c[w]+"?"+c[o]+"?",n=d++;c[n]="^"+i+"$";var s=d++;c[s]="((?:<|>)?=?)";var a=d++;c[a]=c[I]+"|x|X|\\*";var y=d++;c[y]=c[g]+"|x|X|\\*";var S=d++;c[S]="[v=\\s]*("+c[y]+")(?:\\.("+c[y]+")(?:\\.("+c[y]+")(?:"+c[m]+")?"+c[o]+"?)?)?";var A=d++;c[A]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[w]+")?"+c[o]+"?)?)?";var p=d++;c[p]="^"+c[s]+"\\s*"+c[S]+"$";var C=d++;c[C]="^"+c[s]+"\\s*"+c[A]+"$";var N=d++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=d++;c[V]="(?:~>?)";var J=d++;c[J]="(\\s*)"+c[V]+"\\s+",R[J]=new RegExp(c[J],"g");var ne=d++;c[ne]="^"+c[V]+c[S]+"$";var se=d++;c[se]="^"+c[V]+c[A]+"$";var ee=d++;c[ee]="(?:\\^)";var G=d++;c[G]="(\\s*)"+c[ee]+"\\s+",R[G]=new RegExp(c[G],"g");var Y=d++;c[Y]="^"+c[ee]+c[S]+"$";var Z=d++;c[Z]="^"+c[ee]+c[A]+"$";var re=d++;c[re]="^"+c[s]+"\\s*("+i+")$|^$";var j=d++;c[j]="^"+c[s]+"\\s*("+e+")$|^$";var O=d++;c[O]="(\\s*)"+c[s]+"\\s*("+i+"|"+c[S]+")",R[O]=new RegExp(c[O],"g");var z=d++;c[z]="^\\s*("+c[S]+")\\s+-\\s+("+c[S]+")\\s*$";var W=d++;c[W]="^\\s*("+c[A]+")\\s+-\\s+("+c[A]+")\\s*$";var H=d++;c[H]="(<|>)?=?\\s*\\*";for(var k=0;k<35;k++)b(k,c[k]),R[k]||(R[k]=new RegExp(c[k]));function F(U,q){if(U instanceof M)return U;if(typeof U!="string"||U.length>L||!(q?R[n]:R[r]).test(U))return null;try{return new M(U,q)}catch(_){return null}}function M(U,q){if(U instanceof M){if(U.loose===q)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof M))return new M(U,q);b("SemVer",U,q),this.loose=q;var _=U.trim().match(q?R[n]:R[r]);if(!_)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ue=+oe;if(ue>=0&&ue<D)return ue}return oe}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}t.parse=F,t.valid=function(U,q){var _=F(U,q);return _?_.version:null},t.clean=function(U,q){var _=F(U.trim().replace(/^[=v]+/,""),q);return _?_.version:null},t.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(U){return b("SemVer.compare",this.version,this.loose,U),U instanceof M||(U=new M(U,this.loose)),this.compareMain(U)||this.comparePre(U)},M.prototype.compareMain=function(U){return U instanceof M||(U=new M(U,this.loose)),B(this.major,U.major)||B(this.minor,U.minor)||B(this.patch,U.patch)},M.prototype.comparePre=function(U){if(U instanceof M||(U=new M(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var q=0;do{var _=this.prerelease[q],oe=U.prerelease[q];if(b("prerelease compare",q,_,oe),_===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(_===void 0)return-1;if(_!==oe)return B(_,oe)}while(++q)},M.prototype.inc=function(U,q){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},t.inc=function(U,q,_,oe){typeof _=="string"&&(oe=_,_=void 0);try{return new M(U,_).inc(q,oe).version}catch(ue){return null}},t.diff=function(U,q){if(le(U,q))return null;var _=F(U),oe=F(q);if(_.prerelease.length||oe.prerelease.length){for(var ue in _)if((ue==="major"||ue==="minor"||ue==="patch")&&_[ue]!==oe[ue])return"pre"+ue;return"prerelease"}for(var ue in _)if((ue==="major"||ue==="minor"||ue==="patch")&&_[ue]!==oe[ue])return ue},t.compareIdentifiers=B;var x=/^[0-9]+$/;function B(U,q){var _=x.test(U),oe=x.test(q);return _&&oe&&(U=+U,q=+q),_&&!oe?-1:oe&&!_?1:U<q?-1:U>q?1:0}function K(U,q,_){return new M(U,_).compare(new M(q,_))}function Q(U,q,_){return K(U,q,_)>0}function X(U,q,_){return K(U,q,_)<0}function le(U,q,_){return K(U,q,_)===0}function de(U,q,_){return K(U,q,_)!==0}function ce(U,q,_){return K(U,q,_)>=0}function Ee(U,q,_){return K(U,q,_)<=0}function we(U,q,_,oe){var ue;switch(q){case"===":typeof U=="object"&&(U=U.version),typeof _=="object"&&(_=_.version),ue=U===_;break;case"!==":typeof U=="object"&&(U=U.version),typeof _=="object"&&(_=_.version),ue=U!==_;break;case"":case"=":case"==":ue=le(U,_,oe);break;case"!=":ue=de(U,_,oe);break;case">":ue=Q(U,_,oe);break;case">=":ue=ce(U,_,oe);break;case"<":ue=X(U,_,oe);break;case"<=":ue=Ee(U,_,oe);break;default:throw new TypeError("Invalid operator: "+q)}return ue}function pe(U,q){if(U instanceof pe){if(U.loose===q)return U;U=U.value}if(!(this instanceof pe))return new pe(U,q);b("comparator",U,q),this.loose=q,this.parse(U),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(U,q){return B(q,U)},t.major=function(U,q){return new M(U,q).major},t.minor=function(U,q){return new M(U,q).minor},t.patch=function(U,q){return new M(U,q).patch},t.compare=K,t.compareLoose=function(U,q){return K(U,q,!0)},t.rcompare=function(U,q,_){return K(q,U,_)},t.sort=function(U,q){return U.sort(function(_,oe){return t.compare(_,oe,q)})},t.rsort=function(U,q){return U.sort(function(_,oe){return t.rcompare(_,oe,q)})},t.gt=Q,t.lt=X,t.eq=le,t.neq=de,t.gte=ce,t.lte=Ee,t.cmp=we,t.Comparator=pe;var Re={};function ve(U,q){if(U instanceof ve)return U.loose===q?U:new ve(U.raw,q);if(U instanceof pe)return new ve(U.value,q);if(!(this instanceof ve))return new ve(U,q);if(this.loose=q,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function be(U){return!U||U.toLowerCase()==="x"||U==="*"}function ze(U,q,_,oe,ue,De,me,Oe,Pe,Ce,ke,Ie,Le){return((q=be(_)?"":be(oe)?">="+_+".0.0":be(ue)?">="+_+"."+oe+".0":">="+q)+" "+(Oe=be(Pe)?"":be(Ce)?"<"+(+Pe+1)+".0.0":be(ke)?"<"+Pe+"."+(+Ce+1)+".0":Ie?"<="+Pe+"."+Ce+"."+ke+"-"+Ie:"<="+Oe)).trim()}function je(U,q){for(var _=0;_<U.length;_++)if(!U[_].test(q))return!1;if(q.prerelease.length){for(_=0;_<U.length;_++)if(b(U[_].semver),U[_].semver!==Re&&U[_].semver.prerelease.length>0){var oe=U[_].semver;if(oe.major===q.major&&oe.minor===q.minor&&oe.patch===q.patch)return!0}return!1}return!0}function Ue(U,q,_){try{q=new ve(q,_)}catch(oe){return!1}return q.test(U)}function We(U,q,_,oe){var ue,De,me,Oe,Pe;switch(U=new M(U,oe),q=new ve(q,oe),_){case">":ue=Q,De=Ee,me=X,Oe=">",Pe=">=";break;case"<":ue=X,De=ce,me=Q,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(U,q,oe))return!1;for(var Ce=0;Ce<q.set.length;++Ce){var ke=q.set[Ce],Ie=null,Le=null;if(ke.forEach(function(Fe){Fe.semver===Re&&(Fe=new pe(">=0.0.0")),Ie=Ie||Fe,Le=Le||Fe,ue(Fe.semver,Ie.semver,oe)?Ie=Fe:me(Fe.semver,Le.semver,oe)&&(Le=Fe)}),Ie.operator===Oe||Ie.operator===Pe||(!Le.operator||Le.operator===Oe)&&De(U,Le.semver)||Le.operator===Pe&&me(U,Le.semver))return!1}return!0}pe.prototype.parse=function(U){var q=this.loose?R[re]:R[j],_=U.match(q);if(!_)throw new TypeError("Invalid comparator: "+U);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new M(_[2],this.loose):this.semver=Re},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(U){return b("Comparator.test",U,this.loose),this.semver===Re||(typeof U=="string"&&(U=new M(U,this.loose)),we(U,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(U,q){if(!(U instanceof pe))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new ve(U.value,q),Ue(this.value,_,q);if(U.operator==="")return _=new ve(this.value,q),Ue(U.semver,_,q);var oe=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),De=this.semver.version===U.semver.version,me=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Oe=we(this.semver,"<",U.semver,q)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),Pe=we(this.semver,">",U.semver,q)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return oe||ue||De&&me||Oe||Pe},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(U){var q=this.loose;U=U.trim(),b("range",U,q);var _=q?R[W]:R[z];U=U.replace(_,ze),b("hyphen replace",U),U=U.replace(R[O],"$1$2$3"),b("comparator trim",U,R[O]),U=(U=(U=U.replace(R[J],"$1~")).replace(R[G],"$1^")).split(/\s+/).join(" ");var oe=q?R[re]:R[j],ue=U.split(" ").map(function(De){return function(me,Oe){return b("comp",me),me=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){b("caret",Ie,Le);var Fe=Le?R[Z]:R[Y];return Ie.replace(Fe,function(Ae,he,ge,ye,Se){var Te;return b("caret",Ie,Ae,he,ge,ye,Se),be(he)?Te="":be(ge)?Te=">="+he+".0.0 <"+(+he+1)+".0.0":be(ye)?Te=he==="0"?">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0":">="+he+"."+ge+".0 <"+(+he+1)+".0.0":Se?(b("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Te=he==="0"?ge==="0"?">="+he+"."+ge+"."+ye+Se+" <"+he+"."+ge+"."+(+ye+1):">="+he+"."+ge+"."+ye+Se+" <"+he+"."+(+ge+1)+".0":">="+he+"."+ge+"."+ye+Se+" <"+(+he+1)+".0.0"):(b("no pr"),Te=he==="0"?ge==="0"?">="+he+"."+ge+"."+ye+" <"+he+"."+ge+"."+(+ye+1):">="+he+"."+ge+"."+ye+" <"+he+"."+(+ge+1)+".0":">="+he+"."+ge+"."+ye+" <"+(+he+1)+".0.0"),b("caret return",Te),Te})}(ke,Ce)}).join(" ")}(me,Oe),b("caret",me),me=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){var Fe=Le?R[se]:R[ne];return Ie.replace(Fe,function(Ae,he,ge,ye,Se){var Te;return b("tilde",Ie,Ae,he,ge,ye,Se),be(he)?Te="":be(ge)?Te=">="+he+".0.0 <"+(+he+1)+".0.0":be(ye)?Te=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0":Se?(b("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Te=">="+he+"."+ge+"."+ye+Se+" <"+he+"."+(+ge+1)+".0"):Te=">="+he+"."+ge+"."+ye+" <"+he+"."+(+ge+1)+".0",b("tilde return",Te),Te})}(ke,Ce)}).join(" ")}(me,Oe),b("tildes",me),me=function(Pe,Ce){return b("replaceXRanges",Pe,Ce),Pe.split(/\s+/).map(function(ke){return function(Ie,Le){Ie=Ie.trim();var Fe=Le?R[C]:R[p];return Ie.replace(Fe,function(Ae,he,ge,ye,Se,Te){b("xRange",Ie,Ae,he,ge,ye,Se,Te);var Ve=be(ge),Me=Ve||be(ye),xe=Me||be(Se);return he==="="&&xe&&(he=""),Ve?Ae=he===">"||he==="<"?"<0.0.0":"*":he&&xe?(Me&&(ye=0),xe&&(Se=0),he===">"?(he=">=",Me?(ge=+ge+1,ye=0,Se=0):xe&&(ye=+ye+1,Se=0)):he==="<="&&(he="<",Me?ge=+ge+1:ye=+ye+1),Ae=he+ge+"."+ye+"."+Se):Me?Ae=">="+ge+".0.0 <"+(+ge+1)+".0.0":xe&&(Ae=">="+ge+"."+ye+".0 <"+ge+"."+(+ye+1)+".0"),b("xRange return",Ae),Ae})}(ke,Ce)}).join(" ")}(me,Oe),b("xrange",me),me=function(Pe,Ce){return b("replaceStars",Pe,Ce),Pe.trim().replace(R[H],"")}(me,Oe),b("stars",me),me}(De,q)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(De){return!!De.match(oe)})),ue=ue.map(function(De){return new pe(De,q)})},ve.prototype.intersects=function(U,q){if(!(U instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(oe){return U.set.some(function(ue){return ue.every(function(De){return oe.intersects(De,q)})})})})},t.toComparators=function(U,q){return new ve(U,q).set.map(function(_){return _.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new M(U,this.loose));for(var q=0;q<this.set.length;q++)if(je(this.set[q],U))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(U,q,_){var oe=null,ue=null;try{var De=new ve(q,_)}catch(me){return null}return U.forEach(function(me){De.test(me)&&(oe&&ue.compare(me)!==-1||(ue=new M(oe=me,_)))}),oe},t.minSatisfying=function(U,q,_){var oe=null,ue=null;try{var De=new ve(q,_)}catch(me){return null}return U.forEach(function(me){De.test(me)&&(oe&&ue.compare(me)!==1||(ue=new M(oe=me,_)))}),oe},t.validRange=function(U,q){try{return new ve(U,q).range||"*"}catch(_){return null}},t.ltr=function(U,q,_){return We(U,q,"<",_)},t.gtr=function(U,q,_){return We(U,q,">",_)},t.outside=We,t.prerelease=function(U,q){var _=F(U,q);return _&&_.prerelease.length?_.prerelease:null},t.intersects=function(U,q,_){return U=new ve(U,_),q=new ve(q,_),U.intersects(q)},t.coerce=function(U){if(U instanceof M)return U;if(typeof U!="string")return null;var q=U.match(R[N]);return q==null?null:F((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,T(1))},function($,t){var T,P,b=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(v){if(T===setTimeout)return setTimeout(v,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(v,0);try{return T(v,0)}catch(m){try{return T.call(null,v,0)}catch(w){return T.call(this,v,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch(v){T=L}try{P=typeof clearTimeout=="function"?clearTimeout:D}catch(v){P=D}})();var c,d=[],g=!1,I=-1;function f(){g&&c&&(g=!1,c.length?d=c.concat(d):I=-1,d.length&&E())}function E(){if(!g){var v=R(f);g=!0;for(var m=d.length;m;){for(c=d,d=[];++I<m;)c&&c[I].run();I=-1,m=d.length}c=null,g=!1,function(w){if(P===clearTimeout)return clearTimeout(w);if((P===D||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(w);try{P(w)}catch(h){try{return P.call(null,w)}catch(o){return P.call(this,w)}}}(v)}}function l(v,m){this.fun=v,this.array=m}function u(){}b.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];d.push(new l(v,m)),d.length!==1||g||R(E)},l.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=u,b.addListener=u,b.once=u,b.off=u,b.removeListener=u,b.removeAllListeners=u,b.emit=u,b.prependListener=u,b.prependOnceListener=u,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(te[37],ie([0,1,11,2]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=b;function L(h){const o=h;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function D(h,o){return new R(h,o)}t.newWriteableStream=D;class R{constructor(o,r){this.reducer=o,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(r=>r(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(r=>r(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,r){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(o,r){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(h,o){const r=[];let e;for(;(e=h.read())!==null;)r.push(e);return o(r)}t.consumeReadable=c;function d(h,o,r){const e=[];let i;for(;(i=h.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return h.read()}}}t.peekReadable=d;function g(h,o){return new Promise((r,e)=>{const i=[];I(h,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):r(void 0)},onEnd:()=>{r(o?o(i):void 0)}})})}t.consumeStream=g;function I(h,o){h.on("error",r=>o.onError(r)),h.on("end",()=>o.onEnd()),h.on("data",r=>o.onData(r))}t.listenStream=I;function f(h,o){return new Promise((r,e)=>{const i=new P.DisposableStore,n=[],s=S=>{if(n.push(S),n.length>o)return i.dispose(),h.pause(),r({stream:h,buffer:n,ended:!1})},a=S=>e(S),y=()=>r({stream:h,buffer:n,ended:!0});i.add((0,P.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,P.toDisposable)(()=>h.removeListener("end",y))),h.on("end",y),i.add((0,P.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}t.peekStream=f;function E(h,o){const r=D(o);return r.end(h),r}t.toStream=E;function l(){const h=D(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=l;function u(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=u;function v(h,o,r){const e=D(r);return I(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=v;function m(h,o,r){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?r([h,i]):h)}}}t.prefixedReadable=m;function w(h,o,r){let e=!1;const i=D(r);return I(o,{onData:n=>e?i.write(n):(e=!0,i.write(r([h,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=w}),define(te[17],ie([0,1,37]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let b,L;class D{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return P?new D(Buffer.allocUnsafe(s)):new D(new Uint8Array(s))}static wrap(s){return P&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new D(s)}static fromString(s,a){return!(a?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(s)):(b||(b=new TextEncoder),new D(b.encode(s)))}static concat(s,a){if(typeof a=="undefined"){a=0;for(let A=0,p=s.length;A<p;A++)a+=s[A].byteLength}const y=D.alloc(a);let S=0;for(let A=0,p=s.length;A<p;A++){const C=s[A];y.set(C,S),S+=C.byteLength}return y}toString(){return P?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(s,a){return new D(this.buffer.subarray(s,a))}set(s,a){s instanceof D?this.buffer.set(s.buffer,a):this.buffer.set(s,a)}readUInt32BE(s){return d(this.buffer,s)}writeUInt32BE(s,a){g(this.buffer,s,a)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,a){f(this.buffer,s,a)}readUInt8(s){return E(this.buffer,s)}writeUInt8(s,a){l(this.buffer,s,a)}}t.VSBuffer=D;function R(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}t.readUInt16LE=R;function c(n,s,a){n[a+0]=s&255,s=s>>>8,n[a+1]=s&255}t.writeUInt16LE=c;function d(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}t.readUInt32BE=d;function g(n,s,a){n[a+3]=s,s=s>>>8,n[a+2]=s,s=s>>>8,n[a+1]=s,s=s>>>8,n[a]=s}t.writeUInt32BE=g;function I(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}t.readUInt32LE=I;function f(n,s,a){n[a+0]=s&255,s=s>>>8,n[a+1]=s&255,s=s>>>8,n[a+2]=s&255,s=s>>>8,n[a+3]=s&255}t.writeUInt32LE=f;function E(n,s){return n[s]}t.readUInt8=E;function l(n,s,a){n[a]=s}t.writeUInt8=l;function u(n){return T.consumeReadable(n,s=>D.concat(s))}t.readableToBuffer=u;function v(n){return T.toReadable(n)}t.bufferToReadable=v;function m(n){return T.consumeStream(n,s=>D.concat(s))}t.streamToBuffer=m;async function w(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await m(n.stream)])}t.bufferedStreamToBuffer=w;function h(n){return T.toStream(n,s=>D.concat(s))}t.bufferToStream=h;function o(n){return T.transform(n,{data:s=>typeof s=="string"?D.fromString(s):D.wrap(s)},s=>D.concat(s))}t.streamToBufferReadableStream=o;function r(n){return T.newWriteableStream(s=>D.concat(s),n)}t.newWriteableBufferStream=r;function e(n,s){return T.prefixedReadable(n,s,a=>D.concat(a))}t.prefixedBufferReadable=e;function i(n,s){return T.prefixedStream(n,s,a=>D.concat(a))}t.prefixedBufferStream=i}),define(te[18],ie([0,1,12]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.keys(u).forEach(m=>{u[m]&&typeof u[m]=="object"?v[m]=P(u[m]):v[m]=u[m]}),v}t.deepClone=P;function b(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(L.call(m,w)){const h=m[w];typeof h=="object"&&!Object.isFrozen(h)&&v.push(h)}}return u}t.deepFreeze=b;const L=Object.prototype.hasOwnProperty;function D(u,v){return R(u,v,new Set)}t.cloneAndChange=D;function R(u,v,m){if((0,T.isUndefinedOrNull)(u))return u;const w=v(u);if(typeof w!="undefined")return w;if((0,T.isArray)(u)){const h=[];for(const o of u)h.push(R(o,v,m));return h}if((0,T.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const h={};for(let o in u)L.call(u,o)&&(h[o]=R(u[o],v,m));return m.delete(u),h}return u}function c(u,v,m=!0){return(0,T.isObject)(u)?((0,T.isObject)(v)&&Object.keys(v).forEach(w=>{w in u?m&&((0,T.isObject)(u[w])&&(0,T.isObject)(v[w])?c(u[w],v[w],m):u[w]=v[w]):u[w]=v[w]}),u):v}t.mixin=c;function d(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(m=0;m<u.length;m++)if(!d(u[m],v[m]))return!1}else{const h=[];for(w in u)h.push(w);h.sort();const o=[];for(w in v)o.push(w);if(o.sort(),!d(h,o))return!1;for(m=0;m<h.length;m++)if(!d(u[h[m]],v[h[m]]))return!1}return!0}t.equals=d;function g(u){const v=new Set;return JSON.stringify(u,(m,w)=>{if((0,T.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}t.safeStringify=g;function I(u,v,m){const w=v(u);return typeof w=="undefined"?m:w}t.getOrDefault=I;function f(u,v){const m=Object.create(null);return!u||!v||Object.keys(v).forEach(h=>{const o=u[h],r=v[h];d(o,r)||(m[h]=r)}),m}t.distinct=f;function E(u,v){const m=v.toLowerCase(),w=Object.keys(u).find(h=>h.toLowerCase()===m);return w?u[w]:u[v]}t.getCaseInsensitive=E;function l(u,v){const m=Object.create(null);for(const w of Object.keys(u))v(w,u[w])&&(m[w]=u[w]);return m}t.filter=l}),define(te[60],ie([0,1,7]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(d){const g=d;return g&&typeof g.type=="string"&&typeof g.severity=="string"}t.isRemoteConsoleLog=P;function b(d){const g=[];let I;try{const f=JSON.parse(d.arguments),E=f[f.length-1];E&&E.__$stack&&(f.pop(),I=E.__$stack),g.push(...f)}catch(f){g.push("Unable to log remote console arguments",d.arguments)}return{args:g,stack:I}}t.parse=b;function L(d){if(typeof d!="string")return L(b(d).stack);const g=d;if(g){const I=D(g),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(f&&f.length===4)return{uri:T.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}t.getFirstFrame=L;function D(d){if(!d)return d;const g=d.indexOf(`
`);return g===-1?d:d.substring(0,g)}function R(d,g){const{args:I,stack:f}=b(d),E=typeof I[0]=="string"&&I.length===1;let l=D(f);l&&(l=`(${l.trim()})`);let u=[];if(typeof I[0]=="string"?l&&E?u=[`%c[${g}] %c${I[0]} %c${l}`,c("blue"),c(""),c("grey")]:u=[`%c[${g}] %c${I[0]}`,c("blue"),c(""),...I.slice(1)]:u=[`%c[${g}]%`,c("blue"),...I],l&&!E&&u.push(l),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,u)}t.log=R;function c(d){return`color: ${d}`}}),define(te[61],ie([0,1,17,21,7]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function L(g){return JSON.stringify(g,c)}t.stringify=L;function D(g){let I=JSON.parse(g);return I=d(I),I}t.parse=D;var R;(function(g){g[g.Uri=1]="Uri",g[g.Regexp=2]="Regexp",g[g.ScmResource=3]="ScmResource",g[g.ScmResourceGroup=4]="ScmResourceGroup",g[g.ScmProvider=5]="ScmProvider",g[g.CommentController=6]="CommentController",g[g.CommentThread=7]="CommentThread",g[g.CommentThreadReply=8]="CommentThreadReply",g[g.CommentNode=9]="CommentNode",g[g.CommentThreadNode=10]="CommentThreadNode",g[g.TimelineActionContext=11]="TimelineActionContext",g[g.NotebookCellActionContext=12]="NotebookCellActionContext",g[g.TestItemContext=13]="TestItemContext"})(R=t.MarshalledId||(t.MarshalledId={}));function c(g,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,P.regExpFlags)(I)}:I}function d(g,I=0){if(!g||I>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return b.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof T.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let f=0;f<g.length;++f)g[f]=d(g[f],I+1);else for(const f in g)Object.hasOwnProperty.call(g,f)&&(g[f]=d(g[f],I+1))}return g}t.revive=d}),define(te[62],ie([0,1,3,33,47,4,21]),function($,t,T,P,b,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const c="**",d="/",g="[/\\\\]",I="[^/\\\\]",f=/\//g;function E(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${g}|${I}+${g}|${g}${I}+)*?`}}function l(O,z){if(!O)return[];const W=[];let H=!1,k=!1,F="";for(const M of O){switch(M){case z:if(!H&&!k){W.push(F),F="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":k=!0;break;case"]":k=!1;break}F+=M}return F&&W.push(F),W}t.splitGlobAware=l;function u(O){if(!O)return"";let z="";const W=l(O,d);if(W.every(H=>H===c))z=".*";else{let H=!1;W.forEach((k,F)=>{if(k===c){H||(z+=E(2),H=!0);return}let M=!1,x="",B=!1,K="";for(const Q of k){if(Q!=="}"&&M){x+=Q;continue}if(B&&(Q!=="]"||!K)){let X;Q==="-"?X=Q:(Q==="^"||Q==="!")&&!K?X="^":Q===d?X="":X=D.escapeRegExpCharacters(Q),K+=X;continue}switch(Q){case"{":M=!0;continue;case"[":B=!0;continue;case"}":z+=`(?:${l(x,",").map(de=>u(de)).join("|")})`,M=!1,x="";break;case"]":z+="["+K+"]",B=!1,K="";break;case"?":z+=I;continue;case"*":z+=E(1);continue;default:z+=D.escapeRegExpCharacters(Q)}}F<W.length-1&&(W[F+1]!==c||F+2<W.length)&&(z+=g),H=!1})}return z}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new b.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(O,z){if(!O)return n;let W;typeof O!="string"?W=O.pattern:W=O,W=W.trim();const H=`${W}_${!!z.trimForExclusions}`;let k=e.get(H);if(k)return a(k,O);let F;if(v.test(W)){const M=W.substr(4);k=function(x,B){return typeof x=="string"&&x.endsWith(M)?W:null}}else(F=m.exec(y(W,z)))?k=S(F[1],W):(z.trimForExclusions?h:w).test(W)?k=A(W,z):(F=o.exec(y(W,z)))?k=p(F[1].substr(1),W,!0):(F=r.exec(y(W,z)))?k=p(F[1],W,!1):k=C(W);return e.set(H,k),a(k,O)}function a(O,z){return typeof z=="string"?O:function(W,H){return P.isEqualOrParent(W,z.base)?O(L.relative(z.base,W),H):null}}function y(O,z){return z.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function S(O,z){const W=`/${O}`,H=`\\${O}`,k=function(M,x){return typeof M!="string"?null:x?x===O?z:null:M===O||M.endsWith(W)||M.endsWith(H)?z:null},F=[O];return k.basenames=F,k.patterns=[z],k.allBasenames=F,k}function A(O,z){const W=j(O.slice(1,-1).split(",").map(x=>s(x,z)).filter(x=>x!==n),O),H=W.length;if(!H)return n;if(H===1)return W[0];const k=function(x,B){for(let K=0,Q=W.length;K<Q;K++)if(W[K](x,B))return O;return null},F=W.find(x=>!!x.allBasenames);F&&(k.allBasenames=F.allBasenames);const M=W.reduce((x,B)=>B.allPaths?x.concat(B.allPaths):x,[]);return M.length&&(k.allPaths=M),k}function p(O,z,W){const H=L.sep===L.posix.sep,k=H?O:O.replace(f,L.sep),F=L.sep+k,M=L.posix.sep+O,x=W?function(B,K){return typeof B=="string"&&(B===k||B.endsWith(F)||!H&&(B===O||B.endsWith(M)))?z:null}:function(B,K){return typeof B=="string"&&(B===k||!H&&B===O)?z:null};return x.allPaths=[(W?"*/":"./")+O],x}function C(O){try{const z=new RegExp(`^${u(O)}$`);return function(W){return z.lastIndex=0,typeof W=="string"&&z.test(W)?O:null}}catch(z){return n}}function N(O,z,W){return!O||typeof z!="string"?!1:V(O)(z,void 0,W)}t.match=N;function V(O,z={}){if(!O)return i;if(typeof O=="string"||ee(O)){const W=s(O,z);if(W===n)return i;const H=function(k,F){return!!W(k,F)};return W.allBasenames&&(H.allBasenames=W.allBasenames),W.allPaths&&(H.allPaths=W.allPaths),H}return Z(O,z)}t.parse=V;function J(O){if(!O)return;let z;return W=>(z||(z=(O()||Promise.resolve([])).then(H=>H?se(H):{})),z.then(H=>!!H[W]))}t.hasSiblingPromiseFn=J;function ne(O){if(!O)return;let z;return W=>{if(!z){const H=O();z=H?se(H):{}}return!!z[W]}}t.hasSiblingFn=ne;function se(O){const z={};for(const W of O)z[W]=!0;return z}function ee(O){const z=O;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}t.isRelativePattern=ee;function G(O){return O.allBasenames||[]}t.getBasenameTerms=G;function Y(O){return O.allPaths||[]}t.getPathTerms=Y;function Z(O,z){const W=j(Object.getOwnPropertyNames(O).map(x=>re(x,O[x],z)).filter(x=>x!==n)),H=W.length;if(!H)return n;if(!W.some(x=>!!x.requiresSiblings)){if(H===1)return W[0];const x=function(Q,X){for(let le=0,de=W.length;le<de;le++){const ce=W[le](Q,X);if(ce)return ce}return null},B=W.find(Q=>!!Q.allBasenames);B&&(x.allBasenames=B.allBasenames);const K=W.reduce((Q,X)=>X.allPaths?Q.concat(X.allPaths):Q,[]);return K.length&&(x.allPaths=K),x}const k=function(x,B,K){let Q;for(let X=0,le=W.length;X<le;X++){const de=W[X];de.requiresSiblings&&K&&(B||(B=L.basename(x)),Q||(Q=B.substr(0,B.length-L.extname(x).length)));const ce=de(x,B,Q,K);if(ce)return ce}return null},F=W.find(x=>!!x.allBasenames);F&&(k.allBasenames=F.allBasenames);const M=W.reduce((x,B)=>B.allPaths?x.concat(B.allPaths):x,[]);return M.length&&(k.allPaths=M),k}function re(O,z,W){if(z===!1)return n;const H=s(O,W);if(H===n)return n;if(typeof z=="boolean")return H;if(z){const k=z.when;if(typeof k=="string"){const F=(M,x,B,K)=>{if(!K||!H(M,x))return null;const Q=k.replace("$(basename)",B),X=K(Q);return(0,T.isThenable)(X)?X.then(le=>le?O:null):X?O:null};return F.requiresSiblings=!0,F}}return H}function j(O,z){const W=O.filter(x=>!!x.basenames);if(W.length<2)return O;const H=W.reduce((x,B)=>{const K=B.basenames;return K?x.concat(K):x},[]);let k;if(z){k=[];for(let x=0,B=H.length;x<B;x++)k.push(z)}else k=W.reduce((x,B)=>{const K=B.patterns;return K?x.concat(K):x},[]);const F=function(x,B){if(typeof x!="string")return null;if(!B){let Q;for(Q=x.length;Q>0;Q--){const X=x.charCodeAt(Q-1);if(X===47||X===92)break}B=x.substr(Q)}const K=H.indexOf(B);return K!==-1?k[K]:null};F.basenames=H,F.patterns=k,F.allBasenames=H;const M=O.filter(x=>!x.basenames);return M.push(F),M}}),define(te[63],ie([0,1,33,8,4,9,19,21,7]),function($,t,T,P,b,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(s,a,y){if(typeof s=="string"&&(s=c.URI.file(s)),y){const A=y.getWorkspaceFolder(s);if(A){const p=y.getWorkspace().folders.length>1;let C;if((0,D.isEqual)(A.uri,s)?C="":C=(0,D.relativePath)(A.uri,s),p){const N=A.name?A.name:(0,D.basename)(A.uri);C=C?N+" \u2022 "+C:N}return C}}if(s.scheme!==P.Schemas.file&&s.scheme!==P.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(s.fsPath))return(0,b.normalize)(I(s.fsPath));let S=(0,b.normalize)(s.fsPath);return!L.isWindows&&a?.userHome&&(S=E(S,a.userHome.fsPath)),S}t.getPathLabel=d;function g(s){if(!s)return;typeof s=="string"&&(s=c.URI.file(s));const a=(0,D.basename)(s)||(s.scheme===P.Schemas.file?s.fsPath:s.path);return L.isWindows&&(0,T.isRootOrDriveLetter)(a)?I(a):a}t.getBaseLabel=g;function I(s){return(0,T.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=I;let f=Object.create(null);function E(s,a){if(L.isWindows||!s||!a)return s;let y=f.original===a?f.normalized:void 0;return y||(y=`${(0,R.rtrim)(a,b.posix.sep)}${b.posix.sep}`,f={original:a,normalized:y}),(L.isLinux?s.startsWith(y):(0,R.startsWithIgnoreCase)(s,y))&&(s=`~/${s.substr(y.length)}`),s}t.tildify=E;function l(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const u="\u2026",v="\\\\",m="~";function w(s,a=b.sep){const y=new Array(s.length);let S=!1;for(let A=0;A<s.length;A++){let p=s[A];if(p===""){y[A]=`.${a}`;continue}if(!p){y[A]=p;continue}S=!0;let C="";p.indexOf(v)===0?(C=p.substr(0,p.indexOf(v)+v.length),p=p.substr(p.indexOf(v)+v.length)):p.indexOf(a)===0?(C=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(m)===0&&(C=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const N=p.split(a);for(let V=1;S&&V<=N.length;V++)for(let J=N.length-V;S&&J>=0;J--){S=!1;let ne=N.slice(J,J+V).join(a);for(let se=0;!S&&se<s.length;se++)if(se!==A&&s[se]&&s[se].indexOf(ne)>-1){const ee=J+V===N.length,G=J>0&&s[se].indexOf(a)>-1?a+ne:ne,Y=s[se].endsWith(G);S=!ee||Y}if(!S){let se="";(N[0].endsWith(":")||C!=="")&&(J===1&&(J=0,V++,ne=N[0]+a+ne),J>0&&(se=N[0]+a),se=C+se),J>0&&(se=se+u+a),se=se+ne,J+V<N.length&&(se=se+a+u),y[A]=se}}S&&(y[A]=p)}return y}t.shorten=w;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(s,a=Object.create(null)){const y=[];let S=!1,A="";for(const p of s)if(p==="$"||S&&p==="{")A&&y.push({value:A,type:h.TEXT}),A="",S=!0;else if(p==="}"&&S){const C=a[A];if(typeof C=="string")C.length&&y.push({value:C,type:h.VARIABLE});else if(C){const N=y[y.length-1];(!N||N.type!==h.SEPARATOR)&&y.push({value:C.label,type:h.SEPARATOR})}A="",S=!1}else A+=p;return A&&!S&&y.push({value:A,type:h.TEXT}),y.filter((p,C)=>{if(p.type===h.SEPARATOR){const N=y[C-1],V=y[C+1];return[N,V].every(J=>J&&(J.type===h.VARIABLE||J.type===h.TEXT)&&J.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function r(s,a){return L.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):s.replace(/&&|&/g,y=>y==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,a){return L.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):L.isWindows?s.replace(/&&|&/g,y=>y==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const a=s.indexOf("/")!==-1?b.posix:b.win32,y=a.basename(s),S=a.dirname(s);return y.length?{name:y,parentPath:S}:{name:S,parentPath:""}}t.splitName=n}),define(te[48],ie([0,1,127]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(L="utf8"){this.stringDecoder=new T.StringDecoder(L),this.remaining=null}write(L){const D=[],R=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(R.length<1)return D;let c=0,d,g=c;for(;g<R.length;)if(d=R.charCodeAt(g),d===13||d===10){if(D.push(R.substring(c,g)),g++,g<R.length){const I=d;d=R.charCodeAt(g),(I===13&&d===10||I===10&&d===13)&&g++}c=g}else g++;return this.remaining=c<R.length?R.substr(c):null,D}end(){return this.remaining}}t.LineDecoder=P}),define(te[64],ie([0,1,38,4,21,10]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(g){const I=(0,P.dirname)(g);if(g===I)return g;const f=((0,P.basename)(g)||g).toLowerCase();try{const l=(0,L.readdirSync)(I).filter(u=>u.toLowerCase()===f);if(l.length===1){const u=D(I);if(u)return(0,P.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(f);if(u>=0){const v=D(I);if(v)return(0,P.join)(v,l[u])}}}catch(E){}return null}t.realcaseSync=D;async function R(g){try{return await L.Promises.realpath(g)}catch(I){const f=d(g);return await L.Promises.access(f,T.constants.R_OK),f}}t.realpath=R;function c(g){try{return T.realpathSync(g)}catch(I){const f=d(g);return T.accessSync(f,T.constants.R_OK),f}}t.realpathSync=c;function d(g){return(0,b.rtrim)((0,P.normalize)(g),P.sep)}}),define(te[65],ie([0,1,34,4,10]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,D=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class I{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:o=!1,findPreview:r=!1}={}){const e=f({useAlternateBitness:o});if(!e)return null;const i=P.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const S of await b.Promises.readdir(i)){let A=-1;if(r){const C=S.indexOf("-");if(C<0)continue;const N=S.substring(0,C);if(!L.test(N)||S.substring(C+1)!=="preview")continue;A=parseInt(N,10)}else{if(!L.test(S))continue;A=parseInt(S,10)}if(A<=n)continue;const p=P.join(i,S,"pwsh.exe");!await b.SymlinkSupport.existsFile(p)||(s=p,n=A)}if(!s)return null;const a=e.includes("x86")?" (x86)":"",y=r?" Preview":"";return new I(s,`PowerShell${y}${a}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const r=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await b.Promises.readdir(r))if(e.test(n)){const s=P.join(r,n,"pwsh.exe");return new I(s,i)}return null}function u(){const o=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function v(){const o=P.join(process.env.windir,d===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*m(){let o=await E();o&&(yield o),o=await E({useAlternateBitness:!0}),o&&(yield o),o=await l(),o&&(yield o),o=u(),o&&(yield o),o=await E({findPreview:!0}),o&&(yield o),o=await l({findPreview:!0}),o&&(yield o),o=await E({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=v(),o&&(yield o)}async function*w(){for await(const o of m())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=w;async function h(){for await(const o of w())return o;return null}t.getFirstAvailablePowerShellInstallation=h}),define(te[66],ie([0,1,38,33,2,128,4,9,10]),function($,t,T,P,b,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function d(f,E,l){return I({path:f,isDirectory:!1},E,l)}t.watchFile=d;function g(f,E,l){return I({path:f,isDirectory:!0},E,l)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function I(f,E,l){if(R.isMacintosh&&(0,P.isEqualOrParent)(f.path,"/Volumes/"))return l(`Refusing to watch ${f.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),b.Disposable.None;const u=(0,D.basename)(f.path),v=new Map;let m=!1,w=[(0,b.toDisposable)(()=>{v.forEach(h=>(0,b.dispose)(h)),v.clear()})];try{const h=(0,T.watch)(f.path);w.push((0,b.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;f.isDirectory&&c.Promises.readdir(f.path).then(r=>r.forEach(e=>o.add(e))),h.on("error",(r,e)=>{m||l(`Failed to watch ${f.path} for changes using fs.watch() (${r}, ${e})`)}),h.on("change",(r,e)=>{if(m)return;let i="";if(e&&(i=e.toString(),R.isMacintosh&&(i=(0,L.normalizeNFC)(i))),!i||r!=="change"&&r!=="rename")return;const n=f.isDirectory?(0,D.join)(f.path,i):f.path;if(f.isDirectory)if(r==="rename"){const s=v.get(n);s&&(0,b.dispose)(s);const a=setTimeout(async()=>{v.delete(n);const y=await c.Promises.exists(n);if(m)return;let S;y?o.has(i)?S="changed":(S="added",o.add(i)):(o.delete(i),S="deleted"),E(S,n)},t.CHANGE_BUFFER_DELAY);v.set(n,(0,b.toDisposable)(()=>clearTimeout(a)))}else{let s;o.has(i)?s="changed":(s="added",o.add(i)),E(s,n)}else if(r==="rename"||i!==u){const s=setTimeout(async()=>{const a=await c.Promises.exists(n);m||(a?(E("changed",n),w=[I(f,E,l)]):E("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,b.dispose)(w),w=[(0,b.toDisposable)(()=>clearTimeout(s))]}else E("changed",n)})}catch(h){c.Promises.exists(f.path).then(o=>{o&&!m&&l(`Failed to watch ${f.path} for changes using fs.watch() (${h.toString()})`)})}return(0,b.toDisposable)(()=>{m=!0,w=(0,b.dispose)(w)})}});var fe=this&&this.__decorate||function($,t,T,P){var b=arguments.length,L=b<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,T):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,t,T,P);else for(var R=$.length-1;R>=0;R--)(D=$[R])&&(L=(b<3?D(L):b>3?D(t,T,L):D(t,T))||L);return b>3&&L&&Object.defineProperty(t,T,L),L};define(te[39],ie([0,1,22,3,17,25,46,11,13,2,61,21,12]),function($,t,T,P,b,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var E;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(E=t.RequestType||(t.RequestType={}));function l(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function v(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(m||(m={}));class w{constructor(O){this.buffer=O,this.pos=0}read(O){const z=this.buffer.slice(this.pos,this.pos+O);return this.pos+=z.byteLength,z}}class h{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(o||(o={}));function r(j){const O=b.VSBuffer.alloc(4);return O.writeUInt32BE(j,0),O}function e(j){return j.read(4).readUInt32BE(0)}function i(j){const O=b.VSBuffer.alloc(1);return O.writeUInt8(j,0),O}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},s=typeof Buffer!="undefined";function a(j,O){if(typeof O=="undefined")j.write(n.Undefined);else if(typeof O=="string"){const z=b.VSBuffer.fromString(O);j.write(n.String),j.write(r(z.byteLength)),j.write(z)}else if(s&&Buffer.isBuffer(O)){const z=b.VSBuffer.wrap(O);j.write(n.Buffer),j.write(r(z.byteLength)),j.write(z)}else if(O instanceof b.VSBuffer)j.write(n.VSBuffer),j.write(r(O.byteLength)),j.write(O);else if(Array.isArray(O)){j.write(n.Array),j.write(r(O.length));for(const z of O)a(j,z)}else{const z=b.VSBuffer.fromString(JSON.stringify(O));j.write(n.Object),j.write(r(z.byteLength)),j.write(z)}}function y(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(e(j)).toString();case o.Buffer:return j.read(e(j)).buffer;case o.VSBuffer:return j.read(e(j));case o.Array:{const z=e(j),W=[];for(let H=0;H<z;H++)W.push(y(j));return W}case o.Object:return JSON.parse(j.read(e(j)).toString())}}class S{constructor(O,z,W=null,H=1e3){this.protocol=O,this.ctx=z,this.logger=W,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(k=>this.onRawMessage(k)),this.sendResponse({type:200})}registerChannel(O,z){this.channels.set(O,z),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const z=this.send([O.type]);this.logger&&this.logger.logOutgoing(z,0,1,v(O.type));return}case 201:case 202:case 204:case 203:{const z=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(z,O.id,1,v(O.type),O.data);return}}}send(O,z=void 0){const W=new h;return a(W,O),a(W,z),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(z){return 0}}onRawMessage(O){const z=new w(O),W=y(z),H=y(z),k=W[0];switch(k){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}: ${W[2]}.${W[3]}`,H),this.onPromise({type:k,id:W[1],channelName:W[2],name:W[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}: ${W[2]}.${W[3]}`,H),this.onEventListen({type:k,id:W[1],channelName:W[2],name:W[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}`),this.disposeActiveRequest({type:k,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}`),this.disposeActiveRequest({type:k,id:W[1]})}}onPromise(O){const z=this.channels.get(O.channelName);if(!z){this.collectPendingRequest(O);return}const W=new L.CancellationTokenSource;let H;try{H=z.call(this.ctx,O.name,O.arg,W.token)}catch(M){H=Promise.reject(M)}const k=O.id;H.then(M=>{this.sendResponse({id:k,data:M,type:201}),this.activeRequests.delete(O.id)},M=>{M instanceof Error?this.sendResponse({id:k,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.sendResponse({id:k,data:M,type:203}),this.activeRequests.delete(O.id)});const F=(0,d.toDisposable)(()=>W.cancel());this.activeRequests.set(O.id,F)}onEventListen(O){const z=this.channels.get(O.channelName);if(!z){this.collectPendingRequest(O);return}const W=O.id,k=z.listen(this.ctx,O.name,O.arg)(F=>this.sendResponse({id:W,data:F,type:204}));this.activeRequests.set(O.id,k)}disposeActiveRequest(O){const z=this.activeRequests.get(O.id);z&&(z.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let z=this.pendingRequests.get(O.channelName);z||(z=[],this.pendingRequests.set(O.channelName,z));const W=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:O,timeoutTimer:W})}flushPendingRequests(O){const z=this.pendingRequests.get(O);if(z){for(const W of z)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}t.ChannelServer=S;var A;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(A=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(O,z=null){this.protocol=O,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=z}getChannel(O){const z=this;return{call(W,H,k){return z.isDisposed?Promise.reject(R.canceled()):z.requestPromise(O,W,H,k)},listen(W,H){return z.isDisposed?Promise.reject(R.canceled()):z.requestEvent(O,W,H)}}}requestPromise(O,z,W,H=L.CancellationToken.None){const k=this.lastRequestId++,M={id:k,type:100,channelName:O,name:z,arg:W};if(H.isCancellationRequested)return Promise.reject(R.canceled());let x;return new Promise((K,Q)=>{if(H.isCancellationRequested)return Q(R.canceled());const X=()=>{const Ee=we=>{switch(we.type){case 201:this.handlers.delete(k),K(we.data);break;case 202:this.handlers.delete(k);const pe=new Error(we.data.message);pe.stack=we.data.stack,pe.name=we.data.name,Q(pe);break;case 203:this.handlers.delete(k),Q(we.data);break}};this.handlers.set(k,Ee),this.sendRequest(M)};let le=null;this.state===m.Idle?X():(le=(0,P.createCancelablePromise)(Ee=>this.whenInitialized()),le.then(()=>{le=null,X()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:k,type:101}),Q(R.canceled())},ce=H.onCancellationRequested(de);x=(0,d.combinedDisposable)((0,d.toDisposable)(de),ce),this.activeRequests.add(x)}).finally(()=>{this.activeRequests.delete(x)})}requestEvent(O,z,W){const H=this.lastRequestId++,F={id:H,type:102,channelName:O,name:z,arg:W};let M=null;const x=new c.Emitter({onFirstListenerAdd:()=>{M=(0,P.createCancelablePromise)(K=>this.whenInitialized()),M.then(()=>{M=null,this.activeRequests.add(x),this.sendRequest(F)})},onLastListenerRemove:()=>{M?(M.cancel(),M=null):(this.activeRequests.delete(x),this.sendRequest({id:H,type:103}))}}),B=K=>x.fire(K.data);return this.handlers.set(H,B),x.event}sendRequest(O){switch(O.type){case 100:case 102:{const z=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(z,O.id,0,`${l(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const z=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(z,O.id,0,l(O.type));return}}}send(O,z=void 0){const W=new h;return a(W,O),a(W,z),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(z){return 0}}onBuffer(O){const z=new w(O),W=y(z),H=y(z),k=W[0];switch(k){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,v(k)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],0,v(k),H),this.onResponse({type:W[0],id:W[1],data:H})}}onResponse(O){if(O.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(O.id);z&&z(O)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}fe([D.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class C{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:z,onDidClientDisconnect:W})=>{c.Event.once(z.onMessage)(k=>{const F=new w(k),M=y(F),x=new S(z,M),B=new p(z);this.channels.forEach((Q,X)=>x.registerChannel(X,Q));const K={channelServer:x,channelClient:B,ctx:M};this._connections.add(K),this._onDidAddConnection.fire(K),W(()=>{x.dispose(),B.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const O=[];return this._connections.forEach(z=>O.push(z)),O}getChannel(O,z){const W=this;return{call(H,k,F){let M;if((0,f.isFunction)(z)){let B=(0,T.getRandomElement)(W.connections.filter(z));M=B?Promise.resolve(B):c.Event.toPromise(c.Event.filter(W.onDidAddConnection,z))}else M=z.routeCall(W,H,k);const x=M.then(B=>B.channelClient.getChannel(O));return V(x).call(H,k,F)},listen(H,k){if((0,f.isFunction)(z))return W.getMulticastEvent(O,z,H,k);const F=z.routeEvent(W,H,k).then(M=>M.channelClient.getChannel(O));return V(F).listen(H,k)}}}getMulticastEvent(O,z,W,H){const k=this;let F=new d.DisposableStore;const M=new c.Emitter({onFirstListenerAdd:()=>{F=new d.DisposableStore;const x=new c.EventMultiplexer,B=new Map,K=X=>{const de=X.channelClient.getChannel(O).listen(W,H),ce=x.add(de);B.set(X,ce)},Q=X=>{const le=B.get(X);!le||(le.dispose(),B.delete(X))};k.connections.filter(z).forEach(K),c.Event.filter(k.onDidAddConnection,z)(K,void 0,F),k.onDidRemoveConnection(Q,void 0,F),x.event(M.fire,M,F),F.add(x)},onLastListenerRemove:()=>{F.dispose()}});return M.event}registerChannel(O,z){this.channels.set(O,z),this._connections.forEach(W=>{W.channelServer.registerChannel(O,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class N{constructor(O,z,W=null){const H=new h;a(H,z),O.send(H.buffer),this.channelClient=new p(O,W),this.channelServer=new S(O,z,W)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,z){this.channelServer.registerChannel(O,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function V(j){return{call(O,z,W){return j.then(H=>H.call(O,z,W))},listen(O,z){const W=new c.Relay;return j.then(H=>W.input=H.listen(O,z)),W.event}}}t.getDelayedChannel=V;function J(j){let O=!1;return{call(z,W,H){return O?j.call(z,W,H):(0,P.timeout)(0).then(()=>O=!0).then(()=>j.call(z,W,H))},listen(z,W){if(O)return j.listen(z,W);const H=new c.Relay;return(0,P.timeout)(0).then(()=>O=!0).then(()=>H.input=j.listen(z,W)),H.event}}}t.getNextTickChannel=J;class ne{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const z of O.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(O.onDidAddConnection),await this.route(O)}}t.StaticRouter=ne;var se;(function(j){function O(H,k){const F=H,M=k&&k.disableMarshalling,x=new Map;for(const B in F)W(B)&&x.set(B,c.Event.buffer(F[B],!0));return new class{listen(B,K){const Q=x.get(K);if(Q)return Q;throw new Error(`Event not found: ${K}`)}call(B,K,Q){const X=F[K];if(typeof X=="function"){if(!M&&Array.isArray(Q))for(let le=0;le<Q.length;le++)Q[le]=(0,g.revive)(Q[le]);return X.apply(F,Q)}throw new Error(`Method not found: ${K}`)}}}j.fromService=O;function z(H,k){const F=k&&k.disableMarshalling;return new Proxy({},{get(M,x){if(typeof x=="string")return k?.properties?.has(x)?k.properties.get(x):W(x)?H.listen(x):async function(...B){let K;k&&!(0,f.isUndefinedOrNull)(k.context)?K=[k.context,...B]:K=B;const Q=await H.call(x,K);return F?Q:(0,g.revive)(Q)};throw new Error(`Property not found: ${String(x)}`)}})}j.toService=z;function W(H){return H[0]==="o"&&H[1]==="n"&&I.isUpperAsciiLetter(H.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let O=j.toString();if(O!=="[object Object]")return O}return j}function Y(j){return Array.isArray(j)?j.map(G):G(j)}function Z(j,O,z,W,H,k,F){F=Y(F);const M=ee[H],x=M[W%M.length];let B=[`%c[${j}]%c[${String(O).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${k}`,"color: darkgreen","color: grey","color: grey",`color: ${x}`];/\($/.test(k)?(B=B.concat(F),B.push(")")):B.push(F),console.log.apply(console,B)}t.logWithColors=Z;class re{constructor(O,z){this._outgoingPrefix=O,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,z,W,H,k){this._totalOutgoing+=O,Z(this._outgoingPrefix,this._totalOutgoing,O,z,W,H,k)}logIncoming(O,z,W,H,k){this._totalIncoming+=O,Z(this._incomingPrefix,this._totalIncoming,O,z,W,H,k)}}t.IPCLogger=re}),define(te[67],ie([0,1,3,13,2,12]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var D;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=t.StorageHint||(t.StorageHint={}));function R(I){const f=I;return f?.changed instanceof Map||f?.deleted instanceof Set}t.isStorageItemsChangeEvent=R;var c;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(c||(c={}));class d extends b.Disposable{constructor(f,E=Object.create(null)){super();this.database=f,this.options=E,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((E,l)=>this.accept(l,E)),f.deleted?.forEach(E=>this.accept(E,void 0))}accept(f,E){if(this.state===c.Closed)return;let l=!1;(0,L.isUndefinedOrNull)(E)?l=this.cache.delete(f):this.cache.get(f)!==E&&(this.cache.set(f,E),l=!0),l&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,E){const l=this.cache.get(f);return(0,L.isUndefinedOrNull)(l)?E:l}getBoolean(f,E){const l=this.get(f);return(0,L.isUndefinedOrNull)(l)?E:l==="true"}getNumber(f,E){const l=this.get(f);return(0,L.isUndefinedOrNull)(l)?E:parseInt(l,10)}async set(f,E){if(this.state===c.Closed)return;if((0,L.isUndefinedOrNull)(E))return this.delete(f);const l=String(E);if(this.cache.get(f)!==l)return this.cache.set(f,l),this.pendingInserts.set(f,l),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===c.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((E,l)=>this.items.set(l,E)),f.delete&&f.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=g}),define(te[68],ie([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(te[69],ie([0,1,68]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,b=P*60,L=b*24,D=L*7,R=L*30,c=L*365;function d(I,f){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,T.localize)(0,null,d(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let l;return E<P?(l=E,f?l===1?(0,T.localize)(2,null,l):(0,T.localize)(3,null,l):l===1?(0,T.localize)(4,null,l):(0,T.localize)(5,null,l)):E<b?(l=Math.floor(E/P),f?l===1?(0,T.localize)(6,null,l):(0,T.localize)(7,null,l):l===1?(0,T.localize)(8,null,l):(0,T.localize)(9,null,l)):E<L?(l=Math.floor(E/b),f?l===1?(0,T.localize)(10,null,l):(0,T.localize)(11,null,l):l===1?(0,T.localize)(12,null,l):(0,T.localize)(13,null,l)):E<D?(l=Math.floor(E/L),f?l===1?(0,T.localize)(14,null,l):(0,T.localize)(15,null,l):l===1?(0,T.localize)(16,null,l):(0,T.localize)(17,null,l)):E<R?(l=Math.floor(E/D),f?l===1?(0,T.localize)(18,null,l):(0,T.localize)(19,null,l):l===1?(0,T.localize)(20,null,l):(0,T.localize)(21,null,l)):E<c?(l=Math.floor(E/R),f?l===1?(0,T.localize)(22,null,l):(0,T.localize)(23,null,l):l===1?(0,T.localize)(24,null,l):(0,T.localize)(25,null,l)):(l=Math.floor(E/c),f?l===1?(0,T.localize)(26,null,l):(0,T.localize)(27,null,l):l===1?(0,T.localize)(28,null,l):(0,T.localize)(29,null,l))}t.fromNow=d;function g(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=g}),define(te[70],ie([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(te[28],ie([0,1,22,12,70]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(d,g){return g&&(d.stack||d.stacktrace)?b.localize(0,null,R(d),D(d.stack)||D(d.stacktrace)):R(d)}function D(d){return Array.isArray(d)?d.join(`
`):d}function R(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?b.localize(1,null,d.message):d.message||b.localize(2,null)}function c(d=null,g=!1){if(!d)return b.localize(3,null);if(Array.isArray(d)){const I=T.coalesce(d),f=c(I[0],g);return I.length>1?b.localize(4,null,f,I.length):f}if(P.isString(d))return d;if(d.detail){const I=d.detail;if(I.error)return L(I.error,g);if(I.exception)return L(I.exception,g)}return d.stack?L(d,g):d.message?d.message:b.localize(5,null)}t.toErrorMessage=c}),define(te[71],ie([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(te[49],ie([0,1,35,33,8,18,4,9,29,12,48,10,71]),function($,t,T,P,b,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function E(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,r){if(R.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=T.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,a)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?E(e.status):1})}else if(R.isLinux||R.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{T.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function u(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=u;class v{constructor(r,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=n;else{const s=r;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(c.env).forEach(a=>{s[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(D.sep);return e!==-1&&(r=r.substring(e+1)),v.WellKnowCommands[r]?r:"other"}start(r){return R.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(c.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((a,y)=>{i=a,n=y});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=T.exec(a,this.options,(y,S,A)=>{this.childProcess=null;const p=y;p&&p.killed?n({killed:this.terminateRequested,stdout:S.toString(),stderr:A.toString()}):this.handleExec(i,r,y,S,A)})}else{let a=null;const y=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,i,r,n);const A={terminated:this.terminateRequested};d.isNumber(S)&&(A.cmdCode=S),i(A)};if(this.shell&&R.isWindows){const S=L.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let A=!1,p=!1;const C=[];let N=this.ensureQuotes(this.cmd);C.push(N.value),A=N.quoted,this.args&&this.args.forEach(J=>{N=this.ensureQuotes(J),C.push(N.value),p=p&&N.quoted});const V=["/s","/c"];A?p?V.push('"'+C.join(" ")+'"'):C.length>1?V.push('"'+C[0]+'" '+C.slice(1).join(" ")):V.push('"'+C[0]+'"'):V.push(C.join(" ")),a=T.spawn(u(),V,S)}else this.cmd&&(a=T.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(d.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",S=>{this.childProcess=null,n({terminated:this.terminateRequested,error:S})}),a.pid&&(this.childProcess.on("close",y),this.handleSpawn(a,i,r,n,!0)))}return s})}handleClose(r,e,i,n){}ensureQuotes(r){return v.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,l(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!R.isWindows)return r(!1);const e=T.spawn(u(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class m extends v{constructor(r,e,i,n){super(r,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,n,s){[n,s].forEach((a,y)=>{const S=new g.LineDecoder;S.write(a).forEach(C=>{e({line:C,source:y===0?0:1})});const p=S.end();p&&e({line:p,source:y===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,n,s){const a=new g.LineDecoder,y=new g.LineDecoder;r.stdout.on("data",S=>{a.write(S).forEach(p=>i({line:p,source:0}))}),r.stderr.on("data",S=>{y.write(S).forEach(p=>i({line:p,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=y}handleClose(r,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=m;function w(o){let r=[],e=!1;const i=function(n){if(e){r.push(n);return}(!o.send(n,a=>{if(a&&console.error(a),e=!1,r.length>0){const y=r.slice(0);r=[],y.forEach(S=>i(S))}})||R.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=w;var h;(function(o){async function r(e,i,n){if(D.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),D.dirname(e)!=="."||(n===void 0&&d.isString(c.env.PATH)&&(n=c.env.PATH.split(D.delimiter)),n===void 0||n.length===0))return D.join(i,e);async function a(y){if(await I.Promises.exists(y)){let S;try{S=await I.Promises.stat(y)}catch(A){A.message.startsWith("EACCES")&&(S=await I.Promises.lstat(y))}return S?!S.isDirectory():!1}return!1}for(let y of n){let S;if(D.isAbsolute(y)?S=D.join(y,e):S=D.join(i,y,e),await a(S))return S;let A=S+".com";if(await a(A)||(A=S+".exe",await a(A)))return A}return D.join(i,e)}o.findExecutable=r})(h=t.win32||(t.win32={}))}),define(te[72],ie([0,1,34,9,65,49]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function D(E,l){return E===1?P.isWindows?I():L.getWindowsShell(l):d(E,l)}t.getSystemShell=D;function R(E,l){return E===1?P.isWindows?f(l):L.getWindowsShell(l):d(E,l)}t.getSystemShellSync=R;let c=null;function d(E,l){if(P.isLinux&&E===2||P.isMacintosh&&E===3)return"/bin/bash";if(!c){let u;if(P.isWindows)u="/bin/bash";else{if(u=l.SHELL,!u)try{u=(0,T.userInfo)().shell}catch(v){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}c=u}return c}let g=null;async function I(){return g||(g=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),g}function f(E){if(g)return g;const l=P.isWindows&&parseFloat((0,T.release)())>=10,u=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${E.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?v:L.getWindowsShell(E)}}),define(te[50],ie([0,1,35,3,17,25,60,11,13,2,18,9,49,39]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends E.ChannelServer{constructor(m){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch(h){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",w=>b.VSBuffer.wrap(Buffer.from(w,"base64")))},m);process.once("disconnect",()=>this.dispose())}}t.Server=l;class u{constructor(m,w){this.modulePath=m,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new P.Delayer(h),this.child=null,this._client=null}getChannel(m){const w=this;return{call(h,o,r){return w.requestPromise(m,h,o,r)},listen(h,o){return w.requestEvent(m,h,o)}}}requestPromise(m,w,h,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(m),e=(0,P.createCancelablePromise)(s=>r.call(w,h,s)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(m,w,h){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const r=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(m).listen(w,h)(r.fire,r),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&w.env&&delete w.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,m,w);const h=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(b.VSBuffer.wrap(Buffer.from(a,"base64")))});const r=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),i=h.event,n={send:e,onMessage:i};this._client=new E.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,y)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,d.dispose)(S)),this.activeRequests.clear(),a!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+y),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:y})})}return this._client}getCachedChannel(m){let w=this.channels.get(m);return w||(w=this.client.getChannel(m),this.channels.set(m,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(te[73],ie([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(te[74],ie([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(te[75],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(te[76],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(te[77],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(te[78],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(te[79],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(te[80],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(te[81],ie([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(te[82],ie([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(te[83],ie([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(te[84],ie([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(te[85],ie([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(te[86],ie([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(te[87],ie([0,1,69,46,8,4,29,19,7]),function($,t,T,P,b,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(l,u,v){this._args=l,this.paths=u,this.productService=v}get appRoot(){return(0,L.dirname)(b.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(c.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?c.URI.file((0,L.join)(l,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,L.resolve)(l):(0,L.normalize)((0,L.join)(b.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,L.resolve)(l):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,L.resolve)(l);const u=D.env.VSCODE_EXTENSIONS;if(u)return u;const v=D.env.VSCODE_PORTABLE;return v?(0,L.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?c.URI.parse(u):c.URI.file((0,L.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,L.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([P.memoize],d.prototype,"appRoot",null),fe([P.memoize],d.prototype,"userHome",null),fe([P.memoize],d.prototype,"userDataPath",null),fe([P.memoize],d.prototype,"appSettingsHome",null),fe([P.memoize],d.prototype,"tmpDir",null),fe([P.memoize],d.prototype,"userRoamingDataHome",null),fe([P.memoize],d.prototype,"settingsResource",null),fe([P.memoize],d.prototype,"userDataSyncHome",null),fe([P.memoize],d.prototype,"userDataSyncLogResource",null),fe([P.memoize],d.prototype,"sync",null),fe([P.memoize],d.prototype,"machineSettingsResource",null),fe([P.memoize],d.prototype,"globalStorageHome",null),fe([P.memoize],d.prototype,"workspaceStorageHome",null),fe([P.memoize],d.prototype,"keybindingsResource",null),fe([P.memoize],d.prototype,"keyboardLayoutResource",null),fe([P.memoize],d.prototype,"argvResource",null),fe([P.memoize],d.prototype,"snippetsHome",null),fe([P.memoize],d.prototype,"isExtensionDevelopment",null),fe([P.memoize],d.prototype,"untitledWorkspacesHome",null),fe([P.memoize],d.prototype,"installSourcePath",null),fe([P.memoize],d.prototype,"builtinExtensionsPath",null),fe([P.memoize],d.prototype,"extensionsPath",null),fe([P.memoize],d.prototype,"extensionDevelopmentLocationURI",null),fe([P.memoize],d.prototype,"extensionDevelopmentKind",null),fe([P.memoize],d.prototype,"extensionTestsLocationURI",null),fe([P.memoize],d.prototype,"debugExtensionHost",null),fe([P.memoize],d.prototype,"serviceMachineIdResource",null),fe([P.memoize],d.prototype,"telemetryLogResource",null),fe([P.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function g(E,l){return f(E["inspect-extensions"],E["inspect-brk-extensions"],5870,l,E.debugId)}t.parseExtensionHostPort=g;function I(E,l){return f(E["inspect-search"],E["inspect-brk-search"],5876,l)}t.parseSearchPort=I;function f(E,l,u,v,m){const h=Number(l||E)||(v?null:u),o=h?Boolean(!!l):!1;return{port:h,break:o,debugId:m}}}),function(){"use strict";function $(t,T,P,b){function L(R){const c=D(R),d=[c];return t.isAbsolute(c)||d.unshift(b),t.resolve(...d)}function D(R){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,P);const g=R["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(I,"AppData","Roaming")}break;case"darwin":d=t.join(T.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,P)}return{getUserDataPath:L}}if(typeof define=="function")define(te[88],ie([0,89,34,8,19,29]),function(t,T,P,b,L,D){const R=L.dirname(b.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(L.joinPath(R,"package.json").fsPath);return $(T,P,c.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=$(T,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[90],ie([0,1,34,87,88]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends P.AbstractNativeEnvironmentService{constructor(R,c){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,b.getUserDataPath)(R)},c)}}t.NativeEnvironmentService=L}),define(te[91],ie([0,1,18]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function b(L,D){const R=c=>{if(typeof c!="string")return;const d=P.exec(c);if(!d)return;const g=D[d[1]]??c;return typeof g=="string"?g:typeof g.message=="string"?g.message:c};return(0,T.cloneAndChange)(L,R)}t.localizeManifest=b}),define(te[51],ie([0,1,81]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||P.test(f)}t.isValidVersionStr=L;function D(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=f.match(P);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}t.parseVersion=D;function R(f){if(!f)return null;let E=f.majorBase,l=f.majorMustEqual,u=f.minorBase,v=f.minorMustEqual,m=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(E===0||(v=!1),w=!1);let h=0;if(f.preRelease){const o=b.exec(f.preRelease);if(o){const[,r,e,i]=o;h=Date.UTC(Number(r),Number(e)-1,Number(i))}}return{majorBase:E,majorMustEqual:l,minorBase:u,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:h}}t.normalizeVersion=R;function c(f,E,l){let u;typeof f=="string"?u=R(D(f)):u=f;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let m;if(typeof l=="string"?m=R(D(l)):m=l,!u||!m)return!1;let w=u.majorBase,h=u.minorBase,o=u.patchBase,r=m.majorBase,e=m.minorBase,i=m.patchBase,n=m.notBefore,s=m.majorMustEqual,a=m.minorMustEqual,y=m.patchMustEqual;return m.isMinimum?w>r?!0:w<r?!1:h>e?!0:h<e||v&&v<n?!1:o>=i:(w===1&&r===0&&(!s||!a||!y)&&(r=1,e=0,i=0,s=!0,a=!1,y=!1),w<r?!1:w>r?!s:h<e?!1:h>e?!a:o<i?!1:o>i?!y:!(v&&v<n))}t.isValidVersion=c;function d(f,E,l,u){return l.isBuiltin||typeof l.main=="undefined"?!0:I(f,E,l.engines.vscode,u)}t.isValidExtensionVersion=d;function g(f,E,l){return f==="*"||I(E,l,f)}t.isEngineValid=g;function I(f,E,l,u=[]){let v=R(D(l));if(!v)return u.push(T.localize(0,null,l)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return u.push(T.localize(1,null,l)),!1}else if(!v.majorMustEqual)return u.push(T.localize(2,null,l)),!1;return c(f,E,v)?!0:(u.push(T.localize(3,null,f,l)),!1)}}),define(te[92],ie([0,1,2,8,39,50]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends T.Disposable{constructor(c,d,g,I){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new L.Client(P.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=b.ProxyChannel.toService((0,b.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(te[93],ie([0,1,2,8,39,50]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends T.Disposable{constructor(c,d,g,I,f={}){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=I,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new L.Client(P.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=b.ProxyChannel.toService((0,b.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(te[94],ie([0,1,35,62,8,48]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class D{constructor(c,d,g,I,f){this.watchedFolder=c,this.eventCallback=g,this.logCallback=I,this.verboseLogging=f,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(E=>(0,P.parse)(E)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,T.spawn)(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const d=new L.LineDecoder;this.handle.stdout.on("data",g=>{const I=[];for(const f of d.write(g)){const E=f.split("|");if(E.length===2){const l=Number(E[0]),u=E[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(v=>v(u))){this.verboseLogging&&this.log(u);continue}I.push({type:D.changeTypeMap[l],path:u})}else this.log(E[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",g=>this.onError(g)),this.handle.stderr.on("data",g=>this.onError(g)),this.handle.on("exit",(g,I)=>this.onExit(g,I))}onError(c){this.error("process error: "+c.toString())}onExit(c,d){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${d})`),this.restartCounter<=D.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=D,D.MAX_RESTARTS=5,D.changeTypeMap=[0,1,2]}),define(te[95],ie([0,1,4,21,94]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(R,c,d,g){this.onDidFilesChange=c,this.onLogMessage=d,this.verboseLogging=g,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new b.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(te[52],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(b,L=[],D=!1){this.ctor=b,this.staticArguments=L,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=T}),define(te[96],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=T;class P{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let D of this._nodes.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const R=this.lookupOrInsertNode(L),c=this.lookupOrInsertNode(D);R.outgoing.set(this._hashFn(D),c),c.incoming.set(this._hashFn(L),R)}removeNode(L){const D=this._hashFn(L);this._nodes.delete(D);for(let R of this._nodes.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(L){const D=this._hashFn(L);let R=this._nodes.get(D);return R||(R=new T(L),this._nodes.set(D,R)),R}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[D,R]of this._nodes)L.push(`${D}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,D]of this._nodes){const R=new Set([L]),c=this._findCycle(D,R);if(c)return c}}_findCycle(L,D){for(let[R,c]of L.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const d=this._findCycle(c,D);if(d)return d;D.delete(R)}}}t.Graph=P}),define(te[53],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(te[20],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(te[23],ie([0,1,8,9,29,76,15]),function($,t,T,P,b,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.CURRENT_TARGET_PLATFORM=t.getTargetPlatform=t.getTargetPlatformFromOS=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function c(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=c;function d(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=d;function g(o,r){let e;switch(o){case 1:e=3;break;case 3:e=2;break;case 2:e=1;break}return I(e,r)}t.getTargetPlatformFromOS=g;function I(o,r){switch(o){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=I,t.CURRENT_TARGET_PLATFORM=P.isWeb?"web":I(P.platform,b.arch);function f(o,r){return r==="web"&&!o.includes("web")}t.isNotWebExtensionInWebTargetPlatform=f;function E(o,r,e){if(f(r,e))return!1;if(o==="undefined"||o==="universal")return!0;if(o==="unknown")return!1;if(o===e)return!0;switch(e){case"win32-x64":return o==="win32-ia32";case"win32-arm64":return o==="win32-ia32";default:return!1}}t.isTargetPlatformCompatible=E;function l(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}t.isIExtensionIdentifier=l;var u;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=5]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(u=t.SortBy||(t.SortBy={}));var v;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(v=t.SortOrder||(t.SortOrder={}));var m;(function(o){o.Install="install",o.Uninstall="uninstall"})(m=t.StatisticType||(t.StatisticType={}));var w;(function(o){o[o.None=0]="None",o[o.Install=1]="Install",o[o.Update=2]="Update"})(w=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class h extends Error{constructor(r,e){super(r);this.code=e,this.name=e}}t.ExtensionManagementError=h,t.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,L.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,L.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(te[40],ie([0,1,21,15]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=b;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(D=t.ExtensionType||(t.ExtensionType={}));class R{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,f){if(typeof I=="undefined"||I===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof I=="string"||typeof f=="string"){let E=typeof I=="string"?I:I.value,l=typeof f=="string"?f:f.value;return T.equalsIgnoreCase(E,l)}return I._lower===f._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=R;function c(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function d(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[24],ie([0,1,21,40]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(l,u){return l.uuid&&u.uuid?l.uuid===u.uuid:l.id===u.id?!0:(0,T.compareIgnoreCase)(l.id,u.id)===0}t.areSameExtensions=b;class L{constructor(u,v){this.version=v,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof L?b(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=L;function D(l,u){return`${l}.${u}`}t.getExtensionId=D;function R(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function c(l,u){return R(D(l,u))}t.getGalleryExtensionId=c;function d(l,u){const v=[],m=w=>{for(const h of v)if(h.some(o=>b(u(o),u(w))))return h;return null};for(const w of l){const h=m(w);h?h.push(w):v.push([w])}return v}t.groupByExtension=d;function g(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=g;function I(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function f(l){const u=new Set;for(const v of l)v.malicious&&u.add(v.id.id);return u}t.getMaliciousExtensionsSet=f;function E(l,u){const v=[],m=u.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(h=>!b(h.identifier,{id:w}))){const h=l.filter(o=>b(o.identifier,{id:w}));h.length===1&&(v.push(h[0]),m.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=E});var ae=this&&this.__param||function($,t){return function(T,P){t(T,P,$)}};define(te[97],ie([0,1,25,11,63,8,41,7,77,23,24,40]),function($,t,T,P,b,L,D,R,c,d,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const f=w=>(0,c.localize)(0,null,w),E=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(w,h){return h?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(w){const h=u.exec(w);return h&&h[1]?[(0,g.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,g.adoptToGalleryExtensionId)(w),void 0]}t.getIdAndVersion=v;let m=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=I.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(y=>y.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){r.log("Possible Categories: "),i.forEach(s=>{r.log(s)});return}this.location&&r.log((0,c.localize)(2,null,this.location)),e=e.sort((s,a)=>s.identifier.id.localeCompare(a.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,r.log(l(s.manifest,h)))}async installExtensions(h,o,r,e,i=console){const n=[],s=[];h.length&&i.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),y=(p,C)=>{const N=a.find(V=>(0,g.areSameExtensions)(V.identifier,{id:p}));if(N){if(!C&&!e)return i.log((0,c.localize)(5,null,p,N.manifest.version,p)),!1;if(C&&N.manifest.version===C)return i.log((0,c.localize)(6,null,`${p}@${C}`)),!1}return!0},S=[],A=[];for(const p of h)if(p instanceof R.URI)S.push(p);else{const[C,N]=v(p);y(C,N)&&A.push({id:C,version:N,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const p of o){const[C,N]=v(p);y(C,N)&&A.push({id:C,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(S.length&&await Promise.all(S.map(async p=>{try{const C=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:r},e,i);C&&s.push(C)}catch(C){i.error(C.message||C.stack||C),n.push(p.toString())}})),A.length){const p=await this.getGalleryExtensions(A);await Promise.all(A.map(async C=>{const N=p.get(C.id.toLowerCase());if(N)try{const V=await this.installFromGallery(C,N,a,e,i);V&&s.push(V)}catch(V){i.error(V.message||V.stack||V),n.push(C.id)}else i.error(`${f(C.version?`${C.id}@${C.version}`:C.id)}
${E}`),n.push(C.id)}))}if(n.length)throw new Error((0,c.localize)(7,null,n.join(", ")))}async installVSIX(h,o,r,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(h,o),e.log((0,c.localize)(8,null,(0,b.getBaseLabel)(h))),i}catch(s){if((0,P.isPromiseCanceledError)(s))return e.log((0,c.localize)(9,null,(0,b.getBaseLabel)(h))),null;throw s}return null}async getGalleryExtensions(h){const o=new Map,r=await this.extensionGalleryService.getExtensions(h,T.CancellationToken.None);for(const e of r)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:r},e,i,n,s){const a=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(a&&!this.validateExtensionKind(a,s))return null;const y=i.find(S=>(0,g.areSameExtensions)(S.identifier,e.identifier));if(y){if(e.version===y.manifest.version)return s.log((0,c.localize)(10,null,o?`${h}@${o}`:h)),null;s.log((0,c.localize)(11,null,h,e.version))}try{return r.isBuiltin?s.log(o?(0,c.localize)(12,null,h,o):(0,c.localize)(13,null,h)):s.log(o?(0,c.localize)(14,null,h,o):(0,c.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...r,installGivenVersion:!!o}),s.log((0,c.localize)(16,null,h,e.version)),a}catch(S){if((0,P.isPromiseCanceledError)(S))return s.log((0,c.localize)(17,null,h)),null;throw S}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,r){const e={id:(0,g.getGalleryExtensionId)(h.publisher,h.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,g.areSameExtensions)(e,s.identifier)&&(0,D.gt)(s.manifest.version,h.version));return n&&!o?(r.log((0,c.localize)(18,null,n.identifier.id,n.manifest.version,h.version)),!1):this.validateExtensionKind(h,r)}async uninstallExtensions(h,o,r=console){const e=async n=>{if(n instanceof R.URI){const s=await this.extensionManagementService.getManifest(n);return l(s)}return n},i=[];for(const n of h){const s=await e(n),y=(await this.extensionManagementService.getInstalled()).filter(S=>(0,g.areSameExtensions)(S.identifier,{id:s}));if(!y.length)throw new Error(`${this.notInstalled(s)}
${E}`);if(y.some(S=>S.type===0)){r.log((0,c.localize)(19,null,s));return}if(!o&&y.some(S=>S.isBuiltin)){r.log((0,c.localize)(20,null,s));return}r.log((0,c.localize)(21,null,s));for(const S of y)await this.extensionManagementService.uninstall(S),i.push(S);this.location?r.log((0,c.localize)(22,null,s,this.location)):r.log((0,c.localize)(23,null,s))}}async locateExtension(h,o=console){const r=await this.extensionManagementService.getInstalled();h.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===L.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,c.localize)(24,null,h,this.location):(0,c.localize)(25,null,h)}};m=fe([ae(0,d.IExtensionManagementService),ae(1,d.IExtensionGalleryService)],m),t.ExtensionManagementCLIService=m}),define(te[98],ie([0,1,2,4,10,40]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends T.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(d.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=D}),define(te[99],ie([0,1,35,89,25,28,11,9,30,72,129]),function($,t,T,P,b,L,D,R,c,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function I(l,u,v){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(v)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(v)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async m=>{const w=new b.CancellationTokenSource,h=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),w.dispose(!0),m({})},1e4);try{const o=await E(l,w.token);m(o)}catch(o){(0,D.isPromiseCanceledError)(o)||l.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),m({})}finally{clearTimeout(h),w.dispose()}})),f)}t.resolveShellEnv=I;let f;async function E(l,u){const v=new Promise(async(m,w)=>{const h=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",o);const r=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(r+"(.*)"+r),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",i);const n=await(0,d.getSystemShell)(R.OS,i);if(l.trace("getUnixShellEnvironment#shell",n),u.isCancellationRequested)return w(D.canceled);const s=P.basename(n);let a,y;/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' -p '''${r}'' + JSON.stringify(process.env) + ''${r}'''`,y=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,y=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),a);const S=(0,T.spawn)(n,[...y,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});u.onCancellationRequested(()=>(S.kill(),w(D.canceled))),S.on("error",C=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(C)),m({})});const A=[];S.stdout.on("data",C=>A.push(C));const p=[];S.stderr.on("data",C=>p.push(C)),S.on("close",(C,N)=>{const V=Buffer.concat(A).toString("utf8");l.trace("getUnixShellEnvironment#raw",V);const J=Buffer.concat(p).toString("utf8");if(J.trim()&&l.trace("getUnixShellEnvironment#stderr",J),C||N)return w(new Error(`Failed to get environment (code ${C}, signal ${N})`));const ne=e.exec(V),se=ne?ne[1]:"{}";try{const ee=JSON.parse(se);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ee),m(ee)}catch(ee){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ee)),w(ee)}})});try{return await v}catch(m){return l.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(m)),{}}}}),define(te[54],ie([0,1,9,7,16]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(c){return c.map(d=>({type:d.type,resource:P.URI.file(d.path)}))}t.toFileChanges=L;function D(c){const d=new R;for(const g of c)d.processEvent(g);return d.normalize()}t.normalizeFileChanges=D;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const g=this.mapPathToChange.get(d.path);if(g){const I=g.type,f=d.type;I===1&&f===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(g),1)):I===2&&f===1?g.type=0:I===1&&f===0||(g.type=f)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],g=[];return this.normalized.filter(I=>I.type!==2?(d.push(I),!1):!0).sort((I,f)=>I.path.length-f.path.length).filter(I=>g.some(f=>(0,b.isParent)(I.path,f,!T.isLinux))?!1:(g.push(I.path),!0)).concat(d)}}}),define(te[100],ie([0,1,3,2,4,64,10,66,54]),function($,t,T,P,b,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends P.Disposable{constructor(I,f,E,l){super();this.path=I,this.onDidFilesChange=f,this.onLogMessage=E,this.verboseLogging=l,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:f}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(f)try{E=await(0,L.realpath)(E)}catch(l){if(this.onError(l),f.dangling)return}I.isDirectory()?this._register((0,R.watchFolder)(E,(l,u)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(u))})},l=>this.onError(l))):this._register((0,R.watchFile)(E,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,c.normalizeFileChanges)(f);if(this.verboseLogging)for(const l of E)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(te[55],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...b){this._entries=new Map;for(let[L,D]of b)this.set(L,D)}set(b,L){const D=this._entries.get(b);return this._entries.set(b,L),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=T}),define(te[101],ie([0,1,3,11,52,96,15,55]),function($,t,T,P,b,L,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class g{constructor(l=new R.ServiceCollection,u=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=u,this._parent=v,this._services.set(D.IInstantiationService,this)}createChild(l){return new g(l,this._strict,this)}invokeFunction(l,...u){let v=f.traceInvocation(l),m=!1;try{return l({get:(h,o)=>{if(m)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(h,v);if(!r&&o!==D.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return r}},...u)}finally{m=!0,v.stop()}}createInstance(l,...u){let v,m;return l instanceof b.SyncDescriptor?(v=f.traceCreation(l.ctor),m=this._createInstance(l.ctor,l.staticArguments.concat(u),v)):(v=f.traceCreation(l),m=this._createInstance(l,u,v)),v.stop(),m}_createInstance(l,u=[],v){let m=D._util.getServiceDependencies(l).sort((o,r)=>o.index-r.index),w=[];for(const o of m){let r=this._getOrCreateServiceInstance(o.id,v);if(!r&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);w.push(r)}let h=m.length>0?m[0].index:u.length;if(u.length!==h){console.warn(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${u.length} static arguments`);let o=h-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,h)}return new l(...[...u,...w])}_setServiceInstance(l,u){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,u);else if(this._parent)this._parent._setServiceInstance(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let u=this._services.get(l);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):u}_getOrCreateServiceInstance(l,u){let v=this._getServiceInstanceOrDescriptor(l);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,u.branch(l,!0)):(u.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,u,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,u,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,u,v){const m=new L.Graph(o=>o.id.toString());let w=0;const h=[{id:l,desc:u,_trace:v}];for(;h.length;){const o=h.pop();if(m.lookupOrInsertNode(o),w++>1e3)throw new d(m);for(let r of D._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${l} depends on ${r.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const i={id:r.id,desc:e,_trace:o._trace.branch(r.id,!0)};m.insertEdge(o,i),h.push(i)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new d(m);break}for(const{data:r}of o){if(this._getServiceInstanceOrDescriptor(r.id)instanceof b.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}m.removeNode(r)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,u,v=[],m,w){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(u,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,u,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(l,u=[],v,m){if(v){const w=new T.IdleValue(()=>this._createInstance(l,u,m));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let r=w.value,e=r[o];return typeof e!="function"||(e=e.bind(r),h[o]=e),e},set(h,o,r){return w.value[o]=r,!0}})}else return this._createInstance(l,u,m)}}t.InstantiationService=g;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class f{constructor(l,u){this.type=l,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return c?new f(0,l.name):f._None}branch(l,u){let v=new f(2,l.toString());return this._dep.push([l,u,v]),v}stop(){let l=Date.now()-this._start;f._totals+=l;let u=!1;function v(w,h){let o=[],r=new Array(w+1).join("	");for(const[e,i,n]of h._dep)if(i&&n){u=!0,o.push(`${r}CREATES -> ${e}`);let s=v(w+1,n);s&&o.push(s)}else o.push(`${r}uses -> ${e}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||u)&&console.log(m.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[56],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const L of b.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=P}),define(te[14],ie([0,1,28,13,2,9,15]),function($,t,T,P,b,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,D.createDecorator)("logService"),t.ILoggerService=(0,D.createDecorator)("loggerService");function R(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class d extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class g extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=g;class I extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!L.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,e,...i):console.warn(`[main ${R()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class f extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=f;class E extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=E;class l extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class u extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=u;class v extends b.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=v;class m{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=m;function w(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=h(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=w;function h(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=h;function o(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(te[102],ie([0,1,3,11,2,9,19,41,7,30,10,20,23,24,16,14]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends b.Disposable{constructor(h,o,r,e){super();this.fileService=o,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=c.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const r=this.getName(h),e=(0,D.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(h){}async rename(h,o,r){try{await g.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(L.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],r=[];for(const n of h.children){const s=this.parse(n.name);s&&r.push([s,n])}const e=(0,E.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((s,a)=>R.rcompare(s[0].version,a[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new E.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(h){const o=v.exec(h);return o&&o[1]&&o[2]?new E.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};m=fe([ae(0,I.INativeEnvironmentService),ae(1,l.IFileService),ae(2,f.IExtensionGalleryService),ae(3,u.ILogService)],m),t.ExtensionsDownloader=m}),define(te[103],ie([0,1,35,3,28,13,2,8,4,10,20,14]),function($,t,T,P,b,L,D,R,c,d,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let f=class extends D.Disposable{constructor(l,u){super();this.environmentService=l,this.logService=u,this.processesLimiter=new P.Limiter(5)}async postUninstall(l){const u=this.parseScript(l,"uninstall");return u&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${v}`)))),d.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(l,u){const v=`vscode:${u}`;if(l.location.scheme===R.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const m=l.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(l,u,v,m,w){return new Promise((h,o)=>{const r=this.start(l,u,v,w);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):h(void 0)};r.on("error",n=>{i((0,b.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,s)=>{i(n?`post-${u} process exited with code ${n}`:void 0)}),m&&(e=setTimeout(()=>{e=null,r.kill(),o("timed out")},5e3))})}start(l,u,v,m){const w={silent:!0,execArgv:void 0},h=(0,T.fork)(l,[`--type=extension-post-${u}`,...v],w);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=L.Event.fromNodeEventEmitter(h.stdout,"data"),r=L.Event.fromNodeEventEmitter(h.stderr,"data");o(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${u}`,n)),r(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${u}`,n));const e=L.Event.any(L.Event.map(o,n=>({data:`%c${n}`,format:[""]})),L.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};f=fe([ae(0,g.IEnvironmentService),ae(1,I.ILogService)],f),t.ExtensionsLifecycle=f}),define(te[104],ie([0,1,13,2,19,7,20,24,16,14]),function($,t,T,P,b,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let g=class extends P.Disposable{constructor(f,E,l,u){super();this.extensionsManagementService=f,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const v=L.URI.file(l.extensionsPath),m=new b.ExtUri(w=>!E.hasCapability(w,1024));this._register(E.watch(v)),this._register(T.Event.filter(E.onDidChangeFilesRaw,w=>w.changes.some(h=>this.doesChangeAffects(h,v,m)))(()=>this.onDidChange()))}doesChangeAffects(f,E,l){return l.isEqual(l.dirname(f.resource),E)?l.isEqual(f.resource,l.joinPath(E,".obsolete"))?!0:!(f.type!==1&&f.type!==2||l.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const E of f)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(E=>!(0,R.areSameExtensions)(E,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,R.areSameExtensions)(E,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),E=f.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,R.areSameExtensions)(v,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),l=this.installedExtensions.filter(u=>this.installingExtensions.some(v=>(0,R.areSameExtensions)(v,u))?!1:f.every(v=>!(0,R.areSameExtensions)(v.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=f.map(u=>u.identifier),(E.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:l})}}};g=fe([ae(1,c.IFileService),ae(2,D.INativeEnvironmentService),ae(3,d.ILogService)],g),t.ExtensionsWatcher=g}),define(te[105],ie([0,1,130,22,3,2,8,4,10,20,23,24,56,14]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends L.Disposable{constructor(m,w,h){super();this.extensionManagementService=m,this.logService=h,this.cache=this._register(new u(w,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,P.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(h=>w[h]&&w[h].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(w);return!(0,P.equals)(Object.keys(m),Object.keys(h))}};l=fe([ae(0,g.IExtensionManagementService),ae(1,d.INativeEnvironmentService),ae(2,E.ILogService)],l),t.LocalizationsService=l;let u=class extends L.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(h=>delete w[h]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const h of w)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,h);Object.keys(m).forEach(h=>this.updateHash(m[h]))}createLanguagePacksFromExtension(m,w){const h=w.identifier,o=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const r of o)if(w.location.scheme===D.Schemas.file&&(0,f.isValidLocalization)(r)){let e=m[r.languageId];e||(e={hash:"",extensions:[],translations:{}},m[r.languageId]=e);let i=e.extensions.filter(n=>(0,I.areSameExtensions)(n.extensionIdentifier,h))[0];i?i.version=w.manifest.version:e.extensions.push({extensionIdentifier:h,version:w.manifest.version});for(const n of r.translations)e.translations[n.id]=(0,R.join)(w.location.fsPath,n.path)}}updateHash(m){if(m){const w=(0,T.createHash)("md5");for(const h of m.extensions)w.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(w=m(h),h)).then(h=>{for(const r of Object.keys(h))h[r]||delete h[r];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>w,h=>this.logService.error(h))})}};u=fe([ae(0,d.INativeEnvironmentService),ae(1,E.ILogService)],u)}),define(te[106],ie([0,1,16,14]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(c,d,g,I){try{const f=await new Promise((E,l)=>{$(["spdlog"],E,l)});return f.setFlushOn(P.LogLevel.Trace),f.createAsyncRotatingLogger(c,d,g,I)}catch(f){console.error(f)}return null}function L(c,d,g,I){const f=$.__$__nodeRequire("spdlog");return f.setFlushOn(P.LogLevel.Trace),f.createRotatingLogger(c,d,g,I)}t.createRotatingLogger=L;function D(c,d,g){switch(d){case P.LogLevel.Trace:c.trace(g);break;case P.LogLevel.Debug:c.debug(g);break;case P.LogLevel.Info:c.info(g);break;case P.LogLevel.Warning:c.warn(g);break;case P.LogLevel.Error:c.error(g);break;case P.LogLevel.Critical:c.critical(g);break;default:throw new Error("Invalid log level")}}class R extends P.AbstractMessageLogger{constructor(d,g,I,f){super();this.name=d,this.filepath=g,this.rotating=I,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}_createSpdLogLogger(){const d=this.rotating?6:1,g=30/d*T.ByteSize.MB;return b(this.name,this.filepath,g,d).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:f,message:E}of this.buffer)D(this._logger,f,E);this.buffer=[]}})}log(d,g){this._logger?D(this._logger,d,g):this.getLevel()<=d&&this.buffer.push({level:d,message:g})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(te[57],ie([0,1,17,11,83,16,31]),function($,t,T,P,b,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function R(I,f,E,l,u,v){let m;try{await c(I,f,E,l,u,v)}catch(w){m=w}finally{m&&u.errorTransformer&&(m=u.errorTransformer(m)),typeof m!="undefined"&&E.error(m),E.end()}}t.readFileIntoStream=R;async function c(I,f,E,l,u,v){d(v);const m=await I.open(f,{create:!1});try{d(v);let w=0,h=0,o=u&&typeof u.length=="number"?u.length:void 0,r=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,i=0;do h=await I.read(m,e,r.buffer,i,r.byteLength-i),e+=h,i+=h,w+=h,typeof o=="number"&&(o-=h),i===r.byteLength&&(await E.write(l(r)),r=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&d(v)&&g(w,u));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),E.write(l(r.slice(0,n)))}}catch(w){throw(0,L.ensureFileSystemProviderError)(w)}finally{await I.close(m)}}function d(I){if(I.isCancellationRequested)throw(0,P.canceled)();return!0}function g(I,f){if(f?.limits){if(typeof f.limits.memory=="number"&&I>f.limits.memory)throw(0,L.createFileSystemProviderError)((0,b.localize)(0,null,D.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&I>f.limits.size)throw(0,L.createFileSystemProviderError)((0,b.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[107],ie([0,1,22,3,17,25,13,131,2,47,8,132,19,37,82,16,57,14]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u,v,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let w=class Ne extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new u.FileChangesEvent(r,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new u.FileChangesEvent(r,!0)))),this.watchedResources=d.TernarySearchTree.forUris(r=>{const e=this.getProvider(r.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r});const e=new c.DisposableStore;return e.add(r.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(r)))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(r)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return R.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!(0,f.isAbsolutePath)(o))throw new u.FileOperationError((0,l.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r)||(0,u.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,l.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=r?.resolveTo,s=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,y=await e.stat(o);let S;return this.toFileStat(e,o,y,void 0,!!a,(A,p)=>{if(!S&&(S=d.TernarySearchTree.forUris(()=>!i),S.set(o,!0),n))for(const C of n)S.set(C,!0);return S.get(A.resource)||S.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&s?p===1:!1})}async toFileStat(o,r,e,i,n,s){const{providerExtUri:a}=this.getExtUri(o),y={resource:r,name:a.basename(r),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(y.isDirectory&&s(y,i)){try{const S=await o.readdir(r),A=await P.Promises.settled(S.map(async([p,C])=>{try{const N=a.joinPath(r,p),V=n?await o.stat(N):{type:C};return await this.toFileStat(o,N,V,S.length,n,s)}catch(N){return this.logService.trace(N),null}}));y.children=(0,T.coalesce)(A)}catch(S){this.logService.trace(S),y.children=[]}return y}return y}async resolveAll(o){return P.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch(e){return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!r?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,l.localize)(3,null,this.resourceForError(o)),3,r)}async createFile(o,r=b.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,r);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,i)),i}async writeFile(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,u.hasReadWriteCapability)(i)&&!(r instanceof b.VSBuffer))if((0,E.isReadableStream)(r)){const y=await(0,E.peekStream)(r,3);y.ended?a=b.VSBuffer.concat(y.buffer):a=y}else a=(0,E.peekReadable)(r,y=>b.VSBuffer.concat(y),3);else a=r;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a)}catch(s){throw new u.FileOperationError((0,l.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(r)));let n;try{n=await o.stat(r)}catch(s){return}if((n.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,l.localize)(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:n.size}))throw new u.FileOperationError((0,l.localize)(7,null),3,e);return n}async readFile(o,r){const e=await this.withReadProvider(o);return r?.atomic?this.doReadFileAtomic(e,o,r):this.doReadFile(e,o,r)}async doReadFileAtomic(o,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,r,e);i(s)}catch(s){n(s)}})})}async doReadFile(o,r,e){const i=await this.doReadFileStream(o,r,{...e,preferUnbuffered:!0});return{...i,value:await(0,b.streamToBuffer)(i.value)}}async readFileStream(o,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,r)}async doReadFileStream(o,r,e){const i=new L.CancellationTokenSource,n=this.validateReadFile(r,e).then(a=>a,a=>{throw i.cancel(),a});let s;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await n,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?s=this.readFileUnbuffered(o,r,e):(0,u.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,r,i.token,e):s=this.readFileBuffered(o,r,i.token,e),{...await n,value:s}}catch(a){s&&await(0,E.consumeStream)(s);const y=(0,l.localize)(8,null,this.resourceForError(r),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(y,a.stat,e):new u.FileOperationError(y,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,r,e,i=Object.create(null)){const n=o.readFileStream(r,i,e);return(0,E.transform)(n,{data:s=>s instanceof b.VSBuffer?s:b.VSBuffer.wrap(s),error:s=>new u.FileOperationError((0,l.localize)(9,null,this.resourceForError(r),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),i)},s=>b.VSBuffer.concat(s))}readFileBuffered(o,r,e,i=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,r,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new u.FileOperationError((0,l.localize)(10,null,this.resourceForError(r),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),i)},e),n}readFileUnbuffered(o,r,e){const i=(0,E.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(r);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(b.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,l.localize)(11,null,this.resourceForError(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&r.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new u.FileOperationError((0,l.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,i){if(o.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,o,s,r,e,i)}catch(n){return n}return!0}async move(o,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"move",!!e),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,s==="move"?2:3,a)),a}async copy(o,r,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,o,n,r,"copy",!!e),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,s==="copy"?3:2,a)),a}async doMoveCopy(o,r,e,i,n,s){if(r.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(o,r,e,i,n,s);if(a&&!y&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(r,i,{overwrite:s});else{const S=await this.resolve(r);S.isDirectory?await this.doCopyFolder(o,S,e,i):await this.doCopyFile(o,r,e,i)}return n}else return o===e?(await o.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(o,r,e,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,i){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,r,e,i);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,r,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,r,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,r,e,i)}async doCopyFolder(o,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,s):this.doCopyFile(o,n.resource,e,s)}))}async doValidateMoveCopy(o,r,e,i,n,s){let a=!1;if(o===e){const{providerExtUri:S,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(a=S.isEqual(r,i)),a&&n==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&S.isEqualOrParent(i,r))throw new Error((0,l.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!a){if(!s)throw new u.FileOperationError((0,l.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(o===e){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(r,i))throw new Error((0,l.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(r,i.dirname(r));)try{if(((await o.stat(r)).type&u.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await o.mkdir(r)}catch(s){if((0,u.toFileSystemProviderErrorCode)(s)!==u.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!r?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new u.FileOperationError((0,l.localize)(20,null,this.resourceForError(o)),1);if(!!!r?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r),i=!!r?.useTrash,n=!!r?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,r){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!r))}if(i){const n=r?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,r={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,c.toDisposable)(()=>n())),this.doWatch(o,r).then(s=>{i?(0,c.dispose)(s):n=()=>(0,c.dispose)(s)},s=>this.logService.error(s))}return r.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,r){const e=await this.withProvider(o),i=this.toWatchKey(e,o,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,c.toDisposable)(()=>{n.count--,n.count===0&&((0,c.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,r,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(r,{create:!0,unlock:e?.unlock??!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(s){throw(0,u.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,r,e){let i=0,n;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const s=b.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,a)=>{(0,E.listenStream)(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(o,r,y,y.byteLength,i,0)}catch(S){return a(S)}i+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>a(y),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,r,e,i,n,s){let a=0;for(;a<i;)a+=await o.write(r,n+a,e.buffer,s+a,i-a)}async doWriteUnbuffered(o,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,r,e,i))}async doWriteUnbufferedQueued(o,r,e,i){let n;i instanceof b.VSBuffer?n=i:(0,E.isReadableStream)(i)?n=await(0,b.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?n=await(0,b.bufferedStreamToBuffer)(i):n=(0,b.readableToBuffer)(i),await o.writeFile(r,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,r,e,i))}async doPipeBufferedQueued(o,r,e,i){let n,s;try{n=await o.open(r,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,S=0,A=0;do A=await o.read(n,y,a.buffer,S,a.byteLength-S),await this.doWriteBuffer(e,s,a,A,y,S),y+=A,S+=A,S===a.byteLength&&(S=0);while(A>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await P.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,r,e,i))}async doPipeUnbufferedQueued(o,r,e,i){return e.writeFile(i,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,i))}async doPipeUnbufferedToBufferedQueued(o,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(r);await this.doWriteBuffer(e,n,b.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,u.ensureFileSystemProviderError)(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,r,e,i){const n=await(0,b.streamToBuffer)(this.readFileBuffered(o,r,L.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&2048)throw new u.FileOperationError((0,l.localize)(22,null,this.resourceForError(r)),6);return o}throwIfFileIsReadonly(o,r){if((r.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,l.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===g.Schemas.file?o.fsPath:o.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=fe([ae(0,m.ILogService)],w),t.FileService=w}),define(te[108],ie([0,1,22,3,17,13,33,2,4,9,19,37,10,84,16,57,100,92,93,54,95,14,31]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u,v,m,w,h,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends R.Disposable{constructor(s,a){super();this.logService=s,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:a,symbolicLink:y}=await f.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(a,y),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(s){try{const a=await f.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),y=[];return await Promise.all(a.map(async S=>{try{let A;S.isSymbolicLink()?A=(await this.stat((0,g.joinPath)(s,S.name))).type:A=this.toType(S),y.push([S.name,A])}catch(A){this.logService.trace(A)}})),y}catch(a){throw this.toFileSystemProviderError(a)}}toType(s,a){let y;return a?.dangling?y=l.FileType.Unknown:s.isFile()?y=l.FileType.File:s.isDirectory()?y=l.FileType.Directory:y=l.FileType.Unknown,a&&(y|=l.FileType.SymbolicLink),y}async readFile(s){try{const a=this.toFilePath(s);return await f.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(s,a,y){const S=(0,I.newWriteableStream)(A=>b.VSBuffer.concat(A.map(p=>b.VSBuffer.wrap(p))).buffer);return(0,u.readFileIntoStream)(this,s,S,A=>A.buffer,{...a,bufferSize:this.BUFFER_SIZE},y),S}async writeFile(s,a,y){let S;try{const A=this.toFilePath(s);if(!y.create||!y.overwrite){if(await f.Promises.exists(A)){if(!y.overwrite)throw(0,l.createFileSystemProviderError)((0,E.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!y.create)throw(0,l.createFileSystemProviderError)((0,E.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:y.unlock}),await this.write(S,0,a,0,a.byteLength)}catch(A){throw await this.toFileSystemProviderWriteError(s,A)}finally{typeof S=="number"&&await this.close(S)}}async open(s,a){try{const y=this.toFilePath(s);if((0,l.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await f.SymlinkSupport.stat(y);p.mode&128||await f.Promises.chmod(y,p.mode|128)}catch(p){this.logService.trace(p)}let S;if((0,l.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await f.Promises.truncate(y,0),S="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}S||(S="w")}else S="r";const A=await f.Promises.open(y,S);return this.mapHandleToPos.set(A,0),(0,l.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(A,s),A}catch(y){throw(0,l.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(s,y):this.toFileSystemProviderError(y)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await f.Promises.fdatasync(s)}catch(a){this.canFlush=!1,this.logService.error(a)}return await f.Promises.close(s)}catch(a){throw this.toFileSystemProviderError(a)}}async read(s,a,y,S,A){const p=this.normalizePos(s,a);let C=null;try{const N=await f.Promises.read(s,y,S,A,p);return typeof N=="number"?C=N:C=N.bytesRead,C}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(s,p,C)}}normalizePos(s,a){return a===this.mapHandleToPos.get(s)?null:a}updatePos(s,a,y){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof a=="number"||(typeof y=="number"?this.mapHandleToPos.set(s,S+y):this.mapHandleToPos.delete(s)))}async write(s,a,y,S,A){return(0,P.retry)(()=>this.doWrite(s,a,y,S,A),100,3)}async doWrite(s,a,y,S,A){const p=this.normalizePos(s,a);let C=null;try{const N=await f.Promises.write(s,y,S,A,p);return typeof N=="number"?C=N:C=N.bytesWritten,C}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),N)}finally{this.updatePos(s,p,C)}}async mkdir(s){try{await f.Promises.mkdir(this.toFilePath(s))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(s,a){try{const y=this.toFilePath(s);await this.doDelete(y,a)}catch(y){throw this.toFileSystemProviderError(y)}}async doDelete(s,a){a.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}async rename(s,a,y){const S=this.toFilePath(s),A=this.toFilePath(a);if(S!==A)try{await this.validateTargetDeleted(s,a,"move",y.overwrite),await f.Promises.move(S,A)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(2,null,(0,c.basename)(S),(0,c.basename)((0,c.dirname)(A)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(s,a,y){const S=this.toFilePath(s),A=this.toFilePath(a);if(S!==A)try{await this.validateTargetDeleted(s,a,"copy",y.overwrite),await f.Promises.copy(S,A,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(3,null,(0,c.basename)(S),(0,c.basename)((0,c.dirname)(A)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(s,a,y,S){const A=this.toFilePath(s),p=this.toFilePath(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,D.isEqual)(A,p,!0)),C&&y==="copy")throw(0,l.createFileSystemProviderError)((0,E.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!C&&await f.Promises.exists(p)){if(!S)throw(0,l.createFileSystemProviderError)((0,E.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(s,a){return a.recursive?this.watchRecursive(s,a.excludes):this.watchNonRecursive(s)}watchRecursive(s,a){const y={path:this.toFilePath(s),excludes:a},S=(0,T.insert)(this.recursiveFoldersToWatch,y);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof m.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,a;this.options?.watcher?.usePolling?(s=w.FileWatcher,a=this.options?.watcher):e.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?d.isWindows?s=o.FileWatcher:s=w.FileWatcher:s=m.FileWatcher,this.recursiveWatcher=new s(this.recursiveFoldersToWatch,y=>this._onDidChangeFile.fire((0,h.toFileChanges)(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===r.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===r.LogLevel.Trace)}))}}watchNonRecursive(s){const a=new v.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===r.LogLevel.Trace),y=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===r.LogLevel.Trace)});return(0,R.combinedDisposable)(a,y)}toFilePath(s){return(0,c.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof l.FileSystemProviderError)return s;let a;switch(s.code){case"ENOENT":a=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=l.FileSystemProviderErrorCode.NoPermissions;break;default:a=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(s,a)}async toFileSystemProviderWriteError(s,a){let y=this.toFileSystemProviderError(a);if(s&&y.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(y=(0,l.createFileSystemProviderError)(a,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return y}dispose(){super.dispose(),(0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,R.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(te[42],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(te[26],ie([0,1,58,12]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(D,R){T.ok(P.isString(D)),T.ok(P.isObject(R)),T.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,R)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}t.Registry=new b}),define(te[109],ie([0,1,13,26]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[b(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new L;P.Registry.add(t.Extensions.JSONContribution,D)}),define(te[32],ie([0,1,13,12,74,109,26]),function($,t,T,P,b,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var R;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(R=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=D.Registry.as(L.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,h=!0){this.registerConfigurations([w],h)}registerConfigurations(w,h=!0){const o=[];w.forEach(r=>{o.push(...this.validateAndRegisterProperties(r,h,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(w){const h=[],o=r=>{if(r.properties)for(const e in r.properties)h.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,r.properties[e]);r.allOf&&r.allOf.forEach(e=>o(e))};for(const r of w){o(r);const e=this.configurationContributors.indexOf(r);e!==-1&&this.configurationContributors.splice(e,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(w){const h=[],o=[];for(const r of w)for(const e in r)if(h.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...r[e]};const i={type:"object",default:this.defaultValues[e],description:b.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(f(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=r[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(w){const h=[];for(const o of w)for(const r in o)if(h.push(r),delete this.defaultValues[r],t.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const h of w)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,h=!0,o,r=3){r=P.isUndefinedOrNull(w.scope)?r:w.scope;let e=[],i=w.properties;if(i)for(let s in i){if(h&&u(s)){delete i[s];continue}const a=i[s];if(this.updatePropertyDefaultValue(s,a),t.OVERRIDE_PROPERTY_PATTERN.test(s)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?r:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!o?.restrictedConfigurations?.includes(s):a.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=w.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,h,o,r));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const h=o=>{let r=o.properties;if(r)for(const i in r)this.updateSchema(i,r[i]);let e=o.allOf;e&&e.forEach(h)};h(w)}updateSchema(w,h){switch(t.allSettings.properties[w]=h,h.scope){case 1:t.applicationSettings.properties[w]=h;break;case 2:t.machineSettings.properties[w]=h;break;case 6:t.machineOverridableSettings.properties[w]=h;break;case 3:t.windowSettings.properties[w]=h;break;case 4:t.resourceSettings.properties[w]=h;break;case 5:t.resourceSettings.properties[w]=h,this.resourceLanguageSettingsSchema.properties[w]=h;break}}removeFromSchema(w,h){switch(delete t.allSettings.properties[w],h.scope){case 1:delete t.applicationSettings.properties[w];break;case 2:delete t.machineSettings.properties[w];break;case 6:delete t.machineOverridableSettings.properties[w];break;case 3:delete t.windowSettings.properties[w];break;case 4:case 5:delete t.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const h=`[${w}]`,o={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),t.allSettings.properties[h]=o,t.applicationSettings.properties[h]=o,t.machineSettings.properties[h]=o,t.machineOverridableSettings.properties[h]=o,t.windowSettings.properties[h]=o,t.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,h){let o=this.defaultValues[w];P.isUndefined(o)&&(o=h.default),P.isUndefined(o)&&(o=E(h.type)),h.default=o}}const I="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function f(m){return m.substring(1,m.length-1)}t.overrideIdentifierFromKey=f;function E(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=E;const l=new g;D.Registry.add(t.Extensions.Configuration,l);function u(m){return m.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(m)?b.localize(5,null,m):l.getConfigurationProperties()[m]!==void 0?b.localize(6,null,m):null:b.localize(4,null)}t.validateProperty=u;function v(){const m=[],w=l.getConfigurationProperties();for(const h of Object.keys(w))m.push([h,w[h].scope]);return m.push(["launch",4]),m.push(["task",4]),m}t.getScopes=v}),define(te[27],ie([0,1,18,12,7,32,15,26]),function($,t,T,P,b,L,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof b.URI)}t.isConfigurationOverrides=c;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function g(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=g;function I(i,n){const s=n?i?n.keys.filter(N=>i.keys.indexOf(N)===-1):[...n.keys]:[],a=i?n?i.keys.filter(N=>n.keys.indexOf(N)===-1):[...i.keys]:[],y=[];if(n&&i){for(const N of i.keys)if(n.keys.indexOf(N)!==-1){const V=m(i.contents,N),J=m(n.contents,N);T.equals(V,J)||y.push(N)}}const S=[],A=N=>{const V={};for(const J of N)for(const ne of J.identifiers)V[r(ne)]=J;return V},p=n?A(n.overrides):{},C=i?A(i.overrides):{};if(Object.keys(p).length)for(const N of s){const V=p[N];V&&S.push([(0,L.overrideIdentifierFromKey)(N),V.keys])}if(Object.keys(C).length)for(const N of a){const V=C[N];V&&S.push([(0,L.overrideIdentifierFromKey)(N),V.keys])}if(Object.keys(p).length&&Object.keys(C).length)for(const N of y){const V=C[N],J=p[N];if(V&&J){const ne=I({contents:V.contents,keys:V.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});S.push([(0,L.overrideIdentifierFromKey)(N),[...ne.added,...ne.removed,...ne.updated]])}}return{added:s,removed:a,updated:y,overrides:S}}t.compare=I;function f(i,n){const s=[];for(const a of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const y={};for(const S in i[a])y[S]=i[a][S];s.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(y),contents:E(y,n)})}return s}t.toOverrides=f;function E(i,n){const s=Object.create(null);for(let a in i)l(s,a,i[a],n);return s}t.toValuesTree=E;function l(i,n,s,a){const y=n.split("."),S=y.pop();let A=i;for(let p=0;p<y.length;p++){let C=y[p],N=A[C];switch(typeof N){case"undefined":N=A[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${y.slice(0,p+1).join(".")} is ${JSON.stringify(N)}`);return}A=N}if(typeof A=="object"&&A!==null)try{A[S]=s}catch(p){a(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(A)}`)}else a(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(A)}`)}t.addToValueTree=l;function u(i,n){const s=n.split(".");v(i,s)}t.removeFromValueTree=u;function v(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const a=i[s];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[s])}}function m(i,n,s){function a(A,p){let C=A;for(const N of p){if(typeof C!="object"||C===null)return;C=C[N]}return C}const y=n.split("."),S=a(i,y);return typeof S=="undefined"?s:S}t.getConfigurationValue=m;function w(i,n,s){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?P.isObject(i[a])&&P.isObject(n[a])?w(i[a],n[a],s):s&&(i[a]=n[a]):i[a]=n[a])})}t.merge=w;function h(){const i=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),n=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let s in n){let a=n[s].default;l(i,s,a,y=>console.error(`Conflict in default settings: ${y}`))}return i}t.getDefaultValues=o;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,s){const a=i.inspect(n),y=i.inspect(s);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:a.defaultValue}t.getMigratedSettingValue=e}),define(te[110],ie([0,1,22,13,59,2,47,18,12,7,27,32,26]),function($,t,T,P,b,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class E{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,g.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[s],y=i[s];y&&(typeof a=="object"&&typeof y=="object"?(a=R.deepClone(a),this.mergeContents(a,y)):a=y),n[s]=a}return new E(n,this.keys,this.overrides)}merge(...e){const i=R.deepClone(this.contents),n=R.deepClone(this.overrides),s=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const y of a.overrides){const[S]=n.filter(A=>T.equals(A.identifiers,y.identifiers));S?this.mergeContents(S.contents,y.contents):n.push(R.deepClone(y))}for(const y of a.keys)s.indexOf(y)===-1&&s.push(y)}return new E(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&c.isObject(e[n])&&c.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=R.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?R.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,g.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=E;class l extends E{constructor(){const e=(0,g.getDefaultValues)(),i=(0,g.getConfigurationKeys)(),n=[];for(const s of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,I.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(e[s]),contents:(0,g.toValuesTree)(e[s],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=l;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!c.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:a,restricted:y}=this.doParseRaw(e,i);this._configurationModel=new E(n,s,a),this._restrictedConfigurations=y||[]}doParseContent(e){let i={},n=null,s=[],a=[],y=[];function S(p){Array.isArray(s)?s.push(p):n!==null&&(s[n]=p)}let A={onObjectBegin:()=>{let p={};S(p),a.push(s),s=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let p=[];S(p),a.push(s),s=p,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:S,onError:(p,C,N)=>{y.push({error:p,offset:C,length:N})}};if(e)try{b.visit(e,A),i=s[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const n=f.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const a=(0,g.toValuesTree)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),y=Object.keys(e),S=(0,g.toOverrides)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:a,keys:y,overrides:S,restricted:s.restricted}}filter(e,i,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:e,restricted:[]};const a={},y=[];for(let S in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(S)&&n){const A=this.filter(e[S],i,!1,s);a[S]=A.raw,y.push(...A.restricted)}else{const A=i[S],p=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&y.push(S),(p===void 0||s.scopes===void 0||s.scopes.includes(p))&&(s.skipRestricted&&A?.restricted||(a[S]=e[S]))}return{raw:a,restricted:y}}}t.ConfigurationModelParser=u;class v extends L.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class m{constructor(e,i,n=new E,s=new E,a=new D.ResourceMap,y=new E,S=new D.ResourceMap,A=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=y,this._memoryConfigurationByResource=S,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new E,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,V=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,J=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(e):y.getValue(e),ne=s.getValue(e),se=T.distinct(T.flatten(s.overrides.map(ee=>ee.identifiers))).filter(ee=>s.getOverrideValue(e,ee)!==void 0);return{defaultValue:S,userValue:A,userLocalValue:p,userRemoteValue:C,workspaceValue:N,workspaceFolderValue:V,memoryValue:J,value:ne,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:V!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:y.getValue(e),override:i.overrideIdentifier?y.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>I.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const a=(0,I.overrideIdentifierFromKey)(s),y=this._defaultConfiguration.getKeysForOverrideIdentifier(a),S=e.getKeysForOverrideIdentifier(a),A=[...S.filter(p=>y.indexOf(p)===-1),...y.filter(p=>S.indexOf(p)===-1),...y.filter(p=>!R.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,A]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=(0,g.compare)(this.localUserConfiguration,e),y=[...i,...n,...s];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=(0,g.compare)(this.remoteUserConfiguration,e);let y=[...i,...n,...s];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=(0,g.compare)(this.workspaceConfiguration,e);let y=[...i,...n,...s];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:a,removed:y,overrides:S}=(0,g.compare)(n,i);let A=[...s,...a,...y];return(A.length||!n)&&this.updateFolderConfiguration(e,i),{keys:A,overrides:S}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:a,overrides:y}=(0,g.compare)(i,void 0);return{keys:[...n,...s,...a],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((y,S)=>(y.set(d.URI.revive(S[0]),this.parseConfigurationModel(S[1])),y),new D.ResourceMap);return new m(i,n,new E,s,a,new E,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=m;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const s of r)s.keys.forEach(a=>e.add(a)),s.overrides.forEach(([a,y])=>{const S=(0,D.getOrSet)(i,a,new Set);y.forEach(A=>S.add(A))});const n=[];return i.forEach((s,a)=>n.push([a,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=w;class h{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(S=>a.add(S)),e.overrides.forEach(([,S])=>S.forEach(A=>a.add(A))),this.affectedKeys=[...a.values()];const y=new E;this.affectedKeys.forEach(S=>y.setValue(S,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!R.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,g.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=o}),define(te[111],ie([0,1,3,13,2,19,27,110,32,26]),function($,t,T,P,b,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class g extends b.Disposable{constructor(f,E){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,E)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,E){const l=typeof f=="string"?f:void 0,u=(0,D.isConfigurationOverrides)(f)?f:(0,D.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(l,u,void 0)}updateValue(f,E,l,u){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(l,E,1)}onDidDefaultConfigurationChange(f){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(l,E,6)}trigger(f,E,l){const u=new R.ConfigurationChangeEvent(f,{data:E},this.configuration);u.source=l,u.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=g}),define(te[43],ie([0,1,17,85,32,15,26]),function($,t,T,P,b,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,L.createDecorator)("requestService");function R(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=R;function c(l){return l.res.statusCode===204}async function d(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,T.streamToBuffer)(l.stream)).toString()}t.asText=d;async function g(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const v=(await(0,T.streamToBuffer)(l.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}t.asJson=g;function I(l){E(l)}t.updateProxyConfigurationsScope=I;let f;function E(l){const u=D.Registry.as(b.Extensions.Configuration);f&&u.deregisterConfigurations([f]),f={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},u.registerConfiguration(f)}E(2)}),define(te[112],ie([0,1,25,8,16,43]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let D=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,g=T.CancellationToken.None){if(c.scheme===P.Schemas.file||c.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const I={type:"GET",url:c.toString()},f=await this.requestService.request(I,g);if(f.res.statusCode===200)await this.fileService.writeFile(d,f.stream);else{const E=await(0,L.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${E}`)}}};D=fe([ae(0,L.IRequestService),ae(1,b.IFileService)],D),t.DownloadService=D}),define(te[113],ie([0,1,114,12]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(D,R){return D.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:D.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function L(D,R,c={}){const d=(0,T.parse)(D),g=c.proxyUrl||b(d,R);if(!g)return null;const I=(0,T.parse)(g);if(!/^https?:$/.test(I.protocol||""))return null;const f={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,P.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((E,l)=>{$(["http-proxy-agent"],E,l)}))(f):new(await new Promise((E,l)=>{$(["https-proxy-agent"],E,l)}))(f)}t.getProxyAgent=L}),define(te[115],ie([0,1,17,30]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(L,D,R){let c=R&&R.get("storage.serviceMachineId",0)||null;if(c)return c;try{const g=(await D.readFile(L.serviceMachineIdResource)).value.toString();c=(0,P.isUUID)(g)?g:null}catch(d){c=null}if(!c){c=(0,P.generateUuid)();try{await D.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(c))}catch(d){}}return R&&R.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=b}),define(te[116],ie([0,1,3,13,2,12,67,15]),function($,t,T,P,b,L,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,R.createDecorator)("storageService");var d;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var g;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(g=t.StorageScope||(t.StorageScope={}));var I;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class f extends b.Disposable{constructor(v={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,m){m===c?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:m,target:this.getKeyTargets(v)[m]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,m,w){return this.getStorage(m)?.get(v,w)}getBoolean(v,m,w){return this.getStorage(m)?.getBoolean(v,w)}getNumber(v,m,w){return this.getStorage(m)?.getNumber(v,w)}store(v,m,w,h){if((0,L.isUndefinedOrNull)(m)){this.remove(v,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,w,h),this.getStorage(w)?.set(v,m)})}remove(v,m){this.withPausedEmitters(()=>{this.updateKeyTarget(v,m,void 0),this.getStorage(m)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,m){const w=[],h=this.getKeyTargets(v);for(const o of Object.keys(h))h[o]===m&&w.push(o);return w}updateKeyTarget(v,m,w){const h=this.getKeyTargets(m);typeof w=="number"?h[v]!==w&&(h[v]=w,this.getStorage(m)?.set(c,JSON.stringify(h))):typeof h[v]=="number"&&(delete h[v],this.getStorage(m)?.set(c,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const m=this.get(c,v);if(m)try{return JSON.parse(m)}catch(w){}return Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(v=d.NONE){this._onWillSaveState.fire({reason:v}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const v=this.getStorage(0)?.items??new Map,m=this.getStorage(1)?.items??new Map;return l(v,m,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends f{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}t.InMemoryStorageService=E;async function l(u,v,m,w){const h=a=>{try{return JSON.parse(a)}catch(y){return a}},o=new Map,r=new Map;u.forEach((a,y)=>{o.set(y,a),r.set(y,h(a))});const e=new Map,i=new Map;v.forEach((a,y)=>{e.set(y,a),i.set(y,h(a))}),console.group(`Storage: Global (path: ${m})`);let n=[];o.forEach((a,y)=>{n.push({key:y,value:a})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${w})`);let s=[];e.forEach((a,y)=>{s.push({key:y,value:a})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=l}),define(te[117],ie([0,1,9,29,7,30]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function D(d){if(T.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function R(d,g,I,f,E,l,u,v,m,w){const h=Object.create(null);h["common.machineId"]=u,h.sessionID=(0,L.generateUuid)()+Date.now(),h.commitHash=E,h.version=l,h["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,T.PlatformToString)(T.platform),h["common.nodePlatform"]=P.platform,h["common.nodeArch"]=f,h["common.product"]=w||"desktop";const o=c(v||[]);o&&(h["common.msftInternal"]=o);let r=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),T.isLinuxSnap&&(h["common.snap"]="true");const i=D(I);i&&(h["common.platformDetail"]=i);try{const n=await d.readFile(b.URI.file(m));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}t.resolveCommonProperties=R;function c(d){const g=P.env.USERDNSDOMAIN;if(!g)return!1;const I=g.toLowerCase();return d.some(f=>I===f)}t.verifyMicrosoftInternalDomain=c}),define(te[36],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(te[118],ie([0,1,22,3,25,11,13,2,9,7,75,23,24,14,31,36]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let v=class extends R.Disposable{constructor(r,e,i){super();this.galleryService=r,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(r,e={}){if(!this.galleryService.isEnabled())throw new Error(g.localize(0,null));try{r=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion)}catch(n){throw this.logService.error((0,L.getErrorMessage)(n)),w(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,n),n}if(!await this.canInstall(r)){const n=new I.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",r.identifier.id,n.message),w(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,n),n}const i=await this.galleryService.getManifest(r,b.CancellationToken.None);if(i===null){const n=new I.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",r.identifier.id,n.message),w(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,n),n}if(i.version!==r.version){const n=new I.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),w(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,n),n}return this.installExtension(i,r,e)}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(g.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,i){if(!d.URI.isUri(e)){let S=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(S)return this.logService.info("Extensions is already requested to install",e.identifier.id),S.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],a=this.createInstallExtensionTask(r,e,i);d.URI.isUri(e)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(a.identifier,r.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:r});let y=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const A=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,r,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:C}of A)if(y=y||!!C.extensionDependencies?.some(N=>(0,f.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const N=this.createInstallExtensionTask(C,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(N.identifier,C.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:p}),this.logService.info("Installing extension:",N.identifier.id),n.push({task:N,manifest:C})}}catch(A){if(d.URI.isUri(a.source))(0,T.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,A.message),(0,T.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,A.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(A),A}const S=n.reduce((A,{task:p,manifest:C})=>(A.set(p.identifier.id.toLowerCase(),{task:p,manifest:C}),A),new Map);for(;S.size;){let A;const p=[...S.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(N=>S.has(N.toLowerCase())));p.length?A=S.size===1?p:p.filter(({task:C})=>!(C===a&&!y)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:C})=>C.identifier.id)),A=[...S.values()]),await this.joinAllSettled(A.map(async({task:C})=>{const N=new Date().getTime();try{const V=await C.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(V,C.source,i,b.CancellationToken.None))),!d.URI.isUri(C.source)&&(w(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,void 0),c.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch(J){}s.push({local:V,identifier:C.identifier,operation:C.operation,source:C.source})}catch(V){throw d.URI.isUri(C.source)||w(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,V),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(V),V}finally{S.delete(C.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:A})=>this.logService.info("Extension installed successfully:",A.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:A})=>(0,f.areSameExtensions)(A,a.identifier))[0].local}catch(S){if(n.forEach(({task:A})=>A.cancel()),s.length)try{const A=await Promise.allSettled(s.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<A.length;p++){const C=A[p],{identifier:N}=s[p];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,L.getErrorMessage)(C.reason))}}catch(A){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(A),s.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,L.getErrorMessage)(S)),this._onDidInstallExtensions.fire(n.map(({task:A})=>({identifier:A.identifier,operation:1,source:A.source}))),S instanceof Error&&(S.name=S&&S.code?S.code:t.ERROR_UNKNOWN),S}finally{for(const{task:S,manifest:A}of n)if(!d.URI.isUri(S.source)){const p=new f.ExtensionIdentifierWithVersion(S.identifier,A.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(r){const e=[],i=[],n=await Promise.allSettled(r);for(const s of n)s.status==="fulfilled"?e.push(s.value):i.push(s.reason);if(i.length)throw m(i);return e}async getAllDepsAndPackExtensionsToInstall(r,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const s=[r,...n.map(S=>S.identifier)],a=[],y=async(S,A)=>{const p=A.extensionDependencies||[],C=[...p];if(A.extensionPack){const N=i?n.find(V=>(0,f.areSameExtensions)(V.identifier,S)):void 0;for(const V of A.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(J=>(0,f.areSameExtensions)({id:J},{id:V}))||C.every(J=>!(0,f.areSameExtensions)({id:J},{id:V}))&&C.push(V)}if(C.length){const N=[...s,...a.map(J=>J.gallery.identifier)],V=C.filter(J=>N.every(ne=>!(0,f.areSameExtensions)(ne,{id:J})));if(V.length){const J=await this.galleryService.query({names:V,pageSize:C.length},b.CancellationToken.None);for(const ne of J.firstPage){if(N.find(Y=>(0,f.areSameExtensions)(Y,ne.identifier)))continue;if(!p.some(Y=>(0,f.areSameExtensions)({id:Y},ne.identifier))&&!await this.canInstall(ne)){this.logService.info("Skipping the packed extension as it cannot be installed",ne.identifier.id);continue}const ee=await this.checkAndGetCompatibleVersion(ne,!0),G=await this.galleryService.getManifest(ee,b.CancellationToken.None);if(G===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${ee.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:ee,manifest:G}),await y(ee.identifier,G)}}}};return await y(r,e),n=await this.getInstalled(),a.filter(S=>!n.some(A=>(0,f.areSameExtensions)(A.identifier,S.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e){if(await this.isMalicious(r))throw new I.ExtensionManagementError(g.localize(3,null,r.identifier.id),I.INSTALL_ERROR_MALICIOUS);let i=null;if(await this.galleryService.isExtensionCompatible(r,I.CURRENT_TARGET_PLATFORM)&&(i=r),!i&&e&&(i=await this.galleryService.getCompatibleExtension(r,I.CURRENT_TARGET_PLATFORM)),!i)throw new I.ExtensionManagementError(g.localize(4,null,r.identifier.id,l.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return i}async isMalicious(r){const e=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(e).has(r.identifier.id)}async unininstallExtension(r,e){const i=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),i.waitUntilTaskIsFinished();const n=(S,A)=>{const p=this.createUninstallExtensionTask(S,A);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),p},s=(S,A)=>{A?this.logService.error("Failed to uninstall extension:",S.identifier.id,A.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),w(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(S),void 0,A),this._onDidUninstallExtension.fire({identifier:S.identifier,error:A?.code})},a=[],y=[];try{a.push(n(r,{}));const S=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const A=this.getAllPackExtensionsToUninstall(r,S);for(const p of A)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(n(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(a.map(A=>A.extension),S,r),await this.joinAllSettled(a.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(A.extension,e,b.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch(p){}s(A.extension)}catch(p){const C=p instanceof I.ExtensionManagementError?p:new I.ExtensionManagementError((0,L.getErrorMessage)(p),t.ERROR_UNKNOWN);throw s(A.extension,C),C}finally{y.push(A)}}))}catch(S){const A=S instanceof I.ExtensionManagementError?S:new I.ExtensionManagementError((0,L.getErrorMessage)(S),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(C){}y.includes(p)||s(p.extension,A)}throw A}finally{for(const S of a)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(r,e,i){for(const n of r){const s=this.getDependents(n,e);if(s.length){const a=s.filter(y=>!r.some(S=>(0,f.areSameExtensions)(S.identifier,y.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(r,e,i){return i===r?e.length===1?g.localize(5,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?g.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):g.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?g.localize(8,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?g.localize(9,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):g.localize(10,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,i=[]){if(i.indexOf(r)!==-1)return[];i.push(r);const n=r.manifest.extensionPack?r.manifest.extensionPack:[];if(n.length){const s=e.filter(y=>!y.isBuiltin&&n.some(S=>(0,f.areSameExtensions)({id:S},y.identifier))),a=[];for(const y of s)a.push(...this.getAllPackExtensionsToUninstall(y,e,i));return[...s,...a]}return[]}getDependents(r,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,f.areSameExtensions)({id:n},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=fe([ae(0,I.IExtensionGalleryService),ae(1,u.ITelemetryService),ae(2,E.ILogService)],v),t.AbstractExtensionManagementService=v;function m(o){const r=Array.isArray(o)?o:[o];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=m;function w(o,r,e,i,n){const s=n?n instanceof I.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(r,{...e,success:!n,duration:i,errorcode:s})}t.reportTelemetry=w;class h{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(r=>new Promise((e,i)=>{const n=r.onCancellationRequested(()=>{n.dispose(),i((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(te[119],ie([0,1,2,18,21,86,27,32,31,26]),function($,t,T,P,b,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let g=class{constructor(E,l){this._configurationService=l,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appender=E.appender,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(u),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(u=>{const v=/^[a-f0-9]+$/i.test(u["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})})}setExperimentProperty(E,l){this._experimentProperties[E]=l}setEnabled(E){this._enabled=E}_updateUserOptIn(){const E=this._configurationService?.getValue(I);this._userOptIn=E?E.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const E=await this._commonProperties;let l=E.sessionID,u=E["common.instanceId"],v=E["common.machineId"],m=E["common.firstSessionDate"],w=E["common.msftInternal"];return{sessionId:l,instanceId:u,machineId:v,firstSessionDate:m,msftInternal:w}}dispose(){this._disposables.dispose()}publicLog(E,l,u){return this.isOptedIn?this._commonProperties.then(v=>{l=(0,P.mixin)(l,v),l=(0,P.mixin)(l,this._experimentProperties),l=(0,P.cloneAndChange)(l,m=>{if(typeof m=="string")return this._cleanupInfo(m,u)}),this._appender.log(E,l)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(E,l,u){return this.publicLog(E,l,u)}publicLogError(E,l){return this.sendErrorTelemetry?this.publicLog(E,l,!0):Promise.resolve(void 0)}publicLogError2(E,l){return this.publicLogError(E,l)}_cleanupInfo(E,l){let u=E;if(l){const v=[];for(let o of this._cleanupPatterns)for(;;){const r=o.exec(E);if(!r)break;v.push([r.index,o.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(u="";;){const o=w.exec(E);if(!o)break;!m.test(o[0])&&v.every(([r,e])=>o.index<r||o.index>=e)&&(u+=E.substring(h,o.index)+"<REDACTED: user-file-path>",h=w.lastIndex)}h<E.length&&(u+=E.substr(h))}for(let v of this._cleanupPatterns)u=u.replace(v,"");return u}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=fe([ae(1,D.IConfigurationService)],g),t.TelemetryService=g;const I="telemetry";d.Registry.as(R.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(2,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(1,null,c.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[44],ie([0,1,3,18,12,27]),function($,t,T,P,b,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.TelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(v,m){return Promise.resolve(void 0)}publicLog2(v,m){return this.publicLog(v,m)}publicLogError(v,m){return Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class D{async publicLog(m,w,h){}async publicLogError(m,w,h){}}t.NullEndpointTelemetryService=D;function R(...v){return{log:(m,w)=>v.forEach(h=>h.log(m,w)),flush:()=>T.Promises.settled(v.map(m=>m.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(v,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:l(w.sourceConfig)})})}t.configurationTelemetry=c;var d;(function(v){v[v.NONE=0]="NONE",v[v.LOG=1]="LOG",v[v.USER=2]="USER"})(d=t.TelemetryLevel||(t.TelemetryLevel={}));function g(v,m){return m.disableTelemetry||!v.enableTelemetry?0:m.isBuilt?2:1}t.getTelemetryLevel=g;function I(v){const m=Object.create(null),w=Object.create(null),h=Object.create(null);E(v,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const r=h[o];typeof r=="number"?w[o]=r:typeof r=="boolean"?w[o]=r?1:0:typeof r=="string"?m[o]=r.substring(0,1023):typeof r!="undefined"&&r!==null&&(m[o]=r)}return{properties:m,measurements:w}}t.validateTelemetryData=I;function f(v){if(!v)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{v.indexOf(`${h}+`)===0&&(m=h)}),m}t.cleanRemoteAuthority=f;function E(v,m,w=0,h){if(!!v)for(let o of Object.getOwnPropertyNames(v)){const r=v[o],e=h?h+o:o;Array.isArray(r)?m[e]=(0,P.safeStringify)(r):r instanceof Date?m[e]=r.toISOString():(0,b.isObject)(r)?w<2?E(r,m,w+1,e+"."):m[e]=(0,P.safeStringify)(r):m[e]=r}}function l(v){if(!v)return[];const m=[];return u(m,"",v),m}function u(v,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(h=>u(v,m?`${m}.${h}`:h,w[h])):v.push(m)}}),define(te[120],ie([0,1,22,25,11,18,9,7,27,20,23,24,51,16,14,42,43,115,116,36,44]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u,v,m,w,h,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=void 0;var r;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(r||(r={}));function e(...k){return String(k.reduce((F,M)=>F|M,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class S{constructor(F=y){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,M=this.state.pageSize){return new S({...this.state,pageNumber:F,pageSize:M})}withFilter(F,...M){const x=[...this.state.criteria,...M.length?M.map(B=>({filterType:F,value:B})):[{filterType:F}]];return new S({...this.state,criteria:x})}withSortBy(F){return new S({...this.state,sortBy:F})}withSortOrder(F){return new S({...this.state,sortOrder:F})}withFlags(...F){return new S({...this.state,flags:F.reduce((M,x)=>M|x,0)})}withAssetTypes(...F){return new S({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:M,pageSize:x,sortBy:B,sortOrder:K,flags:Q,assetTypes:X}=this.state;return{filters:[{criteria:F,pageNumber:M,pageSize:x,sortBy:B,sortOrder:K}],assetTypes:X,flags:Q}}get searchText(){const F=this.state.criteria.filter(M=>M.filterType===i.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(k,F){const M=(k||[]).filter(x=>x.statisticName===F)[0];return M?M.value:0}function p(k){const F="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(x=>x.assetType.indexOf(F)===0).reduce((x,B)=>{const K=J(k,B.assetType);return K&&x.push([B.assetType.substring(F.length),K]),x},[])}function C(k){if(k.properties){const F=k.properties.filter(B=>B.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=F.filter(B=>M.test(B.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return J(k,n.Repository)}function N(k){return{uri:`${k.fallbackAssetUri}/${n.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${n.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function V(k){const F=J(k,n.Icon);if(F)return F;const M=g.DefaultIconPath;return{uri:M,fallbackUri:M}}function J(k,F){return k.files.filter(x=>x.assetType===F)[0]?{uri:`${k.assetUri}/${F}`,fallbackUri:`${k.fallbackAssetUri}/${F}`}:null}function ne(k,F){const M=k.properties?k.properties.filter(B=>B.key===F):[],x=M.length>0&&M[0].value;return x?x.split(",").map(B=>(0,I.adoptToGalleryExtensionId)(B)):[]}function se(k){const F=k.properties?k.properties.filter(M=>M.key===s.Engine):[];return F.length>0&&F[0].value||""}function ee(k){const F=k.properties?k.properties.filter(x=>x.key===s.LocalizedLanguages):[],M=F.length>0&&F[0].value||"";return M?M.split(","):[]}function G(k){return k.indexOf("preview")!==-1}function Y(k){return k.targetPlatform?(0,g.toTargetPlatform)(k.targetPlatform):"undefined"}function Z(k){const F=(0,T.distinct)(k.versions.map(Y)),M=!!k.tags?.includes(g.WEB_EXTENSION_TAG),x=F.indexOf("web");return M?x===-1&&F.push("web"):x!==-1&&F.splice(x,1),F}function re(k,F,M,x){const B=Z(k);let K=k.versions[0];return K=k.versions.find(Q=>Q.version===K.version&&(0,g.isTargetPlatformCompatible)(Y(Q),B,g.CURRENT_TARGET_PLATFORM))||K,j(k,K,B,F,M,x)}function j(k,F,M,x,B,K){const Q={manifest:J(F,n.Manifest),readme:J(F,n.Details),changelog:J(F,n.Changelog),license:J(F,n.License),repository:C(F),download:N(F),icon:V(F),coreTranslations:p(F)};return{identifier:{id:(0,I.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:F.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:A(k.statistics,"install"),rating:A(k.statistics,"averagerating"),ratingCount:A(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:M,assets:Q,properties:{dependencies:ne(F,s.Dependency),extensionPack:ne(F,s.ExtensionPack),engine:se(F),localizedLanguages:ee(F),targetPlatform:Y(F)},preview:G(k.flags),telemetryData:{index:(B.pageNumber-1)*B.pageSize+x,querySource:K}}}let O=class{constructor(F,M,x,B,K,Q,X,le){this.requestService=M,this.logService=x,this.environmentService=B,this.telemetryService=K,this.fileService=Q,this.productService=X,this.configurationService=le;const de=X.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=H(X.version,X,this.environmentService,this.configurationService,this.fileService,F)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,M){const x=[];let B=new S().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,F.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...F.map(({id:Q})=>Q.toLowerCase()));F.every(Q=>!Q.version)&&(B=B.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:K}=await this.queryGallery(B,P.CancellationToken.None);for(let Q=0;Q<K.length;Q++){const X=K[Q];if(!X.versions.length)continue;const le=(0,I.getGalleryExtensionId)(X.publisher.publisherName,X.extensionName),de=F.find(ce=>(0,I.areSameExtensions)(ce,{id:le}))?.version;if(de){const ce=X.versions.find(Ee=>Ee.version===de);ce&&x.push(j(X,ce,Z(X),Q,B))}else x.push(re(X,Q,B))}return x}async getCompatibleExtension(F,M){const x=(0,g.isIExtensionIdentifier)(F)?null:F;if(x){if((0,g.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(x,M))return x}const{id:B,uuid:K}=x?x.identifier:F;let Q=new S().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?Q=Q.withFilter(i.ExtensionId,K):Q=Q.withFilter(i.ExtensionName,B);const{galleryExtensions:X}=await this.queryGallery(Q,P.CancellationToken.None),[le]=X;if(!le||!le.versions.length)return null;const de=Z(le);if((0,g.isNotWebExtensionInWebTargetPlatform)(de,M))return null;for(let ce of le.versions){if(!se(ce)){const Ee=await this.getEngine(ce);ce={...ce,properties:[...ce.properties||[],{key:s.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(ce,de,M))return j(le,ce,de,0,Q)}return null}async isExtensionCompatible(F,M){if(!(0,g.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,M))return!1;let x=F.properties.engine;if(!x){const B=await this.getManifest(F,P.CancellationToken.None);if(!B)throw new Error("Manifest was not found");x=B.engines.vscode}return(0,f.isEngineValid)(x,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(F,M,x){if(!(0,g.isTargetPlatformCompatible)(Y(F),M,x))return!1;const B=await this.getEngine(F);return(0,f.isEngineValid)(B,this.productService.version,this.productService.date)}async query(F,M){const x=P.CancellationToken.isCancellationToken(F)?{}:F,B=P.CancellationToken.isCancellationToken(F)?F:M;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=x.text||"";const Q=(0,L.getOrDefault)(x,we=>we.pageSize,50);let X=new S().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,Q).withFilter(i.Target,"Microsoft.VisualStudio.Code");K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,pe,Re)=>(X=X.withFilter(i.Category,Re||pe),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,pe,Re)=>(X=X.withFilter(i.Tag,Re||pe),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),X=X.withFilter(i.SearchText,K)),X=X.withSortBy(0)):x.ids?X=X.withFilter(i.ExtensionId,...x.ids):x.names?X=X.withFilter(i.ExtensionName,...x.names):X=X.withSortBy(4),typeof x.sortBy=="number"&&(X=X.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(X=X.withSortOrder(x.sortOrder));const{galleryExtensions:le,total:de}=await this.queryGallery(X,B),ce=le.map((we,pe)=>re(we,pe,X,x.source)),Ee=async(we,pe)=>{if(pe.isCancellationRequested)throw(0,b.canceled)();const Re=X.withPage(we+1),{galleryExtensions:ve}=await this.queryGallery(Re,pe);return ve.map((be,ze)=>re(be,ze,Re,x.source))};return{firstPage:ce,total:de,pageSize:X.pageSize,getPage:Ee}}async queryGallery(F,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,r.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,e(r.Unpublished));const x=await this.commonHeadersPromise,B=JSON.stringify(F.raw),K={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},Q=new Date().getTime();let X,le,de=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:B,headers:K},M),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:de};const ce=await(0,v.asJson)(X);if(ce){const Ee=ce.results[0],we=Ee.extensions,pe=Ee.resultMetadata&&Ee.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return de=pe&&pe.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:de}}return{galleryExtensions:[],total:de}}catch(ce){throw le=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-Q,success:!!X&&(0,v.isSuccess)(X),responseBodySize:X?.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:le?(0,b.isPromiseCanceledError)(le)?"canceled":(0,b.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(F,M,x,B){if(!this.isEnabled())return;const K=D.isWeb?this.api(`/itemName/${F}.${M}/version/${x}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${M}/${x}/stats?statType=${B}`),Q=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:Q};try{await this.requestService.request({type:"POST",url:K,headers:le},P.CancellationToken.None)}catch(de){}}async download(F,M,x){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const B=(0,I.getGalleryExtensionTelemetryData)(F),K=new Date().getTime(),Q=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:ce}),X=x===1?"install":x===2?"update":"",le=X?{uri:`${F.assets.download.uri}${R.URI.parse(F.assets.download.uri).query?"&":"?"}${X}=true`,fallbackUri:`${F.assets.download.fallbackUri}${R.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${X}=true`}:F.assets.download,de=await this.getAsset(le);await this.fileService.writeFile(M,de.stream),Q(new Date().getTime()-K)}async getReadme(F,M){if(F.assets.readme){const x=await this.getAsset(F.assets.readme,{},M);return await(0,v.asText)(x)||""}return""}async getManifest(F,M){if(F.assets.manifest){const x=await this.getAsset(F.assets.manifest,{},M),B=await(0,v.asText)(x);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(F,M){const x=J(F,n.Manifest);if(!x)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},K=await this.getAsset(x,{headers:B});return await(0,v.asJson)(K)}async getCoreTranslation(F,M){const x=F.assets.coreTranslations.filter(B=>B[0]===M.toUpperCase())[0];if(x){const B=await this.getAsset(x[1]),K=await(0,v.asText)(B);return K?JSON.parse(K):null}return null}async getChangelog(F,M){if(F.assets.changelog){const x=await this.getAsset(F.assets.changelog,{},M);return await(0,v.asText)(x)||""}return""}async getAllCompatibleVersions(F,M){let x=new S().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?x=x.withFilter(i.ExtensionId,F.identifier.uuid):x=x.withFilter(i.ExtensionName,F.identifier.id);const{galleryExtensions:B}=await this.queryGallery(x,P.CancellationToken.None);if(!B.length)return[];const K=Z(B[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(K,M))return[];const Q=[];for(const X of B[0].versions)try{await this.isRawExtensionVersionCompatible(X,K,M)&&Q.push({version:X.version,date:X.lastUpdated})}catch(le){}return Q}async getAsset(F,M={},x=P.CancellationToken.None){const B=await this.commonHeadersPromise,K={type:"GET"},Q={...B,...M.headers||{}};M={...M,...K,headers:Q};const X=F.uri,le=F.fallbackUri,de={...M,url:X};try{const ce=await this.requestService.request(de,x);if(ce.res.statusCode===200)return ce;const Ee=await(0,v.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${Ee}`)}catch(ce){if((0,b.isPromiseCanceledError)(ce))throw ce;const Ee=(0,b.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:Ee});const we={...M,url:le};return this.requestService.request(we,x)}}async getEngine(F){let M=se(F);if(!M){const x=await this.getManifestFromRawExtensionVersion(F,P.CancellationToken.None);if(!x)throw new Error("Manifest was not found");M=x.engines.vscode}return M}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,v.asJson)(F),x=new Map;if(M)for(const B of M.malicious){const K=x.get(B)||{id:{id:B},malicious:!0,slow:!1};K.malicious=!0,x.set(B,K)}return[...x.values()]}};O=fe([ae(1,v.IRequestService),ae(2,l.ILogService),ae(3,d.IEnvironmentService),ae(4,h.ITelemetryService),ae(5,E.IFileService),ae(6,u.IProductService),ae(7,c.IConfigurationService)],O);let z=class extends O{constructor(F,M,x,B,K,Q,X,le){super(F,M,x,B,K,Q,X,le)}};z=fe([ae(0,w.IStorageService),ae(1,v.IRequestService),ae(2,l.ILogService),ae(3,d.IEnvironmentService),ae(4,h.ITelemetryService),ae(5,E.IFileService),ae(6,u.IProductService),ae(7,c.IConfigurationService)],z),t.ExtensionGalleryService=z;let W=class extends O{constructor(F,M,x,B,K,Q,X){super(void 0,F,M,x,B,K,Q,X)}};W=fe([ae(0,v.IRequestService),ae(1,l.ILogService),ae(2,d.IEnvironmentService),ae(3,h.ITelemetryService),ae(4,E.IFileService),ae(5,u.IProductService),ae(6,c.IConfigurationService)],W),t.ExtensionGalleryServiceWithNoStorageService=W;async function H(k,F,M,x,B,K){const Q={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},X=await(0,m.getServiceMachineId)(M,B,K);return(0,o.getTelemetryLevel)(F,M)>=2&&x.getValue("telemetry.enableTelemetry")===!0&&(Q["X-Market-User-Id"]=X),Q}t.resolveMarketplaceHeaders=H}),define(te[121],ie([0,1,11,18,44]),function($,t,T,P,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(R){const c=await new Promise((g,I)=>{$(["applicationinsights"],g,I)});let d;return c.defaultClient?(d=new c.TelemetryClient(R),d.channel.setUseDiskRetryCaching(!0)):(c.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=c.defaultClient),R.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class D{constructor(c,d,g){this._eventPrefix=c,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof g=="function"?this._aiClient=g():this._aiClient=g,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,T.onUnexpectedError)(d),console.error(d)})}}log(c,d){!this._aiClient||(d=(0,P.mixin)(d,this._defaultData),d=(0,b.validateTelemetryData)(d),this._withAIClient(g=>g.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=D}),define(te[122],ie([0,1,4,10]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(L,D){const R=Object.create(null),c=(g,I)=>{const f=JSON.parse(g);R[I]=f};if(D){const g=[],I=await P.Promises.readdir(D);for(const E of I)try{(await P.Promises.stat((0,T.join)(D,E))).isDirectory()&&g.push(E)}catch{}const f=[];for(const E of g)(await P.Promises.readdir((0,T.join)(D,E))).filter(u=>u==="telemetry.json").length===1&&f.push(E);for(const E of f){const l=(await P.Promises.readFile((0,T.join)(D,E,"telemetry.json"))).toString();c(l,E)}}let d=(await P.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await P.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(R,null,4)}t.buildTelemetryMessage=b}),define(te[45],ie([0,1,38,3,4,12,10,73,133,134]),function($,t,T,P,b,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class g extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=g;function I(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function f(r){if(r instanceof g)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new g(e,r)}function E(r,e,i,n,s,a){const y=b.dirname(e),S=b.join(n,y);if(!S.startsWith(n))return Promise.reject(new Error(R.localize(0,null,e)));const A=b.join(n,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(D.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((C,N)=>{if(!a.isCancellationRequested)try{p=(0,T.createWriteStream)(A,{mode:i}),p.once("close",()=>C()),p.once("error",N),r.once("error",N),r.pipe(p)}catch(V){N(V)}}))}function l(r,e,i,n){let s=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((y,S)=>{const A=new P.Sequencer,p=C=>{C.isCancellationRequested||(a++,r.readEntry())};r.once("error",S),r.once("close",()=>s.then(()=>{n.isCancellationRequested||r.entryCount===a?y():S(new g("Incomplete",new Error(R.localize(1,null,a,r.entryCount))))},S)),r.readEntry(),r.on("entry",C=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){p(n);return}const N=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const ne=b.join(e,N);s=(0,P.createCancelablePromise)(se=>D.Promises.mkdir(ne,{recursive:!0}).then(()=>p(se)).then(void 0,S));return}const V=v(r,C),J=I(C);s=(0,P.createCancelablePromise)(ne=>A.queue(()=>V.then(se=>E(se,N,J,e,i,ne).then(()=>p(ne)))).then(null,S))})})}function u(r,e=!1){return new Promise((i,n)=>{(0,c.open)(r,e?{lazyEntries:!0}:void 0,(s,a)=>{s?n(f(s)):i((0,L.assertIsDefined)(a))})})}function v(r,e){return new Promise((i,n)=>{r.openReadStream(e,(s,a)=>{s?n(f(s)):i((0,L.assertIsDefined)(a))})})}function m(r,e){return new Promise((i,n)=>{const s=new d.ZipFile;e.forEach(y=>{y.contents?s.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&s.addFile(y.localPath,y.path)}),s.end();const a=(0,T.createWriteStream)(r);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(r))})}t.zip=m;function w(r,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=u(r,!0);return i.overwrite&&(a=a.then(y=>D.Promises.rm(e).then(()=>y))),a.then(y=>l(y,e,{sourcePathRegex:s},n))}t.extract=w;function h(r,e){return u(r).then(i=>new Promise((n,s)=>{i.on("entry",a=>{a.fileName===e&&v(i,a).then(y=>n(y),y=>s(y))}),i.once("close",()=>s(new Error(R.localize(2,null,e))))}))}function o(r,e){return h(r,e).then(i=>new Promise((n,s)=>{const a=[];i.once("error",s),i.on("data",y=>a.push(y)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(te[123],ie([0,1,45,79]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(L){return(0,T.buffer)(L,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(R){throw new Error((0,P.localize)(0,null))}})}t.getManifest=b}),define(te[124],ie([0,1,22,3,11,2,8,4,9,19,41,7,30,10,45,80,20,23,24,91,16,14,42]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u,v,m,w,h,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",a="deleting",y="renaming";let S=class extends L.Disposable{constructor(p,C,N,V,J){super();this.beforeRemovingExtension=p,this.fileService=C,this.logService=N,this.environmentService=V,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=V.builtinExtensionsPath,this.extensionsPath=V.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const C=[];(p===null||p===0)&&C.push(this.scanSystemExtensions().then(null,N=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(N).message,i)))),(p===null||p===1)&&C.push(this.scanUserExtensions(!0).then(null,N=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(N).message,n))));try{const N=await Promise.all(C);return(0,T.flatten)(N)}catch(N){throw this.joinErrors(N)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[C,N]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return N=N.filter(V=>!C[new w.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).key()]),p&&(N=(0,w.groupByExtension)(N,J=>J.identifier).map(J=>J.sort((ne,se)=>g.rcompare(ne.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",N.length),N}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,C,N,V){const J=p.key(),ne=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),se=R.join(this.extensionsPath,J);try{await E.Promises.rm(se)}catch(G){try{await E.Promises.rm(se)}catch(Y){}throw new m.ExtensionManagementError((0,u.localize)(0,null,se,p.id),a)}await this.extractAtLocation(p,C,ne,V);let ee=await this.scanExtension(I.URI.file(ne),1);if(!ee)throw new Error((0,u.localize)(1,null,ne));await this.storeMetadata(ee,{...N,installedTimestamp:Date.now()});try{await this.rename(p,ne,se,Date.now()+2*60*1e3),this.logService.info("Renamed to",se)}catch(G){try{await E.Promises.rm(ne)}catch(Y){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(G)}. Deleted from extracted location`,ne),G}try{ee=await this.scanExtension(I.URI.file(se),1)}catch(G){}if(ee)return ee;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,C){return this.setMetadata(p,C),await this.storeMetadata(p,{...C,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const N=R.join(p.location.fsPath,"package.json"),V=await E.Promises.readFile(N,"utf8"),{manifest:J}=await this.parseManifest(V);return J.__metadata=C,await E.Promises.writeFile(N,JSON.stringify(J,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const C=p.map(N=>new w.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version));await this.withUninstalledExtensions(N=>{C.forEach(V=>N[V.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(V=>delete V[p.key()]);const N=(await this.scanExtensions(1)).find(V=>new w.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).equals(p))||null;return N?(await this.storeMetadata(N,{installedTimestamp:Date.now()}),this.scanExtension(N.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(V){if(V.code!=="ENOENT")throw V}let N={};if(C)try{N=JSON.parse(C)}catch(V){}return p&&(p(N),Object.keys(N).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await E.Promises.rm(this.uninstalledPath)),N})}async removeExtension(p,C){this.logService.trace(`Deleting ${C} extension from disk`,p.identifier.id,p.location.fsPath),await E.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,C,N,V){this.logService.trace(`Started extracting the extension from ${C} to ${N}`);try{await E.Promises.rm(N)}catch(J){throw new m.ExtensionManagementError(this.joinErrors(J).message,a)}try{await(0,l.extract)(C,N,{sourcePath:"extension",overwrite:!0},V),this.logService.info(`Extracted extension to ${N}:`,p.id)}catch(J){try{await E.Promises.rm(N)}catch(ne){}throw new m.ExtensionManagementError(J.message,J instanceof l.ExtractError&&J.type?J.type:s)}}async rename(p,C,N,V){try{await E.Promises.rename(C,N)}catch(J){if(c.isWindows&&J&&J.code==="EPERM"&&Date.now()<V)return this.logService.info(`Failed renaming ${C} to ${N} with 'EPERM' error. Trying again...`,p.id),this.rename(p,C,N,V);throw new m.ExtensionManagementError(J.message||(0,u.localize)(3,null,C,N),J.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const C=this.scanDevSystemExtensions(),[N,V]=await Promise.all([p,C]);return[...N,...V]}async scanExtensionsInDir(p,C){const N=new P.Limiter(10),V=await this.fileService.resolve(I.URI.file(p));return V.children?(await Promise.all(V.children.filter(ne=>ne.isDirectory).map(ne=>N.queue(async()=>C===1&&(0,d.basename)(ne.resource).indexOf(".")===0?null:this.scanExtension(ne.resource,C))))).filter(ne=>ne&&ne.identifier):[]}async scanExtension(p,C){try{const N=await this.fileService.resolve(p);if(N.children){const{manifest:V,metadata:J}=await this.readManifest(p.fsPath),ne=N.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,se=N.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource,ee={id:(0,w.getGalleryExtensionId)(V.publisher,V.name)},G={type:C,identifier:ee,manifest:V,location:p,readmeUrl:ne,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return J&&(this.setMetadata(G,J),G.installedTimestamp=J.installedTimestamp),G}}catch(N){C!==0&&this.logService.trace(N)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(N=>p.some(V=>(0,w.areSameExtensions)(N.identifier,{id:V})))}else return[]}setMetadata(p,C){p.publisherDisplayName=C.publisherDisplayName||null,p.publisherId=C.publisherId||null,p.identifier.uuid=C.id,p.isMachineScoped=!!C.isMachineScoped,p.isBuiltin=p.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),N=new Set;for(const ne of C)p[new w.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]||N.add(ne.identifier.id.toLowerCase());const V=(0,w.groupByExtension)(C,ne=>ne.identifier);await P.Promises.settled(V.map(async ne=>{const se=ne.sort((ee,G)=>g.rcompare(ee.manifest.version,G.manifest.version))[0];N.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const J=C.filter(ne=>p[new w.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]);await P.Promises.settled(J.map(ne=>this.removeUninstalledExtension(ne)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),C=[],N=(0,w.groupByExtension)(p,V=>V.identifier);C.push(...(0,T.flatten)(N.map(V=>V.sort((J,ne)=>g.rcompare(J.manifest.version,ne.manifest.version)).slice(1)))),await P.Promises.settled(C.map(V=>this.removeExtension(V,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const C=Array.isArray(p)?p:[p];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((N,V)=>new Error(`${N.message}${N.message?",":""}${V instanceof Error?V.message:V}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const C=[E.Promises.readFile(R.join(p,"package.json"),"utf8").then(ne=>this.parseManifest(ne)),E.Promises.readFile(R.join(p,"package.nls.json"),"utf8").then(void 0,ne=>ne.code!=="ENOENT"?Promise.reject(ne):"{}").then(ne=>JSON.parse(ne))],[{manifest:N,metadata:V},J]=await Promise.all(C);return{manifest:(0,h.localizeManifest)(N,J),metadata:V}}parseManifest(p){return new Promise((C,N)=>{try{const V=JSON.parse(p),J=V.__metadata||null;C({manifest:V,metadata:J})}catch(V){N(new Error((0,u.localize)(4,null)))}})}};S=fe([ae(1,o.IFileService),ae(2,r.ILogService),ae(3,v.INativeEnvironmentService),ae(4,e.IProductService)],S),t.ExtensionsScanner=S}),define(te[125],ie([0,1,28,8,4,9,19,41,7,30,10,45,78,53,20,118,23,24,102,103,123,98,124,104,51,16,15,14,31,36]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u,v,m,w,h,o,r,e,i,n,s,a,y,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const p="unsetUninstalled",C="downloading";let N=class extends u.AbstractExtensionManagementService{constructor(G,Y,Z,re,j,O,z){super(G,Y,Z);this.environmentService=re,this.downloadService=j;const W=this._register(O.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(O.createInstance(e.ExtensionsScanner,k=>W.postUninstall(k))),this.manifestCache=this._register(new r.ExtensionsManifestCache(re,this)),this.extensionsDownloader=this._register(O.createInstance(w.ExtensionsDownloader));const H=this._register(new i.ExtensionsWatcher(this,z,re,Z));this._register(H.onDidChangeExtensionsByAnotherSource(({added:k,removed:F})=>{k.length&&this._onDidInstallExtensions.fire(k.map(M=>({identifier:M.identifier,operation:0,local:M}))),F.forEach(M=>this._onDidUninstallExtension.fire({identifier:M}))}))}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const Y=await this.collectFiles(G),Z=await(0,I.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,Y);return c.URI.file(Z)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const Y=await this.downloadVsix(G),Z=b.resolve(Y.fsPath);return(0,o.getManifest)(Z)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async canInstall(G){return!0}async install(G,Y={}){this.logService.trace("ExtensionManagementService#install",G.toString());const Z=await this.downloadVsix(G),re=await(0,o.getManifest)(b.resolve(Z.fsPath));if(re.engines&&re.engines.vscode&&!(0,n.isEngineValid)(re.engines.vscode,S.default.version,S.default.date))throw new Error(f.localize(0,null,(0,m.getGalleryExtensionId)(re.publisher,re.name),S.default.version));return this.installExtension(re,Z,Y)}async updateMetadata(G,Y){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},...Y}),this.manifestCache.invalidate(),G}async updateExtensionScope(G,Y){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:Y}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===P.Schemas.file)return G;const Y=(0,D.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(G,Y),Y}createInstallExtensionTask(G,Y,Z){return c.URI.isUri(Y)?new ne(G,Y,Z,this.galleryService,this.extensionsScanner,this.logService):new J(Y,Z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,Y){return new se(G,Y,this.extensionsScanner)}async collectFiles(G){const Y=async re=>{let j=await g.Promises.readdir(re);j=j.map(W=>b.join(re,W));const O=await Promise.all(j.map(W=>g.Promises.stat(W)));let z=Promise.resolve([]);return O.forEach((W,H)=>{const k=j[H];W.isFile()&&(z=z.then(F=>[...F,k])),W.isDirectory()&&(z=z.then(F=>Y(k).then(M=>[...F,...M])))}),z};return(await Y(G.location.fsPath)).map(re=>({path:`extension/${b.relative(G.location.fsPath,re)}`,localPath:re}))}};N=fe([ae(0,v.IExtensionGalleryService),ae(1,A.ITelemetryService),ae(2,y.ILogService),ae(3,l.INativeEnvironmentService),ae(4,E.IDownloadService),ae(5,a.IInstantiationService),ae(6,s.IFileService)],N),t.ExtensionManagementService=N;class V extends u.AbstractExtensionTask{constructor(G,Y,Z,re){super();this.identifier=G,this.source=Y,this.extensionsScanner=Z,this.logService=re,this._operation=1}get operation(){return this._operation}async installExtension(G,Y){try{const Z=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(Z)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Z,G.metadata):Z}catch(Z){throw L.isMacintosh?new v.ExtensionManagementError(f.localize(1,null),p):new v.ExtensionManagementError(f.localize(2,null),p)}return this.extract(G,Y)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const Z=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),Z}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:Y,metadata:Z},re){let j=await this.extensionsScanner.extractUserExtension(Y,G,Z,re);return this.logService.info("Extracting completed.",Y.id),j}}class J extends V{constructor(G,Y,Z,re,j){super(G.identifier,G,re,j);this.gallery=G,this.options=Y,this.extensionsDownloader=Z}async doRun(G){const Z=(await this.extensionsScanner.scanExtensions(null)).find(O=>(0,m.areSameExtensions)(O.identifier,this.gallery.identifier));Z&&(this._operation=2);const re=await this.downloadInstallableExtension(this.gallery,this._operation);re.metadata.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,re.metadata.isBuiltin=this.options.isBuiltin||Z?.isBuiltin;const j=await this.installExtension(re,G);Z&&R.neq(Z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Z);try{await this.extensionsDownloader.delete(c.URI.file(re.zipPath))}catch(O){}return j}async downloadInstallableExtension(G,Y){const Z={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let re;try{this.logService.trace("Started downloading extension:",G.identifier.id),re=(await this.extensionsDownloader.downloadExtension(G,Y)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,re)}catch(j){throw new v.ExtensionManagementError((0,u.joinErrors)(j).message,C)}try{const j=await(0,o.getManifest)(re);return{zipPath:re,identifierWithVersion:new m.ExtensionIdentifierWithVersion(G.identifier,j.version),metadata:Z}}catch(j){throw new v.ExtensionManagementError((0,u.joinErrors)(j).message,u.INSTALL_ERROR_VALIDATING)}}}class ne extends V{constructor(G,Y,Z,re,j,O){super({id:(0,m.getGalleryExtensionId)(G.publisher,G.name)},Y,j,O);this.manifest=G,this.location=Y,this.options=Z,this.galleryService=re}async doRun(G){const Y=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),re=(await this.extensionsScanner.scanExtensions(1)).find(O=>(0,m.areSameExtensions)(this.identifier,O.identifier)),j=await this.getMetadata(this.identifier.id,G);if(j.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||re?.isBuiltin,re)if(this._operation=2,Y.equals(new m.ExtensionIdentifierWithVersion(re.identifier,re.manifest.version)))try{await this.extensionsScanner.removeExtension(re,"existing")}catch(O){throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else R.gt(re.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(re);else{const O=await this.unsetUninstalledAndGetLocal(Y);if(O)try{await this.extensionsScanner.removeExtension(O,"existing")}catch(z){throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:b.resolve(this.location.fsPath),identifierWithVersion:Y,metadata:j},G)}async getMetadata(G,Y){try{const Z=(await this.galleryService.query({names:[G],pageSize:1},Y)).firstPage[0];if(Z)return{id:Z.identifier.uuid,publisherDisplayName:Z.publisherDisplayName,publisherId:Z.publisherId}}catch(Z){}return{}}}class se extends u.AbstractExtensionTask{constructor(G,Y,Z){super();this.extension=G,this.options=Y,this.extensionsScanner=Z}async doRun(G){const Y=[],Z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const re=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Y.push(...Z.filter(j=>re.equals(new m.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else Y.push(...Z.filter(re=>(0,m.areSameExtensions)(re.identifier,this.extension.identifier)));if(!Y.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Y),this.options.remove)for(const re of Y)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(re)}catch(j){throw new Error(f.localize(6,null,(0,T.toErrorMessage)(j)))}}}}),define(te[126],ie([0,1,114,17,11,2,12,27,20,99,14,113,135]),function($,t,T,P,b,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let E=class extends L.Disposable{constructor(u,v,m){super();this.environmentService=v,this.logService=m,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,v){this.logService.trace("RequestService#request",u.url);const{proxyUrl:m,strictSSL:w}=this,h={...process.env,...await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=u.agent?u.agent:await(0,I.getProxyAgent)(u.url||"",h,{proxyUrl:m,strictSSL:w});return u.agent=o,u.strictSSL=w,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,v)}async getNodeRequest(u){return((0,T.parse)(u.url).protocol==="https:"?await new Promise((w,h)=>{$(["https"],w,h)}):await new Promise((w,h)=>{$(["http"],w,h)})).request}_request(u,v){return new Promise(async(m,w)=>{let h;const o=(0,T.parse)(u.url),r=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),h=r(e,i=>{const n=(0,D.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...u,url:i.headers.location,followRedirects:n-1},v).then(m,w);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,f.createGunzip)())),m({res:i,stream:(0,P.streamToBufferReadableStream)(s)})}}),h.on("error",w),u.timeout&&h.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&h.write(u.data),h.end(),v.onCancellationRequested(()=>{h.abort(),w((0,b.canceled)())})})}async resolveProxy(u){}};E=fe([ae(0,R.IConfigurationService),ae(1,c.INativeEnvironmentService),ae(2,g.ILogService)],E),t.RequestService=E}),define(te[136],ie([0,1,38,137,34,3,17,28,11,2,8,4,29,7,10,27,111,53,112,20,90,120,23,97,125,16,107,108,52,101,55,56,105,14,106,31,42,43,126,117,36,119,44,121,122]),function($,t,T,P,b,L,D,R,c,d,g,I,f,E,l,u,v,m,w,h,o,r,e,i,n,s,a,y,S,A,p,C,N,V,J,ne,se,ee,G,Y,Z,re,j,O,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class W extends d.Disposable{constructor(F){super();this.argv=F,(0,P.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[F,M]=await this.initServices();return F.invokeFunction(async x=>{const B=x.get(V.ILogService),K=x.get(s.IFileService),Q=x.get(h.INativeEnvironmentService),X=x.get(e.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(Q,X,K),(0,L.raceTimeout)((0,j.combinedAppender)(...M).flush(),1e3)})}async initServices(){const F=new p.ServiceCollection,M={_serviceBrand:void 0,...ne.default};F.set(se.IProductService,M);const x=new o.NativeEnvironmentService(this.argv,M);F.set(h.INativeEnvironmentService,x),await Promise.all([x.appSettingsHome.fsPath,x.extensionsPath].map(Ee=>Ee?l.Promises.mkdir(Ee,{recursive:!0}):void 0));const B=(0,V.getLogLevel)(x),K=[];K.push(new J.SpdLogLogger("cli",(0,I.join)(x.logsPath,"cli.log"),!0,B)),B===V.LogLevel.Trace&&K.push(new V.ConsoleLogger(B));const Q=this._register(new V.MultiplexLogService(K));F.set(V.ILogService,Q);const X=this._register(new a.FileService(Q));F.set(s.IFileService,X);const le=this._register(new y.DiskFileSystemProvider(Q));X.registerProvider(g.Schemas.file,le);const de=this._register(new v.ConfigurationService(x.settingsResource,X));F.set(u.IConfigurationService,de),await de.initialize(),F.set(ee.IRequestService,new S.SyncDescriptor(G.RequestService)),F.set(m.IDownloadService,new S.SyncDescriptor(w.DownloadService)),F.set(e.IExtensionManagementService,new S.SyncDescriptor(n.ExtensionManagementService)),F.set(e.IExtensionGalleryService,new S.SyncDescriptor(r.ExtensionGalleryServiceWithNoStorageService)),F.set(e.IExtensionManagementCLIService,new S.SyncDescriptor(i.ExtensionManagementCLIService)),F.set(C.ILocalizationsService,new S.SyncDescriptor(N.LocalizationsService));const ce=[];if((0,j.getTelemetryLevel)(M,x)>=2){M.aiConfig&&M.aiConfig.asimovKey&&ce.push(new O.AppInsightsAppender("monacoworkbench",null,M.aiConfig.asimovKey));const{appRoot:Ee,extensionsPath:we,installSourcePath:pe}=x,Re={appender:(0,j.combinedAppender)(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const be=await l.Promises.readFile((0,I.join)(x.userDataPath,"storage.json"));ve=JSON.parse(be.toString())[Z.machineIdKey]}catch(be){be.code!=="ENOENT"&&Q.error(be)}return(0,Y.resolveCommonProperties)(X,(0,b.release)(),(0,b.hostname)(),process.arch,M.commit,M.version,ve,M.msftInternalDomains,pe)})(),piiPaths:[Ee,we]};F.set(Z.ITelemetryService,new S.SyncDescriptor(re.TelemetryService,[Re]))}else F.set(Z.ITelemetryService,j.NullTelemetryService);return[new A.InstantiationService(F),ce]}registerErrorHandler(F){(0,c.setUnexpectedErrorHandler)(M=>{const x=(0,R.toErrorMessage)(M,!0);!x||F.error(`[uncaught exception in CLI]: ${x}`)}),process.on("uncaughtException",M=>(0,c.onUnexpectedError)(M)),process.on("unhandledRejection",M=>(0,c.onUnexpectedError)(M))}async doRun(F,M,x){if(this.argv["install-source"])return this.setInstallSource(F,x,this.argv["install-source"]);if(this.argv["list-extensions"])return M.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return M.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return M.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return M.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,z.buildTelemetryMessage)(F.appRoot,F.extensionsPath))}asExtensionIdOrVSIX(F){return F.map(M=>/\.vsix$/i.test(M)?E.URI.file((0,I.isAbsolute)(M)?M:(0,I.join)((0,f.cwd)(),M)):M)}async setInstallSource(F,M,x){await M.writeFile(E.URI.file(F.installSourcePath),D.VSBuffer.fromString(x.slice(0,30)))}}async function H(k){const F=new W(k);try{await F.run()}finally{F.dispose()}}t.main=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23cffa27b806f9e1733e15d611ec251dcdba2c42/core/vs/code/node/cliProcessMain.js.map
