/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ie){for(var e=[],d=0,M=ie.length;d<M;d++)e[d]=be[ie[d]];return e};define(be[40],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=d}),define(be[51],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const _=[];for(let n in t)d.call(t,n)&&_.push(t[n]);return _}e.values=M;function E(t,_){for(let n in t)if(d.call(t,n)&&_({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,_){const n=Object.create(null);for(const h of t){const u=_(h);let s=n[u];s||(s=n[u]=[]),s.push(h)}return n}e.groupBy=A;function R(t){const _=Object.create(null);return t&&t.forEach((n,h)=>{_[h]=n}),_}e.fromMap=R;function C(t,_){const n=[],h=[];for(let u of t)_.has(u)||n.push(u);for(let u of _)t.has(u)||h.push(u);return{removed:n,added:h}}e.diffSets=C;function y(t,_){const n=[],h=[];for(let[u,s]of t)_.has(u)||n.push(s);for(let[u,s]of _)t.has(u)||h.push(s);return{removed:n,added:h}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(_,n){let h=this.map.get(_);h||(h=new Set,this.map.set(_,h)),h.add(n)}delete(_,n){const h=this.map.get(_);!h||(h.delete(n),h.size===0&&this.map.delete(_))}forEach(_,n){const h=this.map.get(_);!h||h.forEach(n)}}e.SetMap=P}),define(be[52],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(R){return(C,y,P)=>{let t=null,_=null;if(typeof P.value=="function"?(t="value",_=P.value):typeof P.get=="function"&&(t="get",_=P.get),!_)throw new Error("not supported");P[t]=R(_,y)}}e.createDecorator=d;function M(R,C,y){let P=null,t=null;if(typeof y.value=="function"?(P="value",t=y.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",t=y.get),!t)throw new Error("not supported");const _=`$memoize$${C}`;y[P]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[_]}}e.memoize=M;function E(R,C,y){return d((P,t)=>{const _=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...h){this[n]||(this[n]=y?y():void 0),clearTimeout(this[_]),C&&(this[n]=C(this[n],...h),h=[this[n]]),this[_]=setTimeout(()=>{P.apply(this,h),this[n]=y?y():void 0},R)}})}e.debounce=E;function A(R,C,y){return d((P,t)=>{const _=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,h=`$throttle$lastRun$${t}`,u=`$throttle$pending$${t}`;return function(...s){if(this[n]||(this[n]=y?y():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...s)),this[u])return;const v=this[h]+R;v<=Date.now()?(this[h]=Date.now(),P.apply(this,[this[n]]),this[n]=y?y():void 0):(this[u]=!0,this[_]=setTimeout(()=>{this[u]=!1,this[h]=Date.now(),P.apply(this,[this[n]]),this[n]=y?y():void 0},v-Date.now()))}})}e.throttle=A}),define(be[13],Ee([0,1,16]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(q,le=0){return q[q.length-(1+le)]}e.tail=M;function E(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=E;function A(q,le,se=(ve,Fe)=>ve===Fe){if(q===le)return!0;if(!q||!le||q.length!==le.length)return!1;for(let ve=0,Fe=q.length;ve<Fe;ve++)if(!se(q[ve],le[ve]))return!1;return!0}e.equals=A;function R(q,le,se){let ve=0,Fe=q.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Ne=se(q[Me],le);if(Ne<0)ve=Me+1;else if(Ne>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=R;function C(q,le){let se=0,ve=q.length;if(ve===0)return 0;for(;se<ve;){const Fe=Math.floor((se+ve)/2);le(q[Fe])?ve=Fe:se=Fe+1}return se}e.findFirstInSorted=C;function y(q,le,se){if(q=q|0,q>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Ne=[];for(let Qe of le){const ze=se(Qe,ve);ze<0?Fe.push(Qe):ze>0?Me.push(Qe):Ne.push(Qe)}return q<Fe.length?y(q,Fe,se):q<Fe.length+Ne.length?Ne[0]:y(q-(Fe.length+Ne.length),Me,se)}e.quickSelect=y;function P(q,le){const se=[];let ve;for(const Fe of q.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],se.push(ve)):ve.push(Fe);return se}e.groupBy=P;function t(q,le,se){const ve=[];function Fe(Qe,ze,qe){if(ze===0&&qe.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Qe?(x.deleteCount+=ze,x.toInsert.push(...qe)):ve.push({start:Qe,deleteCount:ze,toInsert:qe})}let Me=0,Ne=0;for(;;){if(Me===q.length){Fe(Me,0,le.slice(Ne));break}if(Ne===le.length){Fe(Me,q.length-Me,[]);break}const Qe=q[Me],ze=le[Ne],qe=se(Qe,ze);qe===0?(Me+=1,Ne+=1):qe<0?(Fe(Me,1,[]),Me+=1):qe>0&&(Fe(Me,0,[ze]),Ne+=1)}return ve}e.sortedDiff=t;function _(q,le,se){const ve=t(q,le,se),Fe=[],Me=[];for(const Ne of ve)Fe.push(...q.slice(Ne.start,Ne.start+Ne.deleteCount)),Me.push(...Ne.toInsert);return{removed:Fe,added:Me}}e.delta=_;function n(q,le,se){if(se===0)return[];const ve=q.slice(0,se).sort(le);return u(q,le,ve,se,q.length),ve}e.top=n;function h(q,le,se,ve,Fe){return se===0?Promise.resolve([]):new Promise((Me,Ne)=>{(async()=>{const Qe=q.length,ze=q.slice(0,se).sort(le);for(let qe=se,x=Math.min(se+ve,Qe);qe<Qe;qe=x,x=Math.min(x+ve,Qe)){if(qe>se&&await new Promise(Y=>setTimeout(Y)),Fe&&Fe.isCancellationRequested)throw(0,d.canceled)();u(q,le,ze,qe,x)}return ze})().then(Me,Ne)})}e.topAsync=h;function u(q,le,se,ve,Fe){for(const Me=se.length;ve<Fe;ve++){const Ne=q[ve];if(le(Ne,se[Me-1])<0){se.pop();const Qe=C(se,ze=>le(Ne,ze)<0);se.splice(Qe,0,Ne)}}}function s(q){return q.filter(le=>!!le)}e.coalesce=s;function v(q){let le=0;for(let se=0;se<q.length;se++)q[se]&&(q[le]=q[se],le+=1);q.length=le}e.coalesceInPlace=v;function I(q,le,se){q.splice(se,0,q.splice(le,1)[0])}e.move=I;function S(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=S;function o(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=o;function g(q,le){if(!le)return q.filter((ve,Fe)=>q.indexOf(ve)===Fe);const se=Object.create(null);return q.filter(ve=>{const Fe=le(ve);return se[Fe]?!1:(se[Fe]=!0,!0)})}e.distinct=g;function k(q){const le=new Set;return q.filter(se=>le.has(se)?!1:(le.add(se),!0))}e.distinctES6=k;function i(q){const le=Object.create(null);return se=>{const ve=q(se);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function l(q,le){for(let se=q.length-1;se>=0;se--){const ve=q[se];if(le(ve))return se}return-1}e.lastIndex=l;function r(q,le){return q.length>0?q[0]:le}e.firstOrDefault=r;function a(q,le,se=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(q.length,le.length);Fe<Me&&se(q[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=a;function w(q){return[].concat(...q)}e.flatten=w;function f(q,le){let se=typeof le=="number"?q:0;typeof le=="number"?se=q:(se=0,le=q);const ve=[];if(se<=le)for(let Fe=se;Fe<le;Fe++)ve.push(Fe);else for(let Fe=se;Fe>le;Fe--)ve.push(Fe);return ve}e.range=f;function m(q,le,se){return q.reduce((ve,Fe)=>(ve[le(Fe)]=se?se(Fe):Fe,ve),Object.create(null))}e.index=m;function D(q,le){return q.push(le),()=>T(q,le)}e.insert=D;function T(q,le){const se=q.indexOf(le);if(se>-1)return q.splice(se,1),le}e.remove=T;function p(q,le,se){const ve=q.slice(0,le),Fe=q.slice(le);return ve.concat(se,Fe)}e.arrayInsert=p;function b(q,le){let se;if(typeof le=="number"){let ve=le;se=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else se=Math.random;for(let ve=q.length-1;ve>0;ve-=1){const Fe=Math.floor(se()*(ve+1)),Me=q[ve];q[ve]=q[Fe],q[Fe]=Me}}e.shuffle=b;function c(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.unshift(le))}e.pushToStart=c;function F(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.push(le))}e.pushToEnd=F;function O(q,le){return Array.isArray(q)?q.map(le):le(q)}e.mapArrayOrNot=O;function V(q){return Array.isArray(q)?q:[q]}e.asArray=V;function K(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=K;function W(q,le){for(const se of q){const ve=le(se);if(ve!==void 0)return ve}}e.mapFind=W;function Q(q,le,se){const ve=U(q,le),Fe=q.length,Me=se.length;q.length=Fe+Me;for(let Ne=Fe-1;Ne>=ve;Ne--)q[Ne+Me]=q[Ne];for(let Ne=0;Ne<Me;Ne++)q[Ne+ve]=se[Ne]}e.insertInto=Q;function $(q,le,se,ve){const Fe=U(q,le),Me=q.splice(Fe,se);return Q(q,Fe,ve),Me}e.splice=$;function U(q,le){return le<0?Math.max(le+q.length,0):Math.min(le,q.length)}function H(q,le){let se=Number.MAX_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Ne=le(Fe);Ne<se&&(se=Ne,ve=Me)}),ve}e.minIndex=H;function G(q,le){let se=Number.MIN_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Ne=le(Fe);Ne>se&&(se=Ne,ve=Me)}),ve}e.maxIndex=G;class ue{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let se=this.firstIdx;for(;se<this.items.length&&le(this.items[se]);)se++;const ve=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ve}takeFromEndWhile(le){let se=this.lastIdx;for(;se>=0&&le(this.items[se]);)se--;const ve=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ve}}e.ArrayQueue=ue}),define(be[53],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,l=!1){let r=0,a=i.length,w="",f=0,m=16,D=0;function T(K){let W=0,Q=0;for(;W<K;){const $=i.charCodeAt(r);if($>=48&&$<=57)Q=Q*16+$-48;else if($>=65&&$<=70)Q=Q*16+$-65+10;else if($>=97&&$<=102)Q=Q*16+$-97+10;else break;r++,W++}return W<K&&(Q=-1),Q}function p(K){r=K,w="",f=0,m=16,D=0}function b(){const K=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return D=3,i.substring(K,r);let W=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;W=r}else D=3;return i.substring(K,W)}function c(){let K="",W=r;for(;;){if(r>=a){K+=i.substring(W,r),D=2;break}const Q=i.charCodeAt(r);if(Q===34){K+=i.substring(W,r),r++;break}if(Q===92){if(K+=i.substring(W,r),r++,r>=a){D=2;break}switch(i.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const U=T(4);U>=0?K+=String.fromCharCode(U):D=4;break;default:D=5}W=r;continue}if(Q>=0&&Q<=31)if(y(Q)){K+=i.substring(W,r),D=2;break}else D=6;r++}return K}function F(){if(w="",D=0,f=r,r>=a)return f=a,m=17;let K=i.charCodeAt(r);if(C(K)){do r++,w+=String.fromCharCode(K),K=i.charCodeAt(r);while(C(K));return m=15}if(y(K))return r++,w+=String.fromCharCode(K),K===13&&i.charCodeAt(r)===10&&(r++,w+=`
`),m=14;switch(K){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,w=c(),m=10;case 47:const W=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<a&&!y(i.charCodeAt(r));)r++;return w=i.substring(W,r),m=12}if(i.charCodeAt(r+1)===42){r+=2;const Q=a-1;let $=!1;for(;r<Q;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,D=1),w=i.substring(W,r),m=13}return w+=String.fromCharCode(K),r++,m=16;case 45:if(w+=String.fromCharCode(K),r++,r===a||!P(i.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=b(),m=11;default:for(;r<a&&O(K);)r++,K=i.charCodeAt(r);if(f!==r){switch(w=i.substring(f,r),w){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return w+=String.fromCharCode(K),r++,m=16}}function O(K){if(C(K)||y(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:p,getPosition:()=>r,scan:l?V:F,getToken:()=>m,getTokenValue:()=>w,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>D}}e.createScanner=R;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function _(i,l){const r=[],a=new Object;let w;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(T,p,b,c){f.value=T,f.offset=p,f.length=b,f.type=c,f.colonOffset=void 0,w=f}try{o(i,{onObjectBegin:(T,p)=>{if(l<=T)throw a;w=void 0,m=l>T,r.push("")},onObjectProperty:(T,p,b)=>{if(l<p||(D(T,p,b,"property"),r[r.length-1]=T,l<=p+b))throw a},onObjectEnd:(T,p)=>{if(l<=T)throw a;w=void 0,r.pop()},onArrayBegin:(T,p)=>{if(l<=T)throw a;w=void 0,r.push(0)},onArrayEnd:(T,p)=>{if(l<=T)throw a;w=void 0,r.pop()},onLiteralValue:(T,p,b)=>{if(l<p||(D(T,p,b,k(T)),l<=p+b))throw a},onSeparator:(T,p,b)=>{if(l<=p)throw a;if(T===":"&&w&&w.type==="property")w.colonOffset=p,m=!1,w=void 0;else if(T===","){const c=r[r.length-1];typeof c=="number"?r[r.length-1]=c+1:(m=!0,r[r.length-1]=""),w=void 0}}})}catch(T){if(T!==a)throw T}return{path:r,previousNode:w,isAtPropertyKey:m,matches:T=>{let p=0;for(let b=0;p<T.length&&b<r.length;b++)if(T[p]===r[b]||T[p]==="*")p++;else if(T[p]!=="**")return!1;return p===T.length}}}e.getLocation=_;function n(i,l=[],r=A.DEFAULT){let a=null,w=[];const f=[];function m(T){Array.isArray(w)?w.push(T):a!==null&&(w[a]=T)}return o(i,{onObjectBegin:()=>{const T={};m(T),f.push(w),w=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{w=f.pop()},onArrayBegin:()=>{const T=[];m(T),f.push(w),w=T,a=null},onArrayEnd:()=>{w=f.pop()},onLiteralValue:m,onError:(T,p,b)=>{l.push({error:T,offset:p,length:b})}},r),w[0]}e.parse=n;function h(i,l=[],r=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(T){a.type==="property"&&(a.length=T-a.offset,a=a.parent)}function f(T){return a.children.push(T),T}o(i,{onObjectBegin:T=>{a=f({type:"object",offset:T,length:-1,parent:a,children:[]})},onObjectProperty:(T,p,b)=>{a=f({type:"property",offset:p,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:T,offset:p,length:b,parent:a})},onObjectEnd:(T,p)=>{a.length=T+p-a.offset,a=a.parent,w(T+p)},onArrayBegin:(T,p)=>{a=f({type:"array",offset:T,length:-1,parent:a,children:[]})},onArrayEnd:(T,p)=>{a.length=T+p-a.offset,a=a.parent,w(T+p)},onLiteralValue:(T,p,b)=>{f({type:k(T),offset:p,length:b,parent:a,value:T}),w(p+b)},onSeparator:(T,p,b)=>{a.type==="property"&&(T===":"?a.colonOffset=p:T===","&&w(p))},onError:(T,p,b)=>{l.push({error:T,offset:p,length:b})}},r);const D=a.children[0];return D&&delete D.parent,D}e.parseTree=h;function u(i,l){if(!i)return;let r=i;for(let a of l)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let w=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===a){r=f.children[1],w=!0;break}if(!w)return}else{const w=a;if(r.type!=="array"||w<0||!Array.isArray(r.children)||w>=r.children.length)return;r=r.children[w]}return r}e.findNodeAtLocation=u;function s(i){if(!i.parent||!i.parent.children)return[];const l=s(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}e.getNodePath=s;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const l=Object.create(null);for(let r of i.children){const a=r.children[1];a&&(l[r.children[0].value]=v(a))}return l;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function I(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}e.contains=I;function S(i,l,r=!1){if(I(i,l,r)){const a=i.children;if(Array.isArray(a))for(let w=0;w<a.length&&a[w].offset<=l;w++){const f=S(a[w],l,r);if(f)return f}return i}}e.findNodeAtOffset=S;function o(i,l,r=A.DEFAULT){const a=R(i,!1);function w(se){return se?()=>se(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(se){return se?ve=>se(ve,a.getTokenOffset(),a.getTokenLength()):()=>!0}const m=w(l.onObjectBegin),D=f(l.onObjectProperty),T=w(l.onObjectEnd),p=w(l.onArrayBegin),b=w(l.onArrayEnd),c=f(l.onLiteralValue),F=f(l.onSeparator),O=w(l.onComment),V=f(l.onError),K=r&&r.disallowComments,W=r&&r.allowTrailingComma;function Q(){for(;;){const se=a.scan();switch(a.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:K||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(se){case 12:case 13:K?$(10):O();break;case 16:$(1);break;case 15:case 14:break;default:return se}}}function $(se,ve=[],Fe=[]){if(V(se),ve.length+Fe.length>0){let Me=a.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){Q();break}else if(Fe.indexOf(Me)!==-1)break;Me=Q()}}}function U(se){const ve=a.getTokenValue();return se?c(ve):D(ve),Q(),!0}function H(){switch(a.getToken()){case 11:let se=0;try{se=JSON.parse(a.getTokenValue()),typeof se!="number"&&($(2),se=0)}catch(ve){$(2)}c(se);break;case 7:c(null);break;case 8:c(!0);break;case 9:c(!1);break;default:return!1}return Q(),!0}function G(){return a.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),a.getToken()===6?(F(":"),Q(),le()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ue(){m(),Q();let se=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(se||$(4,[],[]),F(","),Q(),a.getToken()===2&&W)break}else se&&$(6,[],[]);G()||$(4,[],[2,5]),se=!0}return T(),a.getToken()!==2?$(7,[2],[]):Q(),!0}function q(){p(),Q();let se=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(se||$(4,[],[]),F(","),Q(),a.getToken()===4&&W)break}else se&&$(6,[],[]);le()||$(4,[],[4,5]),se=!0}return b(),a.getToken()!==4?$(8,[4],[]):Q(),!0}function le(){switch(a.getToken()){case 3:return q();case 1:return ue();case 10:return U(!0);default:return H()}}return Q(),a.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):le()?(a.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=o;function g(i,l){let r=R(i),a=[],w,f=0,m;do switch(m=r.getPosition(),w=r.scan(),w){case 12:case 13:case 17:f!==m&&a.push(i.substring(f,m)),l!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,l)),f=r.getPosition();break}while(w!==17);return a.join("")}e.stripComments=g;function k(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(be[103],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new d(()=>E(this.getValue()))}}e.Lazy=d}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(Pe,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,De){return ye&&ie(Pe.prototype,ye),De&&ie(Pe,De),Pe}function d(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Pe[De];return Z}function E(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=d(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Pe){A.exports.defaults=Pe}A.exports={defaults:R(),getDefaults:R,changeDefaults:C};var y=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return n[ye]};function u(Pe,ye){if(ye){if(y.test(Pe))return Pe.replace(P,h)}else if(t.test(Pe))return Pe.replace(_,h);return Pe}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(s,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var I=/(^|[^\[])\^/g;function S(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(ce,ge){return ge=ge.source||ge,ge=ge.replace(I,"$1"),Pe=Pe.replace(ce,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var o=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(Pe,ye,De){if(Pe){var Z;try{Z=decodeURIComponent(v(De)).replace(o,"").toLowerCase()}catch(ce){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!g.test(De)&&(De=w(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ce){return null}return De}var i={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Pe,ye){i[" "+Pe]||(l.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=T(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(r,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(a,"$1")+ye:Pe+ye}var f={exec:function(){}};function m(Pe){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Pe[Z]=De[Z])}return Pe}function D(Pe,ye){var De=Pe.replace(/\|/g,function(ge,me,Ie){for(var Be=!1,Le=me;--Le>=0&&Ie[Le]==="\\";)Be=!Be;return Be?"|":" |"}),Z=De.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function T(Pe,ye,De){var Z=Pe.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ge=Pe.charAt(Z-ce-1);if(ge===ye&&!De)ce++;else if(ge!==ye&&De)ce++;else break}return Pe.substr(0,Z-ce)}function p(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,Z=0,ce=0;ce<De;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===ye[0])Z++;else if(Pe[ce]===ye[1]&&(Z--,Z<0))return ce;return-1}function b(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function c(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var F={escape:u,unescape:v,edit:S,cleanUrl:k,resolveUrl:w,noopTest:f,merge:m,splitCells:D,rtrim:T,findClosingBracket:p,checkSanitizeDeprecation:b,repeatString:c},O=A.exports.defaults,V=F.rtrim,K=F.splitCells,W=F.escape,Q=F.findClosingBracket;function $(Pe,ye,De,Z){var ce=ye.href,ge=ye.title?W(ye.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ie={type:"link",raw:De,href:ce,title:ge,text:me,tokens:Z.inlineTokens(me,[])};return Z.state.inLink=!1,Ie}else return{type:"image",raw:De,href:ce,title:ge,text:W(me)}}function U(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(ce){var ge=ce.match(/^\s+/);if(ge===null)return ce;var me=ge[0];return me.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var H=function(){function Pe(De){this.options=De||O}var ye=Pe.prototype;return ye.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},ye.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ge=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:V(ge,`
`)}}},ye.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ge=ce[0],me=U(ge,ce[3]||"");return{type:"code",raw:ge,lang:ce[2]?ce[2].trim():ce[2],text:me}}},ye.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ge=ce[2].trim();if(/#$/.test(ge)){var me=V(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}var Ie={type:"heading",raw:ce[0],depth:ce[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},ye.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ge=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ge,me,Ie,Be,Le,je,Xe,ne,pe,re,B=ce[1].trim(),Ce=B.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+B.slice(0,-1):"",loose:!1,items:[]};B=Ce?"\\d{1,9}\\"+B.slice(-1):"\\"+B,this.options.pedantic&&(B=Ce?B:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+B+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(ce=Ge.exec(Z)));){pe=ce[2].split(`
`),this.options.pedantic?(Be=2,re=pe[0].trimLeft()):(Be=ce[2].search(/[^ ]/),Be=ce[1].length+(Be>4?1:Be),re=pe[0].slice(Be-ce[1].length)),je=!1,ge=ce[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ce[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ne=pe[Le],this.options.pedantic&&(ne=ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ne)){ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!je){ne.trim()||(je=!0),ne.search(/[^ ]/)>=Be?re+=`
`+ne.slice(Be):re+=`
`+ne;continue}if(ne.search(/[^ ]/)>=Be||!ne.trim()){re+=`
`+ne.slice(Be);continue}else{ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Xe?Se.loose=!0:/\n *\n *$/.test(ge)&&(Xe=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(re),me&&(Ie=me[0]!=="[ ] ",re=re.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!me,checked:Ie,loose:!1,text:re}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=re.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Le=0;Le<it;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ge={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ce[0]):W(ce[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ge=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ce[0],href:ce[2],title:ce[3]}}},ye.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ge={type:"table",header:K(ce[1]).map(function(Xe){return{text:Xe}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ce[0];var me=ge.align.length,Ie,Be,Le,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(me=ge.rows.length,Ie=0;Ie<me;Ie++)ge.rows[Ie]=K(ge.rows[Ie],ge.header.length).map(function(Xe){return{text:Xe}});for(me=ge.header.length,Be=0;Be<me;Be++)ge.header[Be].tokens=[],this.lexer.inlineTokens(ge.header[Be].text,ge.header[Be].tokens);for(me=ge.rows.length,Be=0;Be<me;Be++)for(je=ge.rows[Be],Le=0;Le<je.length;Le++)je[Le].tokens=[],this.lexer.inlineTokens(je[Le].text,je[Le].tokens);return ge}}},ye.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce){var ge={type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ge={type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce){var ge={type:"text",raw:ce[0],text:ce[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:W(ce[1])}},ye.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):W(ce[0]):ce[0]}},ye.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ge=ce[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=V(ge.slice(0,-1),"\\");if((ge.length-me.length)%2==0)return}else{var Ie=Q(ce[2],"()");if(Ie>-1){var Be=ce[0].indexOf("!")===0?5:4,Le=Be+ce[1].length+Ie;ce[2]=ce[2].substring(0,Ie),ce[0]=ce[0].substring(0,Le).trim(),ce[3]=""}}var je=ce[2],Xe="";if(this.options.pedantic){var ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);ne&&(je=ne[1],Xe=ne[3])}else Xe=ce[3]?ce[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ge)?je=je.slice(1):je=je.slice(1,-1)),$(ce,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ye.reflink=function(Z,ce){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=ce[me.toLowerCase()],!me||!me.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return $(ge,me,ge[0],this.lexer)}},ye.emStrong=function(Z,ce,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(Z);if(!!me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Be=me[0].length-1,Le,je,Xe=Be,ne=0,pe=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Be);(me=pe.exec(ce))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(je=Le.length,me[3]||me[4]){Xe+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){ne+=je;continue}if(Xe-=je,!(Xe>0)){if(je=Math.min(je,je+Xe+ne),Math.min(Be,je)%2){var re=Z.slice(1,Be+me.index+je);return{type:"em",raw:Z.slice(0,Be+me.index+je+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}var B=Z.slice(2,Be+me.index+je-1);return{type:"strong",raw:Z.slice(0,Be+me.index+je+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}}}}},ye.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ge=ce[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return me&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=W(ge,!0),{type:"codespan",raw:ce[0],text:ge}}},ye.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},ye.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2],[])}},ye.autolink=function(Z,ce){var ge=this.rules.inline.autolink.exec(Z);if(ge){var me,Ie;return ge[2]==="@"?(me=W(this.options.mangle?ce(ge[1]):ge[1]),Ie="mailto:"+me):(me=W(ge[1]),Ie=me),{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.url=function(Z,ce){var ge;if(ge=this.rules.inline.url.exec(Z)){var me,Ie;if(ge[2]==="@")me=W(this.options.mangle?ce(ge[0]):ge[0]),Ie="mailto:"+me;else{var Be;do Be=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Be!==ge[0]);me=W(ge[0]),ge[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.inlineText=function(Z,ce){var ge=this.rules.inline.text.exec(Z);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):W(ge[0]):ge[0]:me=W(this.options.smartypants?ce(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},Pe}(),G=F.noopTest,ue=F.edit,q=F.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ue(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ue(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ue(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ue(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ue(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ue(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=q({},le),le.gfm=q({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ue(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=q({},le.normal,{html:ue(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:ue(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=ue(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=ue(le._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=ue(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=ue(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=ue(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=ue(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=ue(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=ue(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=ue(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=ue(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=q({},se),se.pedantic=q({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ue(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:ue(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=q({},se.normal,{escape:ue(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=ue(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=q({},se.gfm,{br:ue(se.br).replace("{2,}","*").getRegex(),text:ue(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:se},Fe=H,Me=A.exports.defaults,Ne=ve.block,Qe=ve.inline,ze=F.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var ye="",De,Z,ce=Pe.length;for(De=0;De<ce;De++)Z=Pe.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Y=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(Z.block=Ne.pedantic,Z.inline=Qe.pedantic):this.options.gfm&&(Z.block=Ne.gfm,this.options.breaks?Z.inline=Qe.breaks:Z.inline=Qe.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,ce){var ge=new Pe(ce);return ge.lex(Z)},Pe.lexInline=function(Z,ce){var ge=new Pe(ce);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ye.blockTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var me,Ie,Be,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(me=Xe.call({lexer:ge},Z,ce))?(Z=Z.substring(me.raw.length),ce.push(me),!0):!1}))){if(me=this.tokenizer.space(Z)){Z=Z.substring(me.raw.length),me.type&&ce.push(me);continue}if(me=this.tokenizer.code(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me);continue}if(me=this.tokenizer.fences(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.heading(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.hr(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.blockquote(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.list(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.html(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.def(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.lheading(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=Infinity,ne=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(re){pe=re.call({lexer:this},ne),typeof pe=="number"&&pe>=0&&(Xe=Math.min(Xe,pe))}),Xe<Infinity&&Xe>=0&&(Be=Z.substring(0,Xe+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=ce[ce.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me),Le=Be.length!==Z.length,Z=Z.substring(me.raw.length);continue}if(me=this.tokenizer.text(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me);continue}if(Z){var je="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ce},ye.inline=function(Z,ce){this.inlineQueue.push({src:Z,tokens:ce})},ye.inlineTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]);var me,Ie,Be,Le=Z,je,Xe,ne;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,je.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Xe||(ne=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(B){return(me=B.call({lexer:ge},Z,ce))?(Z=Z.substring(me.raw.length),ce.push(me),!0):!1}))){if(me=this.tokenizer.escape(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.tag(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(me=this.tokenizer.link(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(me=this.tokenizer.emStrong(Z,Le,ne)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.codespan(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.br(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.del(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.autolink(Z,x)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(Z,x))){Z=Z.substring(me.raw.length),ce.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var B=Infinity,Ce=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(Ge){Se=Ge.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(B=Math.min(B,Se))}),B<Infinity&&B>=0&&(Be=Z.substring(0,B+1))}(),me=this.tokenizer.inlineText(Be,qe)){Z=Z.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ne=me.raw.slice(-1)),Xe=!0,Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(Z){var re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return ce},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),ee=A.exports.defaults,ae=F.cleanUrl,j=F.escape,oe=function(){function Pe(De){this.options=De||ee}var ye=Pe.prototype;return ye.code=function(Z,ce,ge){var me=(ce||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,me);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+j(me,!0)+'">'+(ge?Z:j(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:j(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,ce,ge,me){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+me.slug(ge)+'">'+Z+"</h"+ce+`>
`:"<h"+ce+">"+Z+"</h"+ce+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,ce,ge){var me=ce?"ol":"ul",Ie=ce&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ie+`>
`+Z+"</"+me+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,ce){var ge=ce.header?"th":"td",me=ce.align?"<"+ge+' align="'+ce.align+'">':"<"+ge+">";return me+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<a href="'+j(Z)+'"';return ce&&(me+=' title="'+ce+'"'),me+=">"+ge+"</a>",me},ye.image=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<img src="'+Z+'" alt="'+ge+'"';return ce&&(me+=' title="'+ce+'"'),me+=this.options.xhtml?"/>":">",me},ye.text=function(Z){return Z},Pe}(),fe=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,ce,ge){return""+ge},ye.image=function(Z,ce,ge){return""+ge},ye.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,ce){var ge=Z,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[Z];do me++,ge=Z+"-"+me;while(this.seen.hasOwnProperty(ge))}return ce||(this.seen[Z]=me,this.seen[ge]=0),ge},ye.slug=function(Z,ce){ce===void 0&&(ce={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,ce.dryrun)},Pe}(),xe=oe,$e=fe,we=Ae,Ze=A.exports.defaults,z=F.unescape,J=function(){function Pe(De){this.options=De||Ze,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new we}Pe.parse=function(Z,ce){var ge=new Pe(ce);return ge.parse(Z)},Pe.parseInline=function(Z,ce){var ge=new Pe(ce);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,ce){ce===void 0&&(ce=!0);var ge="",me,Ie,Be,Le,je,Xe,ne,pe,re,B,Ce,Se,Ge,We,it,mt,vt,nt,ot,lt=Z.length;for(me=0;me<lt;me++){if(B=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(ot=this.options.extensions.renderers[B.type].call({parser:this},B),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(B.type))){ge+=ot||"";continue}switch(B.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(B.tokens),B.depth,z(this.parseInline(B.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(B.text,B.lang,B.escaped);continue}case"table":{for(pe="",ne="",Le=B.header.length,Ie=0;Ie<Le;Ie++)ne+=this.renderer.tablecell(this.parseInline(B.header[Ie].tokens),{header:!0,align:B.align[Ie]});for(pe+=this.renderer.tablerow(ne),re="",Le=B.rows.length,Ie=0;Ie<Le;Ie++){for(Xe=B.rows[Ie],ne="",je=Xe.length,Be=0;Be<je;Be++)ne+=this.renderer.tablecell(this.parseInline(Xe[Be].tokens),{header:!1,align:B.align[Be]});re+=this.renderer.tablerow(ne)}ge+=this.renderer.table(pe,re);continue}case"blockquote":{re=this.parse(B.tokens),ge+=this.renderer.blockquote(re);continue}case"list":{for(Ce=B.ordered,Se=B.start,Ge=B.loose,Le=B.items.length,re="",Ie=0;Ie<Le;Ie++)it=B.items[Ie],mt=it.checked,vt=it.task,We="",it.task&&(nt=this.renderer.checkbox(mt),Ge?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=nt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=nt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(it.tokens,Ge),re+=this.renderer.listitem(We,vt,mt);ge+=this.renderer.list(re,Ce,Se);continue}case"html":{ge+=this.renderer.html(B.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(B.tokens));continue}case"text":{for(re=B.tokens?this.parseInline(B.tokens):B.text;me+1<lt&&Z[me+1].type==="text";)B=Z[++me],re+=`
`+(B.tokens?this.parseInline(B.tokens):B.text);ge+=ce?this.renderer.paragraph(re):re;continue}default:{var Rt='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return ge},ye.parseInline=function(Z,ce){ce=ce||this.renderer;var ge="",me,Ie,Be,Le=Z.length;for(me=0;me<Le;me++){if(Ie=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=Be||"";continue}switch(Ie.type){case"escape":{ge+=ce.text(Ie.text);break}case"html":{ge+=ce.html(Ie.text);break}case"link":{ge+=ce.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ce));break}case"image":{ge+=ce.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ce.strong(this.parseInline(Ie.tokens,ce));break}case"em":{ge+=ce.em(this.parseInline(Ie.tokens,ce));break}case"codespan":{ge+=ce.codespan(Ie.text);break}case"br":{ge+=ce.br();break}case"del":{ge+=ce.del(this.parseInline(Ie.tokens,ce));break}case"text":{ge+=ce.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ge},Pe}(),he=Y,Oe=J,Ve=H,tt=oe,ut=fe,ht=Ae,St=F.merge,Pt=F.checkSanitizeDeprecation,dt=F.escape,bt=A.exports.getDefaults,ft=A.exports.changeDefaults,Et=A.exports.defaults;function Ye(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=St({},Ye.defaults,ye||{}),Pt(ye),De){var Z=ye.highlight,ce;try{ce=he.lex(Pe,ye)}catch(Be){return De(Be)}var ge=function(Le){var je;if(!Le)try{ye.walkTokens&&Ye.walkTokens(ce,ye.walkTokens),je=Oe.parse(ce,ye)}catch(Xe){Le=Xe}return ye.highlight=Z,Le?De(Le):De(null,je)};if(!Z||Z.length<3||(delete ye.highlight,!ce.length))return ge();var me=0;Ye.walkTokens(ce,function(Be){Be.type==="code"&&(me++,setTimeout(function(){Z(Be.text,Be.lang,function(Le,je){if(Le)return ge(Le);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}try{var Ie=he.lex(Pe,ye);return ye.walkTokens&&Ye.walkTokens(Ie,ye.walkTokens),Oe.parse(Ie,ye)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Be.message+"",!0)+"</pre>";throw Be}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),ft(Ye.defaults),Ye},Ye.getDefaults=bt,Ye.defaults=Et,Ye.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var ce=St.apply(void 0,[{}].concat(De)),ge=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var je=ge.renderers?ge.renderers[Le.name]:null;je?ge.renderers[Le.name]=function(){for(var Xe=arguments.length,ne=new Array(Xe),pe=0;pe<Xe;pe++)ne[pe]=arguments[pe];var re=Le.renderer.apply(this,ne);return re===!1&&(re=je.apply(this,ne)),re}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Ye.defaults.renderer||new tt,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var Ge=Ie.renderer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.renderer)je(Xe);ce.renderer=Le}(),Ie.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new Ve,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var Ge=Ie.tokenizer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.tokenizer)je(Xe);ce.tokenizer=Le}(),Ie.walkTokens){var Be=Ye.defaults.walkTokens;ce.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),Be&&Be(Le)}}me&&(ce.extensions=ge),Ye.setOptions(ce)})},Ye.walkTokens=function(Pe,ye){for(var De=function(){var me=ce.value;switch(ye(me),me.type){case"table":{for(var Ie=E(me.header),Be;!(Be=Ie()).done;){var Le=Be.value;Ye.walkTokens(Le.tokens,ye)}for(var je=E(me.rows),Xe;!(Xe=je()).done;)for(var ne=Xe.value,pe=E(ne),re;!(re=pe()).done;){var B=re.value;Ye.walkTokens(B.tokens,ye)}break}case"list":{Ye.walkTokens(me.items,ye);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(Ce){Ye.walkTokens(me[Ce],ye)}):me.tokens&&Ye.walkTokens(me.tokens,ye)}},Z=E(Pe),ce;!(ce=Z()).done;)De()},Ye.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=St({},Ye.defaults,ye||{}),Pt(ye);try{var De=he.lexInline(Pe,ye);return ye.walkTokens&&Ye.walkTokens(De,ye.walkTokens),Oe.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Z.message+"",!0)+"</pre>";throw Z}},Ye.Parser=Oe,Ye.parser=Oe.parse,Ye.Renderer=tt,Ye.TextRenderer=ut,Ye.Lexer=he,Ye.lexer=he.lex,Ye.Tokenizer=Ve,Ye.Slugger=ht,Ye.parse=Ye;var Ct=Ye;return Ct}),define(be[75],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(R,C,y){return Math.min(Math.max(R,C),y)}e.clamp=d;function M(R,C){return(C+R%C)%C}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function ie(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function R(y){A.push(y,Date.now())}function C(){const y=[];for(let P=0;P<A.length;P+=2)y.push({name:A[P],startTime:A[P+1]});return y}return{mark:R,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(E+R.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function d(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[104],Ee([0,1]),function(ie,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,y,P){this.level=C,this.key=y,this.value=P,this.forward=[]}}const E=void 0;class A{constructor(C,y=2**16){this.comparator=C,this[d]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new M(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,E,E)}has(C){return Boolean(A._search(this,C,this.comparator))}get(C){return A._search(this,C,this.comparator)?.value}set(C,y){return A._insert(this,C,y,this.comparator)&&(this._size+=1),this}delete(C){const y=A._delete(this,C,this.comparator);return y&&(this._size-=1),y}forEach(C,y){let P=this._header.forward[0];for(;P;)C.call(y,P.value,P.key,this),P=P.forward[0]}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",y=this._header.forward[0];for(;y;)C+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return C}static _search(C,y,P){let t=C._header;for(let _=C._level-1;_>=0;_--)for(;t.forward[_]&&P(t.forward[_].key,y)<0;)t=t.forward[_];if(t=t.forward[0],t&&P(t.key,y)===0)return t}static _insert(C,y,P,t){let _=[],n=C._header;for(let h=C._level-1;h>=0;h--){for(;n.forward[h]&&t(n.forward[h].key,y)<0;)n=n.forward[h];_[h]=n}if(n=n.forward[0],n&&t(n.key,y)===0)return n.value=P,!1;{let h=A._randomLevel(C);if(h>C._level){for(let u=C._level;u<h;u++)_[u]=C._header;C._level=h}n=new M(h,y,P);for(let u=0;u<h;u++)n.forward[u]=_[u].forward[u],_[u].forward[u]=n;return!0}}static _randomLevel(C,y=.5){let P=1;for(;Math.random()<y&&P<C._maxLevel;)P+=1;return P}static _delete(C,y,P){let t=[],_=C._header;for(let n=C._level-1;n>=0;n--){for(;_.forward[n]&&P(_.forward[n].key,y)<0;)_=_.forward[n];t[n]=_}if(_=_.forward[0],!_||P(_.key,y)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===_;n++)t[n].forward[n]=_.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===E;)C._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(_){const n=this._icons.get(_.id);n?_.description?n.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,_){return new C(t,_)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(_,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=R;class C{constructor(_,n,h){this.id=_,this.definition=n,this.description=h,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function y(t,_){const n=["codicon","codicon-"+t];return _&&n.push("codicon-modifier-"+_),n}e.getClassNamesArray=y;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(s){if(s instanceof C)return["codicon","codicon-"+s.id];const v=_.exec(s.id);if(!v)return n(C.error);let[,I,S]=v;const o=["codicon","codicon-"+I];return S&&o.push("codicon-modifier-"+S.substr(1)),o}t.asClassNameArray=n;function h(s){return n(s).join(" ")}t.asClassName=h;function u(s){return"."+n(s).join(".")}t.asCSSSelector=u})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(o){const g=o;return g?[g.on,g.pause,g.resume,g.destroy].every(k=>typeof k=="function"):!1}e.isReadableStream=E;function A(o){const g=o;return g?E(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(o,g){return new C(o,g)}e.newWriteableStream=R;class C{constructor(g,k){this.reducer=g,this.options=k,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(k=>this.pendingWritePromises.push(k))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(k=>k(g))}emitError(g){this.listeners.error.length===0?(0,d.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(k=>k(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,k){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(k),this.resume();break;case"end":this.listeners.end.push(k),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(k),this.state.flowing&&this.flowErrors();break}}removeListener(g,k){if(this.state.destroyed)return;let i;switch(g){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const l=i.indexOf(k);l>=0&&i.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const k=[...this.pendingWritePromises];this.pendingWritePromises.length=0,k.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(o,g){const k=[];let i;for(;(i=o.read())!==null;)k.push(i);return g(k)}e.consumeReadable=y;function P(o,g,k){const i=[];let l;for(;(l=o.read())!==null&&i.length<k;)i.push(l);return l===null&&i.length>0?g(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l!="undefined"){const r=l;return l=void 0,r}return o.read()}}}e.peekReadable=P;function t(o,g){return new Promise((k,i)=>{const l=[];_(o,{onData:r=>{g&&l.push(r)},onError:r=>{g?i(r):k(void 0)},onEnd:()=>{k(g?g(l):void 0)}})})}e.consumeStream=t;function _(o,g){o.on("error",k=>g.onError(k)),o.on("end",()=>g.onEnd()),o.on("data",k=>g.onData(k))}e.listenStream=_;function n(o,g){return new Promise((k,i)=>{const l=new M.DisposableStore,r=[],a=m=>{if(r.push(m),r.length>g)return l.dispose(),o.pause(),k({stream:o,buffer:r,ended:!1})},w=m=>i(m),f=()=>k({stream:o,buffer:r,ended:!0});l.add((0,M.toDisposable)(()=>o.removeListener("error",w))),o.on("error",w),l.add((0,M.toDisposable)(()=>o.removeListener("end",f))),o.on("end",f),l.add((0,M.toDisposable)(()=>o.removeListener("data",a))),o.on("data",a)})}e.peekStream=n;function h(o,g){const k=R(g);return k.end(o),k}e.toStream=h;function u(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=u;function s(o){let g=!1;return{read:()=>g?null:(g=!0,o)}}e.toReadable=s;function v(o,g,k){const i=R(k);return _(o,{onData:l=>i.write(g.data(l)),onError:l=>i.error(g.error?g.error(l):l),onEnd:()=>i.end()}),i}e.transform=v;function I(o,g,k){let i=!1;return{read:()=>{const l=g.read();return i?l:(i=!0,l!==null?k([o,l]):o)}}}e.prefixedReadable=I;function S(o,g,k){let i=!1;const l=R(k);return _(g,{onData:r=>i?l.write(r):(i=!0,l.write(k([o,r]))),onError:r=>l.error(r),onEnd:()=>{i||(i=!0,l.write(o)),l.end()}}),l}e.prefixedStream=S}),define(be[23],Ee([0,1,105]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class R{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return M?new R(Buffer.allocUnsafe(a)):new R(new Uint8Array(a))}static wrap(a){return M&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new R(a)}static fromString(a,w){return!(w?.dontUseNodeBuffer||!1)&&M?new R(Buffer.from(a)):(E||(E=new TextEncoder),new R(E.encode(a)))}static concat(a,w){if(typeof w=="undefined"){w=0;for(let D=0,T=a.length;D<T;D++)w+=a[D].byteLength}const f=R.alloc(w);let m=0;for(let D=0,T=a.length;D<T;D++){const p=a[D];f.set(p,m),m+=p.byteLength}return f}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(a,w){return new R(this.buffer.subarray(a,w))}set(a,w){a instanceof R?this.buffer.set(a.buffer,w):this.buffer.set(a,w)}readUInt32BE(a){return P(this.buffer,a)}writeUInt32BE(a,w){t(this.buffer,a,w)}readUInt32LE(a){return _(this.buffer,a)}writeUInt32LE(a,w){n(this.buffer,a,w)}readUInt8(a){return h(this.buffer,a)}writeUInt8(a,w){u(this.buffer,a,w)}}e.VSBuffer=R;function C(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0}e.readUInt16LE=C;function y(r,a,w){r[w+0]=a&255,a=a>>>8,r[w+1]=a&255}e.writeUInt16LE=y;function P(r,a){return r[a]*2**24+r[a+1]*2**16+r[a+2]*2**8+r[a+3]}e.readUInt32BE=P;function t(r,a,w){r[w+3]=a,a=a>>>8,r[w+2]=a,a=a>>>8,r[w+1]=a,a=a>>>8,r[w]=a}e.writeUInt32BE=t;function _(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0|r[a+2]<<16>>>0|r[a+3]<<24>>>0}e.readUInt32LE=_;function n(r,a,w){r[w+0]=a&255,a=a>>>8,r[w+1]=a&255,a=a>>>8,r[w+2]=a&255,a=a>>>8,r[w+3]=a&255}e.writeUInt32LE=n;function h(r,a){return r[a]}e.readUInt8=h;function u(r,a,w){r[w]=a}e.writeUInt8=u;function s(r){return d.consumeReadable(r,a=>R.concat(a))}e.readableToBuffer=s;function v(r){return d.toReadable(r)}e.bufferToReadable=v;function I(r){return d.consumeStream(r,a=>R.concat(a))}e.streamToBuffer=I;async function S(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=S;function o(r){return d.toStream(r,a=>R.concat(a))}e.bufferToStream=o;function g(r){return d.transform(r,{data:a=>typeof a=="string"?R.fromString(a):R.wrap(a)},a=>R.concat(a))}e.streamToBufferReadableStream=g;function k(r){return d.newWriteableStream(a=>R.concat(a),r)}e.newWriteableBufferStream=k;function i(r,a){return d.prefixedReadable(r,a,w=>R.concat(w))}e.prefixedBufferReadable=i;function l(r,a){return d.prefixedStream(r,a,w=>R.concat(w))}e.prefixedBufferStream=l}),define(be[35],Ee([0,1,9]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",R="warning",C="warn",y="info",P="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?E.Error:d.equalsIgnoreCase(R,n)||d.equalsIgnoreCase(C,n)?E.Warning:d.equalsIgnoreCase(y,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(n){switch(n){case E.Error:return A;case E.Warning:return R;case E.Info:return y;default:return P}}E.toString=_}(M||(M={})),e.default=M}),define(be[41],Ee([0,1,17,26,9,10]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function C(r){return r.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=C;function y(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function P(r,a=d.posix.sep){if(!r)return"";const w=r.length,f=r.charCodeAt(0);if(R(f)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let D=3;const T=D;for(;D<w&&!R(r.charCodeAt(D));D++);if(T!==D&&!R(r.charCodeAt(D+1))){for(D+=1;D<w;D++)if(R(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,a)}}return a}else if(I(f)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<w;m++)if(R(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const f=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(f===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,a=M.isWindows){const w=a?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=u;function s(r,a,w){const f=r===a;return!w||f?f:!r||!a?!1:(0,E.equalsIgnoreCase)(r,a)}e.isEqual=s;function v(r,a,w,f=d.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,E.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let D=a.length;return a.charAt(a.length-1)===f&&D--,r.charAt(D)===f}return a.charAt(a.length-1)!==f&&(a+=f),r.indexOf(a)===0}e.isEqualOrParent=v;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function S(r,a){return M.isWindows&&r.endsWith(":")&&(r+=d.sep),(0,d.isAbsolute)(r)||(r=(0,d.join)(a,r)),r=(0,d.normalize)(r),M.isWindows?(r=(0,E.rtrim)(r,d.sep),r.endsWith(":")&&(r+=d.sep)):(r=(0,E.rtrim)(r,d.sep),r||(r=d.sep)),r}e.sanitizeFilePath=S;function o(r){const a=(0,d.normalize)(r);return M.isWindows?r.length>3?!1:g(a)&&(r.length===2||a.charCodeAt(2)===92):a===d.posix.sep}e.isRootOrDriveLetter=o;function g(r){return M.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function k(r){return g(r)?r[0]:void 0}e.getDriveLetter=k;function i(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function l(r){const a=r.split(":");let w,f,m;if(a.forEach(D=>{const T=Number(D);(0,A.isNumber)(T)?f===void 0?f=T:m===void 0&&(m=T):w=w?[w,D].join(":"):D}),!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(be[22],Ee([0,1,10]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const v=Array.isArray(s)?[]:{};return Object.keys(s).forEach(I=>{s[I]&&typeof s[I]=="object"?v[I]=M(s[I]):v[I]=s[I]}),v}e.deepClone=M;function E(s){if(!s||typeof s!="object")return s;const v=[s];for(;v.length>0;){const I=v.shift();Object.freeze(I);for(const S in I)if(A.call(I,S)){const o=I[S];typeof o=="object"&&!Object.isFrozen(o)&&v.push(o)}}return s}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function R(s,v){return C(s,v,new Set)}e.cloneAndChange=R;function C(s,v,I){if((0,d.isUndefinedOrNull)(s))return s;const S=v(s);if(typeof S!="undefined")return S;if((0,d.isArray)(s)){const o=[];for(const g of s)o.push(C(g,v,I));return o}if((0,d.isObject)(s)){if(I.has(s))throw new Error("Cannot clone recursive data-structure");I.add(s);const o={};for(let g in s)A.call(s,g)&&(o[g]=C(s[g],v,I));return I.delete(s),o}return s}function y(s,v,I=!0){return(0,d.isObject)(s)?((0,d.isObject)(v)&&Object.keys(v).forEach(S=>{S in s?I&&((0,d.isObject)(s[S])&&(0,d.isObject)(v[S])?y(s[S],v[S],I):s[S]=v[S]):s[S]=v[S]}),s):v}e.mixin=y;function P(s,v){if(s===v)return!0;if(s==null||v===null||v===void 0||typeof s!=typeof v||typeof s!="object"||Array.isArray(s)!==Array.isArray(v))return!1;let I,S;if(Array.isArray(s)){if(s.length!==v.length)return!1;for(I=0;I<s.length;I++)if(!P(s[I],v[I]))return!1}else{const o=[];for(S in s)o.push(S);o.sort();const g=[];for(S in v)g.push(S);if(g.sort(),!P(o,g))return!1;for(I=0;I<o.length;I++)if(!P(s[o[I]],v[o[I]]))return!1}return!0}e.equals=P;function t(s){const v=new Set;return JSON.stringify(s,(I,S)=>{if((0,d.isObject)(S)||Array.isArray(S)){if(v.has(S))return"[Circular]";v.add(S)}return S})}e.safeStringify=t;function _(s,v,I){const S=v(s);return typeof S=="undefined"?I:S}e.getOrDefault=_;function n(s,v){const I=Object.create(null);return!s||!v||Object.keys(v).forEach(o=>{const g=s[o],k=v[o];P(g,k)||(I[o]=k)}),I}e.distinct=n;function h(s,v){const I=v.toLowerCase(),S=Object.keys(s).find(o=>o.toLowerCase()===I);return S?s[S]:s[v]}e.getCaseInsensitive=h;function u(s,v){const I=Object.create(null);for(const S of Object.keys(s))v(S,s[S])&&(I[S]=s[S]);return I}e.filter=u});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[20],Ee([0,1,13,9,2]),function(ie,e,d,M,E){"use strict";var A,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(l,r,a){let w=l.get(r);return w===void 0&&(w=a,l.set(r,w)),w}e.getOrSet=y;function P(l){const r=[];return l.forEach((a,w)=>{r.push(`${w} => ${a}`)}),`Map(${l.size}) {${r.join(", ")}}`}e.mapToString=P;function t(l){const r=[];return l.forEach(a=>{r.push(a)}),`Set(${l.size}) {${r.join(", ")}}`}e.setToString=t;class _{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),w=this._value.charCodeAt(this._pos);return a-w}value(){return this._value[this._pos]}}e.StringIterator=_;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class h{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var u;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(u||(u={}));class s{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new s(r))}static forPaths(){return new I(new h)}static forStrings(){return new I(new _)}static forConfigKeys(){return new I(new n)}clear(){this._root=void 0}set(r,a){const w=this._iter.reset(r);let f;for(this._root||(this._root=new v,this._root.segment=w.value()),f=this._root;;){const D=w.cmp(f.segment);if(D>0)f.left||(f.left=new v,f.left.segment=w.value()),f=f.left;else if(D<0)f.right||(f.right=new v,f.right.segment=w.value()),f=f.right;else if(w.hasNext())w.next(),f.mid||(f.mid=new v,f.mid.segment=w.value()),f=f.mid;else break}const m=f.value;return f.value=a,f.key=r,m}fill(r,a){const w=a.slice(0);(0,d.shuffle)(w);for(let f of w)this.set(f,r)}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let w=this._root;for(;w;){const f=a.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(a.hasNext())a.next(),w=w.mid;else break}return w}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const w=this._iter.reset(r),f=[];let m=this._root;for(;m;){const D=w.cmp(m.segment);if(D>0)f.push([1,m]),m=m.left;else if(D<0)f.push([-1,m]),m=m.right;else if(w.hasNext())w.next(),f.push([0,m]),m=m.mid;else{for(a?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;f.length>0&&m.isEmpty();){let[T,p]=f.pop();switch(T){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}m=p}break}}}findSubstr(r){const a=this._iter.reset(r);let w=this._root,f;for(;w;){const m=a.cmp(w.segment);if(m>0)w=w.left;else if(m<0)w=w.right;else if(a.hasNext())a.next(),f=w.value||f,w=w.mid;else break}return w&&w.value||f}findSuperstr(r){const a=this._iter.reset(r);let w=this._root;for(;w;){const f=a.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(a.hasNext())a.next(),w=w.mid;else return w.mid?this._entries(w.mid):void 0}}forEach(r){for(const[a,w]of this)r(w,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const a=[r];for(;a.length>0;){const w=a.pop();w&&(w.value&&(yield[w.key,w.value]),w.left&&a.push(w.left),w.mid&&a.push(w.mid),w.right&&a.push(w.right))}}}e.TernarySearchTree=I;class S{constructor(r,a){this[A]="ResourceMap",r instanceof S?(this.map=new Map(r.map),this.toKey=a??S.defaultToKey):(this.map=new Map,this.toKey=r??S.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[w,f]of this.map)r(f,E.URI.parse(w),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=S,S.defaultToKey=l=>l.toString();var o;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class g{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const w=this._map.get(r);if(!!w)return a!==0&&this.touch(w,a),w.value}set(r,a,w=0){let f=this._map.get(r);if(f)f.value=a,w!==0&&this.touch(f,w);else{switch(f={key:r,value:a,next:void 0,previous:void 0},w){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(r,f),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const w=this._state;let f=this._head;for(;f;){if(a?r.bind(a)(f.value,f.key,this):r(f.value,f.key,this),this._state!==w)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,a=this._state;let w=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const m={value:w.key,done:!1};return w=w.next,m}else return{value:void 0,done:!0}}};return f}values(){const r=this,a=this._state;let w=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const m={value:w.value,done:!1};return w=w.next,m}else return{value:void 0,done:!0}}};return f}entries(){const r=this,a=this._state;let w=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const m={value:[w.key,w.value],done:!1};return w=w.next,m}else return{value:void 0,done:!0}}};return f}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,w=this.size;for(;a&&w>r;)this._map.delete(a.key),a=a.next,w--;this._head=a,this._size=w,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,w=r.previous;if(!a||!w)throw new Error("Invalid list");a.previous=w,w.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const w=r.next,f=r.previous;r===this._tail?(f.next=void 0,this._tail=f):(w.previous=f,f.next=w),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const w=r.next,f=r.previous;r===this._head?(w.previous=void 0,this._head=w):(w.previous=f,f.next=w),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,w)=>{r.push([w,a])}),r}fromJSON(r){this.clear();for(const[a,w]of r)this.set(a,w)}}e.LinkedMap=g;class k extends g{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=k;class i{constructor(r){C.set(this,void 0),Je(this,C,r,"f")}get size(){return Te(this,C,"f").size}forEach(r,a){Te(this,C,"f").forEach(r,a)}get(r){return Te(this,C,"f").get(r)}has(r){return Te(this,C,"f").has(r)}entries(){return Te(this,C,"f").entries()}keys(){return Te(this,C,"f").keys()}values(){return Te(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Te(this,C,"f").entries()}}e.ReadonlyMapView=i}),define(be[106],Ee([0,1,20,9]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...j){return function(oe,fe){for(let Ae=0,xe=j.length;Ae<xe;Ae++){const $e=j[Ae](oe,fe);if($e)return $e}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(j,oe,fe){if(!fe||fe.length<oe.length)return null;let Ae;return j?Ae=M.startsWithIgnoreCase(fe,oe):Ae=fe.indexOf(oe)===0,Ae?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(j,oe){const fe=oe.toLowerCase().indexOf(j.toLowerCase());return fe===-1?null:[{start:fe,end:fe+j.length}]}e.matchesContiguousSubString=R;function C(j,oe){return y(j.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function y(j,oe,fe,Ae){if(fe===j.length)return[];if(Ae===oe.length)return null;if(j[fe]===oe[Ae]){let xe=null;return(xe=y(j,oe,fe+1,Ae+1))?I({start:Ae,end:Ae+1},xe):null}return y(j,oe,fe,Ae+1)}function P(j){return 97<=j&&j<=122}function t(j){return 65<=j&&j<=90}e.isUpper=t;function _(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(j=>h.add(j.charCodeAt(0)));function u(j){return n(j)||h.has(j)}function s(j,oe){return j===oe||u(j)&&u(oe)}function v(j){return P(j)||t(j)||_(j)}function I(j,oe){return oe.length===0?oe=[j]:j.end===oe[0].start?oe[0].start=j.start:oe.unshift(j),oe}function S(j,oe){for(let fe=oe;fe<j.length;fe++){const Ae=j.charCodeAt(fe);if(t(Ae)||_(Ae)||fe>0&&!v(j.charCodeAt(fe-1)))return fe}return j.length}function o(j,oe,fe,Ae){if(fe===j.length)return[];if(Ae===oe.length)return null;if(j[fe]!==oe[Ae].toLowerCase())return null;{let xe=null,$e=Ae+1;for(xe=o(j,oe,fe+1,Ae+1);!xe&&($e=S(oe,$e))<oe.length;)xe=o(j,oe,fe+1,$e),$e++;return xe===null?null:I({start:Ae,end:Ae+1},xe)}}function g(j){let oe=0,fe=0,Ae=0,xe=0,$e=0;for(let he=0;he<j.length;he++)$e=j.charCodeAt(he),t($e)&&oe++,P($e)&&fe++,v($e)&&Ae++,_($e)&&xe++;const we=oe/j.length,Ze=fe/j.length,z=Ae/j.length,J=xe/j.length;return{upperPercent:we,lowerPercent:Ze,alphaPercent:z,numericPercent:J}}function k(j){const{upperPercent:oe,lowerPercent:fe}=j;return fe===0&&oe>.6}function i(j){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ae,numericPercent:xe}=j;return fe>.2&&oe<.8&&Ae>.6&&xe<.2}function l(j){let oe=0,fe=0,Ae=0,xe=0;for(let $e=0;$e<j.length;$e++)Ae=j.charCodeAt($e),t(Ae)&&oe++,P(Ae)&&fe++,n(Ae)&&xe++;return(oe===0||fe===0)&&xe===0?j.length<=30:oe<=5}function r(j,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!l(j)||oe.length>60)return null;const fe=g(oe);if(!i(fe)){if(!k(fe))return null;oe=oe.toLowerCase()}let Ae=null,xe=0;for(j=j.toLowerCase();xe<oe.length&&(Ae=o(j,oe,0,xe))===null;)xe=S(oe,xe+1);return Ae}e.matchesCamelCase=r;function a(j,oe,fe=!1){if(!oe||oe.length===0)return null;let Ae=null,xe=0;for(j=j.toLowerCase(),oe=oe.toLowerCase();xe<oe.length&&(Ae=w(j,oe,0,xe,fe))===null;)xe=f(oe,xe+1);return Ae}e.matchesWords=a;function w(j,oe,fe,Ae,xe){if(fe===j.length)return[];if(Ae===oe.length)return null;if(s(j.charCodeAt(fe),oe.charCodeAt(Ae))){let $e=null,we=Ae+1;if($e=w(j,oe,fe+1,Ae+1,xe),!xe)for(;!$e&&(we=f(oe,we))<oe.length;)$e=w(j,oe,fe+1,we,xe),we++;return $e===null?null:I({start:Ae,end:Ae+1},$e)}else return null}function f(j,oe){for(let fe=oe;fe<j.length;fe++)if(u(j.charCodeAt(fe))||fe>0&&u(j.charCodeAt(fe-1)))return fe;return j.length}const m=E(e.matchesPrefix,r,R),D=E(e.matchesPrefix,r,C),T=new d.LRUCache(1e4);function p(j,oe,fe=!1){if(typeof j!="string"||typeof oe!="string")return null;let Ae=T.get(j);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(j),"i"),T.set(j,Ae));const xe=Ae.exec(oe);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?D(j,oe):m(j,oe)}e.matchesFuzzy=p;function b(j,oe){const fe=Qe(j,j.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return fe?F(fe):null}e.matchesFuzzy2=b;function c(j,oe,fe,Ae,xe,$e){const we=Math.min(13,j.length);for(;fe<we;fe++){const Ze=Qe(j,oe,fe,Ae,xe,$e,!1);if(Ze)return Ze}return[0,$e]}e.anyScore=c;function F(j){if(typeof j=="undefined")return[];const oe=[],fe=j[1];for(let Ae=j.length-1;Ae>1;Ae--){const xe=j[Ae]+fe,$e=oe[oe.length-1];$e&&$e.end===xe?$e.end=xe+1:oe.push({start:xe,end:xe+1})}return oe}e.createMatches=F;const O=128;function V(){const j=[],oe=[];for(let fe=0;fe<=O;fe++)oe[fe]=0;for(let fe=0;fe<=O;fe++)j.push(oe.slice(0));return j}function K(j){const oe=[];for(let fe=0;fe<=j;fe++)oe[fe]=0;return oe}const W=K(2*O),Q=K(2*O),$=V(),U=V(),H=V(),G=!1;function ue(j,oe,fe,Ae,xe){function $e(Ze,z,J=" "){for(;Ze.length<z;)Ze=J+Ze;return Ze}let we=` |   |${Ae.split("").map(Ze=>$e(Ze,3)).join("|")}
`;for(let Ze=0;Ze<=fe;Ze++)Ze===0?we+=" |":we+=`${oe[Ze-1]}|`,we+=j[Ze].slice(0,xe+1).map(z=>$e(z.toString(),3)).join("|")+`
`;return we}function q(j,oe,fe,Ae){j=j.substr(oe),fe=fe.substr(Ae),console.log(ue(U,j,j.length,fe,fe.length)),console.log(ue(H,j,j.length,fe,fe.length)),console.log(ue($,j,j.length,fe,fe.length))}function le(j,oe){if(oe<0||oe>=j.length)return!1;const fe=j.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(fe)}}function se(j,oe){if(oe<0||oe>=j.length)return!1;switch(j.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(j,oe,fe){return oe[j]!==fe[j]}function Fe(j,oe,fe,Ae,xe,$e,we=!1){for(;oe<fe&&xe<$e;)j[oe]===Ae[xe]&&(we&&(W[oe]=xe),oe+=1),xe+=1;return oe===fe}e.isPatternInWord=Fe;var Me;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Ne;(function(j){j.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}j.isDefault=oe})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(j,oe,fe,Ae,xe,$e,we){const Ze=j.length>O?O:j.length,z=Ae.length>O?O:Ae.length;if(fe>=Ze||$e>=z||Ze-fe>z-$e||!Fe(oe,fe,Ze,xe,$e,z,!0))return;ze(Ze,z,fe,$e,oe,xe);let J=1,he=1,Oe=fe,Ve=$e;const tt=[!1];for(J=1,Oe=fe;Oe<Ze;J++,Oe++){const dt=W[Oe],bt=Q[Oe],ft=Oe+1<Ze?Q[Oe+1]:z;for(he=dt-$e+1,Ve=dt;Ve<ft;he++,Ve++){let Et=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=bt&&(Et=qe(j,oe,Oe,fe,Ae,xe,Ve,z,$e,$[J-1][he-1]===0,tt));let Ct=0;Et!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ct=Et+U[J-1][he-1]);const Pe=Ve>dt,ye=Pe?U[J][he-1]+($[J][he-1]>0?-5:0):0,De=Ve>dt+1&&$[J][he-1]>0,Z=De?U[J][he-2]+($[J][he-2]>0?-5:0):0;if(De&&(!Pe||Z>=ye)&&(!Ye||Z>=Ct))U[J][he]=Z,H[J][he]=3,$[J][he]=0;else if(Pe&&(!Ye||ye>=Ct))U[J][he]=ye,H[J][he]=2,$[J][he]=0;else if(Ye)U[J][he]=Ct,H[J][he]=1,$[J][he]=$[J-1][he-1]+1;else throw new Error("not possible")}}if(G&&q(j,fe,Ae,$e),!tt[0]&&!we)return;J--,he--;const ut=[U[J][he],$e];let ht=0,St=0;for(;J>=1;){let dt=he;do{const bt=H[J][dt];if(bt===3)dt=dt-2;else if(bt===2)dt=dt-1;else break}while(dt>=1);ht>1&&oe[fe+J-1]===xe[$e+he-1]&&!ve(dt+$e-1,Ae,xe)&&ht+1>$[J][dt]&&(dt=he),dt===he?ht++:ht=1,St||(St=dt),J--,he=dt-1,ut.push(he)}z===Ze&&(ut[0]+=2);const Pt=St-Ze;return ut[0]-=Pt,ut}e.fuzzyScore=Qe;function ze(j,oe,fe,Ae,xe,$e){let we=j-1,Ze=oe-1;for(;we>=fe&&Ze>=Ae;)xe[we]===$e[Ze]&&(Q[we]=Ze,we--),Ze--}function qe(j,oe,fe,Ae,xe,$e,we,Ze,z,J,he){if(oe[fe]!==$e[we])return Number.MIN_SAFE_INTEGER;let Oe=1,Ve=!1;return we===fe-Ae?Oe=j[fe]===xe[we]?7:5:ve(we,xe,$e)&&(we===0||!ve(we-1,xe,$e))?(Oe=j[fe]===xe[we]?7:5,Ve=!0):le($e,we)&&(we===0||!le($e,we-1))?Oe=5:(le($e,we-1)||se($e,we-1))&&(Oe=5,Ve=!0),Oe>1&&fe===Ae&&(he[0]=!0),Ve||(Ve=ve(we,xe,$e)||le($e,we-1)||se($e,we-1)),fe===Ae?we>z&&(Oe-=Ve?3:5):J?Oe+=Ve?2:0:Oe+=Ve?0:1,we+1===Ze&&(Oe-=Ve?3:5),Oe}function x(j,oe,fe,Ae,xe,$e,we){return ee(j,oe,fe,Ae,xe,$e,!0,we)}e.fuzzyScoreGracefulAggressive=x;function Y(j,oe,fe,Ae,xe,$e,we){return ee(j,oe,fe,Ae,xe,$e,!1,we)}e.fuzzyScoreGraceful=Y;function ee(j,oe,fe,Ae,xe,$e,we,Ze){let z=Qe(j,oe,fe,Ae,xe,$e,Ze);if(z&&!we)return z;if(j.length>=3){const J=Math.min(7,j.length-1);for(let he=fe+1;he<J;he++){const Oe=ae(j,he);if(Oe){const Ve=Qe(Oe,Oe.toLowerCase(),fe,Ae,xe,$e,Ze);Ve&&(Ve[0]-=3,(!z||Ve[0]>z[0])&&(z=Ve))}}}return z}function ae(j,oe){if(oe+1>=j.length)return;const fe=j[oe],Ae=j[oe+1];if(fe!==Ae)return j.slice(0,oe)+Ae+fe+j.slice(oe+2)}}),define(be[107],Ee([0,1,34,106,9]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function C(s){return s.replace(R,(v,I)=>I?v:`\\${v}`)}e.escapeIcons=C;const y=new RegExp(`\\\\${A.source}`,"g");function P(s){return s.replace(y,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(t,(v,I,S,o)=>S?v:I||o||"")}e.stripIcons=_;function n(s){const v=s.indexOf(e.iconStartMarker);return v===-1?{text:s}:h(s,v)}e.parseLabelWithIcons=n;function h(s,v){const I=[];let S="";function o(f){if(f){S+=f;for(const m of f)I.push(i)}}let g=-1,k="",i=0,l,r,a=v;const w=s.length;for(o(s.substr(0,v));a<w;)l=s[a],r=s[a+1],l===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(g=a,o(k),k=e.iconStartMarker,a++):l===")"&&g!==-1?(i+=a-g+1,g=-1,k=""):g!==-1?/^[a-z0-9\-]$/i.test(l)?k+=l:(o(k),g=-1,k=""):o(l),a++;return o(k),{text:S,iconOffsets:I}}function u(s,v,I=!1){const{text:S,iconOffsets:o}=v;if(!o||o.length===0)return(0,M.matchesFuzzy)(s,S,I);const g=(0,E.ltrim)(S," "),k=S.length-g.length,i=(0,M.matchesFuzzy)(s,g,I);if(i)for(const l of i){const r=o[l.start+k]+k;l.start+=r,l.end+=r}return i}e.matchesFuzzyIconAware=u}),define(be[76],Ee([0,1,16,107]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(h="",u=!1){if(this.value=h,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(h,u=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(h):h).replace(/([ \t]+)/g,(s,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,u){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=A;function R(n){return C(n)?!n.value:Array.isArray(n)?n.every(R):!0}e.isEmptyMarkdownString=R;function C(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function y(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=y;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(n){const h=[],u=n.split("|").map(v=>v.trim());n=u[0];const s=u[1];if(s){const v=/height=(\d+)/.exec(s),I=/width=(\d+)/.exec(s),S=v?v[1]:"",o=I?I[1]:"",g=isFinite(parseInt(o)),k=isFinite(parseInt(S));g&&h.push(`width="${o}"`),k&&h.push(`height="${S}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=_}),define(be[54],Ee([0,1,23,9,2]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,y)}e.stringify=A;function R(t){let _=JSON.parse(t);return _=P(_),_}e.parse=R;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function y(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function P(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],_+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],_+1))}return t}e.revive=P}),define(be[11],Ee([0,1,26,2]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,t){this._hosts[y]=P,this._ports[y]=t}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[P],n=this._connectionTokens[P];let h=`path=${encodeURIComponent(y.path)}`;return typeof n=="string"&&(h+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class R{asBrowserUri(y,P){const t=this.toUri(y,P);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${E.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(y,P){const t=this.toUri(y,P);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(y,P){return M.URI.isUri(y)?y:M.URI.parse(P.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(be[24],Ee([0,1,41,11,17,26,9,2]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(h){return(0,C.uriToFsPath)(h,!0)}e.originalFSPath=y;class P{constructor(u){this._ignorePathCasing=u}compare(u,s,v=!1){return u===s?0:(0,R.compare)(this.getComparisonKey(u,v),this.getComparisonKey(s,v))}isEqual(u,s,v=!1){return u===s?!0:!u||!s?!1:this.getComparisonKey(u,v)===this.getComparisonKey(s,v)}getComparisonKey(u,s=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,s,v=!1){if(u.scheme===s.scheme){if(u.scheme===M.Schemas.file)return d.isEqualOrParent(y(u),y(s),this._ignorePathCasing(u))&&u.query===s.query&&(v||u.fragment===s.fragment);if((0,e.isEqualAuthority)(u.authority,s.authority))return d.isEqualOrParent(u.path,s.path,this._ignorePathCasing(u),"/")&&u.query===s.query&&(v||u.fragment===s.fragment)}return!1}joinPath(u,...s){return C.URI.joinPath(u,...s)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return E.posix.basename(u.path)}extname(u){return E.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let s;return u.scheme===M.Schemas.file?s=C.URI.file(E.dirname(y(u))).path:(s=E.posix.dirname(u.path),u.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),s="/")),u.with({path:s})}normalizePath(u){if(!u.path.length)return u;let s;return u.scheme===M.Schemas.file?s=C.URI.file(E.normalize(y(u))).path:s=E.posix.normalize(u.path),u.with({path:s})}relativePath(u,s){if(u.scheme!==s.scheme||!(0,e.isEqualAuthority)(u.authority,s.authority))return;if(u.scheme===M.Schemas.file){const S=E.relative(y(u),y(s));return A.isWindows?d.toSlashes(S):S}let v=u.path||"/",I=s.path||"/";if(this._ignorePathCasing(u)){let S=0;for(const o=Math.min(v.length,I.length);S<o&&!(v.charCodeAt(S)!==I.charCodeAt(S)&&v.charAt(S).toLowerCase()!==I.charAt(S).toLowerCase());S++);v=I.substr(0,S)+v.substr(S)}return E.posix.relative(v,I)}resolvePath(u,s){if(u.scheme===M.Schemas.file){const v=C.URI.file(E.resolve(y(u),s));return u.with({authority:v.authority,path:v.path})}return s=d.toPosixPath(s),u.with({path:E.posix.resolve(u.path,s)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,s){return u===s||(0,R.equalsIgnoreCase)(u,s)}hasTrailingPathSeparator(u,s=E.sep){if(u.scheme===M.Schemas.file){const v=y(u);return v.length>d.getRoot(v).length&&v[v.length-1]===s}else{const v=u.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,s=E.sep){return(0,e.hasTrailingPathSeparator)(u,s)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,s=E.sep){let v=!1;if(u.scheme===M.Schemas.file){const I=y(u);v=I!==void 0&&I.length===d.getRoot(I).length&&I[I.length-1]===s}else{s="/";const I=u.path;v=I.length===1&&I.charCodeAt(I.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(u,s)?u.with({path:u.path+"/"}):u}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(h=>h.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(h,u){const s=[];for(let v=0;v<h.length;v++){const I=u(h[v]);h.some((S,o)=>o===v?!1:(0,e.isEqualOrParent)(I,u(S)))||s.push(h[v])}return s}e.distinctParents=t;var _;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function u(s){const v=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(o=>{const[g,k]=o.split(":");g&&k&&v.set(g,k)});const S=s.path.substring(0,s.path.indexOf(";"));return S&&v.set(h.META_DATA_MIME,S),v}h.parseMetaData=u})(_=e.DataUri||(e.DataUri={}));function n(h,u,s){if(u){let v=h.path;return v&&v[0]!==E.posix.sep&&(v=E.posix.sep+v),h.with({scheme:s,authority:u,path:v})}return h.with({scheme:s})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C($){return!!$&&typeof $.then=="function"}e.isThenable=C;function y($){const U=new d.CancellationTokenSource,H=$(U.token),G=new Promise((ue,q)=>{const le=U.token.onCancellationRequested(()=>{le.dispose(),U.dispose(),q((0,M.canceled)())});Promise.resolve(H).then(se=>{le.dispose(),U.dispose(),ue(se)},se=>{le.dispose(),U.dispose(),q(se)})});return new class{cancel(){U.cancel()}then(ue,q){return G.then(ue,q)}catch(ue){return this.then(void 0,ue)}finally(ue){return G.finally(ue)}}}e.createCancelablePromise=y;function P($,U,H){return Promise.race([$,new Promise(G=>U.onCancellationRequested(()=>G(H)))])}e.raceCancellation=P;async function t($){let U=-1;const H=$.map((ue,q)=>ue.then(le=>(U=q,le))),G=await Promise.race(H);return $.forEach((ue,q)=>{q!==U&&ue.cancel()}),G}e.raceCancellablePromises=t;function _($,U,H){let G;const ue=setTimeout(()=>{G?.(void 0),H?.()},U);return Promise.race([$.finally(()=>clearTimeout(ue)),new Promise(q=>G=q)])}e.raceTimeout=_;function n($){return new Promise((U,H)=>{const G=$();C(G)?G.then(U,H):U(G)})}e.asPromise=n;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(H,H).then(G)})}return new Promise((H,G)=>{this.queuedPromise.then(H,G)})}return this.activePromise=U(),new Promise((H,G)=>{this.activePromise.then(ue=>{this.activePromise=null,H(ue)},ue=>{this.activePromise=null,G(ue)})})}}e.Throttler=h;class u{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=u;class s{constructor(){this.promiseMap=new Map}queue(U,H){const ue=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(U)===ue&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ue),ue}}e.SequencerByKey=s;class v{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,H=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ue)=>{this.doResolve=G,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class I{constructor(U){this.delayer=new v(U),this.throttler=new h}trigger(U,H){return this.delayer.trigger(()=>this.throttler.queue(U),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class S{constructor(){this._isOpen=!1,this._promise=new Promise((U,H)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=S;class o extends S{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function g($,U){return U?new Promise((H,G)=>{const ue=setTimeout(()=>{q.dispose(),H()},$),q=U.onCancellationRequested(()=>{clearTimeout(ue),q.dispose(),G((0,M.canceled)())})}):y(H=>g($,H))}e.timeout=g;function k($,U=0){const H=setTimeout($,U);return(0,A.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=k;function i($){const U=[];let H=0;const G=$.length;function ue(){return H<G?$[H++]():null}function q(le){le!=null&&U.push(le);const se=ue();return se?se.then(q):Promise.resolve(U)}return Promise.resolve(null).then(q)}e.sequence=i;function l($,U=G=>!!G,H=null){let G=0;const ue=$.length,q=()=>{if(G>=ue)return Promise.resolve(H);const le=$[G++];return Promise.resolve(le()).then(ve=>U(ve)?Promise.resolve(ve):q())};return q()}e.first=l;function r($,U=G=>!!G,H=null){if($.length===0)return Promise.resolve(H);let G=$.length;const ue=()=>{G=-1;for(const q of $)q.cancel?.()};return new Promise((q,le)=>{for(const se of $)se.then(ve=>{--G>=0&&U(ve)?(ue(),q(ve)):G===0&&q(H)}).catch(ve=>{--G>=0&&(ue(),le(ve))})})}e.firstParallel=r;class a{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((H,G)=>{this.outstandingPromises.push({factory:U,c:H,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const H=U.factory();H.then(U.c,U.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class w extends a{constructor(){super(1)}}e.Queue=w;class f{constructor(){this.queues=new Map}queueFor(U,H=R.extUri){const G=H.getComparisonKey(U);let ue=this.queues.get(G);return ue||(ue=new w,E.Event.once(ue.onFinished)(()=>{ue?.dispose(),this.queues.delete(G)}),this.queues.set(G,ue)),ue}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(U,H){this._token=-1,typeof U=="function"&&typeof H=="number"&&this.setIfNotSet(U,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},H)}setIfNotSet(U,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},H))}}e.TimeoutTimer=m;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,H){this.cancel(),this._token=setInterval(()=>{U()},H)}}e.IntervalTimer=D;class T{constructor(U,H){this.timeoutToken=-1,this.runner=U,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class p{constructor(U,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class b extends T{constructor(U,H){super(U,H);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=b;class c extends A.Disposable{constructor(U,H,G,ue){super();this.maxWorkChunkSize=U,this.maxPendingWork=H,this.throttleDelay=G,this.handler=ue,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=c,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const H=setTimeout(()=>U($));let G=!1;return{dispose(){G||(G=!0,clearTimeout(H))}}}}else e.runWhenIdle=($,U)=>{const H=requestIdleCallback($,typeof U=="number"?{timeout:U}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(H))}}}}();class F{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function O($,U,H){let G;for(let ue=0;ue<H;ue++)try{return await $()}catch(q){G=q,await g(U)}throw G}e.retry=O;class V{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,H,G){return this._pending={taskId:U,cancel:()=>G?.(),promise:H},H.then(()=>this.donePending(U),()=>this.donePending(U)),H}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let H,G;const ue=new Promise((q,le)=>{H=q,G=le});this._next={run:U,promise:ue,promiseResolve:H,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class K{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,H)=>{this.completeCallback=U,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(H=>{this.completeCallback(U),this.resolved=!0,H()})}error(U){return new Promise(H=>{this.errorCallback(U),this.rejected=!0,H()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=W;var Q;(function($){async function U(H){let G;const ue=await Promise.all(H.map(q=>q.then(le=>le,le=>{G||(G=le)})));if(typeof G!="undefined")throw G;return ue}$.settled=U})(Q=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new d.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(T,p,b=!1){const c=T||"",F=p||"",O=E.value.collator.compare(c,F);return E.value.collatorIsNumeric&&O===0&&c!==F?c<F?-1:1:O}e.compareFileNames=C;function y(T,p){const b=A.value.collator;return T=T||"",p=p||"",k(b,T,p)}e.compareFileNamesDefault=y;function P(T,p){const b=A.value.collator;return T=T||"",p=p||"",a(T,p)||k(b,T,p)}e.compareFileNamesUpper=P;function t(T,p){const b=A.value.collator;return T=T||"",p=p||"",r(T,p)||k(b,T,p)}e.compareFileNamesLower=t;function _(T,p){return T=T||"",p=p||"",T===p?0:T<p?-1:1}e.compareFileNamesUnicode=_;function n(T,p,b=!1){b||(T=T&&T.toLowerCase(),p=p&&p.toLowerCase());const[c,F]=o(T),[O,V]=o(p);return c!==O?c<O?-1:1:F===V?0:F<V?-1:1}e.noIntlCompareFileNames=n;function h(T,p){const[b,c]=o(T),[F,O]=o(p);let V=E.value.collator.compare(c,O);if(V===0){if(E.value.collatorIsNumeric&&c!==O)return c<O?-1:1;if(V=E.value.collator.compare(b,F),E.value.collatorIsNumeric&&V===0&&b!==F)return b<F?-1:1}return V}e.compareFileExtensions=h;function u(T,p){T=T||"",p=p||"";const b=g(T),c=g(p),F=A.value.collator,O=R.value.collator;return k(O,b,c)||k(F,T,p)}e.compareFileExtensionsDefault=u;function s(T,p){T=T||"",p=p||"";const b=g(T),c=g(p),F=A.value.collator,O=R.value.collator;return k(O,b,c)||a(T,p)||k(F,T,p)}e.compareFileExtensionsUpper=s;function v(T,p){T=T||"",p=p||"";const b=g(T),c=g(p),F=A.value.collator,O=R.value.collator;return k(O,b,c)||r(T,p)||k(F,T,p)}e.compareFileExtensionsLower=v;function I(T,p){T=T||"",p=p||"";const b=g(T).toLowerCase(),c=g(p).toLowerCase();return b!==c?b<c?-1:1:T!==p?T<p?-1:1:0}e.compareFileExtensionsUnicode=I;const S=/^(.*?)(\.([^.]*))?$/;function o(T,p=!1){const b=T?S.exec(T):[];let c=[b&&b[1]||"",b&&b[3]||""];return p&&(!c[0]&&c[1]||c[0]&&c[0].charAt(0)===".")&&(c=[c[0]+"."+c[1],""]),c}function g(T){const p=T?S.exec(T):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function k(T,p,b){let c=T.compare(p,b);return c!==0?c:p.length!==b.length?p.length<b.length?-1:1:0}function i(T){const p=T.charAt(0);return p.toLocaleUpperCase()!==p}function l(T){const p=T.charAt(0);return p.toLocaleLowerCase()!==p}function r(T,p){return i(T)&&l(p)?-1:l(T)&&i(p)?1:0}function a(T,p){return l(T)&&i(p)?-1:i(T)&&l(p)?1:0}function w(T,p,b=!1){return b||(T=T&&T.toLowerCase(),p=p&&p.toLowerCase()),T===p?0:T<p?-1:1}function f(T,p,b=!1){const c=T.split(M.sep),F=p.split(M.sep),O=c.length-1,V=F.length-1;let K,W;for(let Q=0;;Q++){if(K=O===Q,W=V===Q,K&&W)return C(c[Q],F[Q],b);if(K)return-1;if(W)return 1;const $=w(c[Q],F[Q],b);if($!==0)return $}}e.comparePaths=f;function m(T,p,b){const c=T.toLowerCase(),F=p.toLowerCase(),O=D(T,p,b);if(O)return O;const V=c.endsWith(b),K=F.endsWith(b);if(V!==K)return V?-1:1;const W=C(c,F);return W!==0?W:c.localeCompare(F)}e.compareAnything=m;function D(T,p,b){const c=T.toLowerCase(),F=p.toLowerCase(),O=c.startsWith(b),V=F.startsWith(b);if(O!==V)return O?-1:1;if(O&&V){if(c.length<F.length)return-1;if(c.length>F.length)return 1}return 0}e.compareByPrefix=D}),define(be[27],Ee([0,1,14,41,20,17,9]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const y="**",P="/",t="[/\\\\]",_="[^/\\\\]",n=/\//g;function h(G){switch(G){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function u(G,ue){if(!G)return[];const q=[];let le=!1,se=!1,ve="";for(const Fe of G){switch(Fe){case ue:if(!le&&!se){q.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":se=!0;break;case"]":se=!1;break}ve+=Fe}return ve&&q.push(ve),q}e.splitGlobAware=u;function s(G){if(!G)return"";let ue="";const q=u(G,P);if(q.every(le=>le===y))ue=".*";else{let le=!1;q.forEach((se,ve)=>{if(se===y){le||(ue+=h(2),le=!0);return}let Fe=!1,Me="",Ne=!1,Qe="";for(const ze of se){if(ze!=="}"&&Fe){Me+=ze;continue}if(Ne&&(ze!=="]"||!Qe)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!Qe?qe="^":ze===P?qe="":qe=R.escapeRegExpCharacters(ze),Qe+=qe;continue}switch(ze){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":ue+=`(?:${u(Me,",").map(Y=>s(Y)).join("|")})`,Fe=!1,Me="";break;case"]":ue+="["+Qe+"]",Ne=!1,Qe="";break;case"?":ue+=_;continue;case"*":ue+=h(1);continue;default:ue+=R.escapeRegExpCharacters(ze)}}ve<q.length-1&&(q[ve+1]!==y||ve+2<q.length)&&(ue+=t),le=!1})}return ue}const v=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),l=function(){return!1},r=function(){return null};function a(G,ue){if(!G)return r;let q;typeof G!="string"?q=G.pattern:q=G,q=q.trim();const le=`${q}_${!!ue.trimForExclusions}`;let se=i.get(le);if(se)return w(se,G);let ve;if(v.test(q)){const Fe=q.substr(4);se=function(Me,Ne){return typeof Me=="string"&&Me.endsWith(Fe)?q:null}}else(ve=I.exec(f(q,ue)))?se=m(ve[1],q):(ue.trimForExclusions?o:S).test(q)?se=D(q,ue):(ve=g.exec(f(q,ue)))?se=T(ve[1].substr(1),q,!0):(ve=k.exec(f(q,ue)))?se=T(ve[1],q,!1):se=p(q);return i.set(le,se),w(se,G)}function w(G,ue){return typeof ue=="string"?G:function(q,le){return M.isEqualOrParent(q,ue.base)?G(A.relative(ue.base,q),le):null}}function f(G,ue){return ue.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function m(G,ue){const q=`/${G}`,le=`\\${G}`,se=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===G?ue:null:Fe===G||Fe.endsWith(q)||Fe.endsWith(le)?ue:null},ve=[G];return se.basenames=ve,se.patterns=[ue],se.allBasenames=ve,se}function D(G,ue){const q=H(G.slice(1,-1).split(",").map(Me=>a(Me,ue)).filter(Me=>Me!==r),G),le=q.length;if(!le)return r;if(le===1)return q[0];const se=function(Me,Ne){for(let Qe=0,ze=q.length;Qe<ze;Qe++)if(q[Qe](Me,Ne))return G;return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function T(G,ue,q){const le=A.sep===A.posix.sep,se=le?G:G.replace(n,A.sep),ve=A.sep+se,Fe=A.posix.sep+G,Me=q?function(Ne,Qe){return typeof Ne=="string"&&(Ne===se||Ne.endsWith(ve)||!le&&(Ne===G||Ne.endsWith(Fe)))?ue:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===se||!le&&Ne===G)?ue:null};return Me.allPaths=[(q?"*/":"./")+G],Me}function p(G){try{const ue=new RegExp(`^${s(G)}$`);return function(q){return ue.lastIndex=0,typeof q=="string"&&ue.test(q)?G:null}}catch(ue){return r}}function b(G,ue,q){return!G||typeof ue!="string"?!1:c(G)(ue,void 0,q)}e.match=b;function c(G,ue={}){if(!G)return l;if(typeof G=="string"||K(G)){const q=a(G,ue);if(q===r)return l;const le=function(se,ve){return!!q(se,ve)};return q.allBasenames&&(le.allBasenames=q.allBasenames),q.allPaths&&(le.allPaths=q.allPaths),le}return $(G,ue)}e.parse=c;function F(G){if(!G)return;let ue;return q=>(ue||(ue=(G()||Promise.resolve([])).then(le=>le?V(le):{})),ue.then(le=>!!le[q]))}e.hasSiblingPromiseFn=F;function O(G){if(!G)return;let ue;return q=>{if(!ue){const le=G();ue=le?V(le):{}}return!!ue[q]}}e.hasSiblingFn=O;function V(G){const ue={};for(const q of G)ue[q]=!0;return ue}function K(G){const ue=G;return ue&&typeof ue.base=="string"&&typeof ue.pattern=="string"}e.isRelativePattern=K;function W(G){return G.allBasenames||[]}e.getBasenameTerms=W;function Q(G){return G.allPaths||[]}e.getPathTerms=Q;function $(G,ue){const q=H(Object.getOwnPropertyNames(G).map(Me=>U(Me,G[Me],ue)).filter(Me=>Me!==r)),le=q.length;if(!le)return r;if(!q.some(Me=>!!Me.requiresSiblings)){if(le===1)return q[0];const Me=function(ze,qe){for(let x=0,Y=q.length;x<Y;x++){const ee=q[x](ze,qe);if(ee)return ee}return null},Ne=q.find(ze=>!!ze.allBasenames);Ne&&(Me.allBasenames=Ne.allBasenames);const Qe=q.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return Qe.length&&(Me.allPaths=Qe),Me}const se=function(Me,Ne,Qe){let ze;for(let qe=0,x=q.length;qe<x;qe++){const Y=q[qe];Y.requiresSiblings&&Qe&&(Ne||(Ne=A.basename(Me)),ze||(ze=Ne.substr(0,Ne.length-A.extname(Me).length)));const ee=Y(Me,Ne,ze,Qe);if(ee)return ee}return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function U(G,ue,q){if(ue===!1)return r;const le=a(G,q);if(le===r)return r;if(typeof ue=="boolean")return le;if(ue){const se=ue.when;if(typeof se=="string"){const ve=(Fe,Me,Ne,Qe)=>{if(!Qe||!le(Fe,Me))return null;const ze=se.replace("$(basename)",Ne),qe=Qe(ze);return(0,d.isThenable)(qe)?qe.then(x=>x?G:null):qe?G:null};return ve.requiresSiblings=!0,ve}}return le}function H(G,ue){const q=G.filter(Me=>!!Me.basenames);if(q.length<2)return G;const le=q.reduce((Me,Ne)=>{const Qe=Ne.basenames;return Qe?Me.concat(Qe):Me},[]);let se;if(ue){se=[];for(let Me=0,Ne=le.length;Me<Ne;Me++)se.push(ue)}else se=q.reduce((Me,Ne)=>{const Qe=Ne.patterns;return Qe?Me.concat(Qe):Me},[]);const ve=function(Me,Ne){if(typeof Me!="string")return null;if(!Ne){let ze;for(ze=Me.length;ze>0;ze--){const qe=Me.charCodeAt(ze-1);if(qe===47||qe===92)break}Ne=Me.substr(ze)}const Qe=le.indexOf(Ne);return Qe!==-1?se[Qe]:null};ve.basenames=le,ve.patterns=se,ve.allBasenames=le;const Fe=G.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[77],Ee([0,1,41,11,17,26,24,9,2]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(a,w,f){if(typeof a=="string"&&(a=y.URI.file(a)),f){const D=f.getWorkspaceFolder(a);if(D){const T=f.getWorkspace().folders.length>1;let p;if((0,R.isEqual)(D.uri,a)?p="":p=(0,R.relativePath)(D.uri,a),T){const b=D.name?D.name:(0,R.basename)(D.uri);p=p?b+" \u2022 "+p:b}return p}}if(a.scheme!==M.Schemas.file&&a.scheme!==M.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(a.fsPath))return(0,E.normalize)(_(a.fsPath));let m=(0,E.normalize)(a.fsPath);return!A.isWindows&&w?.userHome&&(m=h(m,w.userHome.fsPath)),m}e.getPathLabel=P;function t(a){if(!a)return;typeof a=="string"&&(a=y.URI.file(a));const w=(0,R.basename)(a)||(a.scheme===M.Schemas.file?a.fsPath:a.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(w)?_(w):w}e.getBaseLabel=t;function _(a){return(0,d.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=_;let n=Object.create(null);function h(a,w){if(A.isWindows||!a||!w)return a;let f=n.original===w?n.normalized:void 0;return f||(f=`${(0,C.rtrim)(w,E.posix.sep)}${E.posix.sep}`,n={original:w,normalized:f}),(A.isLinux?a.startsWith(f):(0,C.startsWithIgnoreCase)(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=h;function u(a,w){return a.replace(/^~($|\/|\\)/,`${w}$1`)}e.untildify=u;const s="\u2026",v="\\\\",I="~";function S(a,w=E.sep){const f=new Array(a.length);let m=!1;for(let D=0;D<a.length;D++){let T=a[D];if(T===""){f[D]=`.${w}`;continue}if(!T){f[D]=T;continue}m=!0;let p="";T.indexOf(v)===0?(p=T.substr(0,T.indexOf(v)+v.length),T=T.substr(T.indexOf(v)+v.length)):T.indexOf(w)===0?(p=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length)):T.indexOf(I)===0&&(p=T.substr(0,T.indexOf(I)+I.length),T=T.substr(T.indexOf(I)+I.length));const b=T.split(w);for(let c=1;m&&c<=b.length;c++)for(let F=b.length-c;m&&F>=0;F--){m=!1;let O=b.slice(F,F+c).join(w);for(let V=0;!m&&V<a.length;V++)if(V!==D&&a[V]&&a[V].indexOf(O)>-1){const K=F+c===b.length,W=F>0&&a[V].indexOf(w)>-1?w+O:O,Q=a[V].endsWith(W);m=!K||Q}if(!m){let V="";(b[0].endsWith(":")||p!=="")&&(F===1&&(F=0,c++,O=b[0]+w+O),F>0&&(V=b[0]+w),V=p+V),F>0&&(V=V+s+w),V=V+O,F+c<b.length&&(V=V+w+s),f[D]=V}}m&&(f[D]=T)}return f}e.shorten=S;var o;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function g(a,w=Object.create(null)){const f=[];let m=!1,D="";for(const T of a)if(T==="$"||m&&T==="{")D&&f.push({value:D,type:o.TEXT}),D="",m=!0;else if(T==="}"&&m){const p=w[D];if(typeof p=="string")p.length&&f.push({value:p,type:o.VARIABLE});else if(p){const b=f[f.length-1];(!b||b.type!==o.SEPARATOR)&&f.push({value:p.label,type:o.SEPARATOR})}D="",m=!1}else D+=T;return D&&!m&&f.push({value:D,type:o.TEXT}),f.filter((T,p)=>{if(T.type===o.SEPARATOR){const b=f[p-1],c=f[p+1];return[b,c].every(F=>F&&(F.type===o.VARIABLE||F.type===o.TEXT)&&F.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=g;function k(a,w){return A.isMacintosh||w?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function i(a,w){return A.isMacintosh||w?a.replace(/\(&&\w\)|&&/g,""):A.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function l(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=l;function r(a){const w=a.indexOf("/")!==-1?E.posix:E.win32,f=w.basename(a),m=w.dirname(a);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(a){a.text="text/plain",a.binary="application/octet-stream",a.unknown="application/unknown",a.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let y=[],P=[],t=[];function _(a,w=!1){const f=n(a);y.push(f),f.userConfigured?t.push(f):P.push(f),w&&!f.userConfigured&&y.forEach(m=>{m.mime===f.mime||m.userConfigured||(f.extension&&m.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&m.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&m.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&m.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=_;function n(a){return{id:a.id,mime:a.mime,filename:a.filename,extension:a.extension,filepattern:a.filepattern,firstline:a.firstline,userConfigured:a.userConfigured,filenameLowercase:a.filename?a.filename.toLowerCase():void 0,extensionLowercase:a.extension?a.extension.toLowerCase():void 0,filepatternLowercase:a.filepattern?(0,d.parse)(a.filepattern.toLowerCase()):void 0,filepatternOnPath:a.filepattern?a.filepattern.indexOf(E.posix.sep)>=0:!1}}function h(a){a?(y=y.filter(w=>!w.userConfigured),t=[]):(y=[],P=[],t=[])}e.clearTextMimes=h;function u(a,w){let f;if(a)switch(a.scheme){case M.Schemas.file:f=a.fsPath;break;case M.Schemas.data:f=A.DataUri.parseMetaData(a).get(A.DataUri.META_DATA_LABEL);break;default:f=a.path}if(!f)return[C.unknown];f=f.toLowerCase();const m=(0,E.basename)(f),D=s(f,m,t);if(D)return[D,C.text];const T=s(f,m,P);if(T)return[T,C.text];if(w){const p=v(w);if(p)return[p,C.text]}return[C.unknown]}e.guessMimeTypes=u;function s(a,w,f){let m=null,D=null,T=null;for(let p=f.length-1;p>=0;p--){const b=f[p];if(w===b.filenameLowercase){m=b;break}if(b.filepattern&&(!D||b.filepattern.length>D.filepattern.length)){const c=b.filepatternOnPath?a:w;b.filepatternLowercase?.(c)&&(D=b)}b.extension&&(!T||b.extension.length>T.extension.length)&&w.endsWith(b.extensionLowercase)&&(T=b)}return m?m.mime:D?D.mime:T?T.mime:null}function v(a){if((0,R.startsWithUTF8BOM)(a)&&(a=a.substr(1)),a.length>0)for(let w=y.length-1;w>=0;w--){const f=y[w];if(!f.firstline)continue;const m=a.match(f.firstline);if(m&&m.length>0)return f.mime}return null}function I(a){return a?typeof a=="string"?a===C.binary||a===C.text||a===C.unknown:a.length===1&&I(a[0]):!0}e.isUnspecific=I;const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(a){const w=(0,E.extname)(a),f=S[w.toLowerCase()];return f!==void 0?f:k(a)}e.getMediaOrTextMime=g;function k(a){const w=(0,E.extname)(a);return o[w.toLowerCase()]}e.getMediaMime=k;function i(a){for(const w in o)if(o[w]===a)return w}e.getExtensionForMimeType=i;const l=/^(.+)\/(.+?)(;.+)?$/;function r(a,w){const f=l.exec(a);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:w?void 0:a}e.normalizeMimeType=r}),define(be[109],Ee([0,1,2]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(d.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(d.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:d.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,_,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return _.transformOutgoing(t);for(let h in t)if(Object.hasOwnProperty.call(t,h)){const u=A(t[h],_,n+1);u!==null&&(t[h]=u)}}return null}function R(t,_){const n=A(t,_,0);return n===null?t:n}e.transformOutgoingURIs=R;function C(t,_,n,h){if(!t||h>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let u in t)if(Object.hasOwnProperty.call(t,u)){const s=C(t[u],_,n,h+1);s!==null&&(t[u]=s)}}return null}function y(t,_){const n=C(t,_,!1,0);return n===null?t:n}e.transformIncomingURIs=y;function P(t,_){const n=C(t,_,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(be[36],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(y){return d.test(y)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function C(){R(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let y=0,P="";return P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P}e.generateUuid=C}),define(be[110],Ee([0,1,227]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends d.CharacterClassifier{constructor(C){super(0);for(let y=0,P=C.length;y<P;y++)this.set(C.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(R){let C={};return y=>(C.hasOwnProperty(y)||(C[y]=R(y)),C[y])}e.getMapForWordSeparators=A(R=>new E(R))}),define(be[79],Ee([0,1,22]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class P{constructor(v,I){this._findMatchBrand=void 0,this.range=v,this.matches=I}}e.FindMatch=P;var t;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None"})(_=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class h{constructor(v,I,S,o,g,k){this.identifier=v,this.range=I,this.text=S,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=g,this._isTracked=k}}e.ValidAnnotatedEditOperation=h;class u{constructor(v,I,S){this.reverseEdits=v,this.changes=I,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=u}),define(be[111],Ee([0,1,9,110,112,42,79]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class y{constructor(o,g,k,i){this.searchString=o,this.isRegex=g,this.matchCase=k,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=P(this.searchString):o=this.searchString.indexOf(`
`)>=0;let g=null;try{g=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!g)return null;let k=!this.isRegex&&!o;return k&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(k=this.matchCase),new t(g,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,k?this.searchString:null)}}e.SearchParams=y;function P(S){if(!S||S.length===0)return!1;for(let o=0,g=S.length;o<g;o++)if(S.charCodeAt(o)===92){if(o++,o>=g)break;const i=S.charCodeAt(o);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(o,g,k){this.regex=o,this.wordSeparators=g,this.simpleSearch=k}}e.SearchData=t;function _(S,o,g){if(!g)return new R.FindMatch(S,null);let k=[];for(let i=0,l=o.length;i<l;i++)k[i]=o[i];return new R.FindMatch(S,k)}e.createFindMatch=_;class n{constructor(o){let g=[],k=0;for(let i=0,l=o.length;i<l;i++)o.charCodeAt(i)===10&&(g[k++]=i);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(o){const g=this._lineFeedsOffsets;let k=0,i=g.length-1;if(i===-1||o<=g[0])return 0;for(;k<i;){const l=k+((i-k)/2>>0);g[l]>=o?i=l-1:g[l+1]>=o?(k=l,i=l):k=l+1}return k+1}}class h{static findMatches(o,g,k,i,l){const r=g.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,k,new I(r.wordSeparators,r.regex),i,l):this._doFindMatchesLineByLine(o,k,r,i,l):[]}static _getMultilineMatchRange(o,g,k,i,l,r){let a,w=0;i?(w=i.findLineFeedCountBeforeOffset(l),a=g+l+w):a=g+l;let f;if(i){let p=i.findLineFeedCountBeforeOffset(l+r.length)-w;f=a+r.length+p}else f=a+r.length;const m=o.getPositionAt(a),D=o.getPositionAt(f);return new A.Range(m.lineNumber,m.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(o,g,k,i,l){const r=o.getOffsetAt(g.getStartPosition()),a=o.getValueInRange(g,1),w=o.getEOL()===`\r
`?new n(a):null,f=[];let m=0,D;for(k.reset(0);D=k.next(a);)if(f[m++]=_(this._getMultilineMatchRange(o,r,a,w,D.index,D[0]),D,i),m>=l)return f;return f}static _doFindMatchesLineByLine(o,g,k,i,l){const r=[];let a=0;if(g.startLineNumber===g.endLineNumber){const f=o.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return a=this._findMatchesInLine(k,f,g.startLineNumber,g.startColumn-1,a,r,i,l),r}const w=o.getLineContent(g.startLineNumber).substring(g.startColumn-1);a=this._findMatchesInLine(k,w,g.startLineNumber,g.startColumn-1,a,r,i,l);for(let f=g.startLineNumber+1;f<g.endLineNumber&&a<l;f++)a=this._findMatchesInLine(k,o.getLineContent(f),f,0,a,r,i,l);if(a<l){const f=o.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);a=this._findMatchesInLine(k,f,g.endLineNumber,0,a,r,i,l)}return r}static _findMatchesInLine(o,g,k,i,l,r,a,w){const f=o.wordSeparators;if(!a&&o.simpleSearch){const T=o.simpleSearch,p=T.length,b=g.length;let c=-p;for(;(c=g.indexOf(T,c+p))!==-1;)if((!f||v(f,g,b,c,p))&&(r[l++]=new R.FindMatch(new A.Range(k,c+1+i,k,c+1+p+i),null),l>=w))return l;return l}const m=new I(o.wordSeparators,o.regex);let D;m.reset(0);do if(D=m.next(g),D&&(r[l++]=_(new A.Range(k,D.index+1+i,k,D.index+1+D[0].length+i),D,a),l>=w))return l;while(D);return l}static findNextMatch(o,g,k,i){const l=g.parseSearchRequest();if(!l)return null;const r=new I(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(o,k,r,i):this._doFindNextMatchLineByLine(o,k,r,i)}static _doFindNextMatchMultiline(o,g,k,i){const l=new E.Position(g.lineNumber,1),r=o.getOffsetAt(l),a=o.getLineCount(),w=o.getValueInRange(new A.Range(l.lineNumber,l.column,a,o.getLineMaxColumn(a)),1),f=o.getEOL()===`\r
`?new n(w):null;k.reset(g.column-1);let m=k.next(w);return m?_(this._getMultilineMatchRange(o,r,w,f,m.index,m[0]),m,i):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(o,new E.Position(1,1),k,i):null}static _doFindNextMatchLineByLine(o,g,k,i){const l=o.getLineCount(),r=g.lineNumber,a=o.getLineContent(r),w=this._findFirstMatchInLine(k,a,r,g.column,i);if(w)return w;for(let f=1;f<=l;f++){const m=(r+f-1)%l,D=o.getLineContent(m+1),T=this._findFirstMatchInLine(k,D,m+1,1,i);if(T)return T}return null}static _findFirstMatchInLine(o,g,k,i,l){o.reset(i-1);const r=o.next(g);return r?_(new A.Range(k,r.index+1,k,r.index+1+r[0].length),r,l):null}static findPreviousMatch(o,g,k,i){const l=g.parseSearchRequest();if(!l)return null;const r=new I(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(o,k,r,i):this._doFindPreviousMatchLineByLine(o,k,r,i)}static _doFindPreviousMatchMultiline(o,g,k,i){const l=this._doFindMatchesMultiline(o,new A.Range(1,1,g.lineNumber,g.column),k,i,10*C);if(l.length>0)return l[l.length-1];const r=o.getLineCount();return g.lineNumber!==r||g.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new E.Position(r,o.getLineMaxColumn(r)),k,i):null}static _doFindPreviousMatchLineByLine(o,g,k,i){const l=o.getLineCount(),r=g.lineNumber,a=o.getLineContent(r).substring(0,g.column-1),w=this._findLastMatchInLine(k,a,r,i);if(w)return w;for(let f=1;f<=l;f++){const m=(l+r-f-1)%l,D=o.getLineContent(m+1),T=this._findLastMatchInLine(k,D,m+1,i);if(T)return T}return null}static _findLastMatchInLine(o,g,k,i){let l=null,r;for(o.reset(0);r=o.next(g);)l=_(new A.Range(k,r.index+1,k,r.index+1+r[0].length),r,i);return l}}e.TextModelSearch=h;function u(S,o,g,k,i){if(k===0)return!0;const l=o.charCodeAt(k-1);if(S.get(l)!==0||l===13||l===10)return!0;if(i>0){const r=o.charCodeAt(k);if(S.get(r)!==0)return!0}return!1}function s(S,o,g,k,i){if(k+i===g)return!0;const l=o.charCodeAt(k+i);if(S.get(l)!==0||l===13||l===10)return!0;if(i>0){const r=o.charCodeAt(k+i-1);if(S.get(r)!==0)return!0}return!1}function v(S,o,g,k,i){return u(S,o,g,k,i)&&s(S,o,g,k,i)}e.isValidMatch=v;class I{constructor(o,g){this._wordSeparators=o,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const g=o.length;let k;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(k=this._searchRegex.exec(o),!k))return null;const i=k.index,l=k[0].length;if(i===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){d.getNextCodePoint(o,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=l,!this._wordSeparators||v(this._wordSeparators,o,g,i,l))return k}while(k);return null}}e.Searcher=I}),define(be[113],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let y=0,P=C.notIn.length;y<P;y++)switch(C.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of C)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=E;function A(R,C,y){R.has(C)?R.get(C).push(y):R.set(C,[y])}}),define(be[55],Ee([0,1,27,17]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,R,C,y){if(Array.isArray(A)){let P=0;for(const t of A){const _=E(t,R,C,y);if(_===10)return _;_>P&&(P=_)}return P}else{if(typeof A=="string")return y?A==="*"?5:A===C?10:0:0;if(A){const{language:P,pattern:t,scheme:_,hasAccessToAllModels:n}=A;if(!y&&!n)return 0;let h=0;if(_)if(_===R.scheme)h=10;else if(_==="*")h=5;else return 0;if(P)if(P===C)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(t){let u;if(typeof t=="string"?u=t:u={...t,base:(0,M.normalize)(t.base)},u===R.fsPath||(0,d.match)(u,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=E}),define(be[114],Ee([0,1,3,6]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,C){return this._map.set(R,C),this.fire([R]),(0,M.toDisposable)(()=>{this._map.get(R)===C&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,C){let y=null,P=!1;return this._promises.set(R,C.then(t=>{this._promises.delete(R),!(P||!t)&&(y=this.register(R,t))})),(0,M.toDisposable)(()=>{P=!0,y&&y.dispose()})}getPromise(R){const C=this.get(R);if(C)return Promise.resolve(C);const y=this._promises.get(R);return y?y.then(P=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[80],Ee([0,1,23,26]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function A(_){for(let n=0,h=_.length;n<h;n+=4){const u=_[n+0],s=_[n+1],v=_[n+2],I=_[n+3];_[n+0]=I,_[n+1]=v,_[n+2]=s,_[n+3]=u}}function R(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function C(_){const n=_.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const h=new Uint8Array(n.byteLength);return h.set(n),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function y(_){const n=new Uint32Array(P(_));let h=0;if(n[h++]=_.id,_.type==="full")n[h++]=1,n[h++]=_.data.length,n.set(_.data,h),h+=_.data.length;else{n[h++]=2,n[h++]=_.deltas.length;for(const u of _.deltas)n[h++]=u.start,n[h++]=u.deleteCount,u.data?(n[h++]=u.data.length,n.set(u.data,h),h+=u.data.length):n[h++]=0}return R(n)}e.encodeSemanticTokensDto=y;function P(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const h of _.deltas)h.data&&(n+=h.data.length)}return n}function t(_){const n=C(_);let h=0;const u=n[h++];if(n[h++]===1){const S=n[h++],o=n.subarray(h,h+S);return h+=S,{id:u,type:"full",data:o}}const v=n[h++];let I=[];for(let S=0;S<v;S++){const o=n[h++],g=n[h++],k=n[h++];let i;k>0&&(i=n.subarray(h,h+k),h+=k),I[S]={start:o,deleteCount:g,data:i}}return{id:u,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,13,10,115]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?E.localize(0,null,C(P),R(P.stack)||R(P.stacktrace)):C(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?E.localize(1,null,P.message):P.message||E.localize(2,null)}function y(P=null,t=!1){if(!P)return E.localize(3,null);if(Array.isArray(P)){const _=d.coalesce(P),n=y(_[0],t);return _.length>1?E.localize(4,null,n,_.length):n}if(M.isString(P))return P;if(P.detail){const _=P.detail;if(_.error)return A(_.error,t);if(_.exception)return A(_.exception,t)}return P.stack?A(P,t):P.message?P.message:E.localize(5,null)}e.toErrorMessage=y}),define(be[116],Ee([18,19]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,26,118]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=R;class C{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,he){this._values[J]=he}}e.ValidatedEditorOptions=C;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class P{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}compute(J,he,Oe){return Oe}}class t{constructor(J,he=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(J){return this.defaultValue}}class _{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,he,Oe){return Oe}}function n(z,J){return typeof z=="undefined"?J:z==="false"?!1:Boolean(z)}e.boolean=n;class h extends _{constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return n(J,this.defaultValue)}}class u extends _{constructor(J,he,Oe,Ve,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="integer",ut.default=Oe,ut.minimum=Ve,ut.maximum=tt),super(J,he,Oe,ut),this.minimum=Ve,this.maximum=tt}static clampedInt(J,he,Oe,Ve){if(typeof J=="undefined")return he;let tt=parseInt(J,10);return isNaN(tt)?he:(tt=Math.max(Oe,tt),tt=Math.min(Ve,tt),tt|0)}validate(J){return u.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class s extends _{constructor(J,he,Oe,Ve,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Oe),super(J,he,Oe,tt),this.validationFn=Ve}static clamp(J,he,Oe){return J<he?he:J>Oe?Oe:J}static float(J,he){if(typeof J=="number")return J;if(typeof J=="undefined")return he;const Oe=parseFloat(J);return isNaN(Oe)?he:Oe}validate(J){return this.validationFn(s.float(J,this.defaultValue))}}class v extends _{static string(J,he){return typeof J!="string"?he:J}constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return v.string(J,this.defaultValue)}}function I(z,J,he){return typeof z!="string"||he.indexOf(z)===-1?J:z}e.stringSet=I;class S extends _{constructor(J,he,Oe,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ve,tt.default=Oe),super(J,he,Oe,tt),this._allowedValues=Ve}validate(J){return I(J,this.defaultValue,this._allowedValues)}}class o extends P{constructor(J,he,Oe,Ve,tt,ut,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=tt,ht.default=Ve),super(J,he,Oe,ht),this._allowedValues=tt,this._convert=ut}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function g(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class k extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,he,Oe){return Oe===0?J.accessibilitySupport:Oe}}class i extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:d.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertSpace:n(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(z){switch(z){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function f(z){switch(z){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class m extends t{constructor(){super(127,[65,32])}compute(J,he,Oe){const Ve=["monaco-editor"];return he.get(32)&&Ve.push(he.get(32)),J.extraEditorClassName&&Ve.push(J.extraEditorClassName),he.get(65)==="default"?Ve.push("mouse-default"):he.get(65)==="copy"&&Ve.push("mouse-copy"),he.get(100)&&Ve.push("showUnused"),he.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class D extends h{constructor(){super(31,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(J,he,Oe){return Oe&&J.emptySelectionClipboard}}class T extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:d.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{cursorMoveOnType:n(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":I(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":I(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(he.loop,this.defaultValue.loop)}}}class p extends P{constructor(){super(43,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?p.OFF:J==="true"?p.ON:J:Boolean(J)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class b extends t{constructor(){super(42)}compute(J,he,Oe){return J.fontInfo}}class c extends _{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(J){let he=s.float(J,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(he,6,100)}compute(J,he,Oe){return J.fontInfo.fontSize}}class F extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(u.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class O extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:d.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{multiple:I(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??I(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??I(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??I(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??I(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??I(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:d.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),delay:u.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:n(he.sticky,this.defaultValue.sticky)}}}var K;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class W extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,he,Oe){return W.computeLayout(he,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const he=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?he-1:0,Ve=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),tt=Math.floor(J.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:tt}}static _computeMinimapLayout(J,he){const Oe=J.outerWidth,Ve=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const ut=he.stableMinimapLayoutInput,ht=ut&&J.outerHeight===ut.outerHeight&&J.lineHeight===ut.lineHeight&&J.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&J.pixelRatio===ut.pixelRatio&&J.scrollBeyondLastLine===ut.scrollBeyondLastLine&&J.minimap.enabled===ut.minimap.enabled&&J.minimap.side===ut.minimap.side&&J.minimap.size===ut.minimap.size&&J.minimap.showSlider===ut.minimap.showSlider&&J.minimap.renderCharacters===ut.minimap.renderCharacters&&J.minimap.maxColumn===ut.minimap.maxColumn&&J.minimap.scale===ut.minimap.scale&&J.verticalScrollbarWidth===ut.verticalScrollbarWidth&&J.isViewportWrapping===ut.isViewportWrapping,St=J.lineHeight,Pt=J.typicalHalfwidthCharacterWidth,dt=J.scrollBeyondLastLine,bt=J.minimap.renderCharacters;let ft=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Et=J.minimap.maxColumn,Ye=J.minimap.size,Ct=J.minimap.side,Pe=J.verticalScrollbarWidth,ye=J.viewLineCount,De=J.remainingWidth,Z=J.isViewportWrapping,ce=bt?2:3;let ge=Math.floor(tt*Ve);const me=ge/tt;let Ie=!1,Be=!1,Le=ce*ft,je=ft/tt,Xe=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:mt}=W.computeContainedMinimapLineCount({viewLineCount:ye,scrollBeyondLastLine:dt,height:Ve,lineHeight:St,pixelRatio:tt});if(ye/mt>1)Ie=!0,Be=!0,ft=1,Le=1,je=ft/tt;else{let nt=!1,ot=ft+1;if(Ye==="fit"){const lt=Math.ceil((ye+We)*Le);Z&&ht&&De<=he.stableFitRemainingWidth?(nt=!0,ot=he.stableFitMaxMinimapScale):nt=lt>ge}if(Ye==="fill"||nt){Ie=!0;const lt=ft;Le=Math.min(St*tt,Math.max(1,Math.floor(1/it))),Z&&ht&&De<=he.stableFitRemainingWidth&&(ot=he.stableFitMaxMinimapScale),ft=Math.min(ot,Math.max(1,Math.floor(Le/ce))),ft>lt&&(Xe=Math.min(2,ft/lt)),je=ft/tt/Xe,ge=Math.ceil(Math.max(Ge,ye+We)*Le),Z?(he.stableMinimapLayoutInput=J,he.stableFitRemainingWidth=De,he.stableFitMaxMinimapScale=ft):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const ne=Math.floor(Et*je),pe=Math.min(ne,Math.max(0,Math.floor((De-Pe-2)*je/(Pt+je)))+e.MINIMAP_GUTTER_WIDTH);let re=Math.floor(tt*pe);const B=re/tt;re=Math.floor(re*Xe);const Ce=bt?1:2,Se=Ct==="left"?0:Oe-pe-Pe;return{renderMinimap:Ce,minimapLeft:Se,minimapWidth:pe,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Be,minimapScale:ft,minimapLineHeight:Le,minimapCanvasInnerWidth:re,minimapCanvasInnerHeight:ge,minimapCanvasOuterWidth:B,minimapCanvasOuterHeight:me}}static computeLayout(J,he){const Oe=he.outerWidth|0,Ve=he.outerHeight|0,tt=he.lineHeight|0,ut=he.lineNumbersDigitCount|0,ht=he.typicalHalfwidthCharacterWidth,St=he.maxDigitWidth,Pt=he.pixelRatio,dt=he.viewLineCount,bt=J.get(122),ft=bt==="inherit"?J.get(121):bt,Et=ft==="inherit"?J.get(117):ft,Ye=J.get(120),Ct=J.get(2),Pe=he.isDominatedByLongLines,ye=J.get(48),De=J.get(59).renderType!==0,Z=J.get(60),ce=J.get(94),ge=J.get(64),me=J.get(92),Ie=me.verticalScrollbarSize,Be=me.verticalHasArrows,Le=me.arrowSize,je=me.horizontalScrollbarSize,Xe=J.get(57),ne=J.get(36);let pe;if(typeof Xe=="string"&&/^\d+(\.\d+)?ch$/.test(Xe)){const Ot=parseFloat(Xe.substr(0,Xe.length-2));pe=u.clampedInt(Ot*ht,0,0,1e3)}else pe=u.clampedInt(Xe,0,0,1e3);ne&&(pe+=16);let re=0;if(De){const Ot=Math.max(ut,Z);re=Math.round(Ot*St)}let B=0;ye&&(B=tt);let Ce=0,Se=Ce+B,Ge=Se+re,We=Ge+pe;const it=Oe-B-re-pe;let mt=!1,vt=!1,nt=-1;Ct!==2&&(ft==="inherit"&&Pe?(mt=!0,vt=!0):Et==="on"||Et==="bounded"?vt=!0:Et==="wordWrapColumn"&&(nt=Ye));const ot=W._computeMinimapLayout({outerWidth:Oe,outerHeight:Ve,lineHeight:tt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Pt,scrollBeyondLastLine:ce,minimap:ge,verticalScrollbarWidth:Ie,viewLineCount:dt,remainingWidth:it,isViewportWrapping:vt},he.memory||new y);ot.renderMinimap!==0&&ot.minimapLeft===0&&(Ce+=ot.minimapWidth,Se+=ot.minimapWidth,Ge+=ot.minimapWidth,We+=ot.minimapWidth);const lt=it-ot.minimapWidth,Rt=Math.max(1,Math.floor((lt-Ie-2)/ht)),_t=Be?Le:0;return vt&&(nt=Math.max(1,Rt),Et==="bounded"&&(nt=Math.min(nt,Ye))),{width:Oe,height:Ve,glyphMarginLeft:Ce,glyphMarginWidth:B,lineNumbersLeft:Se,lineNumbersWidth:re,decorationsLeft:Ge,decorationsWidth:pe,contentLeft:We,contentWidth:lt,minimap:ot,viewportColumn:Rt,isWordWrapMinified:mt,isViewportWrapping:vt,wrappingColumn:nt,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:_t,width:Ie,height:Ve-2*_t,right:0}}}}e.EditorLayoutInfoComputer=W;class Q extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:d.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class $ extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:d.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(he.fontFamily,this.defaultValue.fontFamily)}}}class U extends s{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>s.clamp(J,0,150),{markdownDescription:d.localize(46,null)})}compute(J,he,Oe){return J.fontInfo.lineHeight}}class H extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:J.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:d.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),size:I(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:I(he.side,this.defaultValue.side,["right","left"]),showSlider:I(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(he.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(he.scale,1,1,3),maxColumn:u.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(z){return z==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ue extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{top:u.clampedInt(he.top,0,0,1e3),bottom:u.clampedInt(he.bottom,0,0,1e3)}}}class q extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:d.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),cycle:n(he.cycle,this.defaultValue.cycle)}}}class le extends t{constructor(){super(128)}compute(J,he,Oe){return J.pixelRatio}}class se extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:d.localize(61,null)},comments:{type:"boolean",default:J.comments,description:d.localize(62,null)},other:{type:"boolean",default:J.other,description:d.localize(63,null)}}}],default:J,description:d.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const he=J,Oe={other:n(he.other,this.defaultValue.other),comments:n(he.comments,this.defaultValue.comments),strings:n(he.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var ve;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(J){let he=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(he=4,Oe=J):J==="interval"?he=3:J==="relative"?he=2:J==="on"?he=1:he=0),{renderType:he,renderFn:Oe}}}function Me(z){const J=z.get(87);return J==="editable"?z.get(80):J!=="on"}e.filterValidationDecorations=Me;class Ne extends P{constructor(){const J=[],he={type:"number",description:d.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:J,description:d.localize(72,null)})}validate(J){if(Array.isArray(J)){let he=[];for(let Oe of J)if(typeof Oe=="number")he.push({column:u.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ve=Oe;he.push({column:u.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Oe,Ve)=>Oe.column-Ve.column),he}return this.defaultValue}}function Qe(z,J){if(typeof z!="string")return J;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:d.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J,Oe=u.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=u.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(he.vertical,this.defaultValue.vertical),horizontal:Qe(he.horizontal,this.defaultValue.horizontal),useShadows:n(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:u.clampedInt(he.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:u.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:n(he.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:d.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null)],default:J.mode,description:d.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),mode:I(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:d.localize(89,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class Y extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(90,null),d.localize(91,null)],default:J.insertMode,description:d.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:d.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:d.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:d.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:d.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:d.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:d.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:d.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[d.localize(100,null),d.localize(101,null),d.localize(102,null)],default:J.previewMode,description:d.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:d.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertMode:I(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(he.showIcons,this.defaultValue.showIcons),showStatusBar:n(he.showStatusBar,this.defaultValue.showStatusBar),preview:n(he.preview,this.defaultValue.preview),previewMode:I(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(he.showMethods,this.defaultValue.showMethods),showFunctions:n(he.showFunctions,this.defaultValue.showFunctions),showConstructors:n(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(he.showDeprecated,this.defaultValue.showDeprecated),showFields:n(he.showFields,this.defaultValue.showFields),showVariables:n(he.showVariables,this.defaultValue.showVariables),showClasses:n(he.showClasses,this.defaultValue.showClasses),showStructs:n(he.showStructs,this.defaultValue.showStructs),showInterfaces:n(he.showInterfaces,this.defaultValue.showInterfaces),showModules:n(he.showModules,this.defaultValue.showModules),showProperties:n(he.showProperties,this.defaultValue.showProperties),showEvents:n(he.showEvents,this.defaultValue.showEvents),showOperators:n(he.showOperators,this.defaultValue.showOperators),showUnits:n(he.showUnits,this.defaultValue.showUnits),showValues:n(he.showValues,this.defaultValue.showValues),showConstants:n(he.showConstants,this.defaultValue.showConstants),showEnums:n(he.showEnums,this.defaultValue.showEnums),showEnumMembers:n(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(he.showKeywords,this.defaultValue.showKeywords),showWords:n(he.showWords,this.defaultValue.showWords),showColors:n(he.showColors,this.defaultValue.showColors),showFiles:n(he.showFiles,this.defaultValue.showFiles),showReferences:n(he.showReferences,this.defaultValue.showReferences),showFolders:n(he.showFolders,this.defaultValue.showFolders),showTypeParameters:n(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(he.showSnippets,this.defaultValue.showSnippets),showUsers:n(he.showUsers,this.defaultValue.showUsers),showIssues:n(he.showIssues,this.defaultValue.showIssues)}}}class ee extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(136,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends t{constructor(){super(129,[80])}compute(J,he,Oe){return he.get(80)?!0:J.tabFocusMode}}var j;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(j=e.WrappingIndent||(e.WrappingIndent={}));function oe(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends t{constructor(){super(131,[130])}compute(J,he,Oe){const Ve=he.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?xe:M.isLinux?$e:Ae,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function we(z){return e.editorOptionsRegistry[z.id]=z,z}var Ze;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.bracketPairColorization=12]="bracketPairColorization",z[z.codeLens=13]="codeLens",z[z.codeLensFontFamily=14]="codeLensFontFamily",z[z.codeLensFontSize=15]="codeLensFontSize",z[z.colorDecorators=16]="colorDecorators",z[z.columnSelection=17]="columnSelection",z[z.comments=18]="comments",z[z.contextmenu=19]="contextmenu",z[z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",z[z.cursorBlinking=21]="cursorBlinking",z[z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",z[z.cursorStyle=23]="cursorStyle",z[z.cursorSurroundingLines=24]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",z[z.cursorWidth=26]="cursorWidth",z[z.disableLayerHinting=27]="disableLayerHinting",z[z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",z[z.domReadOnly=29]="domReadOnly",z[z.dragAndDrop=30]="dragAndDrop",z[z.emptySelectionClipboard=31]="emptySelectionClipboard",z[z.extraEditorClassName=32]="extraEditorClassName",z[z.fastScrollSensitivity=33]="fastScrollSensitivity",z[z.find=34]="find",z[z.fixedOverflowWidgets=35]="fixedOverflowWidgets",z[z.folding=36]="folding",z[z.foldingStrategy=37]="foldingStrategy",z[z.foldingHighlight=38]="foldingHighlight",z[z.foldingImportsByDefault=39]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=41]="fontFamily",z[z.fontInfo=42]="fontInfo",z[z.fontLigatures=43]="fontLigatures",z[z.fontSize=44]="fontSize",z[z.fontWeight=45]="fontWeight",z[z.formatOnPaste=46]="formatOnPaste",z[z.formatOnType=47]="formatOnType",z[z.glyphMargin=48]="glyphMargin",z[z.gotoLocation=49]="gotoLocation",z[z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",z[z.hover=52]="hover",z[z.inDiffEditor=53]="inDiffEditor",z[z.inlineSuggest=54]="inlineSuggest",z[z.letterSpacing=55]="letterSpacing",z[z.lightbulb=56]="lightbulb",z[z.lineDecorationsWidth=57]="lineDecorationsWidth",z[z.lineHeight=58]="lineHeight",z[z.lineNumbers=59]="lineNumbers",z[z.lineNumbersMinChars=60]="lineNumbersMinChars",z[z.linkedEditing=61]="linkedEditing",z[z.links=62]="links",z[z.matchBrackets=63]="matchBrackets",z[z.minimap=64]="minimap",z[z.mouseStyle=65]="mouseStyle",z[z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=67]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",z[z.multiCursorModifier=69]="multiCursorModifier",z[z.multiCursorPaste=70]="multiCursorPaste",z[z.occurrencesHighlight=71]="occurrencesHighlight",z[z.overviewRulerBorder=72]="overviewRulerBorder",z[z.overviewRulerLanes=73]="overviewRulerLanes",z[z.padding=74]="padding",z[z.parameterHints=75]="parameterHints",z[z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",z[z.quickSuggestions=78]="quickSuggestions",z[z.quickSuggestionsDelay=79]="quickSuggestionsDelay",z[z.readOnly=80]="readOnly",z[z.renameOnType=81]="renameOnType",z[z.renderControlCharacters=82]="renderControlCharacters",z[z.renderIndentGuides=83]="renderIndentGuides",z[z.renderFinalNewline=84]="renderFinalNewline",z[z.renderLineHighlight=85]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=87]="renderValidationDecorations",z[z.renderWhitespace=88]="renderWhitespace",z[z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",z[z.roundedSelection=90]="roundedSelection",z[z.rulers=91]="rulers",z[z.scrollbar=92]="scrollbar",z[z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=94]="scrollBeyondLastLine",z[z.scrollPredominantAxis=95]="scrollPredominantAxis",z[z.selectionClipboard=96]="selectionClipboard",z[z.selectionHighlight=97]="selectionHighlight",z[z.selectOnLineNumbers=98]="selectOnLineNumbers",z[z.showFoldingControls=99]="showFoldingControls",z[z.showUnused=100]="showUnused",z[z.snippetSuggestions=101]="snippetSuggestions",z[z.smartSelect=102]="smartSelect",z[z.smoothScrolling=103]="smoothScrolling",z[z.stickyTabStops=104]="stickyTabStops",z[z.stopRenderingLineAfter=105]="stopRenderingLineAfter",z[z.suggest=106]="suggest",z[z.suggestFontSize=107]="suggestFontSize",z[z.suggestLineHeight=108]="suggestLineHeight",z[z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",z[z.suggestSelection=110]="suggestSelection",z[z.tabCompletion=111]="tabCompletion",z[z.tabIndex=112]="tabIndex",z[z.unusualLineTerminators=113]="unusualLineTerminators",z[z.useShadowDOM=114]="useShadowDOM",z[z.useTabStops=115]="useTabStops",z[z.wordSeparators=116]="wordSeparators",z[z.wordWrap=117]="wordWrap",z[z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=120]="wordWrapColumn",z[z.wordWrapOverride1=121]="wordWrapOverride1",z[z.wordWrapOverride2=122]="wordWrapOverride2",z[z.wrappingIndent=123]="wrappingIndent",z[z.wrappingStrategy=124]="wrappingStrategy",z[z.showDeprecated=125]="showDeprecated",z[z.inlayHints=126]="inlayHints",z[z.editorClassName=127]="editorClassName",z[z.pixelRatio=128]="pixelRatio",z[z.tabFocusMode=129]="tabFocusMode",z[z.layoutInfo=130]="layoutInfo",z[z.wrappingInfo=131]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(137,null)})),acceptSuggestionOnEnter:we(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(138,null),""],markdownDescription:d.localize(139,null)})),accessibilitySupport:we(new k),accessibilityPageSize:we(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(140,null)})),ariaLabel:we(new v(4,"ariaLabel",d.localize(141,null))),autoClosingBrackets:we(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(142,null),d.localize(143,null),""],description:d.localize(144,null)})),autoClosingDelete:we(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(145,null),""],description:d.localize(146,null)})),autoClosingOvertype:we(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(147,null),""],description:d.localize(148,null)})),autoClosingQuotes:we(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(149,null),d.localize(150,null),""],description:d.localize(151,null)})),autoIndent:we(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[d.localize(152,null),d.localize(153,null),d.localize(154,null),d.localize(155,null),d.localize(156,null)],description:d.localize(157,null)})),automaticLayout:we(new h(10,"automaticLayout",!1)),autoSurround:we(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(158,null),d.localize(159,null),d.localize(160,null),""],description:d.localize(161,null)})),bracketPairColorization:we(new x),stickyTabStops:we(new h(104,"stickyTabStops",!1,{description:d.localize(162,null)})),codeLens:we(new h(13,"codeLens",!0,{description:d.localize(163,null)})),codeLensFontFamily:we(new v(14,"codeLensFontFamily","",{description:d.localize(164,null)})),codeLensFontSize:we(new u(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(165,null)})),colorDecorators:we(new h(16,"colorDecorators",!0,{description:d.localize(166,null)})),columnSelection:we(new h(17,"columnSelection",!1,{description:d.localize(167,null)})),comments:we(new i),contextmenu:we(new h(19,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new h(20,"copyWithSyntaxHighlighting",!0,{description:d.localize(168,null)})),cursorBlinking:we(new o(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:d.localize(169,null)})),cursorSmoothCaretAnimation:we(new h(22,"cursorSmoothCaretAnimation",!1,{description:d.localize(170,null)})),cursorStyle:we(new o(23,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:d.localize(171,null)})),cursorSurroundingLines:we(new u(24,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(172,null)})),cursorSurroundingLinesStyle:we(new S(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(173,null),d.localize(174,null)],description:d.localize(175,null)})),cursorWidth:we(new u(26,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(176,null)})),disableLayerHinting:we(new h(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new h(28,"disableMonospaceOptimizations",!1)),domReadOnly:we(new h(29,"domReadOnly",!1)),dragAndDrop:we(new h(30,"dragAndDrop",!0,{description:d.localize(177,null)})),emptySelectionClipboard:we(new D),extraEditorClassName:we(new v(32,"extraEditorClassName","")),fastScrollSensitivity:we(new s(33,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:d.localize(178,null)})),find:we(new T),fixedOverflowWidgets:we(new h(35,"fixedOverflowWidgets",!1)),folding:we(new h(36,"folding",!0,{description:d.localize(179,null)})),foldingStrategy:we(new S(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(180,null),d.localize(181,null)],description:d.localize(182,null)})),foldingHighlight:we(new h(38,"foldingHighlight",!0,{description:d.localize(183,null)})),foldingImportsByDefault:we(new h(39,"foldingImportsByDefault",!1,{description:d.localize(184,null)})),unfoldOnClickAfterEndOfLine:we(new h(40,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(185,null)})),fontFamily:we(new v(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(186,null)})),fontInfo:we(new b),fontLigatures2:we(new p),fontSize:we(new c),fontWeight:we(new F),formatOnPaste:we(new h(46,"formatOnPaste",!1,{description:d.localize(187,null)})),formatOnType:we(new h(47,"formatOnType",!1,{description:d.localize(188,null)})),glyphMargin:we(new h(48,"glyphMargin",!0,{description:d.localize(189,null)})),gotoLocation:we(new O),hideCursorInOverviewRuler:we(new h(50,"hideCursorInOverviewRuler",!1,{description:d.localize(190,null)})),highlightActiveIndentGuide:we(new h(51,"highlightActiveIndentGuide",!0,{description:d.localize(191,null)})),hover:we(new V),inDiffEditor:we(new h(53,"inDiffEditor",!1)),letterSpacing:we(new s(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>s.clamp(z,-5,20),{description:d.localize(192,null)})),lightbulb:we(new Q),lineDecorationsWidth:we(new _(57,"lineDecorationsWidth",10)),lineHeight:we(new U),lineNumbers:we(new Fe),lineNumbersMinChars:we(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new h(61,"linkedEditing",!1,{description:d.localize(193,null)})),links:we(new h(62,"links",!0,{description:d.localize(194,null)})),matchBrackets:we(new S(63,"matchBrackets","always",["always","near","never"],{description:d.localize(195,null)})),minimap:we(new H),mouseStyle:we(new S(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new s(66,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:d.localize(196,null)})),mouseWheelZoom:we(new h(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(197,null)})),multiCursorMergeOverlapping:we(new h(68,"multiCursorMergeOverlapping",!0,{description:d.localize(198,null)})),multiCursorModifier:we(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[d.localize(199,null),d.localize(200,null)],markdownDescription:d.localize(201,null)})),multiCursorPaste:we(new S(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(202,null),d.localize(203,null)],markdownDescription:d.localize(204,null)})),occurrencesHighlight:we(new h(71,"occurrencesHighlight",!0,{description:d.localize(205,null)})),overviewRulerBorder:we(new h(72,"overviewRulerBorder",!0,{description:d.localize(206,null)})),overviewRulerLanes:we(new u(73,"overviewRulerLanes",3,0,3)),padding:we(new ue),parameterHints:we(new q),peekWidgetDefaultFocus:we(new S(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(207,null),d.localize(208,null)],description:d.localize(209,null)})),definitionLinkOpensInPeek:we(new h(77,"definitionLinkOpensInPeek",!1,{description:d.localize(210,null)})),quickSuggestions:we(new se),quickSuggestionsDelay:we(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(211,null)})),readOnly:we(new h(80,"readOnly",!1)),renameOnType:we(new h(81,"renameOnType",!1,{description:d.localize(212,null),markdownDeprecationMessage:d.localize(213,null)})),renderControlCharacters:we(new h(82,"renderControlCharacters",!1,{description:d.localize(214,null)})),renderIndentGuides:we(new h(83,"renderIndentGuides",!0,{description:d.localize(215,null)})),renderFinalNewline:we(new h(84,"renderFinalNewline",!0,{description:d.localize(216,null)})),renderLineHighlight:we(new S(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(217,null)],description:d.localize(218,null)})),renderLineHighlightOnlyWhenFocus:we(new h(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(219,null)})),renderValidationDecorations:we(new S(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new S(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(220,null),d.localize(221,null),d.localize(222,null),""],description:d.localize(223,null)})),revealHorizontalRightPadding:we(new u(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new h(90,"roundedSelection",!0,{description:d.localize(224,null)})),rulers:we(new Ne),scrollbar:we(new ze),scrollBeyondLastColumn:we(new u(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(225,null)})),scrollBeyondLastLine:we(new h(94,"scrollBeyondLastLine",!0,{description:d.localize(226,null)})),scrollPredominantAxis:we(new h(95,"scrollPredominantAxis",!0,{description:d.localize(227,null)})),selectionClipboard:we(new h(96,"selectionClipboard",!0,{description:d.localize(228,null),included:M.isLinux})),selectionHighlight:we(new h(97,"selectionHighlight",!0,{description:d.localize(229,null)})),selectOnLineNumbers:we(new h(98,"selectOnLineNumbers",!0)),showFoldingControls:we(new S(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(230,null),d.localize(231,null)],description:d.localize(232,null)})),showUnused:we(new h(100,"showUnused",!0,{description:d.localize(233,null)})),showDeprecated:we(new h(125,"showDeprecated",!0,{description:d.localize(234,null)})),inlayHints:we(new $),snippetSuggestions:we(new S(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(235,null),d.localize(236,null),d.localize(237,null),d.localize(238,null)],description:d.localize(239,null)})),smartSelect:we(new ee),smoothScrolling:we(new h(103,"smoothScrolling",!1,{description:d.localize(240,null)})),stopRenderingLineAfter:we(new u(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new Y),inlineSuggest:we(new qe),suggestFontSize:we(new u(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(241,null)})),suggestLineHeight:we(new u(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(242,null)})),suggestOnTriggerCharacters:we(new h(109,"suggestOnTriggerCharacters",!0,{description:d.localize(243,null)})),suggestSelection:we(new S(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(244,null),d.localize(245,null),d.localize(246,null)],description:d.localize(247,null)})),tabCompletion:we(new S(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(248,null),d.localize(249,null),d.localize(250,null)],description:d.localize(251,null)})),tabIndex:we(new u(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new S(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(252,null),d.localize(253,null),d.localize(254,null)],description:d.localize(255,null)})),useShadowDOM:we(new h(114,"useShadowDOM",!0)),useTabStops:we(new h(115,"useTabStops",!0,{description:d.localize(256,null)})),wordSeparators:we(new v(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:d.localize(257,null)})),wordWrap:we(new S(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(258,null),d.localize(259,null),d.localize(260,null),d.localize(261,null)],description:d.localize(262,null)})),wordWrapBreakAfterCharacters:we(new v(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new v(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new u(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(263,null)})),wordWrapOverride1:we(new S(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new S(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[d.localize(264,null),d.localize(265,null),d.localize(266,null),d.localize(267,null)],description:d.localize(268,null)})),wrappingStrategy:we(new S(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(269,null),d.localize(270,null)],description:d.localize(271,null)})),editorClassName:we(new m),pixelRatio:we(new le),tabFocusMode:we(new ae),layoutInfo:we(new W),wrappingInfo:we(new fe)}}),define(be[119],Ee([18,19]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function R(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=n.match(M);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function C(n){if(!n)return null;let h=n.majorBase,u=n.majorMustEqual,s=n.minorBase,v=n.minorMustEqual,I=n.patchBase,S=n.patchMustEqual;n.hasCaret&&(h===0||(v=!1),S=!1);let o=0;if(n.preRelease){const g=E.exec(n.preRelease);if(g){const[,k,i,l]=g;o=Date.UTC(Number(k),Number(i)-1,Number(l))}}return{majorBase:h,majorMustEqual:u,minorBase:s,minorMustEqual:v,patchBase:I,patchMustEqual:S,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=C;function y(n,h,u){let s;typeof n=="string"?s=C(R(n)):s=n;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let I;if(typeof u=="string"?I=C(R(u)):I=u,!s||!I)return!1;let S=s.majorBase,o=s.minorBase,g=s.patchBase,k=I.majorBase,i=I.minorBase,l=I.patchBase,r=I.notBefore,a=I.majorMustEqual,w=I.minorMustEqual,f=I.patchMustEqual;return I.isMinimum?S>k?!0:S<k?!1:o>i?!0:o<i||v&&v<r?!1:g>=l:(S===1&&k===0&&(!a||!w||!f)&&(k=1,i=0,l=0,a=!0,w=!1,f=!1),S<k?!1:S>k?!a:o<i?!1:o>i?!w:g<l?!1:g>l?!f:!(v&&v<r))}e.isValidVersion=y;function P(n,h,u,s){return u.isBuiltin||typeof u.main=="undefined"?!0:_(n,h,u.engines.vscode,s)}e.isValidExtensionVersion=P;function t(n,h,u){return n==="*"||_(h,u,n)}e.isEngineValid=t;function _(n,h,u,s=[]){let v=C(R(u));if(!v)return s.push(d.localize(0,null,u)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return s.push(d.localize(1,null,u)),!1}else if(!v.majorMustEqual)return s.push(d.localize(2,null,u)),!1;return y(n,h,v)?!0:(s.push(d.localize(3,null,n,u)),!1)}}),define(be[81],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(E,A=[],R=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,81]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(R,C,y){C instanceof d.SyncDescriptor||(C=new d.SyncDescriptor(C,[],y)),M.push([R,C])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const C=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(R);C.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(A),C)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let C of this._nodes.values())C.outgoing.delete(R),C.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let C=this._nodes.get(R);return C||(C=new d(A),this._nodes.set(R,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,C]of this._nodes)A.push(`${R}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const C=new Set([A]),y=this._findCycle(R,C);if(y)return y}}_findCycle(A,R){for(let[C,y]of A.outgoing){if(R.has(C))return[...R,C].join(" -> ");R.add(C);const P=this._findCycle(y,R);if(P)return P;R.delete(C)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(d=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(C,y,P,t){y[d.DI_TARGET]===y?y[d.DI_DEPENDENCIES].push({id:C,index:P,optional:t}):(y[d.DI_DEPENDENCIES]=[{id:C,index:P,optional:t}],y[d.DI_TARGET]=y)}function E(C){if(d.serviceIds.has(C))return d.serviceIds.get(C);const y=function(P,t,_){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(y,P,_,!1)};return y.toString=()=>C,d.serviceIds.set(C,y),y}e.createDecorator=E;function A(C){return C}e.refineServiceDecorator=A;function R(C){return function(y,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,y,t,!0)}}e.optional=R}),define(be[140],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,75,55,140]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(s){return typeof s=="string"?!1:Array.isArray(s)?s.every(P):!!s.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(v,I){let S={selector:v,provider:I,_score:-1,_time:this._clock++};return this._entries.push(S),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(S){let o=this._entries.indexOf(S);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const I=[];for(let S of this._entries)S._score>0&&I.push(S.provider);return I}ordered(v){const I=[];return this._orderedForEach(v,S=>I.push(S.provider)),I}orderedGroups(v){const I=[];let S,o;return this._orderedForEach(v,g=>{S&&o===g._score?S.push(g.provider):(o=g._score,S=[g.provider],I.push(S))}),I}_orderedForEach(v,I){if(!!v){this._updateScores(v);for(const S of this._entries)S._score>0&&I(S)}}_updateScores(v){let I={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let S of this._entries)if(S._score=(0,C.score)(S.selector,v.uri,v.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(v)),P(S.selector)&&S._score>0){for(let o of this._entries)o._score=0;S._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,I){return v._score<I._score?1:v._score>I._score?-1:v._time<I._time?1:v._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let n=0;function h(s){let v=_.get(s);return v===void 0&&(v=++n,_.set(s,v)),v}class u{constructor(v,I,S=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=I,this.max=S,this._cache=new A.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((I,S)=>(0,M.doHash)(h(S),I),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const I=this._key(v),S=this._cache.get(I);return this._clamp(S?.value)}update(v,I){const S=this._key(v);let o=this._cache.get(S);return o||(o=new R.MovingAverage,this._cache.set(S,o)),o.update(I),this.get(v)}}e.LanguageFeatureRequestDelays=u}),define(be[59],Ee([0,1,2,42,141,114,34]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class y{constructor(b,c){this.language=b,this.id=c}}e.LanguageIdentifier=y;var P;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var _;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(_=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let c=this.getForeground(b),F="mtk"+c,O=this.getFontStyle(b);return O&1&&(F+=" mtki"),O&2&&(F+=" mtkb"),O&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(b,c){const F=this.getForeground(b),O=this.getFontStyle(b);let V=`color: ${c[F]};`;return O&1&&(V+="font-style: italic;"),O&2&&(V+="font-weight: bold;"),O&4&&(V+="text-decoration: underline;"),V}}e.TokenMetadata=h;var u;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(b){const c=p[b];let F=c&&R.iconRegistry.get(c);return F||(console.info("No codicon found for CompletionItemKind "+b),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(b,c){let F=p[b];return typeof F=="undefined"&&!c&&(F=9),F}}();var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var k;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(k=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(p){return p&&d.URI.isUri(p.uri)&&M.Range.isIRange(p.range)&&(M.Range.isIRange(p.originSelectionRange)||M.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=i;var l;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(l=e.SymbolKind||(e.SymbolKind={}));var r;(function(p){p[p.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var a;(function(p){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const c=new Map;c.set(0,"file"),c.set(1,"module"),c.set(2,"namespace"),c.set(3,"package"),c.set(4,"class"),c.set(5,"method"),c.set(6,"property"),c.set(7,"field"),c.set(8,"constructor"),c.set(9,"enum"),c.set(10,"interface"),c.set(11,"function"),c.set(12,"variable"),c.set(13,"constant"),c.set(14,"string"),c.set(15,"number"),c.set(16,"boolean"),c.set(17,"array"),c.set(18,"object"),c.set(19,"key"),c.set(20,"null"),c.set(21,"enum-member"),c.set(22,"struct"),c.set(23,"event"),c.set(24,"operator"),c.set(25,"type-parameter");function F(K){return b.get(K)}p.fromString=F;function O(K){return c.get(K)}p.toString=O;function V(K,W){const Q=c.get(K);let $=Q&&R.iconRegistry.get("symbol-"+Q);return $||(console.info("No codicon found for SymbolKind "+K),$=R.Codicon.symbolProperty),`${W?"inline":"block"} ${$.classNames}`}p.toCssClassName=V})(a=e.SymbolKinds||(e.SymbolKinds={}));class w{constructor(b){this.value=b}}e.FoldingRangeKind=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var f;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var D;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var T;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[43],Ee([0,1,26,9,4]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",d.isMacintosh),R.set("isLinux",d.isLinux),R.set("isWindows",d.isWindows),R.set("isWeb",d.isWeb),R.set("isMacNative",d.isMacintosh&&!d.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var y;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return _.INSTANCE}static true(){return n.INSTANCE}static has(c){return h.create(c)}static equals(c,F){return u.create(c,F)}static notEquals(c,F){return I.create(c,F)}static regex(c,F){return l.create(c,F)}static in(c,F){return s.create(c,F)}static not(c){return S.create(c)}static and(...c){return a.create(c,null)}static or(...c){return w.create(c,null,!0)}static greater(c,F){return o.create(c,F)}static less(c,F){return k.create(c,F)}static deserialize(c,F=!1){if(!!c)return this._deserializeOrExpression(c,F)}static _deserializeOrExpression(c,F){let O=c.split("||");return w.create(O.map(V=>this._deserializeAndExpression(V,F)),null,!0)}static _deserializeAndExpression(c,F){let O=c.split("&&");return a.create(O.map(V=>this._deserializeOne(V,F)),null)}static _deserializeOne(c,F){if(c=c.trim(),c.indexOf("!=")>=0){let O=c.split("!=");return I.create(O[0].trim(),this._deserializeValue(O[1],F))}if(c.indexOf("==")>=0){let O=c.split("==");return u.create(O[0].trim(),this._deserializeValue(O[1],F))}if(c.indexOf("=~")>=0){let O=c.split("=~");return l.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(c.indexOf(" in ")>=0){let O=c.split(" in ");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(c)){const O=c.split(">=");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(c)){const O=c.split(">");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(c)){const O=c.split("<=");return i.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(c)){const O=c.split("<");return k.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(c)?S.create(c.substr(1).trim()):h.create(c)}static _deserializeValue(c,F){if(c=c.trim(),c==="true")return!0;if(c==="false")return!1;let O=/^'([^']*)'$/.exec(c);return O?O[1].trim():c}static _deserializeRegexValue(c,F){if((0,M.isFalsyOrWhitespace)(c)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=c.indexOf("/"),V=c.lastIndexOf("/");if(O===V||O<0){if(F)throw new Error(`bad regexp-value '${c}', missing /-enclosure`);return console.warn(`bad regexp-value '${c}', missing /-enclosure`),null}let K=c.slice(O+1,V),W=c[V+1]==="i"?"i":"";try{return new RegExp(K,W)}catch(Q){if(F)throw new Error(`bad regexp-value '${c}', parse error: ${Q}`);return console.warn(`bad regexp-value '${c}', parse error: ${Q}`),null}}}e.ContextKeyExpr=P;function t(b,c){return b.cmp(c)}class _{constructor(){this.type=0}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}evaluate(c){return!1}serialize(){return"false"}keys(){return[]}map(c){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=_,_.INSTANCE=new _;class n{constructor(){this.type=1}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}evaluate(c){return!0}serialize(){return"true"}keys(){return[]}map(c){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class h{constructor(c,F){this.key=c,this.negated=F,this.type=2}static create(c,F=null){const O=R.get(c);return typeof O=="boolean"?O?n.INSTANCE:_.INSTANCE:new h(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:m(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}evaluate(c){return!!c.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(c){return c.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class u{constructor(c,F,O){this.key=c,this.value=F,this.negated=O,this.type=4}static create(c,F,O=null){if(typeof F=="boolean")return F?h.create(c,O):S.create(c,O);const V=R.get(c);return typeof V=="boolean"?F===(V?"true":"false")?n.INSTANCE:_.INSTANCE:new u(c,F,O)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return c.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(c){return c.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class s{constructor(c,F){this.key=c,this.valueKey=F,this.type=10,this.negated=null}static create(c,F){return new s(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.valueKey,c.key,c.valueKey)}equals(c){return c.type===this.type?this.key===c.key&&this.valueKey===c.valueKey:!1}evaluate(c){const F=c.getValue(this.valueKey),O=c.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?C.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(c){return c.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=s;class v{constructor(c){this._actual=c,this.type=11}static create(c){return new v(c)}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}evaluate(c){return!this._actual.evaluate(c)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(c){return new v(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class I{constructor(c,F,O){this.key=c,this.value=F,this.negated=O,this.type=5}static create(c,F,O=null){if(typeof F=="boolean")return F?S.create(c,O):h.create(c,O);const V=R.get(c);return typeof V=="boolean"?F===(V?"true":"false")?_.INSTANCE:n.INSTANCE:new I(c,F,O)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return c.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(c){return c.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class S{constructor(c,F){this.key=c,this.negated=F,this.type=3}static create(c,F=null){const O=R.get(c);return typeof O=="boolean"?O?_.INSTANCE:n.INSTANCE:new S(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:m(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}evaluate(c){return!c.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(c){return c.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;class o{constructor(c,F,O){this.key=c,this.value=F,this.negated=O,this.type=12}static create(c,F,O=null){return new o(c,F,O)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class g{constructor(c,F,O){this.key=c,this.value=F,this.negated=O,this.type=13}static create(c,F,O=null){return new g(c,F,O)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class k{constructor(c,F,O){this.key=c,this.value=F,this.negated=O,this.type=14}static create(c,F,O=null){return new k(c,F,O)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=k;class i{constructor(c,F,O){this.key=c,this.value=F,this.negated=O,this.type=15}static create(c,F,O=null){return new i(c,F,O)}cmp(c){return c.type!==this.type?this.type-c.type:D(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class l{constructor(c,F){this.key=c,this.regexp=F,this.type=7,this.negated=null}static create(c,F){return new l(c,F)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.key<c.key)return-1;if(this.key>c.key)return 1;const F=this.regexp?this.regexp.source:"",O=c.regexp?c.regexp.source:"";return F<O?-1:F>O?1:0}equals(c){if(c.type===this.type){const F=this.regexp?this.regexp.source:"",O=c.regexp?c.regexp.source:"";return this.key===c.key&&F===O}return!1}evaluate(c){let F=c.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const c=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${c}`}keys(){return[this.key]}map(c){return c.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=l;class r{constructor(c){this._actual=c,this.type=8}static create(c){return new r(c)}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}evaluate(c){return!this._actual.evaluate(c)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(c){return new r(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class a{constructor(c,F){this.expr=c,this.negated=F,this.type=6}static create(c,F){return a._normalizeArr(c,F)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const V=t(this.expr[F],c.expr[F]);if(V!==0)return V}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(c.expr[F]))return!1;return!0}return!1}evaluate(c){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(c))return!1;return!0}static _normalizeArr(c,F){const O=[];let V=!1;for(const K of c)if(!!K){if(K.type===1){V=!0;continue}if(K.type===0)return _.INSTANCE;if(K.type===6){O.push(...K.expr);continue}O.push(K)}if(O.length===0&&V)return n.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(t);for(let K=1;K<O.length;K++)O[K-1].equals(O[K])&&(O.splice(K,1),K--);if(O.length===1)return O[0];for(;O.length>1;){const K=O[O.length-1];if(K.type!==9)break;O.pop();const W=O.pop(),Q=O.length===0,$=w.create(K.expr.map(U=>a.create([U,W],null)),null,Q);$&&(O.push($),O.sort(t))}return O.length===1?O[0]:new a(O,F)}}serialize(){return this.expr.map(c=>c.serialize()).join(" && ")}keys(){const c=[];for(let F of this.expr)c.push(...F.keys());return c}map(c){return new a(this.expr.map(F=>F.map(c)),null)}negate(){if(!this.negated){const c=[];for(let F of this.expr)c.push(F.negate());this.negated=w.create(c,this,!0)}return this.negated}}class w{constructor(c,F){this.expr=c,this.negated=F,this.type=9}static create(c,F,O){return w._normalizeArr(c,F,O)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const V=t(this.expr[F],c.expr[F]);if(V!==0)return V}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(c.expr[F]))return!1;return!0}return!1}evaluate(c){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(c))return!0;return!1}static _normalizeArr(c,F,O){let V=[],K=!1;if(c){for(let W=0,Q=c.length;W<Q;W++){const $=c[W];if(!!$){if($.type===0){K=!0;continue}if($.type===1)return n.INSTANCE;if($.type===9){V=V.concat($.expr);continue}V.push($)}}if(V.length===0&&K)return _.INSTANCE;V.sort(t)}if(V.length!==0){if(V.length===1)return V[0];for(let W=1;W<V.length;W++)V[W-1].equals(V[W])&&(V.splice(W,1),W--);if(V.length===1)return V[0];if(O){for(let W=0;W<V.length;W++)for(let Q=W+1;Q<V.length;Q++)T(V[W],V[Q])&&(V.splice(Q,1),Q--);if(V.length===1)return V[0]}return new w(V,F)}}serialize(){return this.expr.map(c=>c.serialize()).join(" || ")}keys(){const c=[];for(let F of this.expr)c.push(...F.keys());return c}map(c){return new w(this.expr.map(F=>F.map(c)),null)}negate(){if(!this.negated){let c=[];for(let F of this.expr)c.push(F.negate());for(;c.length>1;){const F=c.shift(),O=c.shift(),V=[];for(const W of p(F))for(const Q of p(O))V.push(a.create([W,Q],null));const K=c.length===0;c.unshift(w.create(V,null,K))}this.negated=c[0]}return this.negated}}class f extends h{constructor(c,F,O){super(c,null);this._defaultValue=F,typeof O=="object"?f._info.push({...O,key:c}):O!==!0&&f._info.push({key:c,description:O,type:F!=null?typeof F:void 0})}static all(){return f._info.values()}bindTo(c){return c.createKey(this.key,this._defaultValue)}getValue(c){return c.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(c){return u.create(this.key,c)}notEqualsTo(c){return I.create(this.key,c)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(b,c){return b<c?-1:b>c?1:0}function D(b,c,F,O){return b<F?-1:b>F?1:c<O?-1:c>O?1:0}function T(b,c){if(c.type===6&&b.type!==9&&b.type!==6){for(const V of c.expr)if(b.equals(V))return!0}const F=b.negate(),O=p(F).concat(p(c));O.sort(t);for(let V=0;V<O.length;V++){const W=O[V].negate();for(let Q=V+1;Q<O.length;Q++){const $=O[Q];if(W.equals($))return!0}}return!1}e.implies=T;function p(b){return b.type===9?b.expr:[b]}}),define(be[142],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],Ee([0,1,9,4]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,n){if(typeof _=="undefined"||_===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof _=="string"||typeof n=="string"){let h=typeof _=="string"?_:_.value,u=typeof n=="string"?n:n.value;return d.equalsIgnoreCase(h,u)}return _._lower===n._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=C;function y(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[143],Ee([0,1,9,25]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(u,s){return u.uuid&&s.uuid?u.uuid===s.uuid:u.id===s.id?!0:(0,d.compareIgnoreCase)(u.id,s.id)===0}e.areSameExtensions=E;class A{constructor(s,v){this.version=v,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof A?E(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(u,s){return`${u}.${s}`}e.getExtensionId=R;function C(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(u,s){return C(R(u,s))}e.getGalleryExtensionId=y;function P(u,s){const v=[],I=S=>{for(const o of v)if(o.some(g=>E(s(g),s(S))))return o;return null};for(const S of u){const o=I(S);o?o.push(S):v.push([S])}return v}e.groupByExtension=P;function t(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(u){const s=new Set;for(const v of u)v.malicious&&s.add(v.id.id);return s}e.getMaliciousExtensionsSet=n;function h(u,s){const v=[],I=s.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const S=I.shift();if(S&&v.every(o=>!E(o.identifier,{id:S}))){const o=u.filter(g=>E(g.identifier,{id:S}));o.length===1&&(v.push(o[0]),I.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=h}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(W){W[W.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=h;function u(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=u;function s(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function v(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=v;var I;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(Q,$){super(Q);this.code=$}}e.FileSystemProviderError=S;function o(W,Q){const $=new S(W.toString(),Q);return k($,Q),$}e.createFileSystemProviderError=o;function g(W){return W||o((0,C.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=g;function k(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=k;function i(W){if(!W)return I.Unknown;if(W instanceof S)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return I.Unknown;switch(Q[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function l(W){if(W instanceof D)return W.fileOperationResult;switch(i(W)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(Q,$,U){this.resource=Q,this.operation=$,this.target=U}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=a;var w;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class f{constructor(Q,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of Q)switch(U.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>$)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>$)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>$)),this.deleted.set(U.resource,U);break}}contains(Q,...$){return this.doContains(Q,{includeChildren:!1},...$)}affects(Q,...$){return this.doContains(Q,{includeChildren:!0},...$)}doContains(Q,$,...U){if(!Q)return!1;const H=U.length>0;return!!((!H||U.includes(1))&&(this.added?.get(Q)||$.includeChildren&&this.added?.findSuperstr(Q))||(!H||U.includes(0))&&(this.updated?.get(Q)||$.includeChildren&&this.updated?.findSuperstr(Q))||(!H||U.includes(2))&&(this.deleted?.findSubstr(Q)||$.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(W,Q,$){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==M.sep&&(Q+=M.sep),$?(0,E.startsWithIgnoreCase)(W,Q):W.indexOf(Q)===0)}e.isParent=m;class D extends Error{constructor(Q,$,U){super(Q);this.fileOperationResult=$,this.options=U}}e.FileOperationError=D;class T extends D{constructor(Q,$,U){super(Q,2,U);this.stat=$}}e.NotModifiedSinceFileOperationError=T;var p;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var b;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(b=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function c(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=c;async function F(W,Q){if(!Q.canHandleResource(R.URI.from({scheme:W.scheme})))return new Promise($=>{const U=Q.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===W.scheme&&H.added&&(U.dispose(),$())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(Q){return(0,A.isNumber)(Q)||(Q=0),Q<O.KB?(0,C.localize)(1,null,Q.toFixed(0)):Q<O.MB?(0,C.localize)(2,null,(Q/O.KB).toFixed(2)):Q<O.GB?(0,C.localize)(3,null,(Q/O.MB).toFixed(2)):Q<O.TB?(0,C.localize)(4,null,(Q/O.GB).toFixed(2)):(0,C.localize)(5,null,(Q/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var V;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*O.MB:16*O.GB,maxHeapSize:W===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=K}),define(be[61],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...E){this._entries=new Map;for(let[A,R]of E)this.set(A,R)}set(E,A){const R=this._entries.get(E);return this._entries.set(E,A),R}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=d}),define(be[144],Ee([0,1,14,16,81,139,4,61]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class t{constructor(u=new C.ServiceCollection,s=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=s,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(u){return new t(u,this._strict,this)}invokeFunction(u,...s){let v=n.traceInvocation(u),I=!1;try{return u({get:(o,g)=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const k=this._getOrCreateServiceInstance(o,v);if(!k&&g!==R.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return k}},...s)}finally{I=!0,v.stop()}}createInstance(u,...s){let v,I;return u instanceof E.SyncDescriptor?(v=n.traceCreation(u.ctor),I=this._createInstance(u.ctor,u.staticArguments.concat(s),v)):(v=n.traceCreation(u),I=this._createInstance(u,s,v)),v.stop(),I}_createInstance(u,s=[],v){let I=R._util.getServiceDependencies(u).sort((g,k)=>g.index-k.index),S=[];for(const g of I){let k=this._getOrCreateServiceInstance(g.id,v);if(!k&&this._strict&&!g.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${g.id}.`);S.push(k)}let o=I.length>0?I[0].index:s.length;if(s.length!==o){console.warn(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${s.length} static arguments`);let g=o-s.length;g>0?s=s.concat(new Array(g)):s=s.slice(0,o)}return new u(...[...s,...S])}_setServiceInstance(u,s){if(this._services.get(u)instanceof E.SyncDescriptor)this._services.set(u,s);else if(this._parent)this._parent._setServiceInstance(u,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let s=this._services.get(u);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):s}_getOrCreateServiceInstance(u,s){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,s.branch(u,!0)):(s.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,s,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,s,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,s,v){const I=new A.Graph(g=>g.id.toString());let S=0;const o=[{id:u,desc:s,_trace:v}];for(;o.length;){const g=o.pop();if(I.lookupOrInsertNode(g),S++>1e3)throw new P(I);for(let k of R._util.getServiceDependencies(g.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(k.id);if(!i&&!k.optional&&console.warn(`[createInstance] ${u} depends on ${k.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const l={id:k.id,desc:i,_trace:g._trace.branch(k.id,!0)};I.insertEdge(g,l),o.push(l)}}}for(;;){const g=I.roots();if(g.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:k}of g){if(this._getServiceInstanceOrDescriptor(k.id)instanceof E.SyncDescriptor){const l=this._createServiceInstanceWithOwner(k.id,k.desc.ctor,k.desc.staticArguments,k.desc.supportsDelayedInstantiation,k._trace);this._setServiceInstance(k.id,l)}I.removeNode(k)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,s,v=[],I,S){if(this._services.get(u)instanceof E.SyncDescriptor)return this._createServiceInstance(s,v,I,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,s,v,I,S);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(u,s=[],v,I){if(v){const S=new d.IdleValue(()=>this._createInstance(u,s,I));return new Proxy(Object.create(null),{get(o,g){if(g in o)return o[g];let k=S.value,i=k[g];return typeof i!="function"||(i=i.bind(k),o[g]=i),i},set(o,g,k){return S.value[g]=k,!0}})}else return this._createInstance(u,s,I)}}e.InstantiationService=t;var _;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(_||(_={}));class n{constructor(u,s){this.type=u,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return y?new n(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(u){return y?new n(0,u.name):n._None}branch(u,s){let v=new n(2,u.toString());return this._dep.push([u,s,v]),v}stop(){let u=Date.now()-this._start;n._totals+=u;let s=!1;function v(S,o){let g=[],k=new Array(S+1).join("	");for(const[i,l,r]of o._dep)if(l&&r){s=!0,g.push(`${k}CREATES -> ${i}`);let a=v(S+1,r);a&&g.push(a)}else g.push(`${k}uses -> ${i}`);return g.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(u>2||s)&&console.log(I.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,26,4]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function C(){return new Date().toISOString()}var y;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class P extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...l){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([i,...l]))}debug(i,...l){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([i,...l]))}info(i,...l){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([i,...l]))}warn(i,...l){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([i,...l]))}error(i,...l){if(this.checkLogLevel(y.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([i,...l]))}critical(i,...l){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([i,...l]))}flush(){}format(i){let l="";for(let r=0;r<i.length;r++){let a=i[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(w){}l+=(r>0?" ":"")+a}return l}}e.AbstractMessageLogger=t;class _ extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...l){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...l):console.log(`[main ${C()}]`,i,...l))}debug(i,...l){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...l):console.log(`[main ${C()}]`,i,...l))}info(i,...l){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...l):console.log(`[main ${C()}]`,i,...l))}warn(i,...l){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...l):console.warn(`[main ${C()}]`,i,...l))}error(i,...l){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...l):console.error(`[main ${C()}]`,i,...l))}critical(i,...l){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...l):console.error(`[main ${C()}]`,i,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...l){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...l)}debug(i,...l){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...l)}info(i,...l){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...l)}warn(i,...l){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...l)}error(i,...l){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...l)}critical(i,...l){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...l)}dispose(){}flush(){}}e.ConsoleLogger=n;class h extends P{constructor(i,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(l)}trace(i,...l){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...l])}debug(i,...l){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...l])}info(i,...l){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...l])}warn(i,...l){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...l])}error(i,...l){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...l])}critical(i,...l){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...l])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class u extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const l of this.logServices)l.setLevel(i);super.setLevel(i)}trace(i,...l){for(const r of this.logServices)r.trace(i,...l)}debug(i,...l){for(const r of this.logServices)r.debug(i,...l)}info(i,...l){for(const r of this.logServices)r.info(i,...l)}warn(i,...l){for(const r of this.logServices)r.warn(i,...l)}error(i,...l){for(const r of this.logServices)r.error(i,...l)}critical(i,...l){for(const r of this.logServices)r.critical(i,...l)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=u;class s extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...l){this.logger.trace(i,...l)}debug(i,...l){this.logger.debug(i,...l)}info(i,...l){this.logger.info(i,...l)}warn(i,...l){this.logger.warn(i,...l)}error(i,...l){this.logger.error(i,...l)}critical(i,...l){this.logger.critical(i,...l)}flush(){this.logger.flush()}}e.LogService=s;class v extends E.Disposable{constructor(i,l){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,l){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,l?.always?y.Trace:this.logLevel,l),this.loggers.set(i.toString(),r),l?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class I{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...l){}debug(i,...l){}info(i,...l){}warn(i,...l){}error(i,...l){}critical(i,...l){}dispose(){}flush(){}}e.NullLogService=I;function S(k){if(k.verbose)return y.Trace;if(typeof k.logLevel=="string"){const i=o(k.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function o(k){switch(k){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=o;function g(k){switch(k){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=g}),define(be[82],Ee([0,1,35,122,4]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(u,s){return s-u}y.compare=P;const t=Object.create(null);t[y.Error]=(0,M.localize)(0,null),t[y.Warning]=(0,M.localize)(1,null),t[y.Info]=(0,M.localize)(2,null);function _(u){return t[u]||""}y.toString=_;function n(u){switch(u){case d.default.Error:return y.Error;case d.default.Warning:return y.Warning;case d.default.Info:return y.Info;case d.default.Ignore:return y.Hint}}y.fromSeverity=n;function h(u){switch(u){case y.Error:return d.default.Error;case y.Warning:return d.default.Warning;case y.Info:return d.default.Info;case y.Hint:return d.default.Ignore}}y.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(y){const P="";function t(n){return _(n,!0)}y.makeKey=t;function _(n,h){let u=[P];return n.source?u.push(n.source.replace("\xA6","\\\xA6")):u.push(P),n.code?typeof n.code=="string"?u.push(n.code.replace("\xA6","\\\xA6")):u.push(n.code.value.replace("\xA6","\\\xA6")):u.push(P),n.severity!==void 0&&n.severity!==null?u.push(R.toString(n.severity)):u.push(P),n.message&&h?u.push(n.message.replace("\xA6","\\\xA6")):u.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?u.push(n.startLineNumber.toString()):u.push(P),n.startColumn!==void 0&&n.startColumn!==null?u.push(n.startColumn.toString()):u.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?u.push(n.endLineNumber.toString()):u.push(P),n.endColumn!==void 0&&n.endColumn!==null?u.push(n.endColumn.toString()):u.push(P),u.push(P),u.join("\xA6")}y.makeKeyOptionalMessage=_})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,35,4]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new y,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class y{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=y}),define(be[146],Ee([0,1,6,9,2,4]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function R(C,y){return E.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,y):(0,M.startsWithIgnoreCase)(C,y+":")}e.matchesScheme=R});var Ue=this&&this.__decorate||function(ie,e,d,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,d,M);else for(var C=ie.length-1;C>=0;C--)(R=ie[C])&&(A=(E<3?R(A):E>3?R(e,d,A):R(e,d))||A);return E>3&&A&&Object.defineProperty(e,d,A),A},He=this&&this.__param||function(ie,e){return function(d,M){e(d,M,ie)}};define(be[147],Ee([0,1,14,21,6,4]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let y=class extends E.Disposable{constructor(_,n){super();this.deferred=new d.DeferredPromise,n.withProgress(_,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};y=Ue([He(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,h=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:h.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,40,10]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(R,C){d.ok(M.isString(R)),d.ok(M.isObject(C)),d.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,C)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new E}),define(be[83],Ee([0,1,3,28]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[E(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;M.Registry.add(e.Extensions.JSONContribution,R)}),define(be[62],Ee([0,1,3,10,119,83,28]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=R.Registry.as(A.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(S,o=!0){this.registerConfigurations([S],o)}registerConfigurations(S,o=!0){const g=[];S.forEach(k=>{g.push(...this.validateAndRegisterProperties(k,o,k.extensionInfo)),this.configurationContributors.push(k),this.registerJSONConfiguration(k)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(S){const o=[],g=k=>{if(k.properties)for(const i in k.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,k.properties[i]);k.allOf&&k.allOf.forEach(i=>g(i))};for(const k of S){g(k);const i=this.configurationContributors.indexOf(k);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(S){const o=[],g=[];for(const k of S)for(const i in k)if(o.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...k[i]};const l={type:"object",default:this.defaultValues[i],description:E.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};g.push(n(i)),this.configurationProperties[i]=l,this.defaultLanguageConfigurationOverridesNode.properties[i]=l}else{this.defaultValues[i]=k[i];const l=this.configurationProperties[i];l&&(this.updatePropertyDefaultValue(i,l),this.updateSchema(i,l))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(S){const o=[];for(const g of S)for(const k in g)if(o.push(k),delete this.defaultValues[k],e.OVERRIDE_PROPERTY_PATTERN.test(k))delete this.configurationProperties[k],delete this.defaultLanguageConfigurationOverridesNode.properties[k];else{const i=this.configurationProperties[k];i&&(this.updatePropertyDefaultValue(k,i),this.updateSchema(k,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const o of S)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(S,o=!0,g,k=3){k=M.isUndefinedOrNull(S.scope)?k:S.scope;let i=[],l=S.properties;if(l)for(let a in l){if(o&&s(a)){delete l[a];continue}const w=l[a];if(this.updatePropertyDefaultValue(a,w),e.OVERRIDE_PROPERTY_PATTERN.test(a)?w.scope=void 0:(w.scope=M.isUndefinedOrNull(w.scope)?k:w.scope,w.restricted=M.isUndefinedOrNull(w.restricted)?!!g?.restrictedConfigurations?.includes(a):w.restricted),l[a].hasOwnProperty("included")&&!l[a].included){this.excludedConfigurationProperties[a]=l[a],delete l[a];continue}else this.configurationProperties[a]=l[a];!l[a].deprecationMessage&&l[a].markdownDeprecationMessage&&(l[a].deprecationMessage=l[a].markdownDeprecationMessage),i.push(a)}let r=S.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,g,k));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(S){const o=g=>{let k=g.properties;if(k)for(const l in k)this.updateSchema(l,k[l]);let i=g.allOf;i&&i.forEach(o)};o(S)}updateSchema(S,o){switch(e.allSettings.properties[S]=o,o.scope){case 1:e.applicationSettings.properties[S]=o;break;case 2:e.machineSettings.properties[S]=o;break;case 6:e.machineOverridableSettings.properties[S]=o;break;case 3:e.windowSettings.properties[S]=o;break;case 4:e.resourceSettings.properties[S]=o;break;case 5:e.resourceSettings.properties[S]=o,this.resourceLanguageSettingsSchema.properties[S]=o;break}}removeFromSchema(S,o){switch(delete e.allSettings.properties[S],o.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const o=`[${S}]`,g={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,g),e.allSettings.properties[o]=g,e.applicationSettings.properties[o]=g,e.machineSettings.properties[o]=g,e.machineOverridableSettings.properties[o]=g,e.windowSettings.properties[o]=g,e.resourceSettings.properties[o]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,o){let g=this.defaultValues[S];M.isUndefined(g)&&(g=o.default),M.isUndefined(g)&&(g=h(o.type)),o.default=g}}const _="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(_);function n(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=n;function h(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new t;R.Registry.add(e.Extensions.Configuration,u);function s(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?E.localize(5,null,I):u.getConfigurationProperties()[I]!==void 0?E.localize(6,null,I):null:E.localize(4,null)}e.validateProperty=s;function v(){const I=[],S=u.getConfigurationProperties();for(const o of Object.keys(S))I.push([o,S[o].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=v}),define(be[84],Ee([0,1,22,10,2,62,4,28]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function y(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof E.URI)}e.isConfigurationOverrides=y;var P;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(l,r){const a=r?l?r.keys.filter(b=>l.keys.indexOf(b)===-1):[...r.keys]:[],w=l?r?l.keys.filter(b=>r.keys.indexOf(b)===-1):[...l.keys]:[],f=[];if(r&&l){for(const b of l.keys)if(r.keys.indexOf(b)!==-1){const c=I(l.contents,b),F=I(r.contents,b);d.equals(c,F)||f.push(b)}}const m=[],D=b=>{const c={};for(const F of b)for(const O of F.identifiers)c[k(O)]=F;return c},T=r?D(r.overrides):{},p=l?D(l.overrides):{};if(Object.keys(T).length)for(const b of a){const c=T[b];c&&m.push([(0,A.overrideIdentifierFromKey)(b),c.keys])}if(Object.keys(p).length)for(const b of w){const c=p[b];c&&m.push([(0,A.overrideIdentifierFromKey)(b),c.keys])}if(Object.keys(T).length&&Object.keys(p).length)for(const b of f){const c=p[b],F=T[b];if(c&&F){const O=_({contents:c.contents,keys:c.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});m.push([(0,A.overrideIdentifierFromKey)(b),[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:w,updated:f,overrides:m}}e.compare=_;function n(l,r){const a=[];for(const w of Object.keys(l))if(A.OVERRIDE_PROPERTY_PATTERN.test(w)){const f={};for(const m in l[w])f[m]=l[w][m];a.push({identifiers:[(0,A.overrideIdentifierFromKey)(w).trim()],keys:Object.keys(f),contents:h(f,r)})}return a}e.toOverrides=n;function h(l,r){const a=Object.create(null);for(let w in l)u(a,w,l[w],r);return a}e.toValuesTree=h;function u(l,r,a,w){const f=r.split("."),m=f.pop();let D=l;for(let T=0;T<f.length;T++){let p=f[T],b=D[p];switch(typeof b){case"undefined":b=D[p]=Object.create(null);break;case"object":break;default:w(`Ignoring ${r} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(b)}`);return}D=b}if(typeof D=="object"&&D!==null)try{D[m]=a}catch(T){w(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(D)}`)}else w(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=u;function s(l,r){const a=r.split(".");v(l,a)}e.removeFromValueTree=s;function v(l,r){const a=r.shift();if(r.length===0){delete l[a];return}if(Object.keys(l).indexOf(a)!==-1){const w=l[a];typeof w=="object"&&!Array.isArray(w)&&(v(w,r),Object.keys(w).length===0&&delete l[a])}}function I(l,r,a){function w(D,T){let p=D;for(const b of T){if(typeof p!="object"||p===null)return;p=p[b]}return p}const f=r.split("."),m=w(l,f);return typeof m=="undefined"?a:m}e.getConfigurationValue=I;function S(l,r,a){Object.keys(r).forEach(w=>{w!=="__proto__"&&(w in l?M.isObject(l[w])&&M.isObject(r[w])?S(l[w],r[w],a):a&&(l[w]=r[w]):l[w]=r[w])})}e.merge=S;function o(){const l=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=o;function g(){const l=Object.create(null),r=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let a in r){let w=r[a].default;u(l,a,w,f=>console.error(`Conflict in default settings: ${f}`))}return l}e.getDefaultValues=g;function k(l){return`[${l}]`}e.keyFromOverrideIdentifier=k;function i(l,r,a){const w=l.inspect(r),f=l.inspect(a);return typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:w.defaultValue}e.getMigratedSettingValue=i}),define(be[148],Ee([0,1,13,3,102,6,20,22,10,2,84,62,28]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(i={},l=[],r=[]){this._contents=i,this._keys=l,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,l){const r=this.getContentsForOverrideIdentifer(l);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.keys;return[]}override(i){const l=this.getContentsForOverrideIdentifer(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let r={};for(const a of d.distinct([...Object.keys(this.contents),...Object.keys(l)])){let w=this.contents[a],f=l[a];f&&(typeof w=="object"&&typeof f=="object"?(w=C.deepClone(w),this.mergeContents(w,f)):w=f),r[a]=w}return new h(r,this.keys,this.overrides)}merge(...i){const l=C.deepClone(this.contents),r=C.deepClone(this.overrides),a=[...this.keys];for(const w of i){this.mergeContents(l,w.contents);for(const f of w.overrides){const[m]=r.filter(D=>d.equals(D.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):r.push(C.deepClone(f))}for(const f of w.keys)a.indexOf(f)===-1&&a.push(f)}return new h(l,a,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,l){for(const r of Object.keys(l)){if(r in i&&y.isObject(i[r])&&y.isObject(l[r])){this.mergeContents(i[r],l[r]);continue}i[r]=C.deepClone(l[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.addKey(i),(0,t.addToValueTree)(this.contents,i,l,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let l=this.keys.length;for(let r=0;r<l;r++)i.indexOf(this.keys[r])===0&&(l=r);this.keys.splice(l,1,i)}removeKey(i){let l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=h;class u extends h{constructor(){const i=(0,t.getDefaultValues)(),l=(0,t.getConfigurationKeys)(),r=[];for(const a of Object.keys(i))_.OVERRIDE_PROPERTY_PATTERN.test(a)&&r.push({identifiers:[(0,_.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(i[a]),contents:(0,t.toValuesTree)(i[a],w=>console.error(`Conflict in default settings file: ${w}`))});super(i,l,r)}}e.DefaultConfigurationModel=u;class s{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,l){if(!y.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,l)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,l){this._raw=i;const{contents:r,keys:a,overrides:w,restricted:f}=this.doParseRaw(i,l);this._configurationModel=new h(r,a,w),this._restrictedConfigurations=f||[]}doParseContent(i){let l={},r=null,a=[],w=[],f=[];function m(T){Array.isArray(a)?a.push(T):r!==null&&(a[r]=T)}let D={onObjectBegin:()=>{let T={};m(T),w.push(a),a=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{a=w.pop()},onArrayBegin:()=>{let T=[];m(T),w.push(a),a=T,r=null},onArrayEnd:()=>{a=w.pop()},onLiteralValue:m,onError:(T,p,b)=>{f.push({error:T,offset:p,length:b})}};if(i)try{E.visit(i,D),l=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return l}doParseRaw(i,l){const r=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),a=this.filter(i,r,!0,l);i=a.raw;const w=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(i),m=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:w,keys:f,overrides:m,restricted:a.restricted}}filter(i,l,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[]};const w={},f=[];for(let m in i)if(_.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const D=this.filter(i[m],l,!1,a);w[m]=D.raw,f.push(...D.restricted)}else{const D=l[m],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&f.push(m),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&D?.restricted||(w[m]=i[m]))}return{raw:w,restricted:f}}}e.ConfigurationModelParser=s;class v extends A.Disposable{constructor(i,l,r,a){super();this.userSettingsResource=i,this.scopes=l,this.fileService=a,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class I{constructor(i,l,r=new h,a=new h,w=new R.ResourceMap,f=new h,m=new R.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=l,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=w,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,l,r){return this.getConsolidateConfigurationModel(l,r).getValue(i)}updateValue(i,l,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new h,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,l===void 0?a.removeValue(i):a.setValue(i,l),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,l,r){const a=this.getConsolidateConfigurationModel(l,r),w=this.getFolderConfigurationModelForResource(l.resource,r),f=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,m=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),p=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),b=r?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,c=w?l.overrideIdentifier?w.freeze().override(l.overrideIdentifier).getValue(i):w.freeze().getValue(i):void 0,F=l.overrideIdentifier?f.override(l.overrideIdentifier).getValue(i):f.getValue(i),O=a.getValue(i),V=d.distinct(d.flatten(a.overrides.map(K=>K.identifiers))).filter(K=>a.getOverrideValue(i,K)!==void 0);return{defaultValue:m,userValue:D,userLocalValue:T,userRemoteValue:p,workspaceValue:b,workspaceFolderValue:c,memoryValue:F,value:O,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspace:b!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspaceFolder:c!==void 0?{value:w?.freeze().getValue(i),override:l.overrideIdentifier?w?.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:f.getValue(i),override:l.overrideIdentifier?f.getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const l=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,l){this._folderConfigurations.set(i,l),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const r=l.filter(a=>_.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const w=(0,_.overrideIdentifierFromKey)(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(w),m=i.getKeysForOverrideIdentifier(w),D=[...m.filter(T=>f.indexOf(T)===-1),...f.filter(T=>m.indexOf(T)===-1),...f.filter(T=>!C.equals(this._defaultConfiguration.override(w).getValue(T),i.override(w).getValue(T)))];return[w,D]});return this.updateDefaultConfiguration(i),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:r,removed:a,overrides:w}=(0,t.compare)(this.localUserConfiguration,i),f=[...l,...r,...a];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:w}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:r,removed:a,overrides:w}=(0,t.compare)(this.remoteUserConfiguration,i);let f=[...l,...r,...a];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:w}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:r,removed:a,overrides:w}=(0,t.compare)(this.workspaceConfiguration,i);let f=[...l,...r,...a];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:w}}compareAndUpdateFolderConfiguration(i,l){const r=this.folderConfigurations.get(i),{added:a,updated:w,removed:f,overrides:m}=(0,t.compare)(r,l);let D=[...a,...w,...f];return(D.length||!r)&&this.updateFolderConfiguration(i,l),{keys:D,overrides:m}}compareAndDeleteFolderConfiguration(i){const l=this.folderConfigurations.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:w,overrides:f}=(0,t.compare)(l,void 0);return{keys:[...r,...a,...w],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,l){let r=this.getConsolidatedConfigurationModelForResource(i,l);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},l){let r=this.getWorkspaceConsolidatedConfiguration();if(l&&i){const a=l.getFolder(i);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const w=this._memoryConfigurationByResource.get(i);w&&(r=r.merge(w))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let l=this._foldersConsolidatedConfigurations.get(i);if(!l){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(i);a?(l=r.merge(a),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(i,l)):l=r}return l}getFolderConfigurationModelForResource(i,l){if(l&&i){const r=l.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,l)=>{const{contents:r,overrides:a,keys:w}=this._folderConfigurations.get(l);return i.push([l,{contents:r,overrides:a,keys:w}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>l.add(a))),[...l.values()]}static parse(i){const l=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),w=i.folders.reduce((f,m)=>(f.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new R.ResourceMap);return new I(l,r,new h,a,w,new h,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new h(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function S(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const i=new Set,l=new Map;for(const a of k)a.keys.forEach(w=>i.add(w)),a.overrides.forEach(([w,f])=>{const m=(0,R.getOrSet)(l,w,new Set);f.forEach(D=>m.add(D))});const r=[];return l.forEach((a,w)=>r.push([w,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=S;class o{constructor(i,l,r,a){this.change=i,this.previous=l,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const w=new Set;i.keys.forEach(m=>w.add(m)),i.overrides.forEach(([,m])=>m.forEach(D=>w.add(D))),this.affectedKeys=[...w.values()];const f=new h;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(l){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(i,l,this.currentWorkspace);return!C.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(i,l){let r=(0,t.toValuesTree)({[l]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(i=i[a],!i)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=o;class g extends o{constructor(i,l,r,a){super({keys:i.allKeys(),overrides:[]},void 0,i,l);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=g}),define(be[85],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(R,C=M.Unknown,y){super(R);this._message=R,this._code=C,this._detail=y,this.isHandled=C===M.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(R){return R instanceof E&&R._code===M.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof E&&R._code===M.NoResolverFound}static isHandled(R){return R instanceof E&&R.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[86],Ee([0,1,11]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===d.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function E(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=E;function A(P){return P.scheme!==d.Schemas.file&&P.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function R(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function C(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=C;function y(P){return R(P)!==void 0}e.isVirtualWorkspace=y}),define(be[149],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.TerminalPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var M;(function(s){s.Shell="terminal.integrated.shell.",s.ShellArgs="terminal.integrated.shellArgs.",s.DefaultProfile="terminal.integrated.defaultProfile.",s.Profiles="terminal.integrated.profiles."})(M=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var E;(function(s){s.ShellLinux="terminal.integrated.shell.linux",s.ShellMacOs="terminal.integrated.shell.osx",s.ShellWindows="terminal.integrated.shell.windows",s.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",s.AutomationShellLinux="terminal.integrated.automationShell.linux",s.AutomationShellMacOs="terminal.integrated.automationShell.osx",s.AutomationShellWindows="terminal.integrated.automationShell.windows",s.ShellArgsLinux="terminal.integrated.shellArgs.linux",s.ShellArgsMacOs="terminal.integrated.shellArgs.osx",s.ShellArgsWindows="terminal.integrated.shellArgs.windows",s.ProfilesWindows="terminal.integrated.profiles.windows",s.ProfilesMacOs="terminal.integrated.profiles.osx",s.ProfilesLinux="terminal.integrated.profiles.linux",s.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",s.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",s.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",s.UseWslProfiles="terminal.integrated.useWslProfiles",s.TabsEnabled="terminal.integrated.tabs.enabled",s.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",s.TabsHideCondition="terminal.integrated.tabs.hideCondition",s.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",s.TabsShowActions="terminal.integrated.tabs.showActions",s.TabsLocation="terminal.integrated.tabs.location",s.TabsFocusMode="terminal.integrated.tabs.focusMode",s.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",s.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",s.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",s.CopyOnSelection="terminal.integrated.copyOnSelection",s.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",s.FontFamily="terminal.integrated.fontFamily",s.FontSize="terminal.integrated.fontSize",s.LetterSpacing="terminal.integrated.letterSpacing",s.LineHeight="terminal.integrated.lineHeight",s.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",s.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",s.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",s.BellDuration="terminal.integrated.bellDuration",s.FontWeight="terminal.integrated.fontWeight",s.FontWeightBold="terminal.integrated.fontWeightBold",s.CursorBlinking="terminal.integrated.cursorBlinking",s.CursorStyle="terminal.integrated.cursorStyle",s.CursorWidth="terminal.integrated.cursorWidth",s.Scrollback="terminal.integrated.scrollback",s.DetectLocale="terminal.integrated.detectLocale",s.DefaultLocation="terminal.integrated.defaultLocation",s.GpuAcceleration="terminal.integrated.gpuAcceleration",s.TerminalTitleSeparator="terminal.integrated.tabs.separator",s.TerminalTitle="terminal.integrated.tabs.title",s.TerminalDescription="terminal.integrated.tabs.description",s.RightClickBehavior="terminal.integrated.rightClickBehavior",s.Cwd="terminal.integrated.cwd",s.ConfirmOnExit="terminal.integrated.confirmOnExit",s.ConfirmOnKill="terminal.integrated.confirmOnKill",s.EnableBell="terminal.integrated.enableBell",s.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",s.AllowChords="terminal.integrated.allowChords",s.AllowMnemonics="terminal.integrated.allowMnemonics",s.EnvMacOs="terminal.integrated.env.osx",s.EnvLinux="terminal.integrated.env.linux",s.EnvWindows="terminal.integrated.env.windows",s.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",s.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",s.ShowExitAlert="terminal.integrated.showExitAlert",s.SplitCwd="terminal.integrated.splitCwd",s.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",s.WordSeparators="terminal.integrated.wordSeparators",s.TitleMode="terminal.integrated.titleMode",s.EnableFileLinks="terminal.integrated.enableFileLinks",s.UnicodeVersion="terminal.integrated.unicodeVersion",s.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",s.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",s.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",s.LocalEchoStyle="terminal.integrated.localEchoStyle",s.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",s.CustomGlyphs="terminal.integrated.customGlyphs",s.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",s.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",s.InheritEnv="terminal.integrated.inheritEnv",s.ShowLinkHover="terminal.integrated.showLinkHover"})(E=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(s){s.CommandPrompt="cmd",s.PowerShell="pwsh",s.Wsl="wsl",s.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(s){s[s.Api=0]="Api",s[s.Process=1]="Process",s[s.Sequence=2]="Sequence",s[s.Config=3]="Config"})(R=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(s){s.LocalPty="localPty",s.PtyHost="ptyHost",s.Log="log",s.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,d.createDecorator)("ptyService");var y;(function(s){s[s.cwd=0]="cwd",s[s.initialCwd=1]="initialCwd"})(y=e.TerminalPropertyType||(e.TerminalPropertyType={}));var P;(function(s){s[s.BeatInterval=5e3]="BeatInterval",s[s.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",s[s.SecondWaitMultiplier=1]="SecondWaitMultiplier",s[s.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P=e.HeartbeatConstants||(e.HeartbeatConstants={}));var t;(function(s){s[s.Panel=1]="Panel",s[s.Editor=2]="Editor"})(t=e.TerminalLocation||(e.TerminalLocation={}));var _;(function(s){s.TerminalView="view",s.Editor="editor"})(_=e.TerminalLocationString||(e.TerminalLocationString={}));var n;(function(s){s[s.GraceTime=6e4]="GraceTime",s[s.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(s){s[s.HighWatermarkChars=1e5]="HighWatermarkChars",s[s.LowWatermarkChars=5e3]="LowWatermarkChars",s[s.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(s){s.GitBash="Git Bash",s.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}))}),define(be[150],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,R=5){let C;return C=A(y=>{const P=typeof y=="string"?y:y.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(P);return}const _=setTimeout(()=>this.flushBuffer(E),R);t={data:[P],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),C.dispose()}},this._terminalBufferMap.set(E,t)}),C}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=d}),define(be[151],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[44],Ee([0,1,34,3,6,4,28,151]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var y;(function(v){function I(S){return S&&typeof S=="object"&&typeof S.id=="string"}v.isThemeColor=I})(y=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var t;(function(v){function I(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||y.isThemeColor(l.color))}v.isThemeIcon=I;const S=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(l){const r=S.exec(l);if(!r)return;let[,a]=r;return{id:a}}v.fromString=o;function g(l,r){let a=l.id;const w=a.lastIndexOf("~");return w!==-1&&(a=a.substring(0,w)),r&&(a=`${a}~${r}`),{id:a}}v.modify=g;function k(l,r){return l.id===r.id&&l.color?.id===r.color?.id}v.isEqual=k;function i(l,r){return{id:l.id,color:r?P(r):void 0}}v.asThemeIcon=i,v.asClassNameArray=d.CSSIcon.asClassNameArray,v.asClassName=d.CSSIcon.asClassName,v.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function _(v){switch(v){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,E.toDisposable)(()=>{const S=this.themingParticipants.indexOf(I);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new n;R.Registry.add(e.Extensions.ThemingContribution,h);function u(v){return h.onColorThemeChange(v)}e.registerThemingParticipant=u;class s extends E.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,S){let o=this.theme.getColor(I);return o&&S&&(o=S(o,this.theme)),o?o.toString():null}}e.Themable=s}),define(be[152],Ee([0,1,14,34,3,123,83,28,44]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,S,o,g){const k=this.iconsById[I];if(k){if(o&&!k.description){k.description=o,this.iconSchema.properties[I].markdownDescription=`${o} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return k}let i={id:I,description:o,defaults:S,deprecationMessage:g};this.iconsById[I]=i;let l={$ref:"#/definitions/icons"};return g&&(l.deprecationMessage=g),o&&(l.markdownDescription=`${o}: $(${I})`),this.iconSchema.properties[I]=l,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const S=this.iconReferenceSchema.enum.indexOf(I);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,S){const o=this.iconFontsById[I];if(o)return o;let g={id:I,definition:S};return this.iconFontsById[I]=g,this._onDidChange.fire(),g}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(k,i)=>k.id.localeCompare(i.id),S=k=>{for(;y.ThemeIcon.isThemeIcon(k.defaults);)k=this.iconsById[k.defaults.id];return`codicon codicon-${k?k.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.iconsById).map(k=>this.iconsById[k]);for(const k of g.filter(i=>!!i.description).sort(I))o.push(`|<i class="${S(k)}"></i>|${k.id}|${y.ThemeIcon.isThemeIcon(k.defaults)?k.defaults.id:k.id}|${k.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const k of g.filter(i=>!y.ThemeIcon.isThemeIcon(i.defaults)).sort(I))o.push(`|<i class="${S(k)}"></i>|${k.id}|`);return o.join(`
`)}}const t=new P;C.Registry.add(e.Extensions.IconContribution,t);function _(v,I,S,o){return t.registerIcon(v,I,S,o)}e.registerIcon=_;function n(){return t}e.getIconRegistry=n;function h(){for(const v of M.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);M.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let u=C.Registry.as(R.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,t.getIconSchema());const s=new d.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=y.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[45],Ee([0,1,20,24,2,4]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const h=n;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=C;function y(n){const h=n;return!!(h&&typeof h=="object"&&E.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(h,u,s,v){this._id=h,this._configuration=s,this._ignorePathCasing=v,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(h,u){this.raw=u,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,M.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(be[63],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const y=this._providerInfo.get(C.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(C,y){y===null?this._providerInfo.delete(C):this._providerInfo.set(C,y)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,14]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(R,C,y){this._deferredPromises=new Map,this._id=R,this._shared=C,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const _ of P.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,C){let y=this._value[R];return typeof y=="undefined"&&(y=C),y}update(R,C){this._value[R]=C;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const P=new d.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(R,C){super(R.identifier.value,!0,C);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=E}),define(be[154],Ee([0,1,3,2,15]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(C,y){this._logService=C,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,y,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(C,y){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(y)}$acceptModelSaved(C){const y=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(C,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,y);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=Ue([He(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[155],Ee([0,1,25,3]),function(ie,e,d,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,y){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(C.identifier),Je(this,E,y,"f"),Te(this,E,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Te(this,E,"f").get(this._id,C)}store(C,y){return Te(this,E,"f").store(this._id,C,y)}delete(C){return Te(this,E,"f").delete(this._id,C)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[46],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(S,o)=>{const g={controllerId:o};return M.set(S,g),g};e.createPrivateApiFor=E;const A=S=>M.get(S);e.getPrivateApiFor=A;const R=(S,o,g,k)=>{let i=g;return{enumerable:!0,configurable:!1,get(){return i},set(l){if(!k(i,l)){const r=i;i=l,S.listener?.({op:3,key:o,value:l,previous:r})}}}},C=(S,o)=>S===o,y={range:(S,o)=>S===o?!0:!S||!o?!1:S.isEqual(o),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(S,o)=>!(S.length!==o.length||S.some(g=>!o.find(k=>g.id===k.id)))},P=Object.keys(y),t=(S,o)=>({range:R(S,"range",void 0,y.range),label:R(S,"label",o,y.label),description:R(S,"description",void 0,y.description),canResolveChildren:R(S,"canResolveChildren",!1,y.canResolveChildren),busy:R(S,"busy",!1,y.busy),error:R(S,"error",void 0,y.error),tags:R(S,"tags",[],y.tags)}),_=(S,o)=>{const g=new Map;for(const k of P)y[k](S[k],o[k])||g.set(k,o[k]);return g};e.diffTestItems=_;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class h extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class u extends Error{constructor(o,g,k){super(`TestItem with ID "${o}" is from controller "${g}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=u;const s=S=>{const o=(0,e.getPrivateApiFor)(S);let g=new Map;return{get size(){return g.size},forEach(k,i){for(const l of g.values())k.call(i,l,this)},replace(k){const i=new Map,l=new Set(g.keys()),r={op:4,ops:[]};for(const a of k){if(!(a instanceof v))throw new h(a.id);const w=(0,e.getPrivateApiFor)(a).controllerId;if(w!==o.controllerId)throw new u(a.id,w,o.controllerId);if(i.has(a.id))throw new n(a.id);i.set(a.id,a),l.delete(a.id),r.ops.push({op:0,item:a})}for(const a of l.keys())r.ops.push({op:1,id:a});o.listener?.(r),g=i},add(k){if(!(k instanceof v))throw new h(k.id);g.set(k.id,k),o.listener?.({op:0,item:k})},delete(k){g.delete(k)&&o.listener?.({op:1,id:k})},get(k){return g.get(k)},toJSON(){return Array.from(g.values())},[Symbol.iterator](){return g.values()}}};class v{constructor(o,g,k,i){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const l=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof I?void 0:l.parent}},children:{value:s(this),enumerable:!0,writable:!1},...t(l,k)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class I extends v{constructor(o,g){super(o,o,g,void 0)}}e.TestItemRootImpl=I}),define(be[64],Ee([0,1,4,3,12]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(C){function y(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}C.fromApiTunnel=y;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}C.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let R=class{constructor(y){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,P){return{dispose:()=>{}}}async $providePortAttributes(y,P,t,_,n){return[]}async $forwardPort(y,P){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ue([He(0,E.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[7],Ee([0,1,13,16,76,20,78,10,2,36,60,85]),function(ie,e,d,M,E,A,R,C,y,P,t,_){"use strict";var n,h,u,s,v,I,S,o,g,k,i,l,r,a,w,f,m,D,T,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let c=v=class{constructor(L){n.set(this,void 0),Je(this,n,L,"f")}static from(...L){let te=L;return new v(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Te(this,n,"f")=="function"&&(Te(this,n,"f").call(this),Je(this,n,void 0,"f"))}};n=new WeakMap,c=v=Ue([b],c),e.Disposable=c;let F=I=class{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof I)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new I(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new I(_e,te)}toJSON(){return{line:this.line,character:this.character}}};F=I=Ue([b],F),e.Position=F;let O=S=class{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(L,te),st=new F(_e,Ke)):L instanceof F&&te instanceof F&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(L){return L instanceof S?!0:L?F.isPosition(L.start)&&F.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof S?this.contains(L._start)&&this.contains(L._end):L instanceof F?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=F.Max(L.start,this._start),_e=F.Min(L.end,this._end);if(!te.isAfter(_e))return new S(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=F.Min(L.start,this._start),_e=F.Max(L.end,this.end);return new S(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return L?F.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new S(_e,te)}toJSON(){return[this.start,this.end]}};O=S=Ue([b],O),e.Range=O;let V=o=class extends O{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(L,te),st=new F(_e,Ke)):L instanceof F&&te instanceof F&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(L){return L instanceof o?!0:L?O.isRange(L)&&F.isPosition(L.anchor)&&F.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=Ue([b],V),e.Selection=V;class K{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=K;class W extends Error{constructor(L,te=_.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable(L,te){return new W(L,_.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new W(L,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var Q;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=g=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof g?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new g(L,te)}static insert(L,te){return g.replace(new O(L,L),te)}static delete(L){return g.replace(L,"")}static setEndOfLine(L){const te=new g(new O(new F(0,0),new F(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!O.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=g=Ue([b],U),e.TextEdit=U;var H;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ke){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ke})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ke,et){let st,at,yt=[],At;if(zt.isNotebookRange(te)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ke)?(st=te.start,at=te.end,yt=_e,At=Ke):typeof te=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ke)&&(st=te,at=_e,yt=Ke,At=et),st===void 0||at===void 0)throw new Error("Invalid arguments");(st!==at||yt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:at-st,cells:yt,metadata:At})}replaceNotebookCellMetadata(L,te,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ke){this._edits.push({_type:2,uri:L,edit:new U(te,_e),metadata:Ke})}insert(L,te,_e,Ke){this.replace(L,new O(te,te),_e,Ke)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new A.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Ue([b],G),e.WorkspaceEdit=G;let ue=k=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof k?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=k._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new k;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=k._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new k;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ue=k=Ue([b],ue),e.SnippetString=ue;var q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof O)this.range=te;else if(te instanceof F)this.range=new O(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?O.isRange(L.range)&&y.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=Ue([b],se),e.Location=se;let ve=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&y.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};ve=Ue([b],ve),e.DiagnosticRelatedInformation=ve;let Fe=class{constructor(L,te,_e=le.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,d.equals)(L.tags,te.tags)&&(0,d.equals)(L.relatedInformation,te.relatedInformation,ve.isEqual)}};Fe=Ue([b],Fe),e.Diagnostic=Fe;let Me=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Me=Ue([b],Me),e.Hover=Me;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,te=Ne.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=Ue([b],Qe),e.DocumentHighlight=Qe;var ze;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=l=class{constructor(L,te,_e,Ke,et){this.name=L,this.kind=te,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof se?this.location=Ke:_e instanceof O&&(this.location=new se(Ke,_e)),l.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};x=l=Ue([b],x),e.SymbolInformation=x;let Y=r=class{constructor(L,te,_e,Ke,et){this.name=L,this.detail=te,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};Y=r=Ue([b],Y),e.DocumentSymbol=Y;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,te){this.title=L,this.kind=te}};ae=Ue([b],ae),e.CodeAction=ae;let j=a=class{constructor(L){this.value=L}append(L){return new a(this.value?this.value+a.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+a.sep)}};j.sep=".",j=a=Ue([b],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let oe=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ue([b],oe),e.SelectionRange=oe;class fe{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=fe;class Ae{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ae;class xe{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=xe;var $e;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let we=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};we=Ue([b],we),e.CodeLens=we;let Ze=w=class{constructor(L,te=!1){h.set(this,void 0),Je(this,h,new E.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Te(this,h,"f").value}set value(L){Te(this,h,"f").value=L}get isTrusted(){return Te(this,h,"f").isTrusted}set isTrusted(L){Te(this,h,"f").isTrusted=L}get supportThemeIcons(){return Te(this,h,"f").supportThemeIcons}set supportThemeIcons(L){Te(this,h,"f").supportThemeIcons=L}get supportHtml(){return Te(this,h,"f").supportHtml}set supportHtml(L){Te(this,h,"f").supportHtml=L}appendText(L){return Te(this,h,"f").appendText(L),this}appendMarkdown(L){return Te(this,h,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Te(this,h,"f").appendCodeblock(te??"",L),this}};h=new WeakMap,Ze=w=Ue([b],Ze),e.MarkdownString=Ze;let z=class{constructor(L,te){this.label=L,this.documentation=te}};z=Ue([b],z),e.ParameterInformation=z;let J=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};J=Ue([b],J),e.SignatureInformation=J;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Ue([b],he),e.SignatureHelp=he;var Oe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};tt=Ue([b],tt),e.InlayHint=tt;var ut;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ht;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ht=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(N){N[N.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ht[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=Ue([b],Pt),e.CompletionItem=Pt;let dt=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};dt=Ue([b],dt),e.CompletionList=dt;let bt=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};bt=Ue([b],bt),e.InlineSuggestion=bt;let ft=class{constructor(L){this.items=L}};ft=Ue([b],ft),e.InlineSuggestions=ft;var Et;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ce;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(L,te){if(te&&!y.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=te}};ge=Ue([b],ge),e.DocumentLink=ge;let me=class{constructor(L,te,_e,Ke){this.red=L,this.green=te,this.blue=_e,this.alpha=Ke}};me=Ue([b],me),e.Color=me;let Ie=class{constructor(L,te){if(te&&!(te instanceof me))throw(0,M.illegalArgument)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=te}};Ie=Ue([b],Ie),e.ColorInformation=Ie;let Be=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Be=Ue([b],Be),e.ColorPresentation=Be;var Le;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var je;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Xe{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Xe;var ne;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=pe;var re;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=f=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ce.Clean=new f("clean","Clean"),Ce.Build=new f("build","Build"),Ce.Rebuild=new f("rebuild","Rebuild"),Ce.Test=new f("test","Test"),Ce=f=Ue([b],Ce),e.TaskGroup=Ce;function Se(N){let L="";for(let te=0;te<N.length;te++)L+=N[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Se(L)}};Ge=Ue([b],Ge),e.ProcessExecution=Ge;let We=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Se(L)}};We=Ue([b],We),e.ShellExecution=We;var it;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let nt=m=class{constructor(L,te,_e,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=L;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ke,at=et,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=m=Ue([b],nt),e.Task=nt;var ot;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(L,te=Rt.None){this.collapsibleState=te,y.URI.isUri(L)?this.resourceUri=L:this.label=L}};lt=Ue([b],lt),e.TreeItem=lt;var Rt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,te){this.id=L,this.color=te}};_t=Ue([b],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ot=class{constructor(L){this.id=L}};Ot=Ue([b],Ot),e.ThemeColor=Ot;var di;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(di=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,te){if(typeof L!="string"&&(!L||!y.URI.isUri(L)&&!y.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=y.URI.file(L),this.base=L):y.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};kt=Ue([b],kt),e.RelativePattern=kt;let $t=class{constructor(L,te,_e,Ke){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Ue([b],$t),e.Breakpoint=$t;let Zt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};Zt=Ue([b],Zt),e.SourceBreakpoint=Zt;let gt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);this.functionName=L}};gt=Ue([b],gt),e.FunctionBreakpoint=gt;let Kt=class extends $t{constructor(L,te,_e,Ke,et,st,at){super(Ke,et,st,at);if(!te)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Kt=Ue([b],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};Vt=Ue([b],Vt),e.DebugAdapterExecutable=Vt;let ei=class{constructor(L,te){this.port=L,this.host=te}};ei=Ue([b],ei),e.DebugAdapterServer=ei;let ti=class{constructor(L){this.path=L}};ti=Ue([b],ti),e.DebugAdapterNamedPipeServer=ti;let It=class{constructor(L){this.implementation=L}};It=Ue([b],It),e.DebugAdapterInlineImplementation=It;let Qt=class{constructor(L,te){this.range=L,this.expression=te}};Qt=Ue([b],Qt),e.EvaluatableExpression=Qt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,te){this.range=L,this.text=te}};Wt=Ue([b],Wt),e.InlineValueText=Wt;let Ht=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};Ht=Ue([b],Ht),e.InlineValueVariableLookup=Ht;let ct=class{constructor(L,te){this.range=L,this.expression=te}};ct=Ue([b],ct),e.InlineValueEvaluatableExpression=ct;let ii=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};ii=Ue([b],ii),e.InlineValueContext=ii;var Nt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=D=class extends Error{constructor(L,te=t.FileSystemProviderErrorCode.Unknown,_e){super(y.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new D(L,t.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(L){return new D(L,t.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(L){return new D(L,t.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(L){return new D(L,t.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(L){return new D(L,t.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(L){return new D(L,t.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};xt=D=Ue([b],xt),e.FileSystemError=xt;let Yt=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};Yt=Ue([b],Yt),e.FoldingRange=Yt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function ni(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class ri{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ke,et){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,te,_e,Ke,et);if(O.isRange(L)&&typeof te=="string"&&ni(_e))return this._push(L,te,_e);throw(0,M.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,et=L.start.character,st=L.end.character-L.start.character,at=this._tokenTypeStrToInt.get(te);let yt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);yt|=1<<Ft>>>0}this._pushEncoded(Ke,et,st,at,yt)}_pushEncoded(L,te,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<yt;Lt++){let Bt=this._data[5*Lt],ui=this._data[5*Lt+1];Bt===0?(Bt=At,ui+=Ft):Bt+=At,this._data[5*Lt]=Bt,this._data[5*Lt+1]=ui,At=Bt,Ft=ui}}let st=L,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(at-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let at=0;at<_e;at++)te[at]=at;te.sort((at,yt)=>{const At=L[5*at],Ft=L[5*yt];if(At===Ft){const Lt=L[5*at+1],Bt=L[5*yt+1];return Lt-Bt}return At-Ft});const Ke=new Uint32Array(L.length);let et=0,st=0;for(let at=0;at<_e;at++){const yt=5*te[at],At=L[yt+0],Ft=L[yt+1],Lt=L[yt+2],Bt=L[yt+3],ui=L[yt+4],xi=At-et,qi=xi===0?Ft-st:Ft,ci=5*at;Ke[ci+0]=xi,Ke[ci+1]=qi,Ke[ci+2]=Lt,Ke[ci+3]=Bt,Ke[ci+4]=ui,et=At,st=Ft}return Ke}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(ri._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=ri;class jt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=jt;class si{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=si;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new _t("arrow-left")},Jt=Ue([b],Jt),e.QuickInputButtons=Jt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let oi=class{constructor(L){this.kind=L}};oi=Ue([b],oi),e.ColorTheme=oi;var ai;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(ai=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new zt(te,_e)}}e.NotebookRange=zt;class Mt{constructor(L,te,_e,Ke,et,st,at){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=st,this.executionSummary=at,Mt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Mt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Mt;class Re{constructor(L){this.cells=L}}e.NotebookData=Re;class Tt{constructor(L,te){this.data=L,this.mime=te;const _e=(0,R.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Tt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Tt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Tt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Tt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Tt(L,te)}static text(L,te=R.Mimes.text){const _e=Te(Tt,u,"f",s).encode(String(L));return new Tt(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Tt.text(_e,te)}}e.NotebookCellOutputItem=Tt,u=Tt,s={value:new TextEncoder};class Gt{constructor(L,te,_e){this.items=Gt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof Gt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ke=new Set;for(let et=0;et<L.length;et++){const st=L[et],at=(0,R.normalizeMimeType)(st.mime);if(!_e.has(at)){_e.add(at);continue}Ke.add(et),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?L:L.filter((et,st)=>!Ke.has(st))}}e.NotebookCellOutput=Gt;var pt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(L,te=[]){this.uri=L,this.provides=(0,d.asArray)(te)}}e.NotebookRendererScript=Pi;let li=class{constructor(L,te){this.label=L,this.timestamp=te}};li=Ue([b],li),e.TimelineItem=li;var Ai;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ti;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ti=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(L,te,_e){this.include=L,this.exclude=te,this.profile=_e}};X=Ue([b],X),e.TestRunRequest=X;let de=T=class{constructor(L){this.message=L}static diff(L,te,_e){const Ke=new T(L);return Ke.expectedOutput=te,Ke.actualOutput=_e,Ke}};de=T=Ue([b],de),e.TestMessage=de;let ke=class{constructor(L){this.id=L}};ke=Ue([b],ke),e.TestTag=ke;let rt=class{constructor(L,te){this.covered=L,this.total=te}};rt=Ue([b],rt),e.CoveredCount=rt;let wt=p=class{constructor(L,te,_e,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(L,te){const _e=new rt(0,0),Ke=new rt(0,0),et=new rt(0,0);for(const at of te)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const yt of at.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else et.total+=1,et.covered+=at.executionCount>0?1:0;const st=new p(L,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return st.detailedCoverage=te,st}};wt=p=Ue([b],wt),e.FileCoverage=wt;let Dt=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Dt=Ue([b],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(L,te){this.executionCount=L,this.location=te}};Oi=Ue([b],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(L,te){this.executionCount=L,this.location=te}};Ni=Ue([b],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,40,11,9,228,118,7,13]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(u,s){s?P.set(u,s):P.delete(u)}e.setWordDefinitionFor=t;function _(u){return P.get(u)}e.getWordDefinitionFor=_;class n extends A.MirrorTextModel{constructor(s,v,I,S,o,g,k,i){super(v,I,S,o);this._proxy=s,this._languageId=g,this._isDirty=k,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,y.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===M.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(v){return v?s._getTextInRange(v):s.getText()},get eol(){return s._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(v){return s._lineAt(v)},offsetAt(v){return s._offsetAt(v)},positionAt(v){return s._positionAt(v)},validateRange(v){return s._validateRange(v)},validatePosition(v){return s._validatePosition(v)},getWordRangeAtPosition(v,I){return s._getWordRangeAtPosition(v,I)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,d.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,d.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const v=this._validateRange(s);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const I=this._eol,S=v.start.line,o=v.end.line,g=[];g.push(this._lines[S].substring(v.start.character));for(let k=S+1;k<o;k++)g.push(this._lines[k]);return g.push(this._lines[o].substring(0,v.end.character)),g.join(I)}_lineAt(s){let v;if(s instanceof C.Position?v=s.line:typeof s=="number"&&(v=s),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new h(v,this._lines[v],v===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(s),I=this._lines[v.index].length;return new C.Position(v.index,Math.min(v.remainder,I))}_validateRange(s){if(!(s instanceof C.Range))throw new Error("Invalid argument");const v=this._validatePosition(s.start),I=this._validatePosition(s.end);return v===s.start&&I===s.end?s:new C.Range(v.line,v.character,I.line,I.character)}_validatePosition(s){if(!(s instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:v,character:I}=s,S=!1;if(v<0)v=0,I=0,S=!0;else if(v>=this._lines.length)v=this._lines.length-1,I=this._lines[v].length,S=!0;else{const o=this._lines[v].length;I<0?(I=0,S=!0):I>o&&(I=o,S=!0)}return S?new C.Position(v,I):s}_getWordRangeAtPosition(s,v){const I=this._validatePosition(s);if(!v)v=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const S=(0,R.getWordAtText)(I.character+1,(0,R.ensureValidWordDefinition)(v),this._lines[I.line],0);if(S)return new C.Range(I.line,S.startColumn-1,I.line,S.endColumn-1)}}e.ExtHostDocumentData=n;class h{constructor(s,v,I){this._line=s,this._text=v,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(be[156],Ee([0,1,7,3,229,6,55,20,2,36]),function(ie,e,d,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,h,u,s){this._notebook=u,this._selector=s,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(I=>{const S=this._cellUris.get(I.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(I=>v(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],h=[];for(const u of this._notebook.getCells())u.kind===d.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),n.push(u.document.getText().length+1),h.push(u.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(n){if(!n){let S="";for(const o of this._cells)S+=o.document.getText()+`
`;return S=S.slice(0,-1),S}if(n.isEmpty)return"";const h=this.locationAt(n.start),u=this.locationAt(n.end),s=this._cellUris.get(h.uri),v=this._cellUris.get(u.uri);if(s===void 0||v===void 0)return"";if(s===v)return this._cells[s].document.getText(new d.Range(h.range.start,u.range.end));const I=[this._cells[s].document.getText(new d.Range(h.range.start,new d.Position(this._cells[s].document.lineCount,0)))];for(let S=s+1;S<v;S++)I.push(this._cells[S].document.getText());return I.push(this._cells[v].document.getText(new d.Range(new d.Position(0,0),u.range.end))),I.join(`
`)}offsetAt(n){const h=this._cellLines.getIndexOf(n.line),u=this._cellLengths.getPrefixSum(h.index-1),s=this._cells[h.index].document.offsetAt(n.with(h.remainder));return u+s}positionAt(n){if(typeof n=="number"){const u=this._cellLengths.getIndexOf(n),s=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(s)}const h=this._cellUris.get(n.uri);if(h!==void 0){const u=this._cellLines.getPrefixSum(h-1);return new d.Position(u+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const h=this._cellLines.getIndexOf(n.start.line);let u=h;n.isEmpty||(u=this._cellLines.getIndexOf(n.end.line));const s=new d.Position(h.remainder,n.start.character),v=new d.Position(u.remainder,n.end.character),I=new d.Range(s,v),S=this._cells[h.index];return new d.Location(S.document.uri,S.document.validateRange(I))}contains(n){return this._cellUris.has(n)}validateRange(n){const h=this.validatePosition(n.start),u=this.validatePosition(n.end);return n.with(h,u)}validatePosition(n){const h=this._cellLines.getIndexOf(n.line),u=new d.Position(h.remainder,n.character),s=this._cells[h.index].document.validatePosition(u),v=this._cellLines.getPrefixSum(h.index-1);return new d.Position(v+s.line,s.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,12,3]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let y=C==="light"?d.ColorThemeKind.Light:C==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ue([He(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[65],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=M}),define(be[158],Ee([0,1,23]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function E(C,y){if(y.serializeBuffersForPostMessage){const P=new M,t=(h,u)=>{if(u instanceof ArrayBuffer){const s=P.add(u);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(u)){const s=A(u);if(s){const v=P.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:s,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},_=JSON.stringify(C,t),n=P.buffers.map(h=>{const u=new Uint8Array(h);return d.VSBuffer.wrap(u)});return{message:_,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=E;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(C,y){const P=y.map(n=>{const h=new ArrayBuffer(n.byteLength);return new Uint8Array(h).set(n.buffer),h}),t=y.length?(n,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const u=h,{index:s}=u,v=P[s];if(u.view)switch(u.view.type){case 1:return new Int8Array(v,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return h}:void 0;return{message:JSON.parse(C,t),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(be[159],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function E(R){const C={items:new Map};return R.types.forEach((y,P)=>{C.items.set(y,{asString:async()=>R.items[P].asString})}),C}M.toITreeDataTransfer=E;async function A(R){const C={types:[],items:[]},y=Array.from(R.items.entries());for(const P of y)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(C,y){return C.scheme===d.Schemas.http||C.scheme===d.Schemas.https?C:(y&&y.authority&&y.isRemote&&C.scheme===d.Schemas.file&&(C=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:y.authority,path:C.path})),M.URI.from({scheme:d.Schemas.https,authority:`${C.scheme}+${A(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=E;function A(C){return C.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function R(C){return C.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(be[160],Ee([0,1,3,6,66]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(C,y,P){this._proxy=C,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const t=y.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,y,P,t,_){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===C){n=o;break}if(!n)throw new Error("not a visible editor");const h=this,u=this._handlePool++,s=new d.Emitter,v=new d.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,E.asWebviewUri)(o,h._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(o){this._options=o,h._proxy.$setOptions(u,o)}get options(){return this._options}set html(o){this._html=o,h._proxy.$setHtml(u,o)}get html(){return this._html}get onDidReceiveMessage(){return s.event}postMessage(o){return h._proxy.$postMessage(u,o)}},S=new class{constructor(){this.editor=C,this.line=y,this.height=P,this.webview=I,this.onDidDispose=v.event}dispose(){h._insets.has(u)&&(h._insets.delete(u),h._proxy.$disposeEditorInset(u),v.fire(),v.dispose(),s.dispose())}};return this._proxy.$createEditorInset(u,n.id,n.value.document.uri,y+1,P,t||{},_.identifier,_.extensionLocation),this._insets.set(u,{editor:C,inset:S,onDidReceiveMessage:s}),S}$onDidDispose(C){const y=this._insets.get(C);y&&y.inset.dispose()}$onDidReceiveMessage(C,y){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,43,28,13,11]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function _(b){if(o(b))return!1;const c=b;return E.URI.isUri(c?.resource)}e.isResourceEditorInput=_;function n(b){if(o(b))return!1;const c=b;return c?.original!==void 0&&c.modified!==void 0}e.isResourceDiffEditorInput=n;function h(b){if(o(b))return!1;const c=b;return c?.primary!==void 0&&c.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function u(b){if(o(b))return!1;const c=b;return c?c.resource===void 0||c.resource.scheme===t.Schemas.untitled||c.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var s;(function(b){b[b.SHORT=0]="SHORT",b[b.MEDIUM=1]="MEDIUM",b[b.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var v;(function(b){b[b.EXPLICIT=1]="EXPLICIT",b[b.AUTO=2]="AUTO",b[b.FOCUS_CHANGE=3]="FOCUS_CHANGE",b[b.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var I;(function(b){b[b.None=0]="None",b[b.Readonly=2]="Readonly",b[b.Untitled=4]="Untitled",b[b.Singleton=8]="Singleton",b[b.RequiresTrust=16]="RequiresTrust",b[b.CanSplitInGroup=32]="CanSplitInGroup"})(I=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class S extends A.Disposable{}e.AbstractEditorInput=S;function o(b){return b instanceof S}e.isEditorInput=o;function g(b){const c=b;return E.URI.isUri(c?.preferredResource)}function k(b){const c=b;return o(c?.primary)&&o(c?.secondary)}e.isSideBySideEditorInput=k;function i(b){const c=b;return o(c?.modified)&&o(c?.original)}e.isDiffEditorInput=i;function l(b){return o(b?.editor)}e.isEditorInputWithOptions=l;function r(b){const c=b;return l(b)&&c?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function a(b){const c=b;return typeof c?.groupId=="number"&&o(c.editor)}e.isEditorIdentifier=a;var w;(function(b){b[b.PRIMARY=1]="PRIMARY",b[b.SECONDARY=2]="SECONDARY",b[b.BOTH=3]="BOTH",b[b.ANY=4]="ANY"})(w=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(c,F){if(!c)return;if(F?.supportSideBySide){const{primary:V,secondary:K}=this.getSideEditors(c);if(V&&K){if(F?.supportSideBySide===w.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:F.filterByScheme})};if(F?.supportSideBySide===w.ANY)return this.getOriginalUri(V,{filterByScheme:F.filterByScheme})??this.getOriginalUri(K,{filterByScheme:F.filterByScheme});c=F.supportSideBySide===w.PRIMARY?V:K}}if(n(c)||h(c))return;const O=g(c)?c.preferredResource:c.resource;return!O||!F||!F.filterByScheme?O:this.filterUri(O,F.filterByScheme)}getSideEditors(c){return k(c)||h(c)?{primary:c.primary,secondary:c.secondary}:i(c)||n(c)?{primary:c.modified,secondary:c.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(c,F){if(!c)return;if(F?.supportSideBySide){const{primary:V,secondary:K}=this.getSideEditors(c);if(V&&K){if(F?.supportSideBySide===w.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:F.filterByScheme})};if(F?.supportSideBySide===w.ANY)return this.getCanonicalUri(V,{filterByScheme:F.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:F.filterByScheme});c=F.supportSideBySide===w.PRIMARY?V:K}}if(n(c)||h(c))return;const O=c.resource;return!O||!F||!F.filterByScheme?O:this.filterUri(O,F.filterByScheme)}filterUri(c,F){if(Array.isArray(F)){if(F.some(O=>c.scheme===O))return c}else if(F===c.scheme)return c}}e.EditorResourceAccessor=new f;var m;(function(b){b[b.LEFT=0]="LEFT",b[b.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class D{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(c){const F=this.instantiationService=c.get(R.IInstantiationService);for(const[O,V]of this.editorSerializerConstructors)this.createEditorSerializer(O,V,F);this.editorSerializerConstructors.clear()}createEditorSerializer(c,F,O){const V=O.createInstance(F);this.editorSerializerInstances.set(c,V)}registerFileEditorFactory(c){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=c}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(c,F){if(this.editorSerializerConstructors.has(c)||this.editorSerializerInstances.has(c))throw new Error(`A editor serializer with type ID '${c}' was already registered.`);return this.instantiationService?this.createEditorSerializer(c,F,this.instantiationService):this.editorSerializerConstructors.set(c,F),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(c),this.editorSerializerInstances.delete(c)})}getEditorSerializer(c){return this.editorSerializerInstances.get(typeof c=="string"?c:c.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new D);async function T(b,c){if(!b||!b.length)return[];const F=await Promise.all(b.map(async O=>{const V=E.URI.revive(O.fileUri);if(!V||(await c.activateProvider(V.scheme),!c.canHandleResource(V)))return;const K=typeof O.exists=="boolean"?O.exists:await c.exists(V);if(!K&&O.openOnlyIfExists)return;const W={selection:K?O.selection:void 0,pinned:!0,override:O.editorOverrideId};let Q;return K?Q={resource:V,options:W}:Q={resource:V,options:W,forceUntitled:!0},Q}));return(0,P.coalesce)(F)}e.pathsToEditors=T;var p;(function(b){b[b.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",b[b.SEQUENTIAL=1]="SEQUENTIAL"})(p=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,43,132,4,6,20,28,13,51,22,34,152]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var u;(function(w){w.ViewContainersRegistry="workbench.registry.view.containers",w.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var s;(function(w){w[w.Sidebar=0]="Sidebar",w[w.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(w){switch(w){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function I(w){return`viewContainer.${w}.enabled`}e.getEnabledViewContainerContextKey=I;class S extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(f,m,D){const T=this.get(f.id);if(T)return T;const p=f;return p.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,C.getOrSet)(this.viewContainers,m,[]).push(p),D?.isDefault&&this.defaultViewContainers.push(p),this._onDidRegister.fire({viewContainer:p,viewContainerLocation:m}),p}deregisterViewContainer(f){for(const m of this.viewContainers.keys()){const D=this.viewContainers.get(m),T=D?.indexOf(f);if(T!==-1){D?.splice(T,1),D.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:m});return}}}get(f){return this.all.filter(m=>m.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(D=>D?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===f)}}y.Registry.add(u.ViewContainersRegistry,new S);var o;(function(w){w.Open="2_open",w.Debug="4_debug",w.SCM="5_scm",w.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function g(w,f){const m=w.group??o.More,D=f.group??o.More;return m!==D?m.localeCompare(D):(w.order??5)-(f.order??5)}class k extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(f,m){this.registerViews2([{views:f,viewContainer:m}])}registerViews2(f){f.forEach(({views:m,viewContainer:D})=>this.addViews(m,D)),this._onViewsRegistered.fire(f)}deregisterViews(f,m){const D=this.removeViews(f,m);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:m})}moveViews(f,m){for(const D of this._views.keys())if(D!==m){const T=this.removeViews(f,D);T.length&&(this.addViews(T,m),this._onDidChangeContainer.fire({views:T,from:D,to:m}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const m of this._viewContainers){const D=(this._views.get(m)||[]).filter(T=>T.id===f)[0];if(D)return D}return null}getViewContainer(f){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(T=>T.id===f)[0])return m;return null}registerViewWelcomeContent(f,m){return this._viewWelcomeContents.add(f,m),this._onDidChangeViewWelcomeContent.fire(f),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,m),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,m){const D=new Map;for(const[T,p]of m)this._viewWelcomeContents.add(f,p),D.set(T,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,p),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),D}getViewWelcomeContent(f){const m=[];return this._viewWelcomeContents.forEach(f,D=>m.push(D)),m.sort(g)}addViews(f,m){let D=this._views.get(m);D||(D=[],this._views.set(m,D),this._viewContainers.push(m));for(const T of f){if(this.getView(T.id)!==null)throw new Error((0,E.localize)(1,null,T.id));D.push(T)}}removeViews(f,m){const D=this._views.get(m);if(!D)return[];const T=[],p=[];for(const b of D)f.includes(b)?T.push(b):p.push(b);return T.length&&(p.length?this._views.set(m,p):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),T}}y.Registry.add(u.ViewsRegistry,new k),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(w){return`view.${w}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var l;(function(w){w[w.Default=0]="Default",w[w.Expand=1]="Expand"})(l=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(w){w[w.None=0]="None",w[w.Collapsed=1]="Collapsed",w[w.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(f,m){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,f),this._hasResolve=!!m,this.resolve=async D=>{if(m&&!this.resolved){const T=await m(D);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,14,133]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,y,P,t){const _={command:C};if(y&&Object.keys(y).length>0&&(_.arguments=y),this.internalSend("request",_),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const h=this.pendingRequests.get(_.seq);if(h){this.pendingRequests.delete(_.seq);const u={type:"response",seq:0,request_seq:_.seq,success:!1,command:C,message:(0,E.localize)(0,null,t,C)};h(u)}},t)}return P&&this.pendingRequests.set(_.seq,P),_.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,y){return C.type!=="event"||y.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const y=C,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}internalSend(C,y){y.type=C,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((y,P)=>C.set(P,y)),await(0,M.timeout)(500),C.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,22,11]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function y(r,a,w){return r.replace(C,function(f,m){return a&&m.length>0&&m[0]!=="_"?f:w&&w.hasOwnProperty(m)?w[m]:f})}e.formatPII=y;function P(r){const a={};for(const w of Object.keys(r))w.startsWith("!")||(a[w]=r[w]);return a}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function _(r){let a=r.configuration.type;if(!!a)return a==="vslsShare"&&(a=r.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(a,"extensionhost")||(0,d.equalsIgnoreCase)(a,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function h(r,a,w){let f,m=0,D=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=D.exec(r);){let p=T.index+1,b=p+T[0].length;if(p<=a&&b>=w){f=T[0],m=p;break}}if(f){let p=/\w+/g,b=null;for(;(b=p.exec(f))&&!(b.index+1+m+b[0].length>=w););b&&(f=f.substring(0,p.lastIndex))}return f?{start:m,end:m+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(r){return!!(r&&r.match(u))}e.isUri=s;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(s(r.path))return M.URI.parse(r.path);if((0,E.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const a=M.URI.revive(r.path);if(a)return a.scheme===R.Schemas.file?a.fsPath:a.toString()}return r.path}function S(r,a){const w=a?v:I,f=(0,A.deepClone)(r);return g(f,(m,D)=>{m&&D&&(D.path=w(D))}),f}e.convertToDAPaths=S;function o(r,a){const w=a?v:I,f=(0,A.deepClone)(r);return g(f,(m,D)=>{!m&&D&&(D.path=w(D))}),f}e.convertToVSCPaths=o;function g(r,a){switch(r.type){case"event":const w=r;switch(w.event){case"output":a(!1,w.body.source);break;case"loadedSource":a(!1,w.body.source);break;case"breakpoint":a(!1,w.body.breakpoint.source);break;default:break}break;case"request":const f=r;switch(f.command){case"setBreakpoints":a(!0,f.arguments.source);break;case"breakpointLocations":a(!0,f.arguments.source);break;case"source":a(!0,f.arguments.source);break;case"gotoTargets":a(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(D=>a(!1,D));break;default:break}break;case"response":const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(D=>a(!1,D.source));break;case"loadedSources":m.body.sources.forEach(D=>a(!1,D));break;case"scopes":m.body.scopes.forEach(D=>a(!1,D.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(D=>a(!1,D.source));break;case"setBreakpoints":m.body.breakpoints.forEach(D=>a(!1,D.source));break;default:break}break}}function k(r){return r.filter(a=>!a.presentation?.hidden).sort((a,w)=>a.presentation?w.presentation?a.presentation.group?w.presentation.group?a.presentation.group!==w.presentation.group?a.presentation.group.localeCompare(w.presentation.group):i(a.presentation.order,w.presentation.order):-1:w.presentation.group?1:i(a.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=k;function i(r,a){return typeof r!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:r-a}async function l(r,a){const w=r.getValue("debug.saveBeforeStart",{overrideIdentifier:a.activeTextEditorMode});if(w!=="none"&&(await a.saveAll(),w==="allEditorsInActiveGroup")){const f=a.activeEditorPane;f&&await a.save({editor:f.input,groupId:f.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(be[89],Ee([0,1,27,78,11,17,26,43]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var s;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(s=e.CellEditType||(e.CellEditType={}));var v;(function(p){p.scheme=E.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function c(W,Q){return W.with({scheme:p.scheme,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==E.Schemas.file?W.scheme:""}`})}p.generate=c;function F(W){if(W.scheme!==p.scheme)return;const Q=b.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substr(Q[0].length)||E.Schemas.file,fragment:null})}:void 0}p.parse=F;function O(W){if(W.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const Q=b.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substr(Q[0].length)||E.Schemas.file,fragment:null})}:void 0}p.parseCellMetadataUri=O;function V(W,Q,$){return W.with({scheme:$,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==E.Schemas.file?W.scheme:""}`})}p.generateCellUri=V;function K(W,Q){if(W.scheme!==Q)return;const $=b.exec(W.fragment);return $?{handle:Number($[1]),notebook:W.with({scheme:W.fragment.substr($[0].length)||E.Schemas.file,fragment:null})}:void 0}p.parseCellUri=K})(v=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(p){return I.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=S;function o(p){return I.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function g(p){return I.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=g;function k(p,b){return R.isWindows&&(p=p.replace(/\//g,"\\"),b=b.replace(/\//g,"\\")),d.match(p,b)}function i(p,b,c){let F=0;for(let O=0;O<b.length;O++){if(k(b[O],p))return F;F++}for(let O=0;O<c.length;O++){if(k(c[O],p))return F;F++}return F}function l(p,b,c){return p.sort((F,O)=>i(F,b,c)-i(O,b,c))}e.sortMimeTypes=l;function r(p,b,c,F=(O,V)=>O===V){const O=[];function V(Q,$,U){if($===0&&U.length===0)return;const H=O[O.length-1];H&&H.start+H.deleteCount===Q?(H.deleteCount+=$,H.toInsert.push(...U)):O.push({start:Q,deleteCount:$,toInsert:U})}let K=0,W=0;for(;;){if(K===p.length){V(K,0,b.slice(W));break}if(W===b.length){V(K,p.length-K,[]);break}const Q=p[K],$=b[W];if(F(Q,$)){K+=1,W+=1;continue}c($)?(V(K,1,[]),K+=1):(V(K,0,[$]),W+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(p){p.default="default",p.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function w(p){const b=p;return!!((typeof b.include=="string"||d.isRelativePattern(b.include))&&(typeof b.exclude=="string"||d.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=w;function f(p,b,c){if(Array.isArray(p.viewType)&&p.viewType.indexOf(b)>=0||p.viewType===b)return!0;if(p.filenamePattern){let F=w(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,O=w(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(d.match(F,(0,A.basename)(c.fsPath).toLowerCase()))return!(O&&d.match(O,(0,A.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let c=0;c<this.textModel.cells.length;c++)b[c]=this.textModel.cells[c].getHashValue();return b}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var D;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(b){return`${T._prefix}${b}`}static parse(b){if(b.startsWith(T._prefix))return b.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,43]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=d;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=R;var C;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var y;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,h){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const h=this.createChangeCollector();for(const u of n)switch(u[0]){case 0:{const s=u[1];if(s.parent){if(this.items.has(s.parent)){const v=this.items.get(s.parent);v.children.add(s.item.extId);const I=this.createItem(s,v);this.items.set(s.item.extId,I),h.add(I)}}else{const v=this.createItem(s);this.roots.add(v),this.items.set(s.item.extId,v),h.add(v)}s.expand===2&&this.busyControllerCount++;break}case 1:{const s=u[1],v=this.items.get(s.extId);if(!v)break;s.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,s),h.update(v);break}case 2:{const s=this.items.get(u[1]);if(!s)break;s.parent?this.items.get(s.parent).children.delete(s.item.extId):this.roots.delete(s);const v=[[u[1]]];for(;v.length;)for(const I of v.pop()){const S=this.items.get(I);S&&(v.push(S.children),this.items.delete(I),h.remove(S,S!==s),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break;case 5:this._tags.set(u[1].id,u[1]);break;case 6:this._tags.delete(u[1]);break}h.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(R,C=R.length){if(this.path=R,this.viewEnd=C,R.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,C,y=R.parent){if(R.id===C)return new E([C]);let P=[R.id];for(let t=y;t&&t.id!==C;t=t.parent)P.push(t.id);return P.push(C),new E(P.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new E(R.split("\0"))}static join(R,C){return new E([...R.path,C])}static joinToString(R,C){return R.toString()+"\0"+C}static compare(R,C){return R===C?0:C.startsWith(R+"\0")?2:R.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let C=0;C<R.viewEnd&&C<this.viewEnd;C++)if(R.path[C]!==this.path[C])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,22,26,77,136]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(_,n,h){this._contributedVariables=new Map,this._context=_,this._labelService=n,h&&(this._envVariablesPromise=h.then(u=>this.prepareEnv(u)))}prepareEnv(_){if(R.isWindows){const n=Object.create(null);return Object.keys(_).forEach(h=>{n[h.toLowerCase()]=_[h]}),n}return _}resolveWithEnvironment(_,n,h){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,h)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,h,u){const s=A.deepClone(n);return R.isWindows&&s.windows?Object.keys(s.windows).forEach(v=>s[v]=s.windows[v]):R.isMacintosh&&s.osx?Object.keys(s.osx).forEach(v=>s[v]=s.osx[v]):R.isLinux&&s.linux&&Object.keys(s.linux).forEach(v=>s[v]=s.linux[v]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,s,h,u)}async resolveAnyAsync(_,n,h){return this.resolveAnyBase(_,n,h)}async resolveAnyMap(_,n,h){const u=new Map;return{newConfig:await this.resolveAnyBase(_,n,h,u),resolvedVariables:u}}resolveWithInteractionReplace(_,n,h,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,h,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,h,u,s){if(E.isString(h))return this.resolveString(_,n,h,u,s);if(E.isArray(h))return h.map(v=>this.recursiveResolve(_,n,v,u,s));if(E.isObject(h)){let v=Object.create(null);return Object.keys(h).forEach(I=>{const S=this.resolveString(_,n,I,u,s);v[S]=this.recursiveResolve(_,n,h[I],u,s)}),v}return h}resolveString(_,n,h,u,s){return h.replace(P.VARIABLE_REGEXP,(I,S)=>{if(S.includes(P.VARIABLE_LHS))return I;let o=this.evaluateSingleVariable(_,I,S,n,u);return s&&s.set(S,o),o!==I&&E.isString(o)&&o.match(P.VARIABLE_REGEXP)&&(o=this.resolveString(_,n,o,u,s)),o})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,h,u,s){let v;const I=h.split(":");I.length>1&&(h=I[0],v=I[1]);const S=()=>{const k=this._context.getFilePath();if(k)return k;throw new Error((0,y.localize)(0,null,n))},o=()=>{const k=S();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,y.localize)(1,null,n,d.basename(k)))},g=()=>{if(v){const k=this._context.getFolderUri(v);if(k)return k;throw new Error((0,y.localize)(2,null,n,v))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,n)):new Error((0,y.localize)(4,null,n))};switch(h){case"env":if(v){if(_){const k=_[R.isWindows?v.toLowerCase():v];if(E.isString(k))return k}return""}throw new Error((0,y.localize)(5,null,n));case"config":if(v){const k=this._context.getConfigurationValue(u,v);if(E.isUndefinedOrNull(k))throw new Error((0,y.localize)(6,null,n,v));if(E.isObject(k))throw new Error((0,y.localize)(7,null,n,v));return k}throw new Error((0,y.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,s,"command");case"input":return this.resolveFromMap(n,v,s,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return u||v?(0,C.normalizeDriveLetter)(this.fsPath(g())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(g()));case"lineNumber":const k=this._context.getLineNumber();if(k)return k;throw new Error((0,y.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,y.localize)(10,null,n));case"file":return S();case"fileWorkspaceFolder":return o();case"relativeFile":return u||v?d.relative(this.fsPath(g()),S()):S();case"relativeFileDirname":const l=d.dirname(S());if(u||v){const f=d.relative(this.fsPath(g()),l);return f.length===0?".":f}return l;case"fileDirname":return d.dirname(S());case"fileExtname":return d.extname(S());case"fileBasename":return d.basename(S());case"fileBasenameNoExtension":const r=d.basename(S());return r.slice(0,r.length-d.extname(r).length);case"fileDirnameBasename":return d.basename(d.dirname(S()));case"execPath":const a=this._context.getExecPath();return a||n;case"execInstallFolder":const w=this._context.getAppRoot();return w||n;case"pathSeparator":return d.sep;default:try{const f=v?`${h}:${v}`:h;return this.resolveFromMap(n,f,s,void 0)}catch(f){return n}}}}resolveFromMap(_,n,h,u){if(n&&h){const s=u===void 0?h[n]:h[u+":"+n];if(typeof s=="string")return s;throw new Error((0,y.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var E;(function(s){s[s.UP=0]="UP",s[s.DOWN=1]="DOWN",s[s.LEFT=2]="LEFT",s[s.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(s){s[s.FIRST=0]="FIRST",s[s.LAST=1]="LAST",s[s.NEXT=2]="NEXT",s[s.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var C;(function(s){s[s.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",s[s.EVEN=1]="EVEN",s[s.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(s){s[s.COPY_EDITORS=0]="COPY_EDITORS",s[s.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(s){const v=s;return(0,M.isEditorInput)(v?.editor)&&(0,M.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var t;(function(s){s[s.CREATION_TIME=0]="CREATION_TIME",s[s.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",s[s.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(s){s[s.GROUP_ACTIVE=0]="GROUP_ACTIVE",s[s.GROUP_INDEX=1]="GROUP_INDEX",s[s.GROUP_LOCKED=2]="GROUP_LOCKED",s[s.EDITOR_OPEN=3]="EDITOR_OPEN",s[s.EDITOR_CLOSE=4]="EDITOR_CLOSE",s[s.EDITOR_MOVE=5]="EDITOR_MOVE",s[s.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",s[s.EDITOR_LABEL=7]="EDITOR_LABEL",s[s.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",s[s.EDITOR_PIN=9]="EDITOR_PIN",s[s.EDITOR_STICKY=10]="EDITOR_STICKY",s[s.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(s){s[s.NEW_EDITOR=1]="NEW_EDITOR",s[s.MOVE_EDITOR=2]="MOVE_EDITOR",s[s.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function h(s){const v=s;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=h;function u(s){return s.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(be[169],Ee([0,1,4,92]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const R=A;return typeof A=="number"||(0,M.isEditorGroup)(R)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,13,23,76,230,54,22,10,2,42,59,137,82,46,89,67,169,7]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ne){function pe(B){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:Ge,positionColumn:We}=B,it=new S.Position(Ce-1,Se-1),mt=new S.Position(Ge-1,We-1);return new S.Selection(it,mt)}ne.to=pe;function re(B){const{anchor:Ce,active:Se}=B;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ne.from=re})(o=e.Selection||(e.Selection={}));var g;(function(ne){function pe(B){if(!B)return;const{start:Ce,end:Se}=B;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ne.from=pe;function re(B){if(!B)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:Ge,endColumn:We}=B;return new S.Range(Ce-1,Se-1,Ge-1,We-1)}ne.to=re})(g=e.Range||(e.Range={}));var k;(function(ne){function pe(re){switch(re){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}ne.to=pe})(k=e.TokenType||(e.TokenType={}));var i;(function(ne){function pe(B){return new S.Position(B.lineNumber-1,B.column-1)}ne.to=pe;function re(B){return{lineNumber:B.line+1,column:B.character+1}}ne.from=re})(i=e.Position||(e.Position={}));var l;(function(ne){function pe(B){switch(B){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function re(B){switch(B){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}ne.to=re})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ne){function pe(B){let Ce;return B.code&&((0,y.isString)(B.code)||(0,y.isNumber)(B.code)?Ce=String(B.code):Ce={value:String(B.code.value),target:B.code.target}),{...g.from(B.range),message:B.message,source:B.source,code:Ce,severity:w.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(a.from),tags:Array.isArray(B.tags)?(0,d.coalesce)(B.tags.map(l.from)):void 0}}ne.from=pe;function re(B){const Ce=new S.Diagnostic(g.to(B),B.message,w.to(B.severity));return Ce.source=B.source,Ce.code=(0,y.isString)(B.code)?B.code:B.code?.value,Ce.relatedInformation=B.relatedInformation&&B.relatedInformation.map(a.to),Ce.tags=B.tags&&(0,d.coalesce)(B.tags.map(l.to)),Ce}ne.to=re})(r=e.Diagnostic||(e.Diagnostic={}));var a;(function(ne){function pe(B){return{...g.from(B.location.range),message:B.message,resource:B.location.uri}}ne.from=pe;function re(B){return new S.DiagnosticRelatedInformation(new S.Location(B.resource,g.to(B)),B.message)}ne.to=re})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(ne){function pe(B){switch(B){case S.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ne.from=pe;function re(B){switch(B){case h.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}ne.to=re})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(ne){function pe(B){return typeof B=="number"&&B>=S.ViewColumn.One?B-1:B===S.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ne.from=pe;function re(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=re})(f=e.ViewColumn||(e.ViewColumn={}));function m(ne){return typeof ne.range!="undefined"}function D(ne){return ne.length===0?!0:!!m(ne[0])}e.isDecorationOptionsArr=D;var T;(function(ne){function pe(We){return We.map(ne.from)}ne.fromMany=pe;function re(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function B(We){let it;if(re(We)){const{language:ot,value:lt}=We;it={value:"```"+ot+`
`+lt+"\n```\n"}}else S.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const vt=ot=>{try{let lt=P.URI.parse(ot,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ot]=lt}catch(lt){}return""},nt=new A.Renderer;return nt.link=vt,nt.image=ot=>vt(E.parseHrefAndDimensions(ot).href),A(it.value,{renderer:nt}),it}ne.from=B;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,R.parse)(We)}catch(nt){}if(!mt)return We;let vt=!1;return mt=(0,C.cloneAndChange)(mt,nt=>{if(P.URI.isUri(nt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=nt,vt=!0,ot}else return}),vt?JSON.stringify(mt):We}function Se(We){const it=new S.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it}ne.to=Se;function Ge(We){if(!!We)return typeof We=="string"?We:ne.from(We)}ne.fromStrict=Ge})(T=e.MarkdownString||(e.MarkdownString={}));function p(ne){return D(ne)?ne.map(pe=>({range:g.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?T.fromMany(pe.hoverMessage):pe.hoverMessage?T.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:g.from(pe)}))}e.fromRangeOrRangeWithMessage=p;function b(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?P.URI.file(ne):ne}e.pathOrURIToURI=b;var c;(function(ne){function pe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?b(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ne.from=pe})(c=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ne){function pe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?b(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?c.from(re.before):void 0,after:re.after?c.from(re.after):void 0}}ne.from=pe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ne){function pe(re){if(typeof re=="undefined")return re;switch(re){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ne){function pe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?O.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?F.from(re.light):void 0,dark:re.dark?F.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?b(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?c.from(re.before):void 0,after:re.after?c.from(re.after):void 0}}ne.from=pe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ne){function pe(B){return{text:B.newText,eol:B.newEol&&he.from(B.newEol),range:g.from(B.range)}}ne.from=pe;function re(B){const Ce=new S.TextEdit(g.to(B.range),B.text);return Ce.newEol=typeof B.eol=="undefined"?void 0:he.to(B.eol),Ce}ne.to=re})(K=e.TextEdit||(e.TextEdit={}));var W;(function(ne){function pe(B,Ce,Se){const Ge={edits:[]};if(B instanceof S.WorkspaceEdit)for(let We of B._allEntries())if(We._type===1)Ge.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);Ge.edits.push({_type:2,resource:We.uri,edit:K.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Et.from)}});return Ge}ne.from=pe;function re(B){const Ce=new S.WorkspaceEdit;for(const Se of B.edits)Se.edit?Ce.replace(P.URI.revive(Se.resource),g.to(Se.edit.range),Se.edit.text):Ce.renameFile(P.URI.revive(Se.oldUri),P.URI.revive(Se.newUri),Se.options);return Ce}ne.to=re})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(ne){const pe=Object.create(null);pe[S.SymbolKind.File]=0,pe[S.SymbolKind.Module]=1,pe[S.SymbolKind.Namespace]=2,pe[S.SymbolKind.Package]=3,pe[S.SymbolKind.Class]=4,pe[S.SymbolKind.Method]=5,pe[S.SymbolKind.Property]=6,pe[S.SymbolKind.Field]=7,pe[S.SymbolKind.Constructor]=8,pe[S.SymbolKind.Enum]=9,pe[S.SymbolKind.Interface]=10,pe[S.SymbolKind.Function]=11,pe[S.SymbolKind.Variable]=12,pe[S.SymbolKind.Constant]=13,pe[S.SymbolKind.String]=14,pe[S.SymbolKind.Number]=15,pe[S.SymbolKind.Boolean]=16,pe[S.SymbolKind.Array]=17,pe[S.SymbolKind.Object]=18,pe[S.SymbolKind.Key]=19,pe[S.SymbolKind.Null]=20,pe[S.SymbolKind.EnumMember]=21,pe[S.SymbolKind.Struct]=22,pe[S.SymbolKind.Event]=23,pe[S.SymbolKind.Operator]=24,pe[S.SymbolKind.TypeParameter]=25;function re(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}ne.from=re;function B(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return S.SymbolKind.Property}ne.to=B})(Q=e.SymbolKind||(e.SymbolKind={}));var $;(function(ne){function pe(B){switch(B){case S.SymbolTag.Deprecated:return 1}}ne.from=pe;function re(B){switch(B){case 1:return S.SymbolTag.Deprecated}}ne.to=re})($=e.SymbolTag||(e.SymbolTag={}));var U;(function(ne){function pe(B){return{name:B.name,kind:Q.from(B.kind),tags:B.tags&&B.tags.map($.from),containerName:B.containerName,location:le.from(B.location)}}ne.from=pe;function re(B){const Ce=new S.SymbolInformation(B.name,Q.to(B.kind),B.containerName,le.to(B.location));return Ce.tags=B.tags&&B.tags.map($.to),Ce}ne.to=re})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(ne){function pe(B){const Ce={name:B.name||"!!MISSING: name!!",detail:B.detail,range:g.from(B.range),selectionRange:g.from(B.selectionRange),kind:Q.from(B.kind),tags:B.tags?.map($.from)??[]};return B.children&&(Ce.children=B.children.map(pe)),Ce}ne.from=pe;function re(B){const Ce=new S.DocumentSymbol(B.name,B.detail,Q.to(B.kind),g.to(B.range),g.to(B.selectionRange));return(0,d.isNonEmptyArray)(B.tags)&&(Ce.tags=B.tags.map($.to)),B.children&&(Ce.children=B.children.map(re)),Ce}ne.to=re})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(ne){function pe(B){const Ce=new S.CallHierarchyItem(Q.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),g.to(B.range),g.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ne.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:B.name,detail:B.detail,kind:Q.from(B.kind),uri:B.uri,range:g.from(B.range),selectionRange:g.from(B.selectionRange),tags:B.tags?.map($.from)}}ne.from=re})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ne){function pe(re){return new S.CallHierarchyIncomingCall(G.to(re.from),re.fromRanges.map(B=>g.to(B)))}ne.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(ne){function pe(re){return new S.CallHierarchyOutgoingCall(G.to(re.to),re.fromRanges.map(B=>g.to(B)))}ne.to=pe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(ne){function pe(B){return{range:B.range&&g.from(B.range),uri:B.uri}}ne.from=pe;function re(B){return new S.Location(P.URI.revive(B.uri),g.to(B.range))}ne.to=re})(le=e.location||(e.location={}));var se;(function(ne){function pe(B){const Ce=B,Se=B;return{originSelectionRange:Ce.originSelectionRange?g.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:g.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?g.from(Ce.targetSelectionRange):void 0}}ne.from=pe;function re(B){return{targetUri:P.URI.revive(B.uri),targetRange:g.to(B.range),targetSelectionRange:B.targetSelectionRange?g.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?g.to(B.originSelectionRange):void 0}}ne.to=re})(se=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(ne){function pe(B){return{range:g.from(B.range),contents:T.fromMany(B.contents)}}ne.from=pe;function re(B){return new S.Hover(B.contents.map(T.to),g.to(B.range))}ne.to=re})(ve=e.Hover||(e.Hover={}));var Fe;(function(ne){function pe(B){return{range:g.from(B.range),expression:B.expression}}ne.from=pe;function re(B){return new S.EvaluatableExpression(g.to(B.range),B.expression)}ne.to=re})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(ne){function pe(B){if(B instanceof S.InlineValueText)return{type:"text",range:g.from(B.range),text:B.text};if(B instanceof S.InlineValueVariableLookup)return{type:"variable",range:g.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function re(B){switch(B.type){case"text":return{range:g.to(B.range),text:B.text};case"variable":return{range:g.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:g.to(B.range),expression:B.expression}}}ne.to=re})(Me=e.InlineValue||(e.InlineValue={}));var Ne;(function(ne){function pe(B){return{frameId:B.frameId,stoppedLocation:g.from(B.stoppedLocation)}}ne.from=pe;function re(B){return new S.InlineValueContext(B.frameId,g.to(B.stoppedLocation))}ne.to=re})(Ne=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ne){function pe(B){return{range:g.from(B.range),kind:B.kind}}ne.from=pe;function re(B){return new S.DocumentHighlight(g.to(B.range),B.kind)}ne.to=re})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ne){function pe(re){switch(re){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}ne.to=pe})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(ne){function pe(re){return{triggerKind:ze.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ne.to=pe})(qe=e.CompletionContext||(e.CompletionContext={}));var x;(function(ne){function pe(B){switch(B){case S.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function re(B){switch(B){case 1:return S.CompletionItemTag.Deprecated}}ne.to=re})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ne){const pe=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function re(Se){return pe.get(Se)??9}ne.from=re;const B=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ce(Se){return B.get(Se)??S.CompletionItemKind.Property}ne.to=Ce})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ne){function pe(re,B){const Ce=new S.CompletionItem(re.label);return Ce.insertText=re.insertText,Ce.kind=Y.to(re.kind),Ce.tags=re.tags?.map(x.to),Ce.detail=re.detail,Ce.documentation=E.isMarkdownString(re.documentation)?T.to(re.documentation):re.documentation,Ce.sortText=re.sortText,Ce.filterText=re.filterText,Ce.preselect=re.preselect,Ce.commitCharacters=re.commitCharacters,t.Range.isIRange(re.range)?Ce.range=g.to(re.range):typeof re.range=="object"&&(Ce.range={inserting:g.to(re.range.insert),replacing:g.to(re.range.replace)}),Ce.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Ce.insertText=new S.SnippetString(re.insertText):(Ce.insertText=re.insertText,Ce.textEdit=Ce.range instanceof S.Range?new S.TextEdit(Ce.range,Ce.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Ce.additionalTextEdits=re.additionalTextEdits.map(Se=>K.to(Se))),Ce.command=B&&re.command?B.fromInternal(re.command):void 0,Ce}ne.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ne){function pe(B){return{label:B.label,documentation:B.documentation?T.fromStrict(B.documentation):void 0}}ne.from=pe;function re(B){return{label:B.label,documentation:E.isMarkdownString(B.documentation)?T.to(B.documentation):B.documentation}}ne.to=re})(ae=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(ne){function pe(B){return{label:B.label,documentation:B.documentation?T.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.from):[],activeParameter:B.activeParameter}}ne.from=pe;function re(B){return{label:B.label,documentation:E.isMarkdownString(B.documentation)?T.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.to):[],activeParameter:B.activeParameter}}ne.to=re})(j=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ne){function pe(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(j.from):[]}}ne.from=pe;function re(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(j.to):[]}}ne.to=re})(oe=e.SignatureHelp||(e.SignatureHelp={}));var fe;(function(ne){function pe(B){return{text:B.text,position:i.from(B.position),kind:Ae.from(B.kind??S.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}ne.from=pe;function re(B){const Ce=new S.InlayHint(B.text,i.to(B.position),Ae.to(B.kind));return Ce.whitespaceAfter=B.whitespaceAfter,Ce.whitespaceBefore=B.whitespaceBefore,Ce}ne.to=re})(fe=e.InlayHint||(e.InlayHint={}));var Ae;(function(ne){function pe(B){return B}ne.from=pe;function re(B){return B}ne.to=re})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var xe;(function(ne){function pe(B){return{range:g.from(B.range),url:B.target,tooltip:B.tooltip}}ne.from=pe;function re(B){let Ce;if(B.url)try{Ce=typeof B.url=="string"?P.URI.parse(B.url,!0):P.URI.revive(B.url)}catch(Se){}return new S.DocumentLink(g.to(B.range),Ce)}ne.to=re})(xe=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ne){function pe(B){const Ce=new S.ColorPresentation(B.label);return B.textEdit&&(Ce.textEdit=K.to(B.textEdit)),B.additionalTextEdits&&(Ce.additionalTextEdits=B.additionalTextEdits.map(Se=>K.to(Se))),Ce}ne.to=pe;function re(B){return{label:B.label,textEdit:B.textEdit?K.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(Ce=>K.from(Ce)):void 0}}ne.from=re})($e=e.ColorPresentation||(e.ColorPresentation={}));var we;(function(ne){function pe(B){return new S.Color(B[0],B[1],B[2],B[3])}ne.to=pe;function re(B){return[B.red,B.green,B.blue,B.alpha]}ne.from=re})(we=e.Color||(e.Color={}));var Ze;(function(ne){function pe(B){return{range:g.from(B.range)}}ne.from=pe;function re(B){return new S.SelectionRange(g.to(B.range))}ne.to=re})(Ze=e.SelectionRange||(e.SelectionRange={}));var z;(function(ne){function pe(re){switch(re){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}ne.to=pe})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ne){function pe(B){switch(B){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function re(B){switch(B){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}ne.to=re})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(ne){function pe(B){if(B===S.EndOfLine.CRLF)return 1;if(B===S.EndOfLine.LF)return 0}ne.from=pe;function re(B){if(B===1)return S.EndOfLine.CRLF;if(B===0)return S.EndOfLine.LF}ne.to=re})(he=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(ne){function pe(re){if(typeof re=="object")return re.viewId;switch(re){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(ne){function pe(re){const B={start:re.start+1,end:re.end+1};return re.kind&&(B.kind=tt.from(re.kind)),B}ne.from=pe})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ne){function pe(re){if(re)switch(re){case S.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=pe})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ne){function pe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?g.from(re.selection):void 0,override:typeof re.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ht;(function(ne){function pe(B){return B instanceof S.RelativePattern||typeof B=="string"?B:re(B)?new S.RelativePattern(B.base,B.pattern):B}ne.from=pe;function re(B){const Ce=B;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ht=e.GlobPattern||(e.GlobPattern={}));var St;(function(ne){function pe(re){if(re){if(Array.isArray(re))return re.map(pe);if(typeof re=="string")return re;{const B=re;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:ht.from(B.pattern),exclusive:B.exclusive}}}else return}ne.from=pe})(St=e.LanguageSelector||(e.LanguageSelector={}));var Pt;(function(ne){function pe(B){return{start:B.start,end:B.end}}ne.from=pe;function re(B){return new S.NotebookRange(B.start,B.end)}ne.to=re})(Pt=e.NotebookRange||(e.NotebookRange={}));var dt;(function(ne){function pe(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}ne.to=pe;function re(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}ne.from=re})(dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var bt;(function(ne){function pe(B){switch(B){case S.NotebookCellKind.Markup:return s.CellKind.Markup;case S.NotebookCellKind.Code:default:return s.CellKind.Code}}ne.from=pe;function re(B){switch(B){case s.CellKind.Markup:return S.NotebookCellKind.Markup;case s.CellKind.Code:default:return S.NotebookCellKind.Code}}ne.to=re})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ne){function pe(B){const Ce={metadata:B.metadata??Object.create(null),cells:[]};for(let Se of B.cells)S.NotebookCellData.validate(Se),Ce.cells.push(Et.from(Se));return Ce}ne.from=pe;function re(B){const Ce=new S.NotebookData(B.cells.map(Et.to));return(0,y.isEmptyObject)(B.metadata)||(Ce.metadata=B.metadata),Ce}ne.to=re})(ft=e.NotebookData||(e.NotebookData={}));var Et;(function(ne){function pe(B){return{cellKind:bt.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:dt.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Ct.from):[]}}ne.from=pe;function re(B){return new S.NotebookCellData(bt.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Ct.to):void 0,B.metadata,B.internalMetadata?dt.to(B.internalMetadata):void 0)}ne.to=re})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(ne){function pe(B){return{mime:B.mime,valueBytes:M.VSBuffer.wrap(B.data)}}ne.from=pe;function re(B){return new S.NotebookCellOutputItem(B.valueBytes.buffer,B.mime)}ne.to=re})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ne){function pe(B){return{outputId:B.id,items:B.items.map(Ye.from),metadata:B.metadata}}ne.from=pe;function re(B){const Ce=B.items.map(Ye.to);return new S.NotebookCellOutput(Ce,B.outputId,B.metadata)}ne.to=re})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ne){function pe(Se){if(Se!=null){if(Se instanceof S.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new S.RelativePattern(Se.base,Se.pattern);if(B(Se))return{include:ht.from(Se.include)||void 0,exclude:ht.from(Se.exclude)||void 0}}}ne.from=pe;function re(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ne.to=re;function B(Se){const Ge=Se,We=ht.from(Ge.include);if(!(We&&We instanceof S.RelativePattern||typeof We=="string"))return!1;const it=ht.from(Ge.exclude);return!!(it&&it instanceof S.RelativePattern||typeof it=="string")}function Ce(Se){const Ge=Se;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ne){function pe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?c.from(re.top):void 0}}ne.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(ne){function pe(re,B,Ce){const Se=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(Se,Ce),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ne.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ne){function pe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ne.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ce;(function(ne){function pe(B){return{uri:B.uri,provides:B.provides}}ne.from=pe;function re(B){return new S.NotebookRendererScript(P.URI.revive(B.uri),B.provides)}ne.to=re})(ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(B){return{message:T.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?le.from(B.location):void 0}}ne.from=pe;function re(B){const Ce=new S.TestMessage(typeof B.message=="string"?B.message:T.to(B.message));return Ce.actualOutput=B.actual,Ce.expectedOutput=B.expected,Ce.location=B.location?le.to(B.location):void 0,Ce}ne.to=re})(ge=e.TestMessage||(e.TestMessage={}));var me;(function(ne){let pe;(function(re){re.Delimiter="\0"})(pe||(pe={})),ne.namespace=(re,B)=>re+"\0"+B,ne.denamespace=re=>{const B=re.indexOf("\0");return{ctrlId:re.slice(0,B),tagId:re.slice(B+1)}}})(me=e.TestTag||(e.TestTag={}));var Ie;(function(ne){function pe(Se){const Ge=(0,u.getPrivateApiFor)(Se).controllerId;return{extId:v.TestId.fromExtHostTestItem(Se,Ge).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>me.namespace(Ge,We.id)),range:g.from(Se.range)||null,description:Se.description||null,error:Se.error&&T.fromStrict(Se.error)||null}}ne.from=pe;function re(Se){return{id:v.TestId.fromString(Se.extId).localId,label:Se.label,uri:P.URI.revive(Se.uri),tags:(Se.tags||[]).map(Ge=>{const{tagId:We}=me.denamespace(Ge);return new S.TestTag(We)}),range:g.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ne.toPlain=re;function B(Se){const Ge=v.TestId.fromString(Se.extId),We=new u.TestItemImpl(Ge.controllerId,Ge.localId,Se.label,P.URI.revive(Se.uri));return We.range=g.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let Ge;for(const We of Se.tests){const it=B(We.item);(0,u.getPrivateApiFor)(it).parent=Ge,Ge=it}return Ge}ne.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(ne){function pe(B){return{id:B.id}}ne.from=pe;function re(B){return new S.TestTag(B.id)}ne.to=re}(me=e.TestTag||(e.TestTag={}));var Be;(function(ne){const pe=(B,Ce)=>{const Se={...Ie.toPlain(B.item),parent:void 0,taskStates:B.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(We=>We.type===0).map(ge.to)})),children:B.children.map(Ge=>Ce.get(Ge)).filter(y.isDefined).map(Ge=>pe(Ge,Ce))};for(const Ge of Se.children)Ge.parent=Se;return Se};function re(B){const Ce=[],Se=new Map;for(const Ge of B.items)Se.set(Ge.item.extId,Ge),B.request.targets.some(We=>We.controllerId===Ge.controllerId&&We.testIds.includes(Ge.item.extId))&&Ce.push(Ge);return{completedAt:B.completedAt,results:Ce.map(Ge=>pe(Ge,Se))}}ne.to=re})(Be=e.TestResults||(e.TestResults={}));var Le;(function(ne){function pe(Se){return{covered:Se.covered,total:Se.covered}}function re(Se){return"line"in Se?i.from(Se):g.from(Se)}function B(Se){return"branches"in Se?{count:Se.executionCount,location:re(Se.location),type:1,branches:Se.branches.length?Se.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&re(Ge.location)})):void 0}:{type:0,count:Se.executionCount,location:re(Se.location)}}ne.fromDetailed=B;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(B)}}ne.fromFile=Ce})(Le=e.TestCoverage||(e.TestCoverage={}));var je;(function(ne){function pe(re){switch(re){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}ne.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Xe;(function(ne){function pe(B){const Ce=new S.TypeHierarchyItem(Q.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),g.to(B.range),g.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ne.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:Q.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:g.from(B.range),selectionRange:g.from(B.selectionRange),tags:B.tags?.map($.from)}}ne.from=re})(Xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,t,_,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,_,n)=>{const u={dispose:this._callbacks.push([t,_,P])};return Array.isArray(n)&&n.push(u),u}}async $participateInSave(P,t){const _=d.URI.revive(P);let n=!1;const h=setTimeout(()=>n=!0,this._thresholds.timeout),u=[];try{for(let s of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(_),I=await this._deliverEventAsyncAndBlameBadListeners(s,{document:v,reason:A.TextDocumentSaveReason.to(t)});u.push(I)}}finally{clearTimeout(h)}return u}_deliverEventAsyncAndBlameBadListeners([P,t,_],n){const h=this._badListeners.get(P);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,P,t,n).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const s=this._badListeners.get(P);this._badListeners.set(P,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,_,n){const h=[],u=Date.now(),{document:s,reason:v}=n,{version:I}=s,S=Object.freeze({document:s,reason:v,waitUntil(o){if(Object.isFrozen(h))throw(0,M.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(o))}});try{t.apply(_,[S])}catch(o){return Promise.reject(o)}return Object.freeze(h),new Promise((o,g)=>{const k=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(k),o(i)}).catch(i=>{clearTimeout(k),g(i)})}).then(o=>{const g={edits:[]};for(const k of o)if(Array.isArray(k)&&k.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:l,range:r}of k)g.edits.push({_type:2,resource:s.uri,edit:{range:r&&A.Range.from(r),text:i,eol:l&&A.EndOfLine.from(l)}});if(g.edits.length!==0)return I===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[68],Ee([0,1,8,2,3,4]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new E.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new E.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let P=-1;this._tabs=y.map((_,n)=>(_.isActive&&(P=n),Object.freeze({label:_.label,viewColumn:d.ViewColumn.to(_.viewColumn),resource:M.URI.revive(_.resource),viewId:_.editorId,isActive:_.isActive})));const t=this._activeTab;this._activeTab=P===-1?void 0:this._tabs[P],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(be[171],Ee([0,1,3,27,2,8,7]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,_,n,h,u){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),h&&(this._config+=2),u&&(this._config+=4);const s=(0,M.parse)(_),v=t(I=>{if(!n)for(let S of I.created){const o=E.URI.revive(S);s(o.fsPath)&&this._onDidCreate.fire(o)}if(!h)for(let S of I.changed){const o=E.URI.revive(S);s(o.fsPath)&&this._onDidChange.fire(o)}if(!u)for(let S of I.deleted){const o=E.URI.revive(S);s(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(t,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,n,h){return new C(this._onFileSystemEvent.event,t,_,n,h)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(n,h,u)=>{const s=function(I){n.call(h,I)};return s.extension=t,_.event(s,void 0,u)}}async $onWillRunFileOperation(t,_,n,h){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(u=>({oldUri:E.URI.revive(u.source),newUri:E.URI.revive(u.target)}))},n,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(u=>E.URI.revive(u.target))},n,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(u=>E.URI.revive(u.target))},n,h)}}async _fireWillEvent(t,_,n,h){const u=new Set,s=[];if(await t.fireAsync(_,h,async(I,S)=>{const o=Date.now(),g=await Promise.resolve(I);g instanceof R.WorkspaceEdit&&(s.push(g),u.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),h.isCancellationRequested||s.length===0)return;const v={edits:[]};for(let I of s){let{edits:S}=A.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(S)}return{edit:v,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=y}),define(be[172],Ee([0,1,11,22,2,8,7,89]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(n,h,u,s){this.start=n,this.deletedCount=h,this.deletedItems=u,this.items=s}static asApiEvents(n){return n.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(u=>u.apiCell)}))}}class P{constructor(n,h,u){this.notebook=n,this._extHostDocument=h,this._cellData=u,this.handle=u.handle,this.uri=E.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(n,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return n._mime},set mime(u){n._mime=u},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,h,u){const s=u.map(A.NotebookCellOutputItem.to),v=this._outputs.find(I=>I.id===n);v&&(h||(v.items.length=0),v.items.push(...s))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,h,u,s,v,I){this._proxy=n,this._textDocumentsAndEditors=h,this._textDocuments=u,this._emitter=s,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(h){return h=n._validateIndex(h),n._cells[h].apiCell},getCells(h){return(h?n._getCells(h):n._cells).map(s=>s.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,h){this._versionId=n.versionId,this._isDirty=h;for(const u of n.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===C.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let h=n.start|0,u=n.end|0;return h<0&&(h=0),u>this._cells.length&&(u=this._cells.length),n.with({start:h,end:u})}_getCells(n){n=this._validateRange(n);const h=[];for(let u=n.start;u<n.end;u++)h.push(this._cells[u]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,h){if(this._disposed)return;const u=[],s=[],v=[];n.reverse().forEach(I=>{const o=I[2].map(i=>{const l=new P(this,this._textDocumentsAndEditors,i);return h||s.push(P.asModelAddData(this.apiNotebook,i)),l}),g=new y(I[0],I[1],[],o),k=this._cells.splice(I[0],I[1],...o);for(const i of k)v.push(i.uri),g.deletedItems.push(i.apiCell);u.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:v}),h||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(u)}))}_moveCell(n,h){const u=this._cells.splice(n,1);this._cells.splice(h,0,...u);const s=[new y(n,1,u.map(v=>v.apiCell),[]),new y(h,0,[],u)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(s)}))}_setCellOutputs(n,h){const u=this._cells[n];u.setOutputs(h),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(n,h,u,s){const v=this._cells[n];v.setOutputItems(h,u,s),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,h){const u=this._cells[n];u.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(u.uri,h)}_changeCellMime(n,h){const u=this._cells[n];u.apiCell.mime=h}_changeCellMetadata(n,h){const u=this._cells[n],s=u.apiCell.metadata;u.setMetadata(h);const v=u.apiCell.metadata;(0,M.equals)(s,v)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(n,h){const u=this._cells[n],s=u.internalMetadata;if(u.setInternalMetadata(h),s.runState!==h.runState){const v=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(h=>h.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(h=>h.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,t){this._throwIfFinalized(),!(y===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:t.map(M.NotebookCellData.from)})}}class R{constructor(y,P,t,_,n,h){this.id=y,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=h}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(d.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,t){y._proxy.$tryRevealRange(y.id,M.NotebookRange.from(P),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const t=new A(this.document.version);return P(t),y._applyEdit(t.finalize())},setDecorations(P,t){return y.setDecorations(P,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(M.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let _=0;_<y.cellEdits.length;_++){if(t<0){P.push(y.cellEdits[_]),t++;continue}const h=P[t],u=y.cellEdits[_];if(h.editType===1&&u.editType===1&&h.index===u.index){h.cells.push(...y.cellEdits[_].cells),h.count+=y.cellEdits[_].count;continue}P.push(y.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,147,126,21,52]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}withProgress(_,n,h){const u=this._handles++,{title:s,location:v,cancellable:I}=n,S={label:(0,E.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(v),title:s,source:S,cancellable:I},_),this._withProgress(u,h,!!I)}_withProgress(_,n,h){let u;h&&(u=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,u));const s=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),u&&u.dispose()};let v;try{v=n(new P(this._proxy,_),h&&u?u.token:A.CancellationToken.None)}catch(I){throw s(_),I}return v.then(I=>s(_),I=>s(_)),v}$acceptProgressCanceled(_){const n=this._mapHandleToCancellationSource.get(_);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=C;function y(t,_){return t.message=_.message,typeof _.increment=="number"&&(typeof t.increment=="number"?t.increment+=_.increment:t.increment=_.increment),t}class P extends M.Progress{constructor(_,n){super(h=>this.throttledReport(h));this._proxy=_,this._handle=n}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Ue([(0,R.throttle)(100,(t,_)=>y(t,_),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,40,16,53,8,7]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,h,u){const s=C._Keys.nextId();n.$registerTextEditorDecorationType(h.identifier,s,A.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:s,dispose(){n.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=C,C._Keys=new E.IdGenerator("TextEditorDecorationType");class y{constructor(n,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,h){this._throwIfFinalized();let u=null;if(n instanceof R.Position)u=new R.Range(n,n);else if(n instanceof R.Range)u=n;else throw new Error("Unrecognized location");this._pushEdit(u,h,!1)}insert(n,h){this._throwIfFinalized(),this._pushEdit(new R.Range(n,n),h,!0)}delete(n){this._throwIfFinalized();let h=null;if(n instanceof R.Range)h=n;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(n,h,u){const s=this._document.validateRange(n);this._collectedEdits.push({range:s,text:h,forceMoveMarkers:u})}setEndOfLine(n){if(this._throwIfFinalized(),n!==R.EndOfLine.LF&&n!==R.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=y;class P{constructor(n,h,u,s){this._proxy=n,this._id=h,this._accept(u),this._logService=s;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(I){v._setTabSize(I)},get insertSpaces(){return v._insertSpaces},set insertSpaces(I){v._setInsertSpaces(I)},get cursorStyle(){return v._cursorStyle},set cursorStyle(I){v._setCursorStyle(I)},get lineNumbers(){return v._lineNumbers},set lineNumbers(I){v._setLineNumbers(I)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const h=Math.floor(n);return h>0?h:null}if(typeof n=="string"){const h=parseInt(n,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(n){const h=this._validateTabSize(n);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const h=this._validateInsertSpaces(n);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const h={};let u=!1;if(typeof n.tabSize!="undefined"){const s=this._validateTabSize(n.tabSize);s==="auto"?(u=!0,h.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,u=!0,h.tabSize=s)}if(typeof n.insertSpaces!="undefined"){const s=this._validateInsertSpaces(n.insertSpaces);s==="auto"?(u=!0,h.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,u=!0,h.insertSpaces=s)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,u=!0,h.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,u=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(n){n.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,h,u,s,v,I,S,o){this.id=n,this._proxy=h,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,I,u),this._visibleRanges=S,this._viewColumn=o;const g=this;this.value=Object.freeze({get document(){return s.getValue()},set document(k){throw(0,M.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(k){if(!(k instanceof R.Selection))throw(0,M.illegalArgument)("selection");g._selections=[k],g._trySetSelection()},get selections(){return g._selections},set selections(k){if(!Array.isArray(k)||k.some(i=>!(i instanceof R.Selection)))throw(0,M.illegalArgument)("selections");g._selections=k,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(k){throw(0,M.readonly)("visibleRanges")},get options(){return g._options.value},set options(k){g._disposed||g._options.assign(k)},get viewColumn(){return g._viewColumn},set viewColumn(k){throw(0,M.readonly)("viewColumn")},edit(k,i={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new y(s.getValue(),i);return k(l),g._applyEdit(l)},insertSnippet(k,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=g._selections.map(a=>A.Range.from(a));else if(i instanceof R.Position){const{lineNumber:a,column:w}=A.Position.from(i);r=[{startLineNumber:a,startColumn:w,endLineNumber:a,endColumn:w}]}else if(i instanceof R.Range)r=[A.Range.from(i)];else{r=[];for(const a of i)if(a instanceof R.Range)r.push(A.Range.from(a));else{const{lineNumber:w,column:f}=A.Position.from(a);r.push({startLineNumber:w,startColumn:f,endLineNumber:w,endColumn:f})}}return h.$tryInsertSnippet(n,k.value,r,l)},setDecorations(k,i){const l=i.length===0;l&&!g._hasDecorationsForKey.has(k.key)||(l?g._hasDecorationsForKey.delete(k.key):g._hasDecorationsForKey.add(k.key),g._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return h.$trySetDecorations(n,k.key,A.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let a=0,w=i.length;a<w;a++){const f=i[a];r[4*a]=f.start.line+1,r[4*a+1]=f.start.character+1,r[4*a+2]=f.end.line+1,r[4*a+3]=f.end.character+1}return h.$trySetDecorationsFast(n,k.key,r)}}))},revealRange(k,i){g._runOnProxy(()=>h.$tryRevealRange(n,A.Range.from(k),i||R.TextEditorRevealType.Default))},show(k){h.$tryShowEditor(n,A.ViewColumn.from(k))},hide(){h.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const h=n.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const u=h.edits.map(v=>v.range);u.sort((v,I)=>v.end.line===I.end.line?v.end.character===I.end.character?v.start.line===I.start.line?v.start.character-I.start.character:v.start.line-I.start.line:v.end.character-I.end.character:v.end.line-I.end.line);for(let v=0,I=u.length-1;v<I;v++){const S=u[v].end;if(u[v+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=h.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,s,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,14,7,10,13,8,21,159]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(S,o){if((0,t.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let g;return Array.isArray(S.highlights)&&(g=S.highlights.filter(k=>k.length===2&&typeof k[0]=="number"&&typeof k[1]=="number"),g=g.length?g:void 0),{label:S.label,highlights:g}}}class v{constructor(o,g,k){this._proxy=o,this.commands=g,this.logService=k,this.treeViews=new Map;function i(l){return l&&l.$treeViewId&&l.$treeItemHandle}g.registerArgumentProcessor({processArgument:l=>i(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(r=>i(r)?this.convertArgument(r):r):l})}registerTreeDataProvider(o,g,k){const i=this.createTreeView(o,{treeDataProvider:g},k);return{dispose:()=>i.dispose()}}createTreeView(o,g,k){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=g.dragAndDropController!==void 0,l=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(o,g,k);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(a){r.message=a},get title(){return r.title},set title(a){r.title=a},get description(){return r.description},set description(a){r.description=a},reveal:(a,w)=>r.reveal(a,w),dispose:async()=>{await l,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,g){const k=this.treeViews.get(o);return k?k.getChildren(g):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,g,k){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const l=u.TreeDataTransferConverter.toITreeDataTransfer(g);if(l.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const a=JSON.parse(await l.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(w=>i.getExtensionElement(w)).filter(w=>!!w);a.length>0?l.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(a)}):l.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(l,k)}async $hasResolve(o){const g=this.treeViews.get(o);if(!g)throw new Error((0,d.localize)(2,null,o));return g.hasResolve}$resolve(o,g,k){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(g,k)}$setExpanded(o,g,k){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(g,k)}$setSelection(o,g){const k=this.treeViews.get(o);if(!k)throw new Error((0,d.localize)(5,null,o));k.setSelection(g)}$setVisible(o,g){const k=this.treeViews.get(o);if(!k)throw new Error((0,d.localize)(6,null,o));k.setVisible(g)}createExtHostTreeView(o,g,k){const i=new I(o,g,this._proxy,this.commands.converter,this.logService,k);return this.treeViews.set(o,i),i}convertArgument(o){const g=this.treeViews.get(o.$treeViewId);return g?g.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=v;class I extends R.Disposable{constructor(o,g,k,i,l,r){super();if(this.viewId=o,this.proxy=k,this.commands=i,this.logService=l,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,r.contributes&&r.contributes.views)for(const f in r.contributes.views)for(const m of r.contributes.views[f])m.id===o&&(this._title=m.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let a,w;this._register(A.Event.debounce(this._onDidChangeData.event,(f,m)=>(f||(f={message:!1,elements:[]}),m.element!==!1&&(a||(a=new Promise(D=>w=D),this.refreshPromise=this.refreshPromise.then(()=>a)),Array.isArray(m.element)?f.elements.push(...m.element):f.elements.push(m.element)),m.message&&(f.message=!0),f),200,!0)(({message:f,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=w;return a=null,this.refresh(m).then(()=>D())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const g=o?this.getExtensionElement(o):void 0;if(o&&!g)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let k=this.getChildrenNodes(o);return k||(k=await this.fetchChildrenNodes(g)),k?k.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,g){g=g||{select:!0,focus:!1};const k=(0,t.isUndefinedOrNull)(g.select)?!0:g.select,i=(0,t.isUndefinedOrNull)(g.focus)?!1:g.focus,l=(0,t.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(a=>this.proxy.$reveal(this.viewId,{item:a.item,parentChain:r.map(w=>w.item)},{select:k,focus:i,expand:l})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:k,focus:i,expand:l})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,g){const k=this.getExtensionElement(o);k&&(g?this._onDidExpandElement.fire(Object.freeze({element:k})):this._onDidCollapseElement.fire(Object.freeze({element:k})))}setSelection(o){(0,_.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,g){const k=this.getExtensionElement(g);if(!!k)return(0,y.asPromise)(()=>this.dndController?.onDrop(o,k))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,g){if(!this.dataProvider.resolveTreeItem)return;const k=this.elements.get(o);if(k){const i=this.nodes.get(k);if(i){const l=await this.dataProvider.resolveTreeItem(i.extensionItem,k,g)??i.extensionItem;return i.item.tooltip=this.getTooltip(l.tooltip),i.item.command=this.getCommand(i.disposableStore,l.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(g=>g?this.resolveUnknownParentChain(g).then(k=>this.resolveTreeNode(g,k[k.length-1]).then(i=>(k.push(i),k))):Promise.resolve([]))}resolveParent(o){const g=this.nodes.get(o);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,g){const k=this.nodes.get(o);return k?Promise.resolve(k):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,g,!0)).then(i=>this.getChildren(g?g.item.handle:void 0).then(()=>{const l=this.getExtensionElement(i);if(l){const r=this.nodes.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let g;if(typeof o=="string"){const k=this.getExtensionElement(o);g=k?this.nodes.get(k):void 0}else g=o;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const g=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const k=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(g.token.isCancellationRequested)return;const l=await Promise.all((0,_.coalesce)(i||[]).map(async r=>{const a=await this.dataProvider.getTreeItem(r);return a&&!g.token.isCancellationRequested?this.createAndRegisterTreeNode(r,a,k):null}));return g.token.isCancellationRequested?void 0:(0,_.coalesce)(l)}finally{g.dispose()}}refresh(o){if(o.some(k=>!k))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const k=this.getHandlesToRefresh(o);if(k.length)return this.refreshHandles(k)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const g=new Set,k=o.map(l=>this.nodes.get(l));for(const l of k)if(l&&!g.has(l.item.handle)){let r=l;for(;r&&r.parent&&k.findIndex(a=>r&&r.parent&&a&&a.item.handle===r.parent.item.handle)===-1;){const a=this.elements.get(r.parent.item.handle);r=a?this.nodes.get(a):void 0}r&&!r.parent&&g.add(l.item.handle)}const i=[];return g.forEach(l=>{const r=this.elements.get(l);if(r){const a=this.nodes.get(r);a&&(!a.parent||!g.has(a.parent.item.handle))&&i.push(l)}}),i}refreshHandles(o){const g={};return Promise.all(o.map(k=>this.refreshNode(k).then(i=>{i&&(g[k]=i.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(o){const g=this.getExtensionElement(o);if(g){const k=this.nodes.get(g);if(k)return this.clearChildren(g),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(i=>{if(i){const l=this.createTreeNode(g,i,k.parent);return this.updateNodeCache(g,l,k,k.parent),k.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,g,k){const i=this.createTreeNode(o,g,k);if(g.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,g.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,k),i}getTooltip(o){return P.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,g){return g?this.commands.toInternal(g,o):void 0}createTreeNode(o,g,k){const i=new R.DisposableStore,l=this.createHandle(o,g,k),r=this.getLightIconPath(g);return{item:{handle:l,parentHandle:k?k.item.handle:void 0,label:s(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(i,g.command),contextValue:g.contextValue,icon:r,iconDark:this.getDarkIconPath(g)||r,themeIcon:this.getThemeIcon(g),collapsibleState:(0,t.isUndefinedOrNull)(g.collapsibleState)?P.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation},extensionItem:g,parent:k,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof P.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:g,label:k,resourceUri:i},l,r){if(g)return`${I.ID_HANDLE_PREFIX}/${g}`;const a=s(k,this.extension),w=l?l.item.handle:I.LABEL_HANDLE_PREFIX;let f=a?a.label:i?(0,M.basename)(i):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const m=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,D=this.getChildrenNodes(l)||[];let T,p=0;do{if(T=`${w}/${p}:${f}`,r||!this.elements.has(T)||m===T)break;p++}while(p<=D.length);return T}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon))return typeof o.iconPath=="string"||E.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return E.URI.isUri(o)?o:E.URI.file(o)}addNodeToCache(o,g){this.elements.set(g.item.handle,o),this.nodes.set(o,g)}updateNodeCache(o,g,k,i){this.elements.delete(g.item.handle),this.nodes.delete(o),g.item.handle!==k.item.handle&&this.elements.delete(k.item.handle),this.addNodeToCache(o,g);const l=this.getChildrenNodes(i)||[],r=l.filter(a=>a.item.handle===k.item.handle)[0];r&&l.splice(l.indexOf(r),1,g)}addNodeToParentCache(o,g){g?(g.children||(g.children=[]),g.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const g=this.nodes.get(o);if(g){if(g.children)for(const k of g.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}g.children=void 0}}else this.clearAll()}clear(o){const g=this.nodes.get(o);if(g){if(g.children)for(const k of g.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,14,3,6,10,46,8,90,67]),function(ie,e,d,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const h=this.diff[this.diff.length-1];if(h&&n[0]===1){if(h[0]===1&&h[1].extId===n[1].extId){(0,y.applyTestItemUpdate)(h[1],n[1]);return}if(h[0]===0&&h[1].item.extId===n[1].extId){(0,y.applyTestItemUpdate)(h[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,h){const u=this.tree.get(n);if(!!u){if((u.expandLevels===void 0||h>u.expandLevels)&&(u.expandLevels=h),u.expand===1){const s=this.resolveChildren(u);return s.isOpen()?this.expandChildren(u,h-1):s.wait().then(()=>this.expandChildren(u,h-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,h-1)):this.expandChildren(u,h-1)}}dispose(){for(const n of this.tree.values())(0,R.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,h){switch(h.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,h.id));break;case 0:this.upsertItem(h.item,n);break;case 4:for(const S of h.ops)this.onTestItemEvent(n,S);break;case 3:const{key:u,value:s,previous:v}=h,I=n.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(s,v,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:C.Range.from(s)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:C.MarkdownString.fromStrict(s)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[u]:s??null}}]);break}break;default:(0,A.assertNever)(h)}}upsertItem(n,h){if(!(n instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const u=P.TestId.fromExtHostTestItem(n,this.root.id,h?.actual),s=(0,R.getPrivateApiFor)(n);s.parent&&s.parent!==h?.actual&&s.parent.children.delete(n.id);let v=this.tree.get(u.toString());if(!v){v={fullId:u,actual:n,parent:h?u.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,h),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,v,h);return}if(v.actual===n){this.connectItem(n,v,h);return}const I=v.actual.children,S=v.actual,o=(0,R.diffTestItems)(S,n);(0,R.getPrivateApiFor)(S).listener=void 0,v.actual=n,v.expand=0;for(const[g,k]of o)this.onTestItemEvent(v,{op:3,key:g,value:k,previous:S[g]});this.connectItemAndChildren(n,v,h);for(const g of I)n.children.get(g.id)||this.removeItem(P.TestId.joinToString(u,g.id))}diffTagRefs(n,h,u){const s=new Set(h.map(v=>v.id));for(const v of n)s.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:u,item:{tags:n.map(v=>C.TestTag.namespace(this.controllerId,v.id))}}]),s.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const h=this.tags.get(n.id);h?h.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const h=this.tags.get(n);h&&!--h.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,h){(0,R.getPrivateApiFor)(n).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(n,h,u){this.setItemParent(n,u);const s=(0,R.getPrivateApiFor)(n);s.parent=u?.actual,s.listener=v=>this.onTestItemEvent(h,v),this.updateExpandability(h)}connectItemAndChildren(n,h,u){this.connectItem(n,h,u);for(const s of n.children)this.upsertItem(s,h)}updateExpandability(n){let h;this._resolveHandler?n.resolveBarrier?h=n.resolveBarrier.isOpen()?3:2:h=n.actual.canResolveChildren?1:0:h=0,h!==n.expand&&(n.expand=h,this.pushDiff([1,{extId:n.fullId.toString(),expand:h}]),h===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,h){if(h<0)return;const u=[];for(const s of n.actual.children){const v=this.expand(P.TestId.joinToString(n.fullId,s.id),h);(0,d.isThenable)(v)&&u.push(v)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new d.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const h=n.resolveBarrier=new d.Barrier,u=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let s;try{s=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){u(v)}return(0,d.isThenable)(s)?s.catch(u).then(()=>{h.open(),this.updateExpandability(n)}):(h.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const h=this.tree.get(n);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const u=[h];for(;u.length;){const s=u.pop();if(!!s){(0,R.getPrivateApiFor)(s.actual).listener=void 0;for(const v of s.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(s.fullId.toString());for(const v of s.actual.children)u.push(this.tree.get(P.TestId.joinToString(s.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,25,3,17]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(n=>_.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=R._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(h=>h.identifier)),_.length>0){const h=new Set;_.forEach(u=>h.add(d.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!h.has(d.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,I){this.addNode(v),this.addNode(I),this._arcs.has(v)?this._arcs.get(v).push(I):this._arcs.set(v,[I])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,I){const S=_.getArcs(v);for(let o=0;o<S.length;o++)if(!I.has(S[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const I=d.ExtensionIdentifier.toKey(v.identifier);if(n.set(I,v),v.extensionDependencies)for(let S of v.extensionDependencies){const o=d.ExtensionIdentifier.toKey(S);_.addArc(I,o)}}let h=new Set;_.getNodes().filter(v=>_.getArcs(v).length===0).forEach(v=>h.add(v));let u=_.getNodes().filter(v=>!h.has(v)),s;do{s=!1;for(let v=0;v<u.length;v++){const I=u[v];_.hasOnlyGoodArcs(I,h)&&(u.splice(v,1),v--,h.add(I),s=!0)}}while(s);return u.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=R;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function y(P,t){const _=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==n)return _-n;const h=E.posix.basename(P.extensionLocation.path),u=E.posix.basename(t.extensionLocation.path);return h<u?-1:h>u?1:0}}),define(be[178],Ee([0,1,23]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(C){const y=d.VSBuffer.alloc(1);switch(C){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function R(C,y){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(be[30],Ee([0,1,3,2,4,25,143]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var C;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(g){this.dependency=g}}e.MissingExtensionDependency=y;var P;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));function t(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=t;class _{constructor(g,k,i,l){this.codeLoadingTime=g,this.activateCallTime=k,this.activateResolvedTime=i,this.activationReason=l}}e.ActivationTimes=_;class n{constructor(g,k){this.description=g,this.value=k}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var h;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function u(o){o.enableProposedApi||s(o)}e.checkProposedApiEnabled=u;function s(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=s;function v(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=v;function I(o,g){return{identifier:new A.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!g,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=I;class S{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,k){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,k,i,l,r){}_onDidActivateExtensionError(g,k){}_onExtensionRuntimeError(g,k){}_onExtensionHostExit(g){}}e.NullExtensionService=S}),define(be[179],Ee([0,1,25,30,15]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(u,s,v,I){this.startup=u,this.codeLoadingTime=s,this.activateCallTime=v,this.activateResolvedTime=I}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,s){return u===-1||s===-1?-1:s-u}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class y{constructor(u,s,v,I,S,o){this.activationFailed=u,this.activationFailedError=s,this.activationTimes=v,this.module=I,this.exports=S,this.subscriptions=o}}e.ActivatedExtension=y;class P extends y{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends y{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends y{constructor(u){super(!0,u,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let n=class{constructor(u,s,v,I,S){this._logService=S,this._registry=u,this._resolvedExtensionsSet=new Set,s.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,v.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const s=d.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(s)}getActivatedExtension(u){const s=d.ExtensionIdentifier.toKey(u),v=this._activatedExtensions.get(s);if(!v)throw new Error("Extension `"+u.value+"` is not known or not activated");return v}activateByEvent(u,s){if(this._alreadyActivatedEvents[u])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(v.map(I=>({id:I.identifier,reason:{startup:s,extensionId:I.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,s){const v=this._registry.getExtensionDescription(u);if(!v)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:v.identifier,reason:s}])}_handleActivateRequest(u,s,v){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(u.id))){s[d.ExtensionIdentifier.toKey(u.id)]=u;return}const I=this._registry.getExtensionDescription(u.id);if(!I){const g=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,g,new M.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(u.id),new _(g));return}const S=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let o=!0;for(let g=0,k=S.length;g<k;g++){const i=S[g];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const l=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(l&&!l.activationFailed)continue;if(l&&l.activationFailed){const f=I.displayName||I.identifier.value,m=this._registry.getExtensionDescription(i),D=m&&m.displayName||i,T=new Error(`Cannot activate the '${f}' extension because its dependency '${D}' failed to activate`);T.detail=l.activationFailedError,this._host.onExtensionActivationError(I.identifier,T,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new _(T));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,s[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:u.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){o=!1,s[d.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:u.reason};continue}const a=I.displayName||I.identifier.value,w=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,w,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new _(w));return}o?s[d.ExtensionIdentifier.toKey(I.identifier)]=u:v.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(S=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(S.id))),u.length===0))return Promise.resolve(void 0);const s=Object.create(null),v=[];for(let S=0,o=u.length;S<o;S++)this._handleActivateRequest(u[S],s,v);for(let S=0,o=v.length;S<o;S++){const g=d.ExtensionIdentifier.toKey(v[S].id);s[g]&&delete s[g]}const I=Object.keys(s).map(S=>s[S]);return v.length===0?Promise.all(I.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(I).then(S=>this._activateExtensions(v))}_activateExtension(u,s){const v=d.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const I=this._activatingExtensions.get(v);if(I)return I;const S=this._host.actualActivateExtension(u,s).then(void 0,o=>{const g=new Error;return o&&o.name&&(g.name=o.name),o&&o.message?g.message=`Activating extension '${u.value}' failed: ${o.message}.`:g.message=`Activating extension '${u.value}' failed: ${o}.`,o&&o.stack&&(g.stack=o.stack),this._host.onExtensionActivationError(u,g,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(o),new _(o)}).then(o=>{this._activatedExtensions.set(v,o),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,S),S}};n=Ue([He(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[47],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function E(y){const P=new d(!0,y);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=E;function A(y){const P=new d(!1,y);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function R(y){return M[y].sid}e.getStringIdentifierForProxy=R;class C{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=C}),define(be[5],Ee([0,1,54,2,47]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function g(i,l){return Object.defineProperty(i,o.name,{value:l,enumerable:!0}),i}o.mixin=g;function k(i){return i[o.name]}o.of=k})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(g){return g._id=h._n++,g}}e.IdObject=h,h._n=0;var u;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(o){if(o&&o.edits)for(const g of o.edits)typeof g.resource=="object"?g.resource=M.URI.revive(g.resource):(g.newUri=M.URI.revive(g.newUri),g.oldUri=M.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,d.revive)(g.metadata));return o}e.reviveWorkspaceEditDto=I;var S;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,y){return this._proxy.$getPassword(C,y)}store(C,y,P){return this._proxy.$setPassword(C,y,P)}delete(C,y){return this._proxy.$deletePassword(C,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,12]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(E.MainContext.MainThreadTelemetry)}report(y,P,t){const _=this.getUsageKey(y,P);this._reportedUsages.has(_)||(this._reportedUsages.add(_),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};R=Ue([He(0,A.IExtHostRpcService),He(1,M.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(C,y,P){}})}),define(be[181],Ee([0,1,3,5,7,25]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,t,_={}){const n=A.ExtensionIdentifier.toKey(y.identifier),h=this._inFlightRequests.get(n)||[],u=[...t].sort().join(" ");let s=h.find(v=>v.scopes===u);if(s)return s.result;{const v=this._getSession(y,n,P,t,_);s={scopes:u,result:v},h.push(s),this._inFlightRequests.set(n,h);try{await v}finally{const I=h.findIndex(S=>S.scopes===u);I>-1&&(h.splice(I),this._inFlightRequests.set(n,h))}return v}}async _getSession(y,P,t,_,n={}){await this._proxy.$ensureProvider(t);const h=y.displayName||y.name;return this._proxy.$getSession(t,_,P,h,n)}async removeSession(y,P){const t=this._authenticationProviders.get(y);return t?t.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,t,_){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===y)||this._providers.push({id:y,label:P});const n=t.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(y,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(y);const h=this._providers.findIndex(u=>u.id===y);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(be[182],Ee([0,1,5,12,8]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,y){this._extHostDocumentsAndEditors=y,this._proxy=C.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const y=E.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=Ue([He(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const R=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(C){return R.$writeText(C)}})}}e.ExtHostClipboard=M}),define(be[48],Ee([0,1,10,7,8,22,5,13,15,54,42,112,2,6,4,12,46]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let I=class{constructor(l,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=l.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new S(this,a=>{const w=this._apiCommands.get(a);return w?.result===g.Void?w:void 0},r),this._argumentProcessors=[{processArgument(a){return(0,P.revive)(a)}},{processArgument(a){return(0,A.cloneAndChange)(a,function(w){if(t.Range.isIRange(w))return E.Range.to(w);if(_.Position.isIPosition(w))return E.Position.to(w);if(t.Range.isIRange(w.range)&&n.URI.isUri(w.uri))return E.location.to(w);if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const r=this.registerCommand(!1,l.id,async(...a)=>{const w=l.args.map((m,D)=>{if(!m.validate(a[D]))throw new Error(`Invalid argument '${m.name}' when running '${l.id}', received: ${a[D]}`);return m.convert(a[D])}),f=await this.executeCommand(l.internalId,...w);return l.result.convert(f,a,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new M.Disposable(()=>{r.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,r,a,w,f){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:a,thisArg:w,description:f}),l&&this._proxy.$registerCommand(r),new M.Disposable(()=>{this._commands.delete(r)&&l&&this._proxy.$unregisterCommand(r)})}executeCommand(l,...r){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,r,!0)}async _doExecuteCommand(l,r,a){if(this._commands.has(l))return this._executeContributedCommand(l,r);{const w=(0,A.cloneAndChange)(r,function(f){if(f instanceof M.Position)return E.Position.from(f);if(f instanceof M.Range)return E.Range.from(f);if(f instanceof M.Location)return E.location.from(f);if(M.NotebookRange.isNotebookRange(f))return E.NotebookRange.from(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(l,w,a);return(0,P.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(l,r,!1);throw f}}}async _executeContributedCommand(l,r){const a=this._commands.get(l);if(!a)throw new Error("Unknown command");let{callback:w,thisArg:f,description:m}=a;if(m)for(let D=0;D<m.args.length;D++)try{(0,d.validateConstraint)(r[D],m.args[D].constraint)}catch(T){throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${m.args[D].name}' - ${m.args[D].description}`)}try{return await w.apply(f,r)}catch(D){if(l===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...r);T&&(l=T.command)}throw this._logService.error(D,l),new Error(`Running the contributed command: '${l}' failed.`)}}$executeContributedCommand(l,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(r=r.map(a=>this._argumentProcessors.reduce((w,f)=>f.processArgument(w),a)),this._executeContributedCommand(l,r)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),this._proxy.$getCommands().then(r=>(l&&(r=r.filter(a=>a[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[r,a]of this._commands){let{description:w}=a;w&&(l[r]=w)}return Promise.resolve(l)}};I=Ue([He(0,s.IExtHostRpcService),He(1,y.ILogService)],I),e.ExtHostCommands=I,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class S{constructor(l,r,a){this._commands=l,this._lookupApiCommand=r,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,r){if(!l)return;const a={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return a;const w=this._lookupApiCommand(l.command);if(w)a.id=w.internalId,a.arguments=w.args.map((f,m)=>f.convert(l.arguments&&l.arguments[m]));else if((0,C.isNonEmptyArray)(l.arguments)){const f=++this._cachIdPool;this._cache.set(f,l),r.add((0,h.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),a.$ident=f,a.id=this.delegatingCommandId,a.arguments=[f],this._logService.trace("CommandsConverter#CREATE",l.command,f)}return a}fromInternal(l){const r=R.ObjectIdentifier.of(l);return typeof r=="number"?this._cache.get(r):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const r=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=S;class o{constructor(l,r,a,w){this.name=l,this.description=r,this.validate=a,this.convert=w}optional(){return new o(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,r){return new o(l??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),o.Position=new o("position","A position in a text document",i=>M.Position.isPosition(i),E.Position.from),o.Range=new o("range","A range in a text document",i=>M.Range.isRange(i),E.Range.from),o.Selection=new o("selection","A selection in a text document",i=>M.Selection.isSelection(i),E.Selection.from),o.Number=new o("number","",i=>typeof i=="number",i=>i),o.String=new o("string","",i=>typeof i=="string",i=>i),o.CallHierarchyItem=new o("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",i=>i instanceof v.TestItemImpl,E.TestItem.from);class g{constructor(l,r){this.description=l,this.convert=r}}e.ApiCommandResult=g,g.Void=new g("no result",i=>i);class k{constructor(l,r,a,w,f){this.id=l,this.internalId=r,this.description=a,this.args=w,this.result=f}}e.ApiCommand=k}),define(be[184],Ee([0,1,8,7,59,48,13,80]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,R.isFalsyOrEmpty)(n))return;class u extends M.SymbolInformation{static to(v){const I=new u(v.name,d.SymbolKind.to(v.kind),v.containerName||"",new M.Location(h[0],d.Range.to(v.range)));return I.detail=v.detail,I.range=I.location.range,I.selectionRange=d.Range.to(v.selectionRange),I.children=v.children?v.children.map(u.to):[],I}}return n.map(u.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>M.Position.isPosition(h)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let u;for(const s of h.reverse())u=new M.SelectionRange(d.Range.to(s),u);return u}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const h=[];if(Array.isArray(n))for(let u of n)h.push(...u[1].map(d.WorkspaceSymbol.to));return h})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,C.decodeSemanticTokensDto)(n);if(h.type==="full")return new M.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,C.decodeSemanticTokensDto)(n);if(h.type==="full")return new M.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,u)=>{if(!n)return new M.CompletionList([]);const s=n.suggestions.map(v=>d.CompletionItem.to(v,u));return new M.CompletionList(s,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,u)=>t(s=>new M.CodeLens(d.Range.to(s.range),s.command&&u.fromInternal(s.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,u)=>t(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(s.command)}else{const v=new M.CodeAction(s.title,s.kind?new M.CodeActionKind(s.kind):void 0);return s.edit&&(v.edit=d.WorkspaceEdit.to(s.edit)),s.command&&(v.command=u.fromInternal(s.command)),v.isPreferred=s.isPreferred,v}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new M.ColorInformation(d.Range.to(h.range),d.Color.to(h.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>d.NotebookExclusiveDocumentPattern.to(h))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class P{static register(h){y.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=P;function t(n){return h=>{if(Array.isArray(h))return h.map(n)}}function _(n){if(!Array.isArray(n))return;const h=[];for(const u of n)E.isLocationLink(u)?h.push(d.DefinitionLink.to(u)):h.push(d.location.to(u));return h}}),define(be[185],Ee([0,1,14,52,3,6,2,59,25,8,7,5]),function(ie,e,d,M,E,A,R,C,y,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(h,u,s){const v=h.getProxy(_.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const w=this._commentControllers.get(a.handle);return w||a}else if(a&&a.$mid===7){const w=this._commentControllers.get(a.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.commentThreadHandle);return f||a}else if(a&&a.$mid===8){const w=this._commentControllers.get(a.thread.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.thread.commentThreadHandle);return f?{thread:f,text:a.text}:a}else if(a&&a.$mid===9){const w=this._commentControllers.get(a.thread.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.thread.commentThreadHandle);if(!f)return a;let m=a.commentUniqueId,D=f.getCommentByUniqueId(m);return D||a}else if(a&&a.$mid===10){const w=this._commentControllers.get(a.thread.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.thread.commentThreadHandle);if(!f)return a;let m=a.text,D=a.commentUniqueId,T=f.getCommentByUniqueId(D);return T?(T.body=m,T):a}return a}})}createCommentController(a,w,f){const m=I.handlePool++,D=new o(a,m,w,f);this._commentControllers.set(D.handle,D);const T=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(a.identifier))||[];return T.push(D),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(a.identifier),T),D.value}$createCommentThreadTemplate(a,w,f){const m=this._commentControllers.get(a);!m||m.$createCommentThreadTemplate(w,f)}async $updateCommentThreadTemplate(a,w,f){const m=this._commentControllers.get(a);!m||m.$updateCommentThreadTemplate(w,f)}$deleteCommentThread(a,w){const f=this._commentControllers.get(a);f&&f.$deleteCommentThread(w)}$provideCommentingRanges(a,w,f){const m=this._commentControllers.get(a);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const D=s.getDocument(R.URI.revive(w));return(0,d.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(D,f)).then(T=>T?T.map(p=>P.Range.from(p)):void 0)}$toggleReaction(a,w,f,m,D){const T=this._commentControllers.get(a);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const p=T.getCommentThread(w);if(p){const b=p.getCommentByUniqueId(m.uniqueIdInThread);if(T!==void 0&&b&&T.reactionHandler)return T.reactionHandler(b,i(D))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class S{constructor(a,w,f,m,D,T,p){this._commentControllerHandle=w,this._id=f,this._uri=m,this._range=D,this._comments=T,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),v.$createCommentThread(w,this.handle,this._id,this._uri,P.Range.from(this._range),p),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(w,this.handle)}});const b=this;this.value={get uri(){return b.uri},get range(){return b.range},set range(c){b.range=c},get comments(){return b.comments},set comments(c){b.comments=c},get collapsibleState(){return b.collapsibleState},set collapsibleState(c){b.collapsibleState=c},get canReply(){return b.canReply},set canReply(c){b.canReply=c},get contextValue(){return b.contextValue},set contextValue(c){b.contextValue=c},get label(){return b.label},set label(c){b.label=c},dispose:()=>{b.dispose()}}}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const a=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),w={};a("range")&&(w.range=P.Range.from(this._range)),a("label")&&(w.label=this.label),a("contextValue")&&(w.contextValue=this.contextValue),a("comments")&&(w.comments=this._comments.map(f=>g(this,f,this._commentsMap))),a("collapsibleState")&&(w.collapseState=l(this._collapseState)),a("canReply")&&(w.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(a){for(let w of this._commentsMap){let f=w[0],m=w[1];if(a===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}S._handlePool=0,Ue([(0,M.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(a,w,f,m){this._extension=a,this._handle=w,this._id=f,this._label=m,this._threads=new Map,v.$registerCommentController(this.handle,f,m);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(T){D.options=T},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(T){D.commentingRangeProvider=T},get reactionHandler(){return D.reactionHandler},set reactionHandler(T){D.reactionHandler=T},createCommentThread(T,p,b){return D.createCommentThread(T,p,b).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,w,f,m){if(typeof a=="string"){const D=new S(this.id,this.handle,a,w,f,m,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new S(this.id,this.handle,void 0,a,w,f,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(a,w){const f=new S(this.id,this.handle,void 0,R.URI.revive(a),P.Range.to(w),[],this._extension.identifier);return f.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(a,w){let f=this._threads.get(a);f&&(f.range=P.Range.to(w))}$deleteCommentThread(a){let w=this._threads.get(a);w&&w.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function g(r,a,w){let f=w.get(a);f||(f=++r.commentHandle,w.set(a,f));const m=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:f,body:P.MarkdownString.from(a.body),userName:a.author.name,userIconPath:m,label:a.label,commentReactions:a.reactions?a.reactions.map(D=>k(D)):void 0}}function k(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function l(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class vi{constructor(h,u){this._logService=u,this._provider=new Map,this._proxy=h.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,u){const s=vi._handlePool++;this._provider.set(s,{provider:h,extensionId:u}),this._proxy.$registerDecorationProvider(s,u.value);const v=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(s,null);return}let S=(0,y.asArray)(I);if(S.length<=vi._maxEventSize){this._proxy.$onDidChange(s,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,S.length);const o=S.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),g=(0,y.groupBy)(o,(i,l)=>i.rank-l.rank||(0,P.compare)(i.uri.path,l.uri.path));let k=[];e:for(let i of g){let l;for(let r of i){let a=(0,t.dirname)(r.uri.path);if(l!==a&&(l=a,k.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(s,k)});return new E.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(h,u,s){if(!this._provider.has(h))return Object.create(null);const v=Object.create(null),{provider:I,extensionId:S}=this._provider.get(h);return await Promise.all(u.map(async o=>{try{const{uri:g,id:k}=o,i=await Promise.resolve(I.provideFileDecoration(d.URI.revive(g),s));if(!i)return;try{E.FileDecoration.validate(i),v[k]=[i.propagate,i.tooltip,i.badge,i.color]}catch(l){this._logService.warn(`INVALID decoration from extension '${S.value}': ${l}`)}}catch(g){this._logService.error(g)}})),v}};_._handlePool=0,_._maxEventSize=250,_=Ue([He(0,R.IExtHostRpcService),He(1,C.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[186],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n){"use strict";var h,u,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(o,g,k,i,l,r){this._name=o,this._owner=g,this._maxDiagnosticsPerFile=k,h.set(this,void 0),u.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Je(this,s,new n.SkipList((a,w)=>i.compare(a,w)),"f"),Je(this,h,l,"f"),Je(this,u,r,"f")}dispose(){this._isDisposed||(Te(this,u,"f").fire([...Te(this,s,"f").keys()]),Te(this,h,"f")&&Te(this,h,"f").$clear(this._owner),Te(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,g){if(!o){this.clear();return}this._checkDisposed();let k=[];if(E.URI.isUri(o)){if(!g){this.delete(o);return}Te(this,s,"f").set(o,g.slice()),k=[o]}else if(Array.isArray(o)){k=[];let l;o=[...o].sort(v._compareIndexedTuplesByUri);for(const r of o){const[a,w]=r;if((!l||a.toString()!==l.toString())&&(l&&Te(this,s,"f").get(l).length===0&&Te(this,s,"f").delete(l),l=a,k.push(a),Te(this,s,"f").set(a,[])),w){const f=Te(this,s,"f").get(a);f&&f.push(...w)}else{const f=Te(this,s,"f").get(a);f&&(f.length=0)}}}if(Te(this,u,"f").fire(k),!Te(this,h,"f"))return;const i=[];for(let l of k){let r=[];const a=Te(this,s,"f").get(l);if(a)if(a.length>this._maxDiagnosticsPerFile){r=[];const w=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(let m of a)if(m.severity===w[f]&&r.push(C.Diagnostic.from(m))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=a.map(w=>C.Diagnostic.from(w));i.push([l,r])}Te(this,h,"f").$changeMany(this._owner,i)}delete(o){this._checkDisposed(),Te(this,u,"f").fire([o]),Te(this,s,"f").delete(o),Te(this,h,"f")&&Te(this,h,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Te(this,u,"f").fire([...Te(this,s,"f").keys()]),Te(this,s,"f").clear(),Te(this,h,"f")&&Te(this,h,"f").$clear(this._owner)}forEach(o,g){this._checkDisposed();for(let k of Te(this,s,"f").keys())o.apply(g,[k,this.get(k),this])}get(o){this._checkDisposed();const g=Te(this,s,"f").get(o);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Te(this,s,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,g){return o[0].toString()<g[0].toString()?-1:o[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=v,h=new WeakMap,u=new WeakMap,s=new WeakMap;let I=class Xt{constructor(o,g,k){this._logService=g,this._fileSystemInfoService=k,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Xt._mapper),this._proxy=o.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(o){const g=new t.ResourceMap;for(const k of o)g.set(k,k);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(o,g){const{_collections:k,_proxy:i,_onDidChangeDiagnostics:l,_logService:r,_fileSystemInfoService:a}=this,w=new class{$changeMany(D,T){i.$changeMany(D,T),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,D,T.length===0?"CLEARING":T)}$clear(D){i.$clear(D),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,D)}dispose(){i.dispose()}};let f;if(!g)g="_generated_diagnostic_collection_name_#"+Xt._idPool++,f=g;else if(!k.has(g))f=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do f=g+Xt._idPool++;while(k.has(f))}return new class extends v{constructor(){super(g,f,Xt._maxDiagnosticsPerFile,a.extUri,w,l);k.set(f,this)}dispose(){super.dispose(),k.delete(f)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const g=new Map,k=[];for(const i of this._collections.values())i.forEach((l,r)=>{let a=g.get(l.toString());typeof a=="undefined"&&(a=k.length,g.set(l.toString(),a),k.push([l,[]])),k[a][1]=k[a][1].concat(...r)});return k}}_getDiagnostics(o){let g=[];for(let k of this._collections.values())k.has(o)&&(g=g.concat(k.get(o)));return g}$acceptMarkersChange(o){if(!this._mirrorCollection){const g="_generated_mirror",k=new v(g,g,Xt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(g,k),this._mirrorCollection=k}for(const[g,k]of o)this._mirrorCollection.set(E.URI.revive(g),k.map(C.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=Ue([He(1,P.ILogService),He(2,_.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(be[187],Ee([0,1,2,5]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(R){this._proxy=R.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(C=>C?C.map(y=>d.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(C=>C?d.URI.revive(C):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(_,n,h){this._documentsAndEditors=n,this._logService=h,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(R.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const h=P._handlePool++;this._documentContentProviders.set(h,n),this._proxy.$registerTextContentProvider(h,_);let u;return typeof n.onDidChange=="function"&&(u=n.onDidChange(s=>{if(s.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(h,s).then(v=>{if(!v&&typeof v!="string")return;const I=this._documentsAndEditors.getDocument(s);if(!I)return;const S=(0,y.splitLines)(v);if(!I.equalLines(S))return this._proxy.$onVirtualDocumentChange(s,v)},d.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(_,n){const h=this._documentContentProviders.get(_);return h?Promise.resolve(h.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,22,7]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(h,u){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const v of s)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const v of s)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const u=this._documentsAndEditors.getDocument(h);if(u)return u}getDocument(h){const u=this.getDocumentData(h);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return u.document}ensureDocumentData(h){const u=this._documentsAndEditors.getDocument(h);if(u)return Promise.resolve(u);let s=this._documentLoader.get(h.toString());return s||(s=this._proxy.$tryOpenDocument(h).then(v=>{this._documentLoader.delete(h.toString());const I=E.URI.revive(v);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(I))},v=>(this._documentLoader.delete(h.toString()),Promise.reject(v))),this._documentLoader.set(h.toString(),s)),s}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(u=>E.URI.revive(u))}$acceptModelModeChanged(h,u){const s=E.URI.revive(h),v=this._documentsAndEditors.getDocument(s);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(u),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(h){const u=E.URI.revive(h),s=this._documentsAndEditors.getDocument(u);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(h,u){const s=E.URI.revive(h),v=this._documentsAndEditors.getDocument(s);if(!v)throw new Error("unknown document");v._acceptIsDirty(u),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,u,s){const v=E.URI.revive(h),I=this._documentsAndEditors.getDocument(v);if(!I)throw new Error("unknown document");I._acceptIsDirty(s),I.onEvents(u);let S;u.isUndoing?S=t.TextDocumentChangeReason.Undo:u.isRedoing&&(S=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:u.changes.map(o=>({range:C.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:S}))}setWordDefinitionFor(h,u){(0,R.setWordDefinitionFor)(h,u)}}e.ExtHostDocuments=_}),define(be[49],Ee([0,1,40,3,6,2,4,5,88,12,94,8,15,20,11,232,103]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(g,k){this._extHostRpc=g,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const k=[],i=[],l=[];if(g.removedDocuments)for(const r of g.removedDocuments){const a=A.URI.revive(r),w=this._documents.get(a);w?.unref()&&(this._documents.delete(a),k.push(w.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const a=A.URI.revive(r.uri);let w=this._documents.get(a);if(w&&a.scheme!==u.Schemas.vscodeNotebookCell&&a.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);w||(w=new I(new y.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(a,w),i.push(w.value)),w.ref()}if(g.removedEditors)for(const r of g.removedEditors){const a=this._editors.get(r);this._editors.delete(r),a&&l.push(a)}if(g.addedEditors)for(const r of g.addedEditors){const a=A.URI.revive(r.documentUri);d.ok(this._documents.has(a),`document '${a}' does not exist`),d.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const w=this._documents.get(a).value,f=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>w.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(m=>_.Range.to(m)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}g.newActiveEditor!==void 0&&(d.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,E.dispose)(k),(0,E.dispose)(l),g.removedDocuments&&this._onDidRemoveDocuments.fire(k),g.addedDocuments&&this._onDidAddDocuments.fire(i),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return s.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return g?k:k?.value}allEditors(){return[...this._editors.values()]}};S=Ue([He(0,P.IExtHostRpcService),He(1,n.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,23]),function(ie,e,d,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const u=this._schemes.indexOf(h);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),u=[];let s,v,I=14,S=14;for(const o of h){let g=s?(0,y.commonPrefixLength)(s,o):0;for(g===0?v=1:v=S;g<o.length;g++)g+1===o.length?(I=S,S=9):S+=1,u.push([v,o.toUpperCase().charCodeAt(g),S]),u.push([v,o.toLowerCase().charCodeAt(g),S]),v=S;s=o,S=I}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new C.StateMachine(u)}}provideDocumentLinks(h){this._initStateMachine();const u=[],s=C.LinkComputer.computeLinks({getLineContent(v){return h.lineAt(v-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const v of s){const I=R.DocumentLink.to(v);I.target&&u.push(I)}return u}}class _{constructor(h,u){this._extHostLanguageFeatures=u,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,u,s,v={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(I,s);let S=2;v.isCaseSensitive&&(S+=1024),v.isReadonly&&(S+=2048),typeof s.copy=="function"&&(S+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(I,u,S).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${u}`),console.error(g)});const o=s.onDidChangeFile(g=>{const k=[];for(const i of g){let{uri:l,type:r}=i;if(l.scheme!==u)continue;let a;switch(r){case A.FileChangeType.Changed:a=0;break;case A.FileChangeType.Created:a=1;break;case A.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}k.push({resource:l,type:a})}this._proxy.$onFileSystemChange(I,k)});return(0,E.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(h){const{type:u,ctime:s,mtime:v,size:I,permissions:S}=h;return{type:u,ctime:s,mtime:v,size:I,permissions:S}}$stat(h,u){return Promise.resolve(this._getFsProvider(h).stat(d.URI.revive(u))).then(s=>_._asIStat(s))}$readdir(h,u){return Promise.resolve(this._getFsProvider(h).readDirectory(d.URI.revive(u)))}$readFile(h,u){return Promise.resolve(this._getFsProvider(h).readFile(d.URI.revive(u))).then(s=>P.VSBuffer.wrap(s))}$writeFile(h,u,s,v){return Promise.resolve(this._getFsProvider(h).writeFile(d.URI.revive(u),s.buffer,v))}$delete(h,u,s){return Promise.resolve(this._getFsProvider(h).delete(d.URI.revive(u),s))}$rename(h,u,s,v){return Promise.resolve(this._getFsProvider(h).rename(d.URI.revive(u),d.URI.revive(s),v))}$copy(h,u,s,v){const I=this._getFsProvider(h);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(d.URI.revive(u),d.URI.revive(s),v))}$mkdir(h,u){return Promise.resolve(this._getFsProvider(h).createDirectory(d.URI.revive(u)))}$watch(h,u,s,v){const I=this._getFsProvider(h).watch(d.URI.revive(s),v);this._watches.set(u,I)}$unwatch(h,u){const s=this._watches.get(u);s&&(s.dispose(),this._watches.delete(u))}$open(h,u,s){const v=this._getFsProvider(h);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(d.URI.revive(u),s))}$close(h,u){const s=this._getFsProvider(h);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(u))}$read(h,u,s,v){const I=this._getFsProvider(h);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const S=P.VSBuffer.alloc(v);return Promise.resolve(I.read(u,s,S.buffer,0,v)).then(o=>S.slice(0,o))}$write(h,u,s,v){const I=this._getFsProvider(h);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(u,s,v.buffer,0,v.byteLength))}_getFsProvider(h){const u=this._fsProvider.get(h);if(!u){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return u}}e.ExtHostFileSystem=_}),define(be[71],Ee([0,1,5,60,7,23,4,12,37]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(_,n){const h=_.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return h.$stat(u).catch(Ut._handleError)},readDirectory(u){return h.$readdir(u).catch(Ut._handleError)},createDirectory(u){return h.$mkdir(u).catch(Ut._handleError)},async readFile(u){return h.$readFile(u).then(s=>s.buffer).catch(Ut._handleError)},writeFile(u,s){return h.$writeFile(u,A.VSBuffer.wrap(s)).catch(Ut._handleError)},delete(u,s){return h.$delete(u,{recursive:!1,useTrash:!1,...s}).catch(Ut._handleError)},rename(u,s,v){return h.$rename(u,s,{overwrite:!1,...v}).catch(Ut._handleError)},copy(u,s,v){return h.$copy(u,s,{overwrite:!1,...v}).catch(Ut._handleError)},isWritableFileSystem(u){const s=n.getCapabilities(u);if(typeof s=="number")return!(s&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};P=Ue([He(0,C.IExtHostRpcService),He(1,y.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,48]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(R,C,y,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=y,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,C,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(ie,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(R){this._handlePool=0,this._proxy=R.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,R),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,22,8,7,5,9,42,13,10,234,6,80,53,63,194,16,3]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentSymbols(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(ee,Y);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,j)=>{let oe=ae.location.range.start.compareTo(j.location.range.start);return oe===0&&(oe=j.location.range.end.compareTo(ae.location.range.end)),oe});const Y=[],ee=[];for(const ae of x){const j={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(j),Y.push(j);break}const oe=ee[ee.length-1];if(y.Range.containsRange(oe.range,j.range)&&!y.Range.equalsRange(oe.range,j.range)){oe.children&&oe.children.push(j),ee.push(j);break}ee.pop()}}return Y}}class g{constructor(x,Y,ee){this._documents=x,this._commands=Y,this._provider=ee,this._cache=new s.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(ee,Y);if(!ae||Y.isCancellationRequested)return;const j=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(j,oe);const fe={cacheId:j,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)fe.lenses.push({cacheId:[j,Ae],range:E.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,oe)});return fe}async resolveCodeLens(x,Y){const ee=x.cacheId&&this._cache.get(...x.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Y),ae||(ae=ee),Y.isCancellationRequested)return;const j=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!j)return x.command=this._commands.toInternal(ae.command??g._badCmd,j),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function k(qe){return Array.isArray(qe)?qe.map(E.DefinitionLink.from):qe?[E.DefinitionLink.from(qe)]:[]}class i{constructor(x,Y){this._documents=x,this._provider=Y}async provideDefinition(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideDefinition(ae,j,ee);return k(oe)}}class l{constructor(x,Y){this._documents=x,this._provider=Y}async provideDeclaration(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideDeclaration(ae,j,ee);return k(oe)}}class r{constructor(x,Y){this._documents=x,this._provider=Y}async provideImplementation(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideImplementation(ae,j,ee);return k(oe)}}class a{constructor(x,Y){this._documents=x,this._provider=Y}async provideTypeDefinition(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideTypeDefinition(ae,j,ee);return k(oe)}}class w{constructor(x,Y){this._documents=x,this._provider=Y}async provideHover(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideHover(ae,j,ee);if(!(!oe||(0,P.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(j)),oe.range||(oe.range=new A.Range(j,j)),E.Hover.from(oe)}}class f{constructor(x,Y){this._documents=x,this._provider=Y}async provideEvaluatableExpression(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideEvaluatableExpression(ae,j,ee);if(oe)return E.EvaluatableExpression.from(oe)}}class m{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlineValues(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=await this._provider.provideInlineValues(j,E.Range.to(Y),E.InlineValueContext.to(ee),ae);if(Array.isArray(oe))return oe.map(fe=>E.InlineValue.from(fe))}}class D{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentHighlights(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideDocumentHighlights(ae,j,ee);if(Array.isArray(oe))return oe.map(E.DocumentHighlight.from)}}class T{constructor(x,Y){this._documents=x,this._provider=Y}async provideLinkedEditingRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.provideLinkedEditingRanges(ae,j,ee);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,P.coalesce)(oe.ranges.map(E.Range.from)),wordPattern:oe.wordPattern}}}class p{constructor(x,Y){this._documents=x,this._provider=Y}async provideReferences(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Position.to(Y),fe=await this._provider.provideReferences(j,oe,ee,ae);if(Array.isArray(fe))return fe.map(E.location.from)}}class b{constructor(x,Y,ee,ae,j,oe,fe){this._documents=x,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=j,this._extension=oe,this._apiDeprecation=fe,this._cache=new s.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=_.Selection.isISelection(Y)?E.Selection.to(Y):E.Range.to(Y),fe=[];for(const z of this._diagnostics.getDiagnostics(x))if(oe.intersection(z.range)&&fe.push(z)>b._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:E.CodeActionTriggerKind.to(ee.trigger)},xe=await this._provider.provideCodeActions(j,oe,Ae,ae);if(!(0,P.isNonEmptyArray)(xe)||ae.isCancellationRequested)return;const $e=this._cache.add(xe),we=new n.DisposableStore;this._disposables.set($e,we);const Ze=[];for(let z=0;z<xe.length;z++){const J=xe[z];!J||(b._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,we)})):(Ae.only&&(J.kind?Ae.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,z],title:J.title,command:J.command&&this._commands.toInternal(J.command,we),diagnostics:J.diagnostics&&J.diagnostics.map(E.Diagnostic.from),edit:J.edit&&E.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(x,Y){const[ee,ae]=x,j=this._cache.get(ee,ae);if(!j||b._isCommand(j)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(j,Y)??j;return oe?.edit?E.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}b._maxCodeActionsPerFile=1e3;class c{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentFormattingEdits(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentFormattingEdits(ae,Y,ee);if(Array.isArray(j))return j.map(E.TextEdit.from)}}class F{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeFormattingEdits(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Range.to(Y),fe=await this._provider.provideDocumentRangeFormattingEdits(j,oe,ee,ae);if(Array.isArray(fe))return fe.map(E.TextEdit.from)}}class O{constructor(x,Y){this._documents=x,this._provider=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Y,ee,ae,j){const oe=this._documents.getDocument(x),fe=E.Position.to(Y),Ae=await this._provider.provideOnTypeFormattingEdits(oe,fe,ee,ae,j);if(Array.isArray(Ae))return Ae.map(E.TextEdit.from)}}class V{constructor(x,Y){this._provider=x,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Y){const ee=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,Y);if((0,P.isNonEmptyArray)(ae))for(const j of ae){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const oe=R.IdObject.mixin(E.WorkspaceSymbol.from(j));this._symbolCache.set(oe._id,j),ee.symbols.push(oe)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(x,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Y);return ae&&(0,M.mixin)(x,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const Y=this._resultCache.get(x);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class K{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Position.to(Y);try{const fe=await this._provider.provideRenameEdits(j,oe,ee,ae);return fe?E.WorkspaceEdit.from(fe):void 0}catch(fe){const Ae=K._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(x,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),j=E.Position.to(Y);try{const oe=await this._provider.prepareRename(ae,j,ee);let fe,Ae;if(A.Range.isRange(oe)?(fe=oe,Ae=ae.getText(oe)):(0,t.isObject)(oe)&&(fe=oe.range,Ae=oe.placeholder),!fe||!Ae)return;if(fe.start.line>j.line||fe.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(fe),text:Ae}}catch(oe){const fe=K._asMessage(oe);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class W{constructor(x,Y){this.resultId=x,this.tokens=Y}}class Q{constructor(x,Y){this._documents=x,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),j=Y!==0?this._previousResults.get(Y):null;let oe=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,j.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return j&&this._previousResults.delete(Y),oe?(oe=Q._fixProvidedSemanticTokens(oe),this._send(Q._convertToEdits(j,oe),oe)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return Q._isSemanticTokens(x)?Q._isCorrectSemanticTokens(x)?x:new A.SemanticTokens(new Uint32Array(x.data),x.resultId):Q._isSemanticTokensEdits(x)?Q._isCorrectSemanticTokensEdits(x)?x:new A.SemanticTokensEdits(x.edits.map(Y=>new A.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Y of x.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Y){if(!Q._isSemanticTokens(Y)||!x||!x.tokens)return Y;const ee=x.tokens,ae=ee.length,j=Y.data,oe=j.length;let fe=0;const Ae=Math.min(ae,oe);for(;fe<Ae&&ee[fe]===j[fe];)fe++;if(fe===ae&&fe===oe)return new A.SemanticTokensEdits([],Y.resultId);let xe=0;const $e=Ae-fe;for(;xe<$e&&ee[ae-xe-1]===j[oe-xe-1];)xe++;return new A.SemanticTokensEdits([{start:fe,deleteCount:ae-fe-xe,data:j.subarray(fe,oe-xe)}],Y.resultId)}_send(x,Y){if(Q._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new W(x.resultId,x.data)),(0,h.encodeSemanticTokensDto)({id:ee,type:"full",data:x.data})}if(Q._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return Q._isSemanticTokens(Y)?this._previousResults.set(ee,new W(Y.resultId,Y.data)):this._previousResults.set(ee,new W(x.resultId)),(0,h.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=Q;class ${constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(Y),ee);return j?this._send(j):null}_send(x){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=$;class U{constructor(x,Y,ee,ae,j){this._documents=x,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=j,this._cache=new s.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Position.to(Y),fe=j.getWordRangeAtPosition(oe)||new A.Range(oe,oe),Ae=fe.with({end:oe}),xe=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(j,oe,ae,E.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const we=Array.isArray($e)?new A.CompletionList($e):$e,Ze=U.supportsResolving(this._provider)?this._cache.add(we.items):this._cache.add([]),z=new n.DisposableStore;this._disposables.set(Ze,z);const J=[],he={x:Ze,b:J,a:{replace:E.Range.from(fe),insert:E.Range.from(Ae)},c:we.isIncomplete||void 0,d:xe.elapsed()};for(let Oe=0;Oe<we.items.length;Oe++){const Ve=we.items[Oe],tt=this._convertCompletionItem(Ve,[Ze,Oe],Ae,fe);J.push(tt)}return he}async resolveCompletionItem(x,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Y);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Y,ee,ae){const j=this._disposables.get(Y[0]);if(!j)throw Error("DisposableStore is missing...");const oe={x:Y,a:x.label,b:x.kind!==void 0?E.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(E.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(x.command,j)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=x.textEdit.newText):typeof x.insertText=="string"?oe.h=x.insertText:x.insertText instanceof A.SnippetString&&(oe.h=x.insertText.value,oe.i|=4);let fe;return x.textEdit?fe=x.textEdit.range:x.range&&(fe=x.range),A.Range.isRange(fe)?oe.j=E.Range.from(fe):fe&&(!ee?.isEqual(fe.inserting)||!ae?.isEqual(fe.replacing))&&(oe.j={insert:E.Range.from(fe.inserting),replace:E.Range.from(fe.replacing)}),oe}}class H{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._commands=ee,this._cache=new s.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Position.to(Y),fe=await this._provider.provideInlineCompletionItems(j,oe,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:E.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!fe||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Ae.items);let $e;return{pid:xe,items:Ae.items.map((we,Ze)=>{let z;return we.command&&($e||($e=new n.DisposableStore,this._disposables.set(xe,$e)),z=this._commands.toInternal(we.command,$e)),{text:we.text,range:we.range?E.Range.from(we.range):void 0,command:z,idx:Ze}})}}disposeCompletions(x){this._cache.delete(x);const Y=this._disposables.get(x);Y&&Y.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Y){const ee=this._cache.get(x,Y);ee&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new S.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Y=G.map.get(x);return Y||(Y=new G,G.map.set(x,Y)),Y}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=G,G.map=new WeakMap;class ue{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new s.Cache("SignatureHelp")}async provideSignatureHelp(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Position.to(Y),fe=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(j,oe,ae,fe);if(Ae){const xe=this._cache.add([Ae]);return{...E.SignatureHelp.from(Ae),id:xe}}}reviveContext(x){let Y;if(x.activeSignatureHelp){const ee=E.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return{...x,activeSignatureHelp:Y}}releaseSignatureHelp(x){this._cache.delete(x)}}class q{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlayHints(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideInlayHints(ae,E.Range.to(Y),ee);return j?{hints:j.map(E.InlayHint.from)}:void 0}}class le{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new s.Cache("DocumentLink")}async provideLinks(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(ee,Y);if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(E.DocumentLink.from)};{const j=this._cache.add(ae),oe={links:[],id:j};for(let fe=0;fe<ae.length;fe++){if(!le._validateLink(ae[fe]))continue;const Ae=E.DocumentLink.from(ae[fe]);Ae.cacheId=[j,fe],oe.links.push(Ae)}return oe}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Y){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Y);if(!(!ae||!le._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class se{constructor(x,Y){this._documents=x,this._provider=Y}async provideColors(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(ee,Y);return Array.isArray(ae)?ae.map(oe=>({color:E.Color.from(oe.color),range:E.Range.from(oe.range)})):[]}async provideColorPresentations(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Range.to(Y.range),oe=E.Color.to(Y.color),fe=await this._provider.provideColorPresentations(oe,{document:ae,range:j},ee);if(!!Array.isArray(fe))return fe.map(E.ColorPresentation.from)}}class ve{constructor(x,Y){this._documents=x,this._provider=Y}async provideFoldingRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideFoldingRanges(ae,Y,ee);if(!!Array.isArray(j))return j.map(E.FoldingRange.from)}}class Fe{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}async provideSelectionRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=Y.map(E.Position.to),oe=await this._provider.provideSelectionRanges(ae,j,ee);if(!(0,P.isNonEmptyArray)(oe))return[];if(oe.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<j.length;Ae++){const xe=[];fe.push(xe);let $e=j[Ae],we=oe[Ae];for(;;){if(!we.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(E.SelectionRange.from(we)),!we.parent)break;$e=we.range,we=we.parent}}return fe}}class Me{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.prepareCallHierarchy(ae,j,ee);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideCallsTo(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!j)return j.map(oe=>({from:this._cacheAndConvertItem(x,oe.from),fromRanges:oe.fromRanges.map(fe=>E.Range.from(fe))}))}async provideCallsFrom(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!j)return j.map(oe=>({to:this._cacheAndConvertItem(x,oe.to),fromRanges:oe.fromRanges.map(fe=>E.Range.from(fe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=E.CallHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Ne{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),j=E.Position.to(Y),oe=await this._provider.prepareTypeHierarchy(ae,j,ee);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideSupertypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!j)return j.map(oe=>this._cacheAndConvertItem(x,oe))}async provideSubtypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!j)return j.map(oe=>this._cacheAndConvertItem(x,oe))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=E.TypeHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Qe{constructor(x,Y){this.adapter=x,this.extension=Y}}class ze{constructor(x,Y,ee,ae,j,oe,fe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=x.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=j,this._logService=oe,this._apiDeprecation=fe}_transformDocumentSelector(x){return(0,P.coalesce)((0,P.asArray)(x).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:E.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new A.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return ze._handlePool++}_withAdapter(x,Y,ee,ae,j=!1){const oe=this._adapter.get(x);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Y){let fe;oe.extension&&(fe=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Ae=ee(oe.adapter,oe.extension),xe=oe.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),$e=>{j&&$e instanceof I.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Qe(x,Y)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Y,ee,ae){const j=this._addNewAdapter(new o(this._documents,ee),x),oe=ae&&ae.label||ze._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(Y),oe),this._createDisposable(j)}$provideDocumentSymbols(x,Y,ee){return this._withAdapter(x,o,ae=>ae.provideDocumentSymbols(d.URI.revive(Y),ee),void 0)}registerCodeLensProvider(x,Y,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new g(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),j);let oe=this._createDisposable(ae);if(j!==void 0){const fe=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(j));oe=A.Disposable.from(oe,fe)}return oe}$provideCodeLenses(x,Y,ee){return this._withAdapter(x,g,ae=>ae.provideCodeLenses(d.URI.revive(Y),ee),void 0)}$resolveCodeLens(x,Y,ee){return this._withAdapter(x,g,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(x,Y){this._withAdapter(x,g,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(x,Y,ee,ae){return this._withAdapter(x,i,j=>j.provideDefinition(d.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(x,Y,ee){const ae=this._addNewAdapter(new l(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(x,Y,ee,ae){return this._withAdapter(x,l,j=>j.provideDeclaration(d.URI.revive(Y),ee,ae),[])}registerImplementationProvider(x,Y,ee){const ae=this._addNewAdapter(new r(this._documents,ee),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(x,Y,ee,ae){return this._withAdapter(x,r,j=>j.provideImplementation(d.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new a(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(x,Y,ee,ae){return this._withAdapter(x,a,j=>j.provideTypeDefinition(d.URI.revive(Y),ee,ae),[])}registerHoverProvider(x,Y,ee,ae){const j=this._addNewAdapter(new w(this._documents,ee),x);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(Y)),this._createDisposable(j)}$provideHover(x,Y,ee,ae){return this._withAdapter(x,w,j=>j.provideHover(d.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(x,Y,ee,ae){const j=this._addNewAdapter(new f(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(Y)),this._createDisposable(j)}$provideEvaluatableExpression(x,Y,ee,ae){return this._withAdapter(x,f,j=>j.provideEvaluatableExpression(d.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(x,Y,ee,ae){const j=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new m(this._documents,ee),x);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Y),j);let fe=this._createDisposable(oe);if(j!==void 0){const Ae=ee.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(j));fe=A.Disposable.from(fe,Ae)}return fe}$provideInlineValues(x,Y,ee,ae,j){return this._withAdapter(x,m,oe=>oe.provideInlineValues(d.URI.revive(Y),ee,ae,j),void 0)}registerDocumentHighlightProvider(x,Y,ee){const ae=this._addNewAdapter(new D(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(x,Y,ee,ae){return this._withAdapter(x,D,j=>j.provideDocumentHighlights(d.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new T(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,Y,ee,ae){return this._withAdapter(x,T,async j=>{const oe=await j.provideLinkedEditingRanges(d.URI.revive(Y),ee,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?ze._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Y,ee){const ae=this._addNewAdapter(new p(this._documents,ee),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(x,Y,ee,ae,j){return this._withAdapter(x,p,oe=>oe.provideReferences(d.URI.revive(Y),ee,ae,j),void 0)}registerCodeActionProvider(x,Y,ee,ae){const j=new n.DisposableStore,oe=this._addNewAdapter(new b(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Y),{providedKinds:ae?.providedCodeActionKinds?.map(fe=>fe.value),documentation:ae?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,j)}))},ze._extLabel(x),Boolean(ee.resolveCodeAction)),j.add(this._createDisposable(oe)),j}$provideCodeActions(x,Y,ee,ae,j){return this._withAdapter(x,b,oe=>oe.provideCodeActions(d.URI.revive(Y),ee,ae,j),void 0)}$resolveCodeAction(x,Y,ee){return this._withAdapter(x,b,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(x,Y){this._withAdapter(x,b,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new c(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,Y,ee,ae){return this._withAdapter(x,c,j=>j.provideDocumentFormattingEdits(d.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new F(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,Y,ee,ae,j){return this._withAdapter(x,F,oe=>oe.provideDocumentRangeFormattingEdits(d.URI.revive(Y),ee,ae,j),void 0)}registerOnTypeFormattingEditProvider(x,Y,ee,ae){const j=this._addNewAdapter(new O(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(Y),ae,x.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(x,Y,ee,ae,j,oe){return this._withAdapter(x,O,fe=>fe.provideOnTypeFormattingEdits(d.URI.revive(Y),ee,ae,j,oe),void 0)}registerWorkspaceSymbolProvider(x,Y){const ee=this._addNewAdapter(new V(Y,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,Y,ee){return this._withAdapter(x,V,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,Y,ee){return this._withAdapter(x,V,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(x,Y){this._withAdapter(x,V,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(x,Y,ee){const ae=this._addNewAdapter(new K(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),K.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(x,Y,ee,ae,j){return this._withAdapter(x,K,oe=>oe.provideRenameEdits(d.URI.revive(Y),ee,ae,j),void 0)}$resolveRenameLocation(x,Y,ee,ae){return this._withAdapter(x,K,j=>j.resolveRenameLocation(d.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(x,Y,ee,ae){const j=this._nextHandle(),oe=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Qe(new Q(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(Y),ae,oe);let fe=this._createDisposable(j);if(oe){const Ae=ee.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));fe=A.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,Q,j=>j.provideDocumentSemanticTokens(d.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(x,Y){this._withAdapter(x,Q,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(x,Y,ee,ae){const j=this._addNewAdapter(new $(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(Y),ae),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,$,j=>j.provideDocumentRangeSemanticTokens(d.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(x,Y,ee,ae){const j=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(Y),ae,U.supportsResolving(ee),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(j)}$provideCompletionItems(x,Y,ee,ae,j){return this._withAdapter(x,U,oe=>oe.provideCompletionItems(d.URI.revive(Y),ee,ae,j),void 0)}$resolveCompletionItem(x,Y,ee){return this._withAdapter(x,U,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(x,Y){this._withAdapter(x,U,ee=>ee.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(x,Y,ee){const ae=this._addNewAdapter(new H(this._documents,ee,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideInlineCompletions(x,Y,ee,ae,j){return this._withAdapter(x,H,oe=>oe.provideInlineCompletions(d.URI.revive(Y),ee,ae,j),void 0)}$handleInlineCompletionDidShow(x,Y,ee){this._withAdapter(x,H,async ae=>{ae.handleDidShowCompletionItem(Y,ee)},void 0)}$freeInlineCompletionsList(x,Y){this._withAdapter(x,H,async ee=>{ee.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(x,Y,ee,ae){const j=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new ue(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Y),j),this._createDisposable(oe)}$provideSignatureHelp(x,Y,ee,ae,j){return this._withAdapter(x,ue,oe=>oe.provideSignatureHelp(d.URI.revive(Y),ee,ae,j),void 0)}$releaseSignatureHelp(x,Y){this._withAdapter(x,ue,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(x,Y,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new q(this._documents,ee),x);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(Y),ae);let oe=this._createDisposable(j);if(ae!==void 0){const fe=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));oe=A.Disposable.from(oe,fe)}return oe}$provideInlayHints(x,Y,ee,ae){return this._withAdapter(x,q,j=>j.provideInlayHints(d.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(x,Y,ee){const ae=this._addNewAdapter(new le(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,Y,ee){return this._withAdapter(x,le,ae=>ae.provideLinks(d.URI.revive(Y),ee),void 0)}$resolveDocumentLink(x,Y,ee){return this._withAdapter(x,le,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(x,Y){this._withAdapter(x,le,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(x,Y,ee){const ae=this._addNewAdapter(new se(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(x,Y,ee){return this._withAdapter(x,se,ae=>ae.provideColors(d.URI.revive(Y),ee),[])}$provideColorPresentations(x,Y,ee,ae){return this._withAdapter(x,se,j=>j.provideColorPresentations(d.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(x,Y,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new ve(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),j);let oe=this._createDisposable(ae);if(j!==void 0){const fe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));oe=A.Disposable.from(oe,fe)}return oe}$provideFoldingRanges(x,Y,ee,ae){return this._withAdapter(x,ve,j=>j.provideFoldingRanges(d.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(x,Y,ee,ae){return this._withAdapter(x,Fe,j=>j.provideSelectionRanges(d.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(x,Y,ee,ae){return this._withAdapter(x,Me,j=>Promise.resolve(j.prepareSession(d.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,j=>j.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,j=>j.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(x,Y){this._withAdapter(x,Me,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}registerTypeHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareTypeHierarchy(x,Y,ee,ae){return this._withAdapter(x,Ne,j=>Promise.resolve(j.prepareSession(d.URI.revive(Y),ee,ae)),void 0)}$provideTypeHierarchySupertypes(x,Y,ee,ae){return this._withAdapter(x,Ne,j=>j.provideSupertypes(Y,ee,ae),void 0)}$provideTypeHierarchySubtypes(x,Y,ee,ae){return this._withAdapter(x,Ne,j=>j.provideSubtypes(Y,ee,ae),void 0)}$releaseTypeHierarchy(x,Y){this._withAdapter(x,Ne,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,C.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:ze._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?ze._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?ze._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:ze._serializeRegExp(x.beforeText),afterText:x.afterText?ze._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?ze._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(ze._serializeOnEnterRule)}setLanguageConfiguration(x,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const j=this._nextHandle(),oe={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ze._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ze._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ze._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,Y,oe),this._createDisposable(j)}$setWordDefinitions(x){for(const Y of x)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,14,6]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(t,_,n){this._documents=_,this._commands=n,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,_){await this._proxy.$changeLanguage(t,_);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,_){const n=t.version,h=M.Position.from(_),u=await this._proxy.$tokensAtPosition(t.uri,h),s={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!u)return s;const v={range:M.Range.to(u.range),type:M.TokenType.to(u.type)};return!v.range.contains(_)||n!==t.version?s:v}createLanguageStatusItem(t,_,n){const h=this._handlePool++,u=this._proxy,s=this._ids,v=`${t.identifier.value}/${_}`;if(s.has(v))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);s.add(v);const I={selector:n,id:_,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let S,o=new C.DisposableStore;const g=()=>{S?.dispose(),S=(0,R.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(h,{id:v,name:I.name??t.displayName??t.name,source:t.displayName??t.name,selector:I.selector,label:I.text,detail:I.detail??"",severity:I.severity===E.LanguageStatusSeverity.Error?A.default.Error:I.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:I.command&&this._commands.toInternal(I.command,o),accessibilityInfo:I.accessibilityInformation})},0)},k={dispose(){o.dispose(),S?.dispose(),u.$removeLanguageStatus(h),s.delete(v)},get id(){return I.id},get name(){return I.name},set name(i){I.name=i,g()},get selector(){return I.selector},set selector(i){I.selector=i,g()},get text(){return I.text},set text(i){I.text=i,g()},get detail(){return I.detail},set detail(i){I.detail=i,g()},get severity(){return I.severity},set severity(i){I.severity=i,g()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(i){I.accessibilityInformation=i,g()},get command(){return I.command},set command(i){I.command=i,g()}};return g(),k}}e.ExtHostLanguages=y}),define(be[196],Ee([0,1,5,15,30]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let R=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(d.MainContext.MainThreadMessageService)}showMessage(y,P,t,_,n){const h={extension:y};let u;typeof _=="string"||A(_)?u=[_,...n]:(h.modal=_?.modal,h.useCustom=_?.useCustom,h.detail=_?.detail,u=n),h.useCustom&&(0,E.checkProposedApiEnabled)(y);const s=[];for(let v=0;v<u.length;v++){const I=u[v];if(typeof I=="string")s.push({title:I,handle:v,isCloseAffordance:!1});else if(typeof I=="object"){let{title:S,isCloseAffordance:o}=I;s.push({title:S,isCloseAffordance:!!o,handle:v})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,t,h,s).then(v=>{if(typeof v=="number")return u[v]})}};R=Ue([He(1,M.ILogService)],R),e.ExtHostMessageService=R}),define(be[197],Ee([0,1,23,3,58,6,20,9,10,2,63,5,8,7,47,172,93]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(o,g,k,i,l){this._textDocumentsAndEditors=k,this._textDocuments=i,this._extensionStoragePaths=l,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const a=r.notebookEditor?.notebookUri,w=r.cell.handle,m=this._documents.get(a)?.getCell(w);if(m)return m.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const g=this._editors.get(o);if(!g)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(o){for(const[g,k]of this._editors)if(k.apiEditor===o)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,g){const k=this._documents.get(o);if(!k&&!g)throw new Error(`NO notebook document for '${o}'`);return k}_getProviderData(o){const g=this._notebookContentProviders.get(o);if(!g)throw new Error(`NO provider for '${o}'`);return g}registerNotebookContentProvider(o,g,k,i,l){if((0,C.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:o,provider:k});let r;return k.onDidChangeNotebookContentOptions&&(r=k.onDidChangeNotebookContentOptions(()=>{const a=n.NotebookDocumentContentOptions.from(k.options);this._notebookProxy.$updateNotebookProviderOptions(g,a)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},g,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,l)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(o,g){if(!g)return;const k=g.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(g.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:g.displayName,filenamePattern:k,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,g,k){const i=I._notebookStatusBarItemProviderHandlePool++,l=typeof k.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,k),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,l,g);let r;return l!==void 0&&(r=k.onDidChangeCellStatusBarItems(a=>this._notebookProxy.$emitCellStatusBarEvent(l))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,l),r&&r.dispose()})}async createNotebookDocument(o){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return P.URI.revive(g)}async openNotebookDocument(o){const g=this._documents.get(o);if(g)return g.apiNotebook;const k=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(P.URI.revive(k));return(0,y.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,g){P.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let k;typeof g=="object"?k={position:n.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(n.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:k={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,k),l=i&&this._editors.get(i)?.apiEditor;if(l)return l;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,g,k,i){const l=this._notebookStatusBarItemProviders.get(o),r=P.URI.revive(g),a=this._documents.get(r);if(!a||!l)return;const w=a.getCellFromIndex(k);if(!w)return;const f=await l.provideCellStatusBarItems(w.apiCell,i);if(!f)return;const m=new A.DisposableStore,D=this._statusBarCache.add([m]),p=(Array.isArray(f)?f:[f]).map(b=>n.NotebookStatusBarItem.from(b,this._commandsConverter,m));return{cacheId:D,items:p}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,g,k,i,l){if((0,C.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,k),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},g,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,l)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,g,k){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const l=await i.deserializeNotebook(g.buffer,k);return new u.SerializableObjectWithBuffers(n.NotebookData.from(l))}async $notebookToData(o,g,k){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const l=await i.serializeNotebook(n.NotebookData.to(g.value),k);return d.VSBuffer.wrap(l)}async $openNotebook(o,g,k,i,l){const{provider:r}=this._getProviderData(o),a=await r.openNotebook(P.URI.revive(g),{backupId:k,untitledDocumentData:i?.buffer},l);return new u.SerializableObjectWithBuffers({metadata:a.metadata??Object.create(null),cells:a.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,g,k){const i=this.getNotebookDocument(P.URI.revive(g)),{provider:l}=this._getProviderData(o);return await l.saveNotebook(i.apiNotebook,k),!0}async $saveNotebookAs(o,g,k,i){const l=this.getNotebookDocument(P.URI.revive(g)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(P.URI.revive(k),l.apiNotebook,i),!0}async $backupNotebook(o,g,k){const i=this.getNotebookDocument(P.URI.revive(g)),l=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension),a=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),w=P.URI.joinPath(r,a),f=await l.provider.backupNotebook(i.apiNotebook,{destination:w},k);return i.updateBackup(f),f.id}_createExtHostEditor(o,g,k){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const i=new v.ExtHostNotebookEditor(g,this._notebookEditorsProxy,o,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this._editors.set(g,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const k of o.value.removedDocuments){const i=P.URI.revive(k),l=this._documents.get(i);l&&(l.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(l.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const k=[];for(const i of o.value.addedDocuments){const l=P.URI.revive(i.uri);if(this._documents.has(l))throw new Error(`adding EXISTING notebook ${l} `);const r=this,a=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(w){r._onDidChangeNotebookCells.fire(w)},emitCellOutputsChange(w){r._onDidChangeCellOutputs.fire(w)},emitCellMetadataChange(w){r._onDidChangeCellMetadata.fire(w)},emitCellExecutionStateChange(w){r._onDidChangeCellExecutionState.fire(w)}},l,i);k.push(...i.cells.map(w=>s.ExtHostCell.asModelAddData(a.apiNotebook,w))),this._documents.get(l)?.dispose(),this._documents.set(l,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(o.value.addedEditors)for(const k of o.value.addedEditors){if(this._editors.has(k.id))return;const i=P.URI.revive(k.documentUri),l=this._documents.get(i);l&&this._createExtHostEditor(l,k.id,k)}const g=[];if(o.value.removedEditors)for(const k of o.value.removedEditors){const i=this._editors.get(k);i&&(this._editors.delete(k),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),g.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const k=new Set;this._visibleNotebookEditors.forEach(i=>k.add(i.id));for(const i of this._editors.values()){const l=k.has(i.id);i._acceptVisibility(l)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,53,15,5,12,8]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(_,n){const h=y._Keys.nextId();_.$registerNotebookEditorDecorationType(h,C.NotebookDecorationRenderOptions.from(n)),this.value={key:h,dispose(){_.$removeNotebookEditorDecorationType(h)}}}}y._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(_,n,h){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new y(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const h=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&h._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&h._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(_[n]))}};P=Ue([He(0,E.ILogService),He(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(be[199],Ee([0,1,13,14,21,3,6,20,2,25,15,5,8,7,66,165,30,47]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let S=class{constructor(l,r,a,w){this._initData=r,this._extHostNotebook=a,this._logService=w,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=l.getProxy(_.MainContext.MainThreadNotebookKernels)}createNotebookController(l,r,a,w,f,m){for(let G of this._kernelData.values())if(G.controller.id===r&&P.ExtensionIdentifier.equals(l.identifier,G.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const D=this._handlePool++,T=this;this._logService.trace(`NotebookController[${D}], CREATED by ${l.identifier.value}, ${r}`);const p=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${l.identifier}'`);let b=!1;const c=new R.DisposableStore,F=new A.Emitter,O=new A.Emitter,V={id:`${l.identifier.value}/${r}`,notebookType:a,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:w||l.identifier.value,preloads:m?m.map(n.NotebookRendererScript.from):[]};let K=f??p,W;this._proxy.$addKernel(D,V).catch(G=>{console.log(G),b=!0});let Q=0;const $=()=>{if(b)return;const G=++Q;Promise.resolve().then(()=>{G===Q&&this._proxy.$updateKernel(D,V)})},U=new C.ResourceMap,H={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return V.label},set label(G){V.label=G??l.displayName??l.name,$()},get detail(){return V.detail??""},set detail(G){V.detail=G,$()},get description(){return V.description??""},set description(G){V.description=G,$()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(G){V.supportedLanguages=G,$()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(G){V.supportsExecutionOrder=G,$()},get rendererScripts(){return V.preloads?V.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(G){K=G??p},get interruptHandler(){return W},set interruptHandler(G){W=G,V.supportsInterrupt=Boolean(G),$()},createNotebookCellExecution(G){if(b)throw new Error("notebook controller is DISPOSED");if(!U.has(G.notebook.uri))throw T._logService.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(U.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${G.notebook.uri.toString()}`);return T._createNotebookCellExecution(G)},dispose:()=>{b||(this._logService.trace(`NotebookController[${D}], DISPOSED`),b=!0,this._kernelData.delete(D),c.dispose(),F.dispose(),O.dispose(),this._proxy.$removeKernel(D))},updateNotebookAffinity(G,ue){T._proxy.$updateNotebookPriority(D,G.uri,ue)},onDidReceiveMessage:O.event,postMessage(G,ue){return(0,v.checkProposedApiEnabled)(l),T._proxy.$postMessage(D,ue&&T._extHostNotebook.getIdByEditor(ue),G)},asWebviewUri(G){return(0,v.checkProposedApiEnabled)(l),(0,u.asWebviewUri)(G,T._initData.remote)}};return this._kernelData.set(D,{extensionId:l.identifier,controller:H,onDidReceiveMessage:O,onDidChangeSelection:F,associatedNotebooks:U}),H}$acceptNotebookAssociation(l,r,a){const w=this._kernelData.get(l);if(w){const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(r));a?w.associatedNotebooks.set(f.uri,!0):w.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),a),w.onDidChangeSelection.fire({selected:a,notebook:f.apiNotebook})}}async $executeCells(l,r,a){const w=this._kernelData.get(l);if(!w)return;const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(r)),m=[];for(let D of a){const T=f.getCell(D);T&&m.push(T.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),m.length),await w.controller.executeHandler.call(w.controller,m,f.apiNotebook,w.controller)}catch(D){this._logService.error(`NotebookController[${l}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(l,r,a){const w=this._kernelData.get(l);if(!w)return;const f=this._extHostNotebook.getNotebookDocument(y.URI.revive(r));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,f.apiNotebook);else for(let m of a){const D=f.getCell(m);D&&this._activeExecutions.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,r,a){const w=this._kernelData.get(l);if(!w)return;const f=this._extHostNotebook.getEditorById(r);w.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:a}))}_createNotebookCellExecution(l){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const w=new g(a.notebook,a,this._proxy);this._activeExecutions.set(a.uri,w);const f=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),f.dispose(),this._activeExecutions.delete(a.uri))});return w.asApiObject()}};S=Ue([He(3,t.ILogService)],S),e.ExtHostNotebookKernels=S;var o;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(o||(o={}));class g extends R.Disposable{constructor(l,r,a){super();this._document=l,this._cell=r,this._proxy=a,this._handle=g.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new k(10,w=>this.update(w)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const r=Array.isArray(l)?l:[l];return this._proxy.$updateExecutions(new I.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let r=this._cell;if(l&&(r=this._document.getCellFromApiCell(l)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(l){return l.map(r=>{const a=h.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return a===r.items?n.NotebookCellOutput.from(r):n.NotebookCellOutput.from({items:a,id:r.id,metadata:r.metadata})})}async updateOutputs(l,r,a){const w=this.cellIndexToHandle(r),f=this.validateAndConvertOutputs((0,d.asArray)(l));return this.updateSoon({editType:s.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:w,append:a,outputs:f})}async updateOutputItems(l,r,a){return l=h.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(l),!0),this.updateSoon({editType:s.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:l.map(n.NotebookCellOutputItem.from),outputId:r.id,append:a})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(a){l._executionOrder=a,l.update([{editType:s.CellExecutionUpdateType.ExecutionState,executionHandle:l._handle,executionOrder:l._executionOrder}])},start(a){if(l._state===o.Resolved||l._state===o.Started)throw new Error("Cannot call start again");l._state=o.Started,l._onDidChangeState.fire(),l.update({editType:s.CellExecutionUpdateType.ExecutionState,executionHandle:l._handle,runStartTime:a})},end(a,w){if(l._state===o.Resolved)throw new Error("Cannot call resolve twice");l._state=o.Resolved,l._onDidChangeState.fire(),l.updateSoon({editType:s.CellExecutionUpdateType.Complete,executionHandle:l._handle,runEndTime:w,lastRunSuccess:a}),l._collector.flush(),l._proxy.$removeExecution(l._handle)},clearOutput(a){return l.verifyStateForOutput(),l.updateOutputs([],a,!1)},appendOutput(a,w){return l.verifyStateForOutput(),l.updateOutputs(a,w,!0)},replaceOutput(a,w){return l.verifyStateForOutput(),l.updateOutputs(a,w,!1)},appendOutputItems(a,w){return l.verifyStateForOutput(),l.updateOutputItems(a,w,!0)},replaceOutputItems(a,w){return l.verifyStateForOutput(),l.updateOutputItems(a,w,!1)}})}}g.HANDLE=0;class k{constructor(l,r){this.delay=l,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>l.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(C,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,y,P){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(y)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(C,y){if(!C.contributes?.notebookRenderer?.some(n=>n.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const P=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,h,u)=>{const s=P?n:v=>{const I={};t.set(I,v.editor),n({editor:I,message:v.message})};return this.getOrCreateEmitterFor(y).event(s,h,u)},postMessage:(n,h)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,h]=[h,n]);const u=P?h:t.get(h),s=u&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(s?.id,y,n)}}}getOrCreateEmitterFor(C){let y=this._rendererMessageEmitters.get(C);return y||(y=new d.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,y),y)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,23,4,12]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends E.Disposable{constructor(u,s,v,I,S){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=S,this._id=S.$register(this.name,s,v,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?A.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(s=>this._proxy.$clear(s,u))}show(u,s){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof u=="boolean"?u:s)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class P extends y{constructor(u,s,v){super(u,!1,void 0,s,v)}append(u){super.append(u),this._id.then(s=>this._proxy.$append(s,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends y{constructor(u,s,v){super(u,!0,s,void 0,v)}append(u){throw new Error("Not supported")}}class _{constructor(u,s){this.name=u,this._channel=s}append(u){this._channel.then(s=>s.append(u))}appendLine(u){this._channel.then(s=>s.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,s){this._channel.then(v=>v.show(u,s))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=_;let n=class{constructor(u){this._proxy=u.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,s){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new P(u,s.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,s){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new t(u,s,this._proxy)}};n=Ue([He(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,14,21,3,6,5,2,7,16,13,35,44]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(u,s,v){const I=u.getProxy(R.MainContext.MainThreadQuickOpen);class S{constructor(f,m){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=m}showQuickPick(f,m,D,T=M.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(f),b=++this._instances,c=I.$show(b,{title:D?.title,placeHolder:D?.placeHolder,matchOnDescription:D?.matchOnDescription,matchOnDetail:D?.matchOnDetail,ignoreFocusLost:D?.ignoreFocusOut,canPickMany:D?.canPickMany},T),F={},O=c.then(()=>F);return Promise.race([O,p]).then(V=>{if(V!==F)return p.then(K=>{const W=[];for(let Q=0;Q<K.length;Q++){const $=K[Q];let U,H,G,ue,q;typeof $=="string"?U=$:(U=$.label,H=$.description,G=$.detail,ue=$.picked,q=$.alwaysShow),W.push({label:U,description:H,handle:Q,detail:G,picked:ue,alwaysShow:q})}return D&&typeof D.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{D.onDidSelectItem(K[Q])}),I.$setItems(b,W),c.then(Q=>{if(typeof Q=="number")return K[Q];if(Array.isArray(Q))return Q.map($=>K[$])})})}).then(void 0,V=>{if(!(0,P.isPromiseCanceledError)(V))return I.$setError(b,V),Promise.reject(V)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,m=M.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,I.$input(f,typeof this._validateInput=="function",m).then(void 0,D=>{if(!(0,P.isPromiseCanceledError)(D))return Promise.reject(D)})}$validateInput(f){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,m=M.CancellationToken.None){const D=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!D)return;const T=await this._workspace.getWorkspaceFolders2();if(!!T)return T.find(p=>p.uri.toString()===D.uri.toString())}createQuickPick(f,m){const D=new r(f,m,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(f){const m=new a(f,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(f,m){const D=this._sessions.get(f);D&&D._fireDidChangeValue(m)}$onDidAccept(f){const m=this._sessions.get(f);m&&m._fireDidAccept()}$onDidChangeActive(f,m){const D=this._sessions.get(f);D instanceof r&&D._fireDidChangeActive(m)}$onDidChangeSelection(f,m){const D=this._sessions.get(f);D instanceof r&&D._fireDidChangeSelection(m)}$onDidTriggerButton(f,m){const D=this._sessions.get(f);D&&D._fireDidTriggerButton(m)}$onDidTriggerItemButton(f,m,D){const T=this._sessions.get(f);T instanceof r&&T._fireDidTriggerItemButton(m,D)}$onDidHide(f){const m=this._sessions.get(f);m&&m._fireDidHide()}}class o{constructor(f,m){this._extensionId=f,this._onDidDispose=m,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((m,D)=>{const T=m===y.QuickInputButtons.Back?-1:D;this._handlesToButtons.set(T,m)}),this.update({buttons:f.map((m,D)=>({...l(m),tooltip:m.tooltip,handle:m===y.QuickInputButtons.Back?-1:D}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const m=this._handlesToButtons.get(f);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(f){if(!this._disposed){for(const m of Object.keys(f)){const D=f[m];this._pendingUpdate[m]=D===void 0?null:D}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function g(w){if(w instanceof y.ThemeIcon)return{id:w.id};const f=i(w),m=k(w);return{dark:typeof f=="string"?C.URI.file(f):f,light:typeof m=="string"?C.URI.file(m):m}}function k(w){return typeof w=="object"&&"light"in w?w.light:w}function i(w){return typeof w=="object"&&"dark"in w?w.dark:w}function l(w){const f=g(w.iconPath);let m,D;return"id"in f?D=n.ThemeIcon.asClassName(f):m=f,{iconPath:m,iconClass:D}}class r extends o{constructor(f,m,D){super(f,D);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((m,D)=>{this._handlesToItems.set(D,m),this._itemsToHandles.set(m,D)}),this.update({items:f.map((m,D)=>({label:m.label,description:m.description,handle:D,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((T,p)=>({...l(T),tooltip:T.tooltip,handle:p})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(f){this._keepScrollPosition=f,this.update({keepScrollPosition:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(f){const m=(0,t.coalesce)(f.map(D=>this._handlesToItems.get(D)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(f){const m=(0,t.coalesce)(f.map(D=>this._handlesToItems.get(D)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(f,m){const D=this._handlesToItems.get(f);if(!D||!D.buttons||!D.buttons.length)return;const T=D.buttons[m];T&&this._onDidTriggerItemButtonEmitter.fire({button:T,item:D})}}class a extends o{constructor(f,m){super(f,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?_.default.Error:_.default.Ignore})}}return new S(s,v)}e.createExtHostQuickOpen=h}),define(be[202],Ee([0,1,2,3,52,6,14,5,13,108,15,25,30,44,8]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function s(f){if(f)return typeof f.iconPath=="string"?d.URI.file(f.iconPath):d.URI.isUri(f.iconPath)||h.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function v(f,m){if(!f.iconPath&&!m.iconPath)return 0;if(f.iconPath){if(!m.iconPath)return 1}else return-1;const D=typeof f.iconPath=="string"?f.iconPath:d.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,T=typeof m.iconPath=="string"?m.iconPath:d.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(D,T)}function I(f,m){let D=0;if(f.strikeThrough!==m.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==m.faded)return f.faded?1:-1;if(f.tooltip!==m.tooltip)return(f.tooltip||"").localeCompare(m.tooltip||"");if(D=v(f,m),D!==0)return D;if(f.light&&m.light)D=v(f.light,m.light);else{if(f.light)return 1;if(m.light)return-1}if(D!==0)return D;if(f.dark&&m.dark)D=v(f.dark,m.dark);else{if(f.dark)return 1;if(m.dark)return-1}return D}function S(f,m){if(f.command!==m.command)return f.command<m.command?-1:1;if(f.title!==m.title)return f.title<m.title?-1:1;if(f.tooltip!==m.tooltip){if(f.tooltip!==void 0&&m.tooltip!==void 0)return f.tooltip<m.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(f.arguments===m.arguments)return 0;if(f.arguments)if(m.arguments){if(f.arguments.length!==m.arguments.length)return f.arguments.length-m.arguments.length}else return 1;else return-1;for(let D=0;D<f.arguments.length;D++){const T=f.arguments[D],p=m.arguments[D];if(T!==p)return T<p?-1:1}return 0}function o(f,m){let D=(0,P.comparePaths)(f.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(D!==0)return D;if(f.command&&m.command)D=S(f.command,m.command);else{if(f.command)return 1;if(m.command)return-1}if(D!==0)return D;if(f.decorations&&m.decorations)D=I(f.decorations,m.decorations);else{if(f.decorations)return 1;if(m.decorations)return-1}return D}function g(f,m){for(let D=0;D<f.length;D++)if(f[D]!==m[D])return!1;return!0}function k(f,m){return f.command===m.command&&f.title===m.title&&f.tooltip===m.tooltip&&(f.arguments&&m.arguments?g(f.arguments,m.arguments):f.arguments===m.arguments)}function i(f,m){return(0,y.equals)(f,m,k)}class l{constructor(m,D,T){this._extension=m,this._proxy=D,this._sourceControlHandle=T,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,n.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,D){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,D)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=l;class r{constructor(m,D,T,p,b){this._proxy=m,this._commands=D,this._sourceControlHandle=T,this._id=p,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,D){const T=this._resourceStatesCommandsMap.get(m);return T?(0,R.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],D)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(o),T=(0,y.sortedDiff)(this._resourceSnapshot,m,o).map(c=>{const F=c.toInsert.map(O=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,O);const K=O.resourceUri;let W;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const ve=new A.DisposableStore;W=this._commands.converter.toInternal(O.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,O.command);const Q=s(O.decorations),$=O.decorations&&s(O.decorations.light)||Q,U=O.decorations&&s(O.decorations.dark)||Q,H=[$,U],G=O.decorations&&O.decorations.tooltip||"",ue=O.decorations&&!!O.decorations.strikeThrough,q=O.decorations&&!!O.decorations.faded,le=O.contextValue||"";return{rawResource:[V,K,H,G,ue,q,le,W],handle:V}});return{start:c.start,deleteCount:c.deleteCount,toInsert:F}}),p=T.map(({start:c,deleteCount:F,toInsert:O})=>[c,F,O.map(V=>V.rawResource)]),b=T.reverse();for(const{start:c,deleteCount:F,toInsert:O}of b){const V=O.map(W=>W.handle),K=this._handlesSnapshot.splice(c,F,...V);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=m,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class a{constructor(m,D,T,p,b,c){this._proxy=D,this._commands=T,this._id=p,this._label=b,this._rootUri=c,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new l(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,b,c)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=m;const D=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:D})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=m;const D=(m||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:D})}get selected(){return this._selected}createResourceGroup(m,D){const T=new r(this._proxy,this._commands,this.handle,m,D),p=M.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,p),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const m=[],D=[];for(const[T,p]of this.createdResourceGroups){p.dispose();const b=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});M.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),b.dispose(),this._groups.delete(T.handle),this._proxy.$unregisterGroup(this.handle,T.handle)}),m.push([T.handle,T.id,T.label,T.features]);const c=T._takeResourceStateSnapshot();c.length>0&&D.push([T.handle,c]),this._groups.set(T.handle,T)}this._proxy.$registerGroups(this.handle,m,D),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(D=>{const T=D._takeResourceStateSnapshot();T.length!==0&&m.push([D.handle,T])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}a._handlePool=0,Ue([(0,E.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),Ue([(0,E.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let w=class Bi{constructor(m,D,T){this._commands=D,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=m.getProxy(C.MainContext.MainThreadSCM),this._telemetry=m.getProxy(C.MainContext.MainThreadTelemetry),D.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const b=this._sourceControls.get(p.sourceControlHandle);if(!b)return p;const c=b.getResourceGroup(p.groupHandle);return c?c.getResourceState(p.handle):p}else if(p&&p.$mid===4){const b=this._sourceControls.get(p.sourceControlHandle);return b?b.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const b=this._sourceControls.get(p.handle);return b||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,D,T,p){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,D,T,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const b=Bi._handlePool++,c=new a(m,this._proxy,this._commands,D,T,p);this._sourceControls.set(b,c);const F=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(m.identifier))||[];return F.push(c),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(m.identifier),F),c}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const D=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(m.identifier)),T=D&&D[D.length-1];return T&&T.inputBox}$provideOriginalResource(m,D,T){const p=d.URI.revive(D);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,p.toString());const b=this._sourceControls.get(m);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(p,T)).then(c=>c||null)}$onInputBoxValueChange(m,D){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const T=this._sourceControls.get(m);return T&&T.inputBox.$onInputBoxValueChange(D),Promise.resolve(void 0)}$executeResourceCommand(m,D,T,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,D,T);const b=this._sourceControls.get(m);if(!b)return Promise.resolve(void 0);const c=b.getResourceGroup(D);return c?c.$executeResourceCommand(T,p):Promise.resolve(void 0)}$validateInput(m,D,T){this.logService.trace("ExtHostSCM#$validateInput",m);const p=this._sourceControls.get(m);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>p.inputBox.validateInput(D,T)).then(b=>{if(!b)return Promise.resolve(void 0);const c=u.MarkdownString.fromStrict(b.message);return c?Promise.resolve([c,b.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};w._handlePool=0,w=Ue([He(2,t.ILogService)],w),e.ExtHostSCM=w});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[203],Ee([0,1,7,5,127,6,8]),function(ie,e,d,M,E,A,R){"use strict";var C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(h,u,s,v,I=d.StatusBarAlignment.Left,S){C.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Je(this,C,h,"f"),Je(this,y,u,"f"),this._entryId=P.ID_GEN++,this._extension=s,this._id=v,this._alignment=I,this._priority=S}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!P.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Te(this,y,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Te(this,y,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let u;this._name?u=this._name:u=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let s=this._color;this._backgroundColor&&(s=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const v=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,h,u,this._text,v,this._command?.internal,s,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,C=new WeakMap,y=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const u={message:h};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const s=this._messages.indexOf(u);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(h,u){this._proxy=h.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new t(this)}createStatusBarEntry(h,u,s,v){return new P(this._proxy,this._commands,h,u,s,v)}setStatusBarMessage(h,u){const s=this._statusMessage.setMessage(h);let v;return typeof u=="number"?v=setTimeout(()=>s.dispose(),u):typeof u!="undefined"&&u.then(()=>s.dispose(),()=>s.dispose()),new d.Disposable(()=>{s.dispose(),clearTimeout(v)})}}e.ExtHostStatusBar=_}),define(be[72],Ee([0,1,5,3,4]),function(ie,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,y){this._proxy.$registerExtensionStorageKeysToSync(C,y)}getValue(C,y,P){return this._proxy.$getValue(C,y).then(t=>t||P)}setValue(C,y,P){return this._proxy.$setValue(C,y,P)}$acceptValue(C,y,P){this._onDidChangeStorage.fire({shared:C,key:y,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ue([He(0,M.IExtHostInitDataService),He(1,E.ILogService),He(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[38],Ee([0,1,3,5,4,2,12,6,7,128,16,167,21,36,149,150,44,10]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class S{constructor(f,m,D,T){this._proxy=f,this._id=m,this._creationOptions=D,this._name=T,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},get state(){return p._state},sendText(b,c=!0){p._checkDisposed(),p._proxy.$sendText(p._id,b,c)},show(b){p._checkDisposed(),p._proxy.$show(p._id,b)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,I.withNullAsUndefined)(f.shellPath),shellArgs:(0,I.withNullAsUndefined)(f.shellArgs),cwd:(0,I.withNullAsUndefined)(f.cwd),env:(0,I.withNullAsUndefined)(f.env),icon:(0,I.withNullAsUndefined)(r(f.iconPath)),color:v.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,I.withNullAsUndefined)(f.message),strictEnv:(0,I.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,I.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,I.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,I.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this._serializeParentTerminal(f.location,m?.resolvedExtHostIdentifier,m?.location)})}async createExtensionTerminal(f,m,D,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:D,color:v.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(f,m)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,m,D){return typeof f=="object"&&"parentTerminal"in f?m?{parentTerminal:m}:void 0:(D&&(f=D),f)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,m){return f===this._cols&&m===this._rows||f===0||m===0?!1:(this._cols=f,this._rows=m,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=S;class o{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,m){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:m})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose&&this._pty.onDidClose((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(m=>this._onProcessOverrideDimensions.fire(m&&{cols:m.columns,rows:m.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(m=>this._onProcessTitleChanged.fire(m)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=o;let g=1,k=class extends C.Disposable{constructor(f,m){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=m.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[D,T]of this._terminalProcesses)T.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,m){const D=new S(this._proxy,(0,h.generateUuid)(),f,f.name),T=new o(f.pty);return D.createExtensionTerminal(this._resolveLocation(f.location),m?.resolvedExtHostIdentifier,r(f.iconPath),a(f.color)).then(p=>{const b=this._setupExtHostProcessListeners(p,T);this._terminalProcessDisposables[p]=b}),this._terminals.push(D),D.value}_resolveLocation(f){return typeof f=="object"&&"viewColumn"in f&&f.viewColumn!==void 0?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:typeof f=="object"&&"parentTerminal"in f?void 0:(f===u.TerminalLocation.Editor||f===u.TerminalLocation.Panel,f)}attachPtyToTerminal(f,m){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const T=new o(m),p=this._setupExtHostProcessListeners(f,T);this._terminalProcessDisposables[f]=p}async $acceptActiveTerminalChanged(f){const m=this._activeTerminal;if(f===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const D=this._getTerminalById(f);D&&(this._activeTerminal=D,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,m){const D=this._getTerminalById(f);D&&this._onDidWriteTerminalData.fire({terminal:D.value,data:m})}async $acceptTerminalDimensions(f,m,D){const T=this._getTerminalById(f);T&&T.setDimensions(m,D)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(f,m,D){this._terminalProcesses.get(f)?.resize(m,D)}async $acceptTerminalTitleChange(f,m){const D=this._getTerminalById(f);D&&(D.name=m)}async $acceptTerminalClosed(f,m){const D=this._getTerminalObjectIndexById(this._terminals,f);if(D!==null){const T=this._terminals.splice(D,1)[0];T.setExitCode(m),this._onDidCloseTerminal.fire(T.value)}}$acceptTerminalOpened(f,m,D,T){if(m){const c=this._getTerminalObjectIndexById(this._terminals,m);if(c!==null){this._terminals[c]._id=f,this._onDidOpenTerminal.fire(this.terminals[c]),this._terminals[c].isOpen=!0;return}}const p={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:A.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},b=new S(this._proxy,f,p,D);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(f,m){const D=this._getTerminalById(f);D&&D._setProcessId(m)}async $startExtensionTerminal(f,m){const D=this._getTerminalById(f);if(!D)return{message:(0,P.localize)(0,null,f)};D.isOpen||await new Promise(p=>{const b=this.onDidOpenTerminal(async c=>{c===D.value&&(b.dispose(),p())})});const T=this._terminalProcesses.get(f);T?T.startSendingEvents(m):this._extensionTerminalAwaitingStart[f]={initialDimensions:m}}_setupExtHostProcessListeners(f,m){const D=new C.DisposableStore;D.add(m.onProcessReady(p=>this._proxy.$sendProcessReady(f,p.pid,p.cwd))),D.add(m.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(f,p))),this._bufferer.startBuffering(f,m.onProcessData),D.add(m.onProcessExit(p=>this._onProcessExit(f,p))),m.onProcessOverrideDimensions&&D.add(m.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(f,p))),this._terminalProcesses.set(f,m);const T=this._extensionTerminalAwaitingStart[f];return T&&m instanceof o&&(m.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),D}$acceptProcessAckDataEvent(f,m){this._terminalProcesses.get(f)?.acknowledgeDataEvent(m)}$acceptProcessInput(f,m){this._terminalProcesses.get(f)?.input(m)}$acceptTerminalInteraction(f){const m=this._getTerminalById(f);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptProcessResize(f,m,D){try{this._terminalProcesses.get(f)?.resize(m,D)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(f,m){this._terminalProcesses.get(f)?.shutdown(m)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(m=>this._proxy.$sendProcessInitialCwd(f,m))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(m=>this._proxy.$sendProcessCwd(f,m))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,m,D){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,D),this._proxy.$registerProfileProvider(m,f.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}async $createContributedProfileTerminal(f,m){const D=new n.CancellationTokenSource().token,T=await this._profileProviders.get(f)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,m);return}this.createTerminalFromOptions(T.options,m)}}async $provideLinks(f,m){const D=this._getTerminalById(f);if(!D)return[];this._terminalLinkCache.delete(f);const T=this._terminalLinkCancellationSource.get(f);T&&T.dispose(!0);const p=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,p);const b=[],c={terminal:D.value,line:m},F=[];for(const K of this._linkProviders)F.push(new Promise(async W=>{p.token.onCancellationRequested(()=>W({provider:K,links:[]}));const Q=await K.provideTerminalLinks(c,p.token)||[];p.token.isCancellationRequested||W({provider:K,links:Q})}));const O=await Promise.all(F);if(p.token.isCancellationRequested)return[];const V=new Map;for(const K of O)K&&K.links.length>0&&b.push(...K.links.map(W=>{const Q={id:g++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return V.set(Q.id,{provider:K.provider,link:W}),Q}));return this._terminalLinkCache.set(f,V),b}$activateLink(f,m){const D=this._terminalLinkCache.get(f)?.get(m);!D||D.provider.handleTerminalLink(D.link)}_onProcessExit(f,m){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const D=this._terminalProcessDisposables[f];D&&(D.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,m)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,m){const D=this._getTerminalObjectIndexById(f,m);return D!==null?f[D]:null}_getTerminalObjectIndexById(f,m){let D=null;return f.some((T,p)=>T._id===m?(D=p,!0):!1),D}getEnvironmentVariableCollection(f){let m=this._environmentVariableCollections.get(f.identifier.value);return m||(m=new i,this._setEnvironmentVariableCollection(f.identifier.value,m)),m}_syncEnvironmentVariableCollection(f,m){const D=(0,_.serializeEnvironmentVariableCollection)(m.map);this._proxy.$setEnvironmentVariableCollection(f,m.persistent,D.length===0?void 0:D)}$initEnvironmentVariableCollections(f){f.forEach(m=>{const D=m[0],T=new i(m[1]);this._setEnvironmentVariableCollection(D,T)})}$acceptDefaultProfile(f,m){this._defaultProfile=f,this._defaultAutomationProfile=m}_setEnvironmentVariableCollection(f,m){this._environmentVariableCollections.set(f,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,m)})}};k=Ue([He(1,R.IExtHostRpcService)],k),e.BaseExtHostTerminalService=k;class i{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,m){this._setIfDiffers(f,{value:m,type:y.EnvironmentVariableMutatorType.Replace})}append(f,m){this._setIfDiffers(f,{value:m,type:y.EnvironmentVariableMutatorType.Append})}prepend(f,m){this._setIfDiffers(f,{value:m,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,m){const D=this.map.get(f);(!D||D.value!==m.value||D.type!==m.type)&&(this.map.set(f,m),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,m){this.map.forEach((D,T)=>f.call(m,T,D,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let l=class extends k{constructor(f){super(!1,f)}createTerminal(f,m,D){throw new t.NotSupportedError}createTerminalFromOptions(f,m){throw new t.NotSupportedError}};l=Ue([He(0,R.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function r(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function a(w){return v.ThemeColor.isThemeColor(w)?w:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[204],Ee([0,1,13,23,21,3,235,58,6,22,10,36,5,12,46,8,7,175,90,67]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let k=class{constructor(c,F){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=c.getProxy(n.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new l(this.proxy),F.registerArgumentProcessor({processArgument:O=>O?.$mid===13?s.TestItem.toItemFromContext(O):O})}createTestController(c,F){if(this.controllers.has(c))throw new Error(`Attempt to insert a duplicate controller with ID "${c}"`);const O=new y.DisposableStore,V=O.add(new I.SingleUseTestCollection(c));V.root.label=F;const K=new Map,W=this.proxy,Q={items:V.root.children,get label(){return F},set label(U){F=U,V.root.label=U,W.$updateControllerLabel(c,F)},get id(){return c},createRunProfile:(U,H,G,ue,q)=>{let le=(0,C.hash)(U);for(;K.has(le);)le++;const se=new T(this.proxy,c,le,U,H,G,ue,q);return K.set(le,se),se},createTestItem(U,H,G){return new u.TestItemImpl(c,U,H,G)},createTestRun:(U,H,G=!0)=>this.runTracker.createTestRun(c,V,U,H,G),set resolveHandler(U){V.resolveHandler=U},get resolveHandler(){return V.resolveHandler},dispose:()=>{O.dispose()}};Q.createRunConfiguration=Q.createRunProfile,W.$registerTestController(c,F),O.add((0,y.toDisposable)(()=>W.$unregisterTestController(c)));const $={controller:Q,collection:V,profiles:K};return this.controllers.set(c,$),O.add((0,y.toDisposable)(()=>this.controllers.delete(c))),O.add(V.onDidGenerateDiff(U=>W.$publishDiff(c,U))),Q}createTestObserver(){return this.observer.checkout()}async runTests(c,F=E.CancellationToken.None){const O=r(c);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get(O.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:c.include?.map(K=>K.id)??[V.collection.root.id],profileGroup:p[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:c.exclude?.map(K=>K.id)},F)}$provideFileCoverage(c,F,O){return(0,d.mapFind)(this.runTracker.trackers,K=>K.id===c?K.getCoverage(F):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(c,F,O,V){return(0,d.mapFind)(this.runTracker.trackers,W=>W.id===c?W.getCoverage(F):void 0)?.resolveFileCoverage(O,V)??Promise.resolve([])}$configureRunProfile(c,F){this.controllers.get(c)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(c){this.results=Object.freeze(c.map(F=>(0,P.deepFreeze)(s.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(c,F){const O=this.controllers.get(o.TestId.fromString(c).controllerId)?.collection;O&&(await O.expand(c,F<0?Infinity:F),O.flushDiff())}$acceptDiff(c){this.observer.applyDiff(c)}async $runControllerTests(c,F){const O=this.controllers.get(c.controllerId);if(!O)return;const{collection:V,profiles:K}=O,W=K.get(c.profileId);if(!W)return;const Q=c.testIds.map(G=>V.tree.get(G)).filter(t.isDefined),$=c.excludeExtIds.map(G=>O.collection.tree.get(G)).filter(t.isDefined).filter(G=>Q.some(ue=>ue.fullId.compare(G.fullId)===2));if(!Q.length)return;const U=new v.TestRunRequest(Q.some(G=>G.actual instanceof u.TestItemRootImpl)?void 0:Q.map(G=>G.actual),$.map(G=>G.actual),W),H=this.runTracker.prepareForMainThreadTestRun(U,a.fromInternal(c,O.collection),F);try{await W.runHandler(U,F)}finally{H.isRunning&&!F.isCancellationRequested&&await A.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(c){c===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(c)}};k=Ue([He(0,h.IExtHostRpcService)],k),e.ExtHostTesting=k;class i extends y.Disposable{constructor(c,F,O){super();this.dto=c,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:V}of this.tasks.values())V.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(c){return this.tasks.get(c)?.coverage}createRun(c){const F=this.dto.id,O=this.dto.controllerId,V=(0,_.generateUuid)(),K=new w(this.proxy,F,V),W=H=>(G,...ue)=>{if($){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),H(G,...ue))},Q=(H,G)=>{const ue=G instanceof Array?G.map(s.TestMessage.from):[s.TestMessage.from(G)];if(H.uri&&H.range){const q={range:s.Range.from(H.range),uri:H.uri};for(const le of ue)le.location=le.location||q}this.proxy.$appendTestMessagesInRun(F,V,o.TestId.fromExtHostTestItem(H,O).toString(),ue)};let $=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:c,get coverageProvider(){return K.coverageProvider},set coverageProvider(H){K.coverageProvider=H},enqueued:W(H=>{this.proxy.$updateTestStateInRun(F,V,o.TestId.fromExtHostTestItem(H,O).toString(),1)}),skipped:W(H=>{this.proxy.$updateTestStateInRun(F,V,o.TestId.fromExtHostTestItem(H,O).toString(),5)}),started:W(H=>{this.proxy.$updateTestStateInRun(F,V,o.TestId.fromExtHostTestItem(H,O).toString(),2)}),errored:W((H,G,ue)=>{Q(H,G),this.proxy.$updateTestStateInRun(F,V,o.TestId.fromExtHostTestItem(H,O).toString(),6,ue)}),failed:W((H,G,ue)=>{Q(H,G),this.proxy.$updateTestStateInRun(F,V,o.TestId.fromExtHostTestItem(H,O).toString(),4,ue)}),passed:W((H,G)=>{this.proxy.$updateTestStateInRun(F,V,o.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,G)}),appendOutput:(H,G,ue)=>{$||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(F,V,M.VSBuffer.fromString(H),G&&s.location.from(G),ue&&o.TestId.fromExtHostTestItem(ue,O).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(F,V),this.tasks.delete(V),this.isRunning||this.dispose())}};return this.tasks.set(V,{run:U,coverage:K}),this.proxy.$startedTestRunTask(F,{id:V,name:c,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(c){if(!(c instanceof u.TestItemImpl))throw new u.InvalidTestItemError(c.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(c,this.dto.controllerId).toString()))return;const F=[],O=this.dto.colllection.root;for(;;){const V=s.TestItem.from(c);if(F.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),c===O))break;c=c.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class l{constructor(c){this.proxy=c,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(c,F,O){return this.getTracker(c,F,O)}cancelRunById(c){for(const F of this.tracked.values())if(F.id===c){F.dispose();return}}cancelAllRuns(){for(const c of this.tracked.values())c.dispose()}createTestRun(c,F,O,V,K){const W=this.tracked.get(O);if(W)return W.createRun(V);const Q=a.fromPublic(c,F,O,K),$=r(O);this.proxy.$startedExtensionTestRun({controllerId:c,profile:$&&{group:p[$.kind],id:$.profileId},exclude:O.exclude?.map(H=>H.id)??[],id:Q.id,include:O.include?.map(H=>H.id)??[F.root.id],persist:K});const U=this.getTracker(O,Q);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(Q.id)),U.createRun(V)}getTracker(c,F,O){const V=new i(F,this.proxy,O);return this.tracked.set(c,V),V.onEnd(()=>this.tracked.delete(c)),V}}e.TestRunCoordinator=l;const r=b=>{if(!!b.profile){if(!(b.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return b.profile}};class a{constructor(c,F,O,V,K,W){this.controllerId=c,this.id=F,this.isPersisted=K,this.colllection=W,this.includePrefix=O.map(Q=>Q+"\0"),this.excludePrefix=V.map(Q=>Q+"\0")}static fromPublic(c,F,O,V){return new a(c,(0,_.generateUuid)(),O.include?.map(K=>o.TestId.fromExtHostTestItem(K,c).toString())??[c],O.exclude?.map(K=>o.TestId.fromExtHostTestItem(K,c).toString())??[],V,F)}static fromInternal(c,F){return new a(c.controllerId,c.runId,c.testIds,c.excludeExtIds,!0,F)}isIncluded(c){const F=o.TestId.fromExtHostTestItem(c,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(F===O||F.startsWith(O))return!1;for(const O of this.includePrefix)if(F===O||F.startsWith(O))return!0;return!1}}e.TestRunDto=a;class w{constructor(c,F,O){this.proxy=c,this.runId=F,this.taskId=O}set coverageProvider(c){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!c||(this._coverageProvider=c,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(c){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(c))());try{return(await this.fileCoverage)?.map(s.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(c,F){const O=await this.fileCoverage;let V=O?.[c];return!this._coverageProvider||!O||!V?[]:(V.detailedCoverage||(V=O[c]=await this._coverageProvider.resolveFileCoverage?.(V,F)??V),V.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class f extends S.IncrementalChangeCollector{constructor(c){super();this.emitter=c,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(c){this.added.add(c)}update(c){Object.assign(c.revived,s.TestItem.toPlain(c.item)),this.added.has(c)||this.updated.add(c)}remove(c){if(this.added.has(c)){this.added.delete(c);return}if(this.updated.delete(c),c.parent&&this.alreadyRemoved.has(c.parent)){this.alreadyRemoved.add(c.item.extId);return}this.removed.add(c)}getChangeEvent(){const{added:c,updated:F,removed:O}=this;return{get added(){return[...c].map(V=>V.revived)},get updated(){return[...F].map(V=>V.revived)},get removed(){return[...O].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(c){return this.items.get(c)}getMirroredTestDataByReference(c){return this.items.get(c.id)}createItem(c,F){return{...c,revived:s.TestItem.toPlain(c.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=m;class D{constructor(c){this.proxy=c}checkout(){this.current||(this.current=this.createObserverData());const c=this.current;return c.observers++,{onDidChangeTest:c.tests.onDidChangeTests,get tests(){return[...c.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--c.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(c){return this.current?.tests.getMirroredTestDataByReference(c)}applyDiff(c){this.current?.tests.apply(c)}createObserverData(){const c=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:c}}}class T{constructor(c,F,O,V,K,W,Q=!1,$=void 0){this.controllerId=F,this.profileId=O,this._label=V,this.kind=K,this.runHandler=W,this._isDefault=Q,this._tag=$,g.set(this,void 0),Je(this,g,c,"f");const U=p[K];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Te(this,g,"f").$publishTestRunProfile({profileId:O,controllerId:F,tag:$?s.TestTag.namespace(this.controllerId,$.id):null,label:V,group:U,isDefault:Q,hasConfigurationHandler:!1})}get label(){return this._label}set label(c){c!==this._label&&(this._label=c,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:c}))}get isDefault(){return this._isDefault}set isDefault(c){c!==this._isDefault&&(this._isDefault=c,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:c}))}get tag(){return this._tag}set tag(c){c?.id!==this._tag?.id&&(this._tag=c,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:c?s.TestTag.namespace(this.controllerId,c.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(c){c!==this._configureHandler&&(this._configureHandler=c,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!c}))}dispose(){Te(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,g=new WeakMap;const p={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,13,5,94,8,7]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(n=>n.value)}async showTextDocument(t,_,n){let h;typeof _=="number"?h={position:R.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?h={position:R.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?R.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:h={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(t.uri,h),s=u&&this._extHostDocumentsAndEditors.getEditor(u);if(s)return s.value;throw u?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new A.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const h=_.selections.selections.map(R.Selection.to);n._acceptSelections(h)}if(_.visibleRanges){const h=M.coalesce(_.visibleRanges.map(R.Range.to));n._acceptVisibleRanges(h)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:R.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const h=C.TextEditorSelectionChangeKind.fromValue(_.selections.source),u=_.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:u,kind:h})}if(_.visibleRanges){const h=M.coalesce(_.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:h})}}$acceptEditorPositionData(t){for(const _ in t){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const h=R.ViewColumn.to(t[_]);n.value.viewColumn!==h&&(n._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:h}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=y}),define(be[206],Ee([0,1,2,4,5,6,7]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const h=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(y(h))?.get(n.handle)}return n}})}async $getTimeline(t,_,n,h,u){return this._providers.get(t)?.provideTimeline(d.URI.revive(_),n,h,u)}registerTimelineProvider(t,_,n,h){const u=new A.DisposableStore,s=this.convertTimelineItem(_.id,h,u).bind(this);let v;_.onDidChange&&(v=_.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:_.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(S,o,g,k){k?.resetCache&&(u.clear(),I.get(_.id)?.clear());const i=await _.provideTimeline(S,o,g);if(i==null)return;const l=s(S,k);return{...i,source:_.id,items:i.items.map(l)}},dispose(){for(const S of I.values())S.get(_.id)?.clear();v?.dispose(),u.dispose()}})}convertTimelineItem(t,_,n){return(h,u)=>{let s;if(u?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const I=y(h);s=v.get(I),s===void 0&&(s=new Map,v.set(I,s))}return v=>{const{iconPath:I,...S}=v,o=`${t}|${v.id??v.timestamp}`;s?.set(o,v);let g,k,i;return v.iconPath&&(I instanceof R.ThemeIcon?i={id:I.id,color:I.color}:d.URI.isUri(I)?(g=I,k=I):{light:g,dark:k}=I),{...S,id:S.id??void 0,handle:o,source:t,command:v.command?_.toInternal(v.command,n):void 0,icon:g,iconDark:k,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function y(P){return P?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,t,_){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=_.schemes.find(h=>!R.supportedSchemes.has(h));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,_.schemes,y,_.label),(0,d.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,t){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener with id: ${y}`);const n=E.URI.revive(P);return _.canOpenExternalUri(n,t)}async $openUri(y,P,t){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener id: '${y}'`);return _.openExternalUri(E.URI.revive(P.resolvedUri),{sourceUri:E.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,25]),function(ie,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const _=C.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,P),(0,E.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(P,t){const _=this.handlers.get(P);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[50],Ee([0,1,3,2,138,158,66,5]),function(ie,e,d,M,E,A,R,C){"use strict";var y,P,t,_,n,h,u,s,v,I,S,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(m,D,T,p,b,c,F){y.set(this,void 0),P.set(this,void 0),t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),h.set(this,void 0),u.set(this,""),s.set(this,void 0),v.set(this,!1),I.set(this,!1),S.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new d.Emitter),this._onDidDispose=Te(this,o,"f").event,Je(this,y,m,"f"),Je(this,P,D,"f"),Je(this,s,T,"f"),Je(this,_,p,"f"),Je(this,n,b,"f"),Je(this,h,c,"f"),Je(this,S,k(c),"f"),Je(this,t,F,"f")}dispose(){Je(this,v,!0,"f"),Te(this,o,"f").fire(),Te(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Je(this,I,!0,"f"),(0,R.asWebviewUri)(m,Te(this,_,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,u,"f")}set html(m){this.assertNotDisposed(),Te(this,u,"f")!==m&&(Je(this,u,m,"f"),!Te(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Je(this,I,!0,"f"),Te(this,t,"f").report("Webview vscode-resource: uris",Te(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,P,"f").$setHtml(Te(this,y,"f"),m))}get options(){return this.assertNotDisposed(),Te(this,s,"f")}set options(m){this.assertNotDisposed(),Te(this,P,"f").$setOptions(Te(this,y,"f"),r(Te(this,h,"f"),Te(this,n,"f"),m)),Je(this,s,m,"f")}async postMessage(m){if(Te(this,v,"f"))return!1;const D=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Te(this,S,"f")});return Te(this,P,"f").$postMessage(Te(this,y,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Te(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,y=new WeakMap,P=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,h=new WeakMap,u=new WeakMap,s=new WeakMap,v=new WeakMap,I=new WeakMap,S=new WeakMap,o=new WeakMap;function k(f){try{const m=(0,E.normalizeVersion)((0,E.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=k;class i{constructor(m,D,T,p,b){this.initData=D,this.workspace=T,this._logService=p,this._deprecationService=b,this._webviews=new Map,this._webviewProxy=m.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(m,D,...T){const p=this.getWebview(m);if(p){const{message:b}=(0,A.deserializeWebviewMessage)(D,T);p._onMessageEmitter.fire(b)}}$onMissingCsp(m,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,D,T){const p=new g(m,this._webviewProxy,a(D),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(m,p),p._onDidDispose(()=>{this._webviews.delete(m)}),p}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=i;function l(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=l;function r(f,m,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,enableForms:D.enableForms,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||w(f,m)}}e.serializeWebviewOptions=r;function a(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>M.URI.from(m))}}e.reviveOptions=a;function w(f,m){return[...(m?.getWorkspaceFolders()||[]).map(D=>D.uri),f.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(i,l){this.document=i,this._storagePath=l,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,l){await this.getEdit(i).undo(),l||this.disposeBackup()}async redo(i,l){await this.getEdit(i).redo(),l||this.disposeBackup()}disposeEdits(i){for(const l of i)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=g(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const l=this._edits.get(i,0);if(!l)throw new Error("No edit found");return l}}class u{constructor(){this._documents=new Map}get(i,l){return this._documents.get(this.key(i,l))}add(i,l,r){const a=this.key(i,l.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${i} resource:${l.uri}`);const w=new h(l,r);return this._documents.set(a,w),w}delete(i,l){const r=this.key(i,l.uri);this._documents.delete(r)}key(i,l){return`${i}@@@${l}`}}var s;(function(k){k[k.Text=0]="Text",k[k.Custom=1]="Custom"})(s||(s={}));class v{constructor(){this._providers=new Map}addTextProvider(i,l,r){return this.add(0,i,l,r)}addCustomProvider(i,l,r){return this.add(1,i,l,r)}get(i){return this._providers.get(i)}add(i,l,r,a){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:i,extension:r,provider:a}),new n.Disposable(()=>this._providers.delete(l))}}class I{constructor(i,l,r,a,w){this._extHostDocuments=l,this._extensionStoragePaths=r,this._extHostWebview=a,this._extHostWebviewPanels=w,this._editorProviders=new v,this._documents=new u,this._proxy=i.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,l,r,a){const w=new E.DisposableStore;return S(r)?(w.add(this._editorProviders.addTextProvider(l,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),l,a.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(w.add(this._editorProviders.addCustomProvider(l,i,r)),this.supportEditing(r)&&w.add(r.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(l,f.document.uri);if(o(f)){const D=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,l,D,f.label)}else this._proxy.$onContentChange(f.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),l,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(w,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(i,l,r,a,w){const f=this._editorProviders.get(l);if(!f)throw new Error(`No provider found for '${l}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${l}'`);const m=C.URI.revive(i),D=await f.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:a?.buffer},w);let T;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(l,D,T),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(i,l){const r=this._editorProviders.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${l}'`);const a=C.URI.revive(i),{document:w}=this.getCustomDocumentEntry(l,a);this._documents.delete(l,w),w.dispose()}async $resolveWebviewEditor(i,l,r,a,w,f){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const D=y.ViewColumn.to(w),T=this._extHostWebview.createNewWebview(l,a.webviewOptions,m.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(l,r,a.title,D,a.panelOptions,T),b=C.URI.revive(i);switch(m.type){case 1:{const{document:c}=this.getCustomDocumentEntry(r,b);return m.provider.resolveCustomEditor(c,p,f)}case 0:{const c=this._extHostDocuments.getDocument(b);return m.provider.resolveCustomTextEditor(c,p,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,l,r){this.getCustomDocumentEntry(l,i).disposeEdits(r)}async $onMoveCustomEditor(i,l,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const w=this._extHostWebviewPanels.getWebviewPanel(i);if(!w)throw new Error("No webview found");const f=C.URI.revive(l),m=this._extHostDocuments.getDocument(f);await a.provider.moveCustomTextEditor(m,w,d.CancellationToken.None)}async $undo(i,l,r,a){return this.getCustomDocumentEntry(l,i).undo(r,a)}async $redo(i,l,r,a){return this.getCustomDocumentEntry(l,i).redo(r,a)}async $revert(i,l,r){const a=this.getCustomDocumentEntry(l,i);await this.getCustomEditorProvider(l).revertCustomDocument(a.document,r),a.disposeBackup()}async $onSave(i,l,r){const a=this.getCustomDocumentEntry(l,i);await this.getCustomEditorProvider(l).saveCustomDocument(a.document,r),a.disposeBackup()}async $onSaveAs(i,l,r,a){const w=this.getCustomDocumentEntry(l,i);return this.getCustomEditorProvider(l).saveCustomDocumentAs(w.document,C.URI.revive(r),a)}async $backup(i,l,r){const a=this.getCustomDocumentEntry(l,i),f=await this.getCustomEditorProvider(l).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},r);return a.updateBackup(f),f.id}getCustomDocumentEntry(i,l){const r=this._documents.get(i,C.URI.revive(l));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function S(k){return typeof k.resolveCustomTextEditor=="function"}function o(k){return typeof k.undo=="function"&&typeof k.redo=="function"}function g(k){const i=k.scheme===A.Schemas.file||k.scheme===A.Schemas.untitled?k.fsPath:k.toString();return(0,M.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[210],Ee([0,1,3,6,2,36,8,50,5,7]),function(ie,e,d,M,E,A,R,C,y,P){"use strict";var t,_,n,h,u,s,v,I,S,o,g,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends M.Disposable{constructor(f,m,D,T,p,b,c){super();t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),h.set(this,void 0),u.set(this,void 0),s.set(this,void 0),v.set(this,void 0),I.set(this,void 0),S.set(this,!0),o.set(this,!0),g.set(this,!1),k.set(this,this._register(new d.Emitter)),this.onDidDispose=Te(this,k,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Te(this,i,"f").event,Je(this,t,f,"f"),Je(this,_,m,"f"),Je(this,n,D,"f"),Je(this,u,b,"f"),Je(this,I,p,"f"),Je(this,s,T,"f"),Je(this,h,c,"f")}dispose(){Te(this,g,"f")||(Je(this,g,!0,"f"),Te(this,k,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,t,"f")),Te(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,h,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,s,"f")}set title(f){this.assertNotDisposed(),Te(this,s,"f")!==f&&(Je(this,s,f,"f"),Te(this,_,"f").$setTitle(Te(this,t,"f"),f))}get iconPath(){return this.assertNotDisposed(),Te(this,v,"f")}set iconPath(f){this.assertNotDisposed(),Te(this,v,"f")!==f&&(Je(this,v,f,"f"),Te(this,_,"f").$setIconPath(Te(this,t,"f"),E.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Te(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,I,"f")=="number"&&Te(this,I,"f")<0))return Te(this,I,"f")}get active(){return this.assertNotDisposed(),Te(this,o,"f")}get visible(){return this.assertNotDisposed(),Te(this,S,"f")}_updateViewState(f){Te(this,g,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Je(this,o,f.active,"f"),Je(this,S,f.visible,"f"),Je(this,I,f.viewColumn,"f"),Te(this,i,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,t,"f"),{viewColumn:f?R.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Te(this,g,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,n=new WeakMap,h=new WeakMap,u=new WeakMap,s=new WeakMap,v=new WeakMap,I=new WeakMap,S=new WeakMap,o=new WeakMap,g=new WeakMap,k=new WeakMap,i=new WeakMap;class r{constructor(f,m,D){this.webviews=m,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,m,D,T,p={}){const b=typeof T=="object"?T.viewColumn:T,c={viewColumn:R.ViewColumn.from(b),preserveFocus:typeof T=="object"&&!!T.preserveFocus},F=(0,C.shouldSerializeBuffersForPostMessage)(f),O=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(f),O,m,{title:D,panelOptions:a(p),webviewOptions:(0,C.serializeWebviewOptions)(f,this.workspace,p),serializeBuffersForPostMessage:F},c);const V=this.webviews.createNewWebview(O,p,f);return this.createNewWebviewPanel(O,m,D,b,p,V)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((D,T)=>{const p=f[D],b=f[T];return p.active?1:b.active?-1:+p.visible-+b.visible});for(const D of m){const T=this.getWebviewPanel(D);if(!T)continue;const p=f[D];T._updateViewState({active:p.active,visible:p.visible,viewColumn:R.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,D){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:D,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,D,T){const p=this._serializers.get(m);if(!p)throw new Error(`No serializer found for '${m}'`);const{serializer:b,extension:c}=p,F=this.webviews.createNewWebview(f,D.webviewOptions,c),O=this.createNewWebviewPanel(f,m,D.title,T,D.panelOptions,F);await b.deserializeWebviewPanel(O,D.state)}createNewWebviewPanel(f,m,D,T,p,b){const c=new l(f,this._proxy,m,D,T,p,b);return this._webviewPanels.set(f,c),c}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function a(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[211],Ee([0,1,3,6,50,5,7]),function(ie,e,d,M,E,A,R){"use strict";var C,y,P,t,_,n,h,u,s,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends M.Disposable{constructor(g,k,i,l,r,a){super();C.set(this,void 0),y.set(this,void 0),P.set(this,void 0),t.set(this,void 0),_.set(this,!1),n.set(this,void 0),h.set(this,void 0),u.set(this,void 0),s.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Te(this,s,"f").event,v.set(this,this._register(new d.Emitter)),this.onDidDispose=Te(this,v,"f").event,Je(this,P,i,"f"),Je(this,h,l,"f"),Je(this,C,g,"f"),Je(this,y,k,"f"),Je(this,t,r,"f"),Je(this,n,a,"f")}dispose(){Te(this,_,"f")||(Je(this,_,!0,"f"),Te(this,v,"f").fire(),Te(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,h,"f")}set title(g){this.assertNotDisposed(),Te(this,h,"f")!==g&&(Je(this,h,g,"f"),Te(this,y,"f").$setWebviewViewTitle(Te(this,C,"f"),g))}get description(){return this.assertNotDisposed(),Te(this,u,"f")}set description(g){this.assertNotDisposed(),Te(this,u,"f")!==g&&(Je(this,u,g,"f"),Te(this,y,"f").$setWebviewViewDescription(Te(this,C,"f"),g))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,t,"f")}get viewType(){return Te(this,P,"f")}_setVisible(g){g===Te(this,n,"f")||Te(this,_,"f")||(Je(this,n,g,"f"),Te(this,s,"f").fire())}show(g){this.assertNotDisposed(),Te(this,y,"f").$show(Te(this,C,"f"),!!g)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,y=new WeakMap,P=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,h=new WeakMap,u=new WeakMap,s=new WeakMap,v=new WeakMap;class S{constructor(g,k){this._extHostWebview=k,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,k,i,l){if(this._viewProviders.has(k))throw new Error(`View provider for '${k}' already registered`);return this._viewProviders.set(k,{provider:i,extension:g}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(g),k,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(k),this._proxy.$unregisterWebviewViewProvider(k)})}async $resolveWebviewView(g,k,i,l,r){const a=this._viewProviders.get(k);if(!a)throw new Error(`No view provider found for '${k}'`);const{provider:w,extension:f}=a,m=this._extHostWebview.createNewWebview(g,{},f),D=new I(g,this._proxy,k,i,m,!0);this._webviewViews.set(g,D),await w.resolveWebviewView(D,{state:l},r)}async $onDidChangeWebviewViewVisibility(g,k){this.getWebviewView(g)._setVisible(k)}async $disposeWebviewView(g){const k=this.getWebviewView(g);this._webviewViews.delete(g),k.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const k=this._webviewViews.get(g);if(!k)throw new Error("No webview found");return k}}e.ExtHostWebviewViews=S}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(_){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let h;if(typeof _=="string"){h=_;try{_=E.URI.parse(_)}catch(u){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,R.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,h,n)}async asExternalUri(_,n){if((0,R.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(_,n);return E.URI.from(h)}};P.InitialState={focused:!0},P=Ue([He(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,12]),function(ie,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends d.AbstractLogger{constructor(y,P){super();this._proxy=y.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...P){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(y,...P){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(y,...P){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(y,...P){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(y,...P){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(y,...P){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};R=Ue([He(0,A.IExtHostRpcService),He(1,E.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(be[213],Ee([0,1,14,23,21,16,3,6,109,180,47]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(p,b){try{return JSON.stringify(p,b)}catch(c){return"null"}}const h="$$ref$$",u={[h]:-1};class s{constructor(b,c){this.jsonString=b,this.referencedBuffers=c}}function v(p,b=null,c=!1){const F=[];return{jsonString:(c?n:JSON.stringify)(p,(V,K)=>{if(typeof K=="undefined")return u;if(typeof K=="object"){if(K instanceof M.VSBuffer){const W=F.push(K)-1;return{[h]:W}}if(b)return b(V,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=v;function I(p,b,c){return JSON.parse(p,(F,O)=>{if(O){const V=O[h];if(typeof V=="number")return b[V];if(c&&O.$mid===1)return c.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=I;function S(p,b){return JSON.stringify(p,b)}function o(p){return p?(b,c)=>c&&c.$mid===1?p.transformOutgoing(c):c:null}var g;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var k;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(k=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends C.Disposable{constructor(b,c=null,F=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=b,this._logger=c,this._uriTransformer=F,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,V=t.ProxyIdentifier.count;O<V;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(b=>{this._pendingRPCReplies[b].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(b){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(b){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(b){this._responsiveState!==b&&(this._responsiveState=b,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(b){return this._uriTransformer?(0,y.transformIncomingURIs)(b,this._uriTransformer):b}getProxy(b){const{nid:c,sid:F}=b;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,F)),this._proxies[c]}_createProxy(b,c){let F={get:(O,V)=>(typeof V=="string"&&!O[V]&&V.charCodeAt(0)===36&&(O[V]=(...K)=>this._remoteCall(b,V,K)),V===r?c:O[V])};return new Proxy(Object.create(null),F)}set(b,c){return this._locals[b.nid]=c,c}assertRegistered(b){for(let c=0,F=b.length;c<F;c++){const O=b[c];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(b){if(this._isDisposed)return;const c=b.byteLength,F=w.read(b,0),O=F.readUInt8(),V=F.readUInt32();switch(O){case 1:case 2:{let{rpcId:K,method:W,args:Q}=m.deserializeRequestJSONArgs(F);this._uriTransformer&&(Q=(0,y.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(c,V,K,W,Q,O===2);break}case 3:case 4:{let{rpcId:K,method:W,args:Q}=m.deserializeRequestMixedArgs(F);this._uriTransformer&&(Q=(0,y.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(c,V,K,W,Q,O===4);break}case 5:{this._logger&&this._logger.logIncoming(c,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(c,V);break}case 7:{this._receiveReply(c,V,void 0);break}case 9:{let K=m.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,y.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(c,V,K);break}case 10:{const K=m.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(c,V,K);break}case 8:{let K=m.deserializeReplyOKVSBuffer(F);this._receiveReply(c,V,K);break}case 11:{let K=m.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,y.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(c,V,K);break}case 12:{this._receiveReplyErr(c,V,void 0);break}default:console.error("received unexpected message"),console.error(b)}}_receiveRequest(b,c,F,O,V,K){this._logger&&this._logger.logIncoming(b,c,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(F)}.${O}(`,V);const W=String(c);let Q,$;if(K){const H=new E.CancellationTokenSource;V.push(H.token),Q=this._invokeHandler(F,O,V),$=()=>H.cancel()}else Q=this._invokeHandler(F,O,V),$=i;this._cancelInvokedHandlers[W]=$;const U=m.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(U.byteLength,c,1,"ack"),this._protocol.send(U),Q.then(H=>{delete this._cancelInvokedHandlers[W];const G=m.serializeReplyOK(c,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,c,1,"reply:",H),this._protocol.send(G)},H=>{delete this._cancelInvokedHandlers[W];const G=m.serializeReplyErr(c,H);this._logger&&this._logger.logOutgoing(G.byteLength,c,1,"replyErr:",H),this._protocol.send(G)})}_receiveCancel(b,c){this._logger&&this._logger.logIncoming(b,c,1,"receiveCancel");const F=String(c);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(b,c,F){this._logger&&this._logger.logIncoming(b,c,0,"receiveReply:",F);const O=String(c);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const V=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],V.resolveOk(F)}_receiveReplyErr(b,c,F){this._logger&&this._logger.logIncoming(b,c,0,"receiveReplyErr:",F);const O=String(c);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const V=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),V.resolveErr(K)}_invokeHandler(b,c,F){try{return Promise.resolve(this._doInvokeHandler(b,c,F))}catch(O){return Promise.reject(O)}}_doInvokeHandler(b,c,F){const O=this._locals[b];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(b));let V=O[c];if(typeof V!="function")throw new Error("Unknown method "+c+" on actor "+(0,t.getStringIdentifierForProxy)(b));return V.apply(O,F)}_remoteCall(b,c,F){if(this._isDisposed)return Promise.reject(A.canceled());let O=null;if(F.length>0&&E.CancellationToken.isCancellationToken(F[F.length-1])&&(O=F.pop()),O&&O.isCancellationRequested)return Promise.reject(A.canceled());const V=m.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,W=String(K),Q=new P.LazyPromise;O&&O.onCancellationRequested(()=>{const U=m.serializeCancel(K);this._logger&&this._logger.logOutgoing(U.byteLength,K,0,"cancel"),this._protocol.send(m.serializeCancel(K))}),this._pendingRPCReplies[W]=Q,this._onWillSendRequest(K);const $=m.serializeRequest(K,b,c,V,!!O);return this._logger&&this._logger.logOutgoing($.byteLength,K,0,`request: ${(0,t.getStringIdentifierForProxy)(b)}.${c}(`,F),this._protocol.send($),Q}}e.RPCProtocol=a,_=l,a.UNRESPONSIVE_TIME=3*1e3;class w{constructor(b,c){this._buff=b,this._offset=c}static alloc(b,c,F){let O=new w(M.VSBuffer.alloc(F+1+4),0);return O.writeUInt8(b),O.writeUInt32(c),O}static read(b,c){return new w(b,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(b){this._buff.writeUInt8(b,this._offset),this._offset+=1}readUInt8(){const b=this._buff.readUInt8(this._offset);return this._offset+=1,b}writeUInt32(b){this._buff.writeUInt32BE(b,this._offset),this._offset+=4}readUInt32(){const b=this._buff.readUInt32BE(this._offset);return this._offset+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this._buff.writeUInt8(b.byteLength,this._offset),this._offset+=1,this._buff.set(b,this._offset),this._offset+=b.byteLength}readShortString(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,F}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readLongString(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,F}writeBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readVSBuffer(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+b);return this._offset+=b,c}static sizeMixedArray(b){let c=0;c+=1;for(let F=0,O=b.length;F<O;F++){const V=b[F];switch(c+=1,V.type){case 1:c+=this.sizeLongString(V.value);break;case 2:c+=this.sizeVSBuffer(V.value);break;case 3:c+=this.sizeUInt32,c+=this.sizeLongString(V.value);for(let K=0;K<V.buffers.length;++K)c+=this.sizeVSBuffer(V.buffers[K]);break;case 4:break}}return c}writeMixedArray(b){this._buff.writeUInt8(b.length,this._offset),this._offset+=1;for(let c=0,F=b.length;c<F;c++){const O=b[c];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let V=0;V<O.buffers.length;++V)this.writeBuffer(O.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(b);for(let F=0;F<b;F++)switch(this.readUInt8()){case 1:c[F]=this.readLongString();break;case 2:c[F]=this.readVSBuffer();break;case 3:const V=this.readUInt32(),K=this.readLongString(),W=[];for(let Q=0;Q<V;++Q)W.push(this.readVSBuffer());c[F]=new t.SerializableObjectWithBuffers(I(K,W,null));break;case 4:c[F]=void 0;break}return c}}w.sizeUInt32=4;var f;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(f||(f={}));class m{static _useMixedArgSerialization(b){for(let c=0,F=b.length;c<F;c++)if(b[c]instanceof M.VSBuffer||b[c]instanceof t.SerializableObjectWithBuffers||typeof b[c]=="undefined")return!0;return!1}static serializeRequestArguments(b,c){if(this._useMixedArgSerialization(b)){const F=[];for(let O=0,V=b.length;O<V;O++){const K=b[O];if(K instanceof M.VSBuffer)F[O]={type:2,value:K};else if(typeof K=="undefined")F[O]={type:4};else if(K instanceof t.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:Q}=v(K.value,c);F[O]={type:3,value:M.VSBuffer.fromString(W),buffers:Q}}else F[O]={type:1,value:M.VSBuffer.fromString(S(K,c))}}return{type:1,args:F}}return{type:0,args:S(b,c)}}static serializeRequest(b,c,F,O,V){switch(O.type){case 0:return this._requestJSONArgs(b,c,F,O.args,V);case 1:return this._requestMixedArgs(b,c,F,O.args,V)}}static _requestJSONArgs(b,c,F,O,V){const K=M.VSBuffer.fromString(F),W=M.VSBuffer.fromString(O);let Q=0;Q+=w.sizeUInt8(),Q+=w.sizeShortString(K),Q+=w.sizeLongString(W);let $=w.alloc(V?2:1,b,Q);return $.writeUInt8(c),$.writeShortString(K),$.writeLongString(W),$.buffer}static deserializeRequestJSONArgs(b){const c=b.readUInt8(),F=b.readShortString(),O=b.readLongString();return{rpcId:c,method:F,args:JSON.parse(O)}}static _requestMixedArgs(b,c,F,O,V){const K=M.VSBuffer.fromString(F);let W=0;W+=w.sizeUInt8(),W+=w.sizeShortString(K),W+=w.sizeMixedArray(O);let Q=w.alloc(V?4:3,b,W);return Q.writeUInt8(c),Q.writeShortString(K),Q.writeMixedArray(O),Q.buffer}static deserializeRequestMixedArgs(b){const c=b.readUInt8(),F=b.readShortString(),O=b.readMixedArray(),V=new Array(O.length);for(let K=0,W=O.length;K<W;K++){const Q=O[K];typeof Q=="string"?V[K]=JSON.parse(Q):V[K]=Q}return{rpcId:c,method:F,args:V}}static serializeAcknowledged(b){return w.alloc(5,b,0).buffer}static serializeCancel(b){return w.alloc(6,b,0).buffer}static serializeReplyOK(b,c,F){if(typeof c=="undefined")return this._serializeReplyOKEmpty(b);if(c instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(b,c);if(c instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:V}=v(c.value,F,!0);return this._serializeReplyOKJSONWithBuffers(b,O,V)}else return this._serializeReplyOKJSON(b,n(c,F))}static _serializeReplyOKEmpty(b){return w.alloc(7,b,0).buffer}static _serializeReplyOKVSBuffer(b,c){let F=0;F+=w.sizeVSBuffer(c);let O=w.alloc(8,b,F);return O.writeVSBuffer(c),O.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static _serializeReplyOKJSON(b,c){const F=M.VSBuffer.fromString(c);let O=0;O+=w.sizeLongString(F);let V=w.alloc(9,b,O);return V.writeLongString(F),V.buffer}static _serializeReplyOKJSONWithBuffers(b,c,F){const O=M.VSBuffer.fromString(c);let V=0;V+=w.sizeUInt32,V+=w.sizeLongString(O);for(const W of F)V+=w.sizeVSBuffer(W);let K=w.alloc(10,b,V);K.writeUInt32(F.length),K.writeLongString(O);for(const W of F)K.writeBuffer(W);return K.buffer}static deserializeReplyOKJSON(b){const c=b.readLongString();return JSON.parse(c)}static deserializeReplyOKJSONWithBuffers(b,c){const F=b.readUInt32(),O=b.readLongString(),V=[];for(let K=0;K<F;++K)V.push(b.readVSBuffer());return new t.SerializableObjectWithBuffers(I(O,V,c))}static serializeReplyErr(b,c){return c?this._serializeReplyErrEror(b,c):this._serializeReplyErrEmpty(b)}static _serializeReplyErrEror(b,c){const F=M.VSBuffer.fromString(n(A.transformErrorForSerialization(c),null));let O=0;O+=w.sizeLongString(F);let V=w.alloc(11,b,O);return V.writeLongString(F),V.buffer}static deserializeReplyErrError(b){const c=b.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(b){return w.alloc(12,b,0).buffer}}var D;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(D||(D={}));var T;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(T||(T={}))}),define(be[214],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const R=C=>{self.removeEventListener("message",R);const y=C.data;Object.defineProperties(self,{postMessage:{value(P,t){y.postMessage(P,t)}},onmessage:{get(){return y.onmessage},set(P){y.onmessage=P}}}),y.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(A,R,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${d})('${R}'))`,P=new Blob([y],{type:"application/javascript"}),t=URL.createObjectURL(P),_=new MessageChannel,n=t,h={type:"_newWorker",id:n,port:_.port2,url:t,options:C};A(h,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:n};_.port1.postMessage(u),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(u){_.port1.onmessage=u}},onmessageerror:{get(){return _.port1.onmessageerror},set(u){_.port1.onmessageerror=u}}}),_.port1.addEventListener("messageerror",u=>{const s=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(s)}),_.port1.addEventListener("message",u=>{const s=new MessageEvent("message",{data:u.data});this.dispatchEvent(s)}),_.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(ie,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,26,2,4,86,45,176,215]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let _=class $i{constructor(h,u,s,v){this.localUserHome=h,this.remoteAgentService=u,this.environmentService=s,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||h})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,u){if(h.remoteAuthority)return d.Schemas.vscodeRemote;const s=(0,C.getVirtualWorkspaceScheme)(u.getWorkspace());if(s)return s;const v=u.getWorkspace().folders[0];if(v)return v.uri.scheme;const I=u.getWorkspace().configuration;return I?I.scheme:d.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?M.win32:M.posix)}async fileURI(h){let u="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(u=h.substring(2),h="/"):(u=h.substring(2,v),h=h.substring(v)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:u,path:h,query:"",fragment:""})}};_=Ue([He(1,t.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,y.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(be[98],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(R,C){this.line=R,this.character=C}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,C){return new d(0,0)}with(R){return new d(0,0)}}e.Position=d;class M{constructor(R,C,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(R,C),this.end=new d(y,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[39],Ee([0,1,13,27,22,41,9,4,17,16,98,10]),function(ie,e,d,M,E,A,R,C,y,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",h=" characters skipped \u27EB",u=(n.length+h.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var s;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function I(U){return!!U.preview}e.resultIsMatch=I;function S(U){return!!U.resource}e.isFileMatch=S;function o(U){return!!U.message}e.isProgressMessage=o;var g;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class k{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=k;class i{constructor(H,G,ue){this.ranges=G;const q=Array.isArray(G)?G:[G];if(ue&&ue.matchLines===1&&l(q)){H=(0,R.getNLines)(H,ue.matchLines);let le="",se=0,ve=0;const Fe=Math.floor(ue.charsPerLine/5),Me=[];for(const Ne of q){const Qe=Math.max(Ne.startColumn-Fe,0),ze=Ne.startColumn+ue.charsPerLine;if(Qe>ve+Fe+u){const qe=n+(Qe-ve)+h;le+=qe+H.slice(Qe,ze),se+=Qe-(ve+qe.length)}else le+=H.slice(ve,ze);Me.push(new a(0,Ne.startColumn-se,Ne.endColumn-se)),ve=ze}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:H,matches:(0,d.mapArrayOrNot)(G,se=>new r(se.startLineNumber-le,se.startColumn,se.endLineNumber-le,se.endColumn))}}}}e.TextSearchMatch=i;function l(U){const H=U[0].startLineNumber;for(const G of U)if(G.startLineNumber!==H||G.endLineNumber!==H)return!1;return!0}class r{constructor(H,G,ue,q){this.startLineNumber=H,this.startColumn=G,this.endLineNumber=ue,this.endColumn=q}}e.SearchRange=r;class a extends r{constructor(H,G,ue){super(H,G,H,ue)}}e.OneLineRange=a;var w;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(w=e.SearchSortOrder||(e.SearchSortOrder={}));function f(U,H=!0){const G=U&&U.files&&U.files.exclude,ue=H&&U&&U.search&&U.search.exclude;if(!G&&!ue)return;if(!G||!ue)return G||ue;let q=Object.create(null);return q=E.mixin(q,E.deepClone(G)),q=E.mixin(q,E.deepClone(ue),!0),q}e.getExcludes=f;function m(U,H){return U.excludePattern&&M.match(U.excludePattern,H)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,H)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(G=>{const ue=G.folder.fsPath;if(A.isEqualOrParent(H,ue)){const q=y.relative(ue,H);return!G.includePattern||!!M.match(G.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var D;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(D=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(H,G){super(H);this.code=G}}e.SearchError=T;function p(U){const H=U.message;if((0,P.isPromiseCanceledError)(U))return new T(H,D.canceled);try{const G=JSON.parse(H);return new T(G.message,G.code)}catch(G){return new T(H,D.other)}}e.deserializeSearchError=p;function b(U){const H={message:U.message,code:U.code};return new Error(JSON.stringify(H))}e.serializeSearchError=b;function c(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=c;function F(U){return U.type==="success"}e.isSerializedSearchSuccess=F;function O(U){return!!U.path}e.isSerializedFileMatch=O;function V(U,H){const G=U.searchPath?U.searchPath:U.relativePath;return(0,R.fuzzyContains)(G,H)}e.isFilePatternMatch=V;class K{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function W(U,H){const G={...U||{},...H||{}};return Object.keys(G).filter(ue=>{const q=G[ue];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=W;class Q{constructor(H,G){this._parsedIncludeExpression=null,this._excludeExpression={...H.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ue=H.includePattern;G.includePattern&&(ue?ue={...ue,...G.includePattern}:ue=G.includePattern),ue&&(this._parsedIncludeExpression=M.parse(ue))}includedInQuerySync(H,G,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,G,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,G,ue))}includedInQuery(H,G,ue){const q=this._parsedExcludeExpression(H,G,ue),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(H,G,ue):!0;return(0,_.isPromise)(q)?q.then(se=>se?!1:le()):le()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=Q;function $(U){for(const H in U)if(typeof U[H]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,45,37,29,12,7,39,5]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o,g,k,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(b,c,F){return new P.ExtUri(O=>m(O,F)).isEqual(b,c)}function a(b,c,F){return r(b.uri,c.uri,F)?0:(0,t.compare)(b.uri.toString(),c.uri.toString())}function w(b,c,F){return b.index!==c.index?b.index<c.index?-1:1:r(b.uri,c.uri,F)?(0,t.compare)(b.name,c.name):(0,t.compare)(b.uri.toString(),c.uri.toString())}function f(b,c,F,O){const V=b.slice(0).sort((W,Q)=>F(W,Q,O)),K=c.slice(0).sort((W,Q)=>F(W,Q,O));return(0,d.delta)(V,K,(W,Q)=>F(W,Q,O))}function m(b,c){const F=c.getCapabilities(b.scheme);return!(F&&F&1024)}class D extends I.Workspace{constructor(c,F,O,V,K,W){super(c,O.map(Q=>new I.WorkspaceFolder(Q)),V,W);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(W),O.forEach(Q=>{this._workspaceFolders.push(Q),this._structure.set(Q.uri,Q)})}static toExtHostWorkspace(c,F,O,V){if(!c)return{workspace:null,added:[],removed:[]};const{id:K,name:W,folders:Q,configuration:$,isUntitled:U}=c,H=[],G=F;F?Q.forEach((se,ve)=>{const Fe=n.URI.revive(se.uri),Me=D._findFolder(O||F,Fe,V);Me?(Me.name=se.name,Me.index=se.index,H.push(Me)):H.push({uri:Fe,name:se.name,index:ve})}):H.push(...Q.map(({uri:se,name:ve,index:Fe})=>({uri:n.URI.revive(se),name:ve,index:Fe}))),H.sort((se,ve)=>se.index<ve.index?-1:1);const ue=new D(K,W,H,$?n.URI.revive($):null,!!U,se=>m(se,V)),{added:q,removed:le}=f(G?G.workspaceFolders:[],ue.workspaceFolders,a,V);return{workspace:ue,added:q,removed:le}}static _findFolder(c,F,O){for(let V=0;V<c.folders.length;V++){const K=c.workspaceFolders[V];if(r(K.uri,F,O))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(c,F){return F&&this._structure.get(c)&&(c=(0,P.dirname)(c)),this._structure.findSubstr(c)}resolveWorkspaceFolder(c){return this._structure.get(c)}}let T=class{constructor(c,F,O,V){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=O,this._requestIdProvider=new y.Counter,this._barrier=new M.Barrier,this._proxy=c.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=c.getProxy(l.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new D(K.id,K.name,[],K.configuration?n.URI.revive(K.configuration):null,!!K.isUntitled,W=>m(W,O)):void 0}$initializeWorkspace(c,F){this._trusted=F,this.$acceptWorkspaceData(c),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(c,F,O,...V){const K=[];if(Array.isArray(V)&&V.forEach(H=>{n.URI.isUri(H.uri)&&!K.some(G=>r(G.uri,H.uri,this._extHostFileSystemInfo))&&K.push({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[F,O].some(H=>typeof H!="number"||H<0)||O===0&&K.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+O>W.length)return!1;const Q=W.slice(0);Q.splice(F,O,...K.map(H=>({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<Q.length;H++){const G=Q[H];if(Q.some((ue,q)=>q!==H&&r(G.uri,ue.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((H,G)=>H.index=G);const{added:$,removed:U}=f(W,Q,w,this._extHostFileSystemInfo);if($.length===0&&U.length===0)return!1;if(this._proxy){const H=c.displayName||c.name;this._proxy.$updateWorkspaceFolders(H,F,O,K).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,h.localize)(0,null,H,G.toString()),{extension:c},[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(c,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(c,F)}async getWorkspaceFolder2(c,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(c,F)}async resolveWorkspaceFolder(c){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(c)}getPath(){if(!this._actualWorkspace)return;const{folders:c}=this._actualWorkspace;if(c.length!==0)return c[0].uri.fsPath}getRelativePath(c,F){let O,V="";if(typeof c=="string"?(O=n.URI.file(c),V=c):typeof c!="undefined"&&(O=c,V=c.fsPath),!O)return V;const K=this.getWorkspaceFolder(O,!0);if(!K)return V;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let W=(0,P.relativePath)(K.uri,O);return F&&K.name&&(W=`${K.name}/${W}`),W}trySetWorkspaceFolders(c){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:c,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(c){const{workspace:F,added:O,removed:V}=D.toExtHostWorkspace(c,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:V}))}findFiles(c,F,O,V,K=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let W;if(F===null?W=!1:F&&(typeof F=="string"?W=F:W=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:$}=p(c);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(Q),(0,_.withUndefinedAsNull)($),(0,_.withUndefinedAsNull)(W),(0,_.withUndefinedAsNull)(O),K).then(U=>Array.isArray(U)?U.map(H=>n.URI.revive(H)):[])}async findTextInFiles(c,F,O,V,K=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),Q=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:$,folder:U}=p(F.include),H=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,G={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:Q,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:$,excludePattern:H},ue=!1;if(this._activeSearchCallbacks[W]=q=>{if(ue)return;const le=n.URI.revive(q.resource);q.results.forEach(se=>{(0,i.resultIsMatch)(se)?O({uri:le,preview:{text:se.preview.text,matches:(0,d.mapArrayOrNot)(se.preview.matches,ve=>new k.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(se.ranges,ve=>new k.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):O({uri:le,text:se.text,lineNumber:se.lineNumber})})},K.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(c,(0,_.withUndefinedAsNull)(U),G,W,K);return delete this._activeSearchCallbacks[W],q||{}}catch(q){throw delete this._activeSearchCallbacks[W],q}}$handleTextSearchResult(c,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](c)}saveAll(c){return this._proxy.$saveAll(c)}resolveProxy(c){return this._proxy.$resolveProxy(c)}get trusted(){return this._trusted}requestWorkspaceTrust(c){return this._proxy.$requestWorkspaceTrust(c)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=Ue([He(0,g.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,s.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function p(b){let c,F;return b&&(typeof b=="string"?c=b:(c=b.pattern,F=b.baseFolder||n.URI.file(b.base))),{includePattern:c,folder:F}}}),define(be[32],Ee([0,1,22,3,31,5,7,148,62,10,14,4,12,15,2]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(l,r){if(r){const a=r.split(".");let w=l;for(let f=0;w&&f<a.length;f++)w=w[a[f]];return w}}function v(l){return l instanceof u.URI}function I(l){return l&&l.uri instanceof u.URI&&l.languageId&&typeof l.languageId=="string"}function S(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function o(l){return l&&l.uri instanceof u.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function g(l){if(v(l))return{resource:l};if(I(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(S(l))return{overrideIdentifier:l.languageId};if(o(l))return{resource:l.uri};if(l===null)return{resource:null}}let k=class{constructor(r,a,w){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=w,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(r,a))}};k=Ue([He(0,n.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,h.ILogService)],k),e.ExtHostConfiguration=k;class i{constructor(r,a,w,f){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=a,this._configuration=C.Configuration.parse(w),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,a){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,w))}getConfiguration(r,a,w){const f=g(a)||{},m=this._toReadonlyValue(r?s(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,w?.identifier);function D(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(p){return typeof s(m,p)!="undefined"},get:(p,b)=>{this._validateConfigurationAccess(r?`${r}.${p}`:p,f,w?.identifier);let c=s(m,p);if(typeof c=="undefined")c=b;else{let F;const O=(V,K)=>{let W;const Q=()=>{F=F||(0,d.deepClone)(m),W=W||s(F,K)};return(0,P.isObject)(V)?new Proxy(V,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return Q(),()=>W;if(F)return W=W||s(F,K),W[U];const H=$[U];return typeof U=="string"?O(H,`${K}.${U}`):H},set:($,U,H)=>(Q(),W&&(W[U]=H),!0),deleteProperty:($,U)=>(Q(),W&&delete W[U],!0),defineProperty:($,U,H)=>(Q(),W&&Object.defineProperty(W,U,H),!0)}):V};c=O(c,p)}return c},update:(p,b,c,F)=>{p=r?`${r}.${p}`:p;const O=D(c);return b!==void 0?this._proxy.$updateConfigurationOption(O,p,b,f,F):this._proxy.$removeConfigurationOption(O,p,f,F)},inspect:p=>{p=r?`${r}.${p}`:p;const b=(0,d.deepClone)(this._configuration.inspect(p,f,this._extHostWorkspace.workspace));if(b)return{key:p,defaultValue:b.default?.value,globalValue:b.user?.value,workspaceValue:b.workspace?.value,workspaceFolderValue:b.workspaceFolder?.value,defaultLanguageValue:b.default?.override,globalLanguageValue:b.user?.override,workspaceLanguageValue:b.workspace?.override,workspaceFolderLanguageValue:b.workspaceFolder?.override,languageIds:b.overrideIdentifiers}}};return typeof m=="object"&&(0,d.mixin)(T,m,!1),Object.freeze(T)}_toReadonlyValue(r){const a=w=>(0,P.isObject)(w)?new Proxy(w,{get:(f,m)=>a(f[m]),set:(f,m,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return a(r)}_validateConfigurationAccess(r,a,w){const f=y.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=w?`[${w.value}] `:"";if(f===4){typeof a?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){a?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,a){const w=new C.ConfigurationChangeEvent(r,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>w.affectsConfiguration(f,g(m))})}_toMap(r){return r.reduce((a,w)=>(a.set(w[0],w[1]),a),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,38,12,29,4,11,26,15,70,166,16]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o,g){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var l;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(l=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(K){function W(U){if(U){const H=U;return H&&!!H.process}else return!1}K.is=W;function Q(U){if(U==null)return;const H={process:U.process,args:U.args};return U.options&&(H.options=r.from(U.options)),H}K.from=Q;function $(U){if(U!=null)return new R.ProcessExecution(U.process,U.args,U.options)}K.to=$})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var w;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(w=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(K){function W(U){if(U){const H=U;return H&&(!!H.commandLine||!!H.command)}else return!1}K.is=W;function Q(U){if(U==null)return;const H={};return U.commandLine!==void 0?H.commandLine=U.commandLine:(H.command=U.command,H.args=U.args),U.options&&(H.options=w.from(U.options)),H}K.from=Q;function $(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.ShellExecution(U.commandLine,U.options):new R.ShellExecution(U.command,U.args?U.args:[],U.options)}K.to=$})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(K){function W(U){if(U){let H=U;return H&&H.customExecution==="customExecution"}else return!1}K.is=W;function Q(U){return{customExecution:"customExecution"}}K.from=Q;function $(U,H){return H.get(U)}K.to=$})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(K){function W(Q,$){let U;return Q.scope!==void 0&&typeof Q.scope!="number"?U=Q.scope.uri:Q.scope!==void 0&&typeof Q.scope=="number"&&(Q.scope===R.TaskScope.Workspace&&$&&$.workspaceFile?U=$.workspaceFile:U=o.USER_TASKS_GROUP_KEY),{id:Q._id,workspaceFolder:U}}K.from=W})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(K){function W(Q){if(Q!=null)return{_id:Q.id,isDefault:Q.isDefault}}K.from=W})(T=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(K){function W(U,H){if(U==null)return[];const G=[];for(let ue of U){const q=Q(ue,H);q&&G.push(q)}return G}K.fromMany=W;function Q(U,H){if(U==null)return;let G;U.execution instanceof R.ProcessExecution?G=a.from(U.execution):U.execution instanceof R.ShellExecution?G=f.from(U.execution):U.execution&&U.execution instanceof R.CustomExecution&&(G=m.from(U.execution));const ue=i.from(U.definition);let q;return U.scope?typeof U.scope=="number"?q=U.scope:q=U.scope.uri:q=R.TaskScope.Workspace,!ue||!q?void 0:{_id:U._id,definition:ue,name:U.name,source:{extensionId:H.identifier.value,label:U.source,scope:q},execution:G,isBackground:U.isBackground,group:T.from(U.group),presentationOptions:l.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}K.from=Q;async function $(U,H,G){if(U==null)return;let ue;a.is(U.execution)?ue=a.to(U.execution):f.is(U.execution)?ue=f.to(U.execution):m.is(U.execution)&&(ue=m.to(U._id,G));const q=i.to(U.definition);let le;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?le=U.source.scope:le=await H.resolveWorkspaceFolder(d.URI.revive(U.source.scope)):le=R.TaskScope.Workspace),!q||!le)return;const se=new R.Task(q,le,U.name,U.source.label,ue,U.problemMatchers);return U.isBackground!==void 0&&(se.isBackground=U.isBackground),U.group!==void 0&&(se.group=R.TaskGroup.from(U.group._id),se.group&&(se.group=new R.TaskGroup(se.group.id,se.group.label),U.group.isDefault&&(se.group.isDefault=U.group.isDefault))),U.presentationOptions&&(se.presentationOptions=l.to(U.presentationOptions)),U._id&&(se._id=U._id),U.detail&&(se.detail=U.detail),se}K.to=$})(p=e.TaskDTO||(e.TaskDTO={}));var b;(function(K){function W($){return $}K.from=W;function Q($){if(!!$)return Object.assign(Object.create(null),$)}K.to=Q})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class c{constructor(W,Q,$){this._id=Q,this._task=$,k.set(this,void 0),Je(this,k,W,"f")}get task(){return this._task}terminate(){Te(this,k,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}k=new WeakMap;var F;(function(K){function W(Q){return{id:Q._id,task:void 0}}K.from=W})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(W,Q,$,U,H,G,ue,q){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=U,this._configurationService=H,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ue,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,Q,$){if(!$)return new R.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:Q,provider:$,extension:W}),this._proxy.$registerTaskProvider(U,Q),new R.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(W,Q){this._proxy.$registerTaskSystem(W,Q)}fetchTasks(W){return this._proxy.$fetchTasks(b.from(W)).then(async Q=>{const $=[];for(let U of Q){const H=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);H&&$.push(H)}return $})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(Q=>W.push(Q)),W}terminateTask(W){if(!(W instanceof c))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,Q,$){const U=this._providedCustomExecutions2.get(W.id);if(U){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,U),this._terminalService.attachPtyToTerminal(Q,await U.callback($))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const Q=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:Q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const Q=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:Q,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const Q=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:Q,exitCode:W.exitCode})}$provideTasks(W,Q){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));const U=[],H=(0,M.asPromise)(()=>$.provider.provideTasks(t.CancellationToken.None)).then(G=>this.provideTasksInternal(Q,U,$,G));return new Promise(G=>{H.then(ue=>{Promise.all(U).then(()=>{G(ue)})})})}async $resolveTask(W,Q){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));if(Q.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${Q.definition.type}] cannot be resolved by provider of type [${$.type}].`);const U=await p.to(Q,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const H=await $.provider.resolveTask(U,t.CancellationToken.None);if(!H)return;this.checkDeprecation(H,$);const G=p.from(H,$.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(G.execution)&&await this.addCustomExecution(G,H,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,Q,$){const U=await this._proxy.$createTaskId(W);!$&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,Q.execution)}async getTaskExecution(W,Q){if(typeof W=="string"){const H=this._taskExecutionPromises.get(W);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let $=this._taskExecutionPromises.get(W.id);if($)return $;const U=new Promise(async(H,G)=>{const ue=Q||await p.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);ue?H(new c(this,W.id,ue)):G("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,U),U.then(H=>(this._taskExecutions.set(W.id,H),H),H=>Promise.reject(H))}checkDeprecation(W,Q){W._deprecated&&this._deprecationService.report("Task.constructor",Q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let $=this._notProvidedCustomExecutions.values(),U=$.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=$.next()}};O=Ue([He(0,n.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,I.ILogService),He(7,S.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let V=class extends O{constructor(W,Q,$,U,H,G,ue,q){super(W,Q,$,U,H,G,ue,q);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(W,Q){if(!Q.execution)throw new Error("Tasks to execute must include an execution");const $=p.from(Q,W);if($===void 0)throw new Error("Task is not valid");if(m.is($.execution))await this.addCustomExecution($,Q,!1);else throw new g.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution($),Q);return this._proxy.$executeTask($).catch(H=>{throw new Error(H)}),U}provideTasksInternal(W,Q,$,U){const H=[];if(U)for(let G of U){this.checkDeprecation(G,$),(!G.definition||!W[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ue=p.from(G,$.extension);ue&&m.is(ue.execution)?(H.push(ue),Q.push(this.addCustomExecution(ue,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:$.extension}}async resolveTaskInternal(W){if(m.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,Q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,Q,$){}};V=Ue([He(0,n.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,y.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,I.ILogService),He(7,S.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,u.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,45,92,216,39]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(D,T,p,b){this.configurationService=D,this.workspaceContextService=T,this.editorGroupsService=p,this.pathService=b}text(D,T,p={}){D=this.getContentPattern(D,p);const b=this.configurationService.getValue(),c=T&&T.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(T?.map(v.toWorkspaceFolder),p),type:2,contentPattern:D,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:b.search.usePCRE2||c||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles}}getContentPattern(D,T){const p=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const b={...D,wordSeparators:p.editor.wordSeparators};return this.isCaseSensitive(D,T)&&(b.isCaseSensitive=!0),this.isMultiline(D)&&(b.isMultiline=!0),b}file(D,T={}){return{...this.commonQuery(D,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(D,T){return D?(D=Array.isArray(D)?D.map(a):a(D),T?this.parseSearchPaths(D):{pattern:i(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],T={}){const p=this.handleIncludeExclude(T.includePattern,T.expandPatterns),b=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),c=D.length>1,F=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,T,b)):D.map(K=>this.getFolderQueryForRoot(K,T,b,c))).filter(K=>!!K),O={_reason:T._reason,folderQueries:F,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:b.pattern,includePattern:p.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const W=d.coalesce(d.flatten(this.editorGroupsService.groups.map($=>$.editors.map(U=>U.resource)))).filter($=>(0,o.pathIncludedInQuery)(O,$.fsPath)),Q=this.commonQueryFromFileList(W);return{...O,...Q}}const V=T.extraFileResources&&T.extraFileResources.filter(K=>(0,o.pathIncludedInQuery)(O,K.fsPath));return O.extraFileResources=V&&V.length?V:void 0,O}commonQueryFromFileList(D){const T=[],p=new R.ResourceMap,b={};let c=!1;return D.forEach(F=>{if(F.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(F)){const V=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:y.dirname(F.fsPath)});let K=p.get(V);K||(c=!0,K={folder:V,includePattern:{}},T.push(K),p.set(V,K));const W=y.relative(V.fsPath,F.fsPath);(0,_.assertIsDefined)(K.includePattern)[W.replace(/\\/g,"/")]=!0}else F.fsPath&&(c=!0,b[F.fsPath]=!0)}),{folderQueries:T,includePattern:b,usingSearchPaths:!0,excludePattern:c?void 0:{"**/*":!0}}}isCaseSensitive(D,T){if(T.isSmartCase){if(D.isRegExp){if(t.containsUppercaseCharacter(D.pattern,!0))return!0}else if(t.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,h.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const T=Q=>y.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),b=(Array.isArray(D)?D:l(D)).map(Q=>{const $=this.pathService.resolvedUserHome;return $?(0,A.untildify)(Q,$.scheme===C.Schemas.file?$.fsPath:$.path):Q}),c=M.groupBy(b,Q=>T(Q)?"searchPaths":"exprSegments"),F=(c.exprSegments||[]).map(Q=>t.rtrim(Q,"/")).map(Q=>t.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),r(Q))),O={},V=this.expandSearchPathPatterns(c.searchPaths||[]);V&&V.length&&(O.searchPaths=V);const K=d.flatten(F),W=i(...K);return W&&(O.pattern=W),O}getExcludesForFolder(D,T){return T.disregardExcludeSettings?void 0:(0,o.getExcludes)(D,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const T=d.flatten(D.map(b=>{let{pathPortion:c,globPortion:F}=k(b);F&&(F=w(F));const O=this.expandOneSearchPath(c);return d.flatten(O.map(V=>this.resolveOneSearchPathPattern(V,F)))})),p=new Map;return T.forEach(b=>{const c=b.searchPath.toString(),F=p.get(c);F?b.pattern&&(F.pattern=F.pattern||{},F.pattern[b.pattern]=!0):p.set(c,{searchPath:b.searchPath,pattern:b.pattern?i(b.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(D){if(y.isAbsolute(D)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==C.Schemas.file?[{searchPath:T[0].uri.with({path:D})}]:[{searchPath:n.URI.file(y.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=a(D),D.startsWith("../")||D===".."){const b=y.posix.resolve(T.path,D);return[{searchPath:T.with({path:b})}]}const p=w(D);return[{searchPath:T,pattern:p}]}else{if(D==="./"||D===".\\")return[];{const T=D.replace(/^\.[\/\\]/,""),b=this.workspaceContextService.getWorkspace().folders.map(c=>{const F=T.match(new RegExp(`^${t.escapeRegExpCharacters(c.name)}(?:/(.*)|$)`));return F?{match:F,folder:c}:null}).filter(_.isDefined);if(b.length)return b.map(c=>{const F=c.match[1];return{searchPath:c.folder.uri,pattern:F&&w(F)}});{const c=D.match(/\.[\/\\](.+)[\/\\]?/),F=c?c[1]:D,O=u.localize(0,null,F);throw new Error(O)}}}}resolveOneSearchPathPattern(D,T){const p=D.pattern&&T?`${D.pattern}/${T}`:D.pattern||T,b=[{searchPath:D.searchPath,pattern:p}];return p&&!p.endsWith("**")&&b.push({searchPath:D.searchPath,pattern:p+"/**"}),b}getFolderQueryForSearchPath(D,T,p){const b=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(D.searchPath),T,p,!1);return b?{...b,includePattern:D.pattern}:null}getFolderQueryForRoot(D,T,p,b){let c;const F=n.URI.isUri(D)?D:D.uri;if(p.searchPaths){const Q=p.searchPaths.filter($=>(0,P.isEqual)($.searchPath,F))[0];if(Q&&!Q.pattern)return null;Q&&(c=Q.pattern)}const O=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(O,T)||{},...c||{}},W=n.URI.isUri(D)?(0,P.basename)(D):D.name;return{folder:F,folderName:b?W:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!O.search.followSymlinks}}};g=Ue([He(0,s.IConfigurationService),He(1,v.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,S.IPathService)],g),e.QueryBuilder=g;function k(m){const D=m.match(/[\*\{\}\(\)\[\]\?]/);if(D){const T=D.index,p=m.substr(0,T).match(/[/|\\][^/\\]*$/);if(p){let b=m.substr(0,p.index);return b.match(/[/\\]/)||(b+="/"),{pathPortion:b,globPortion:m.substr((p.index||0)+1)}}}return{pathPortion:m}}function i(...m){return m.length?m.reduce((D,T)=>(D[T]=!0,D),Object.create(null)):void 0}function l(m){return E.splitGlobAware(m,",").map(D=>D.trim()).filter(D=>!!D.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function a(m){return m.replace(/\\/g,"/")}function w(m){return a(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,D){m=d.distinct(m,b=>b.toString());const T=[],p=D.getWorkspace();return m&&m.forEach(b=>{let c;if(D.getWorkbenchState()===2)c=(0,P.relativePath)(p.folders[0].uri,b),c&&c!=="."&&(c="./"+c);else{const F=D.getWorkspaceFolder(b);if(F){const O=F.name;if(p.folders.filter(K=>K.name===O).length===1){const K=(0,P.relativePath)(F.uri,b);K===""?c=`./${F.name}`:c=`./${F.name}/${K}`}else c=b.fsPath}}c&&T.push(c)}),T}e.resolveResourcesForSearchIncludes=f}),define(be[218],Ee([0,1,24,2,21,16,4,217,39,45]),function(ie,e,d,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(s,v){const I=v.activationEvents;if(!I)return Promise.resolve(void 0);const S=[],o=[];for(const a of I)if(/^workspaceContains:/.test(a)){const w=a.substr("workspaceContains:".length);w.indexOf("*")>=0||w.indexOf("?")>=0||s.forceUsingSearch?o.push(w):S.push(w)}if(S.length===0&&o.length===0)return Promise.resolve(void 0);let g;const k=new Promise((a,w)=>{g=a}),i=a=>g({activationEvent:a}),l=Promise.all(S.map(a=>n(s,a,i))).then(()=>{}),r=h(s,v.identifier,o,i);return Promise.all([l,r]).then(()=>{g(void 0)}),k}e.checkActivateWorkspaceContainsExtension=_;async function n(s,v,I){for(const S of s.folders)if(await s.exists(d.joinPath(M.URI.revive(S),v))){I(`workspaceContains:${v}`);return}}async function h(s,v,I,S){if(I.length===0)return Promise.resolve(void 0);const o=new E.CancellationTokenSource,g=s.checkExists(s.folders,I,o.token),k=setTimeout(async()=>{o.cancel(),S(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await g}catch(l){A.isPromiseCanceledError(l)||A.onUnexpectedError(l)}o.dispose(),clearTimeout(k),i&&S(`workspaceContains:${I.join(",")}`)}function u(s,v,I,S){const o=s.get(R.IInstantiationService),g=s.get(y.ISearchService),i=o.createInstance(C.QueryBuilder).file(v.map(l=>(0,P.toWorkspaceFolder)(M.URI.revive(l))),{_reason:"checkExists",includePattern:I,exists:!0});return g.fileSearch(i,S).then(l=>!!l.limitHit,l=>A.isPromiseCanceledError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=u});var Je=this&&this.__classPrivateFieldSet||function(ie,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!E:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ie,d):E?E.value=d:e.set(ie,d),d},Te=this&&this.__classPrivateFieldGet||function(ie,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,179,72,31,30,177,16,25,23,153,7,85,4,29,73,12,61,64,38,3,218,69,155]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o,g,k,i,l,r,a,w,f,m,D,T,p,b,c,F){"use strict";var O,V,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let W=class Wi extends C.Disposable{constructor(H,G,ue,q,le,se,ve,Fe,Me,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=ue,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=le,this._logService=se,this._extHostTunnelService=Me,this._extHostTerminalService=Ne,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new c.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=H.createChild(new m.ServiceCollection([u.IExtHostStorage,this._storage],[c.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(ze=>Qe.add(o.ExtensionIdentifier.toKey(ze))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,S.transformErrorForSerialization(qe),x)},actualActivateExtension:async(ze,qe)=>{if(Qe.has(o.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new h.HostExtension;const x=this._registry.getExtensionDescription(ze);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(H){S.onUnexpectedError(H)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let H=[];try{H=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(G){}await Promise.all(H)}isActivated(H){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(H):!1}_activateByEvent(H,G){return this._activator.activateByEvent(H,G)}_activateById(H,G){return this._activator.activateById(H,G)}activateByIdWithErrors(H,G){return this._activateById(H,G).then(()=>{const ue=this._activator.getActivatedExtension(H);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(H=>this._registry)}getExtensionExports(H){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(H).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const H=y.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(ue=>{if(!!this._getEntryPoint(ue))return this._hostUtils.realpath(ue.extensionLocation.fsPath).then(q=>H.set(P.URI.file(q).fsPath,ue))});this._extensionPathIndex=Promise.all(G).then(()=>H)}return this._extensionPathIndex}_deactivate(H){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(H))return G;const ue=this._activator.getActivatedExtension(H);if(!ue)return G;try{typeof ue.module.deactivate=="function"&&(G=Promise.resolve(ue.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(q)}try{(0,C.dispose)(ue.subscriptions)}catch(q){this._logService.error(q)}return G}async _activateExtension(H,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier),this._doActivateExtension(H,G).then(ue=>{const q=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(H.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,G),this._logExtensionActivationTimes(H,G,"success",q),ue},ue=>{throw this._logExtensionActivationTimes(H,G,"failure"),ue})}_logExtensionActivationTimes(H,G,ue,q){const le=Q(H,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...q||{},outcome:ue})}_doActivateExtension(H,G){const ue=Q(H,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const q=this._getEntryPoint(H);if(!q)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${H.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const le=new h.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(H.identifier,(0,A.joinPath)(H.extensionLocation,q),le),this._loadExtensionContext(H)]).then(se=>(E.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Wi._callActivate(this._logService,H.identifier,se[0],se[1],le))).then(se=>(E.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),se))}_loadExtensionContext(H){const G=new k.ExtensionGlobalMemento(H,this._storage),ue=new k.ExtensionMemento(H.identifier.value,!1,this._storage),q=new F.ExtensionSecrets(H,this._secretState),le=H.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,se=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([G.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Fe;return Object.freeze({globalState:G,workspaceState:ue,secrets:q,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(H.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(H)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(H).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,H.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,H.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(H)},get globalStorageUri(){return ve._storagePath.globalValue(H)},get extensionMode(){return le},get extension(){return Fe===void 0&&(Fe=new $(ve,H.identifier,H,se)),Fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(H),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(H)}})})}static _callActivate(H,G,ue,q,le){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(H,G,ue,q,le).then(se=>new h.ActivatedExtension(!1,null,le.build(),ue,se,q.subscriptions))}static _callActivateOptional(H,G,ue,q,le){if(typeof ue.activate=="function")try{le.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${G.value}`);const se=typeof global=="object"?global:self,ve=ue.activate.apply(se,[q]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Fe=>(le.activateResolveStop(),Fe))}catch(se){return Promise.reject(se)}else return Promise.resolve(ue)}_activateOneStartupFinished(H,G){this._activateById(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:G}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const H of this._registry.getAllExtensionDescriptions())if(H.activationEvents)for(const G of H.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(H,G)}_handleEagerExtensions(){const H=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(G),q=Promise.all([H,ue]).then(()=>{});return Promise.race([q,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(H){return H.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(H,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(H,G){if(this.isActivated(G.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:H.map(se=>se.uri),forceUsingSearch:ue,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ve,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(se,ve,Fe)},le=await(0,b.checkActivateWorkspaceContainsExtension)(q,G);if(!!le)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:le.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(H){throw console.error(H),H}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:G}=this._initData.environment;if(!H||!G)throw new Error(d.localize(0,null));const ue=await this._loadCommonJSModule(null,G,new h.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(d.localize(1,null,G.toString()));return new Promise((q,le)=>{const se=(Me,Ne)=>{Me?le(Me):q(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,A.originalFSPath)(G),Fe=ue.run(ve,se);Fe&&Fe.then&&Fe.then(()=>{q(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(H){this._logService.info(`extension host terminating: test runner requested exit with code ${H}`),this._logService.info(`exiting with code ${H}`),this._logService.flush(),this._hostUtils.exit(H)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(H,G){return this._resolvers[H]=G,(0,C.toDisposable)(()=>{delete this._resolvers[H]})}async _activateAndGetResolver(H){const G=H.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const ue=H.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(H,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(H);if(!q)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(q)),E.mark(`code/extHost/willResolveAuthority/${ue}`);const le=await q.resolve(H,{resolveAttempt:G});E.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const se={authority:H,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:se,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(E.mark(`code/extHost/didResolveAuthorityError/${ue}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(H,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(H);if(!q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const le=P.URI.revive(G);if(typeof q.getCanonicalURI=="undefined")return le;const se=await(0,R.asPromise)(()=>q.getCanonicalURI(le));return se||le}$startExtensionHost(H){return this._registry.keepOnly(H),this._startExtensionHost()}$activateByEvent(H,G){return G===1?this._activateByEvent(H,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(H,!1))}async $activate(H,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(H)?(await this._activateById(H,G),!0):!1}async $deltaExtensions(H,G){H.forEach(q=>q.extensionLocation=P.URI.revive(q.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(G.map(async q=>{const le=this._registry.getExtensionDescription(q);if(!le)return;const se=await this._hostUtils.realpath(le.extensionLocation.fsPath);ue.delete(P.URI.file(se).fsPath)})),await Promise.all(H.map(async q=>{const le=await this._hostUtils.realpath(q.extensionLocation.fsPath);ue.set(P.URI.file(le).fsPath,q)})),this._registry.deltaExtensions(H,G),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){let G=g.VSBuffer.alloc(H),ue=Math.random()%256;for(let q=0;q<H;q++)G.writeUInt8(ue,q);return G}async $updateRemoteConnectionData(H){this._remoteConnectionData=H,this._onDidChangeRemoteConnectionData.fire()}};W=Ue([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,f.IExtHostRpcService),He(3,s.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,t.ILogService),He(6,a.IExtHostInitDataService),He(7,w.IExtensionStoragePaths),He(8,D.IExtHostTunnelService),He(9,T.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function Q(U,H){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(H,G,ue,q){O.set(this,void 0),V.set(this,void 0),K.set(this,void 0),Je(this,O,H,"f"),Je(this,V,G,"f"),Je(this,K,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=q}get isActive(){return Te(this,O,"f").isActivated(Te(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,O,"f").getExtensionExports(Te(this,K,"f"))}activate(){return Te(this,O,"f").activateByIdWithErrors(Te(this,K,"f"),{startup:!1,extensionId:Te(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,O=new WeakMap,V=new WeakMap,K=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,163,31,33,49,168,32,164,12,4,10,91,68]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let g=class{constructor(m,D,T,p,b,c){this._workspaceService=D,this._extensionService=T,this._editorsService=p,this._configurationService=b,this._editorTabs=c,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=m.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(O=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,D){const T=m;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let p=`debug:${encodeURIComponent(T.path||"")}`,b="?";return D&&(p+=`${b}session=${encodeURIComponent(D.id)}`,b="&"),p+=`${b}ref=${T.sourceReference}`,M.URI.parse(p)}else{if(T.path)return M.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const D=[];for(const T of m.getAllExtensionDescriptions())if(T.contributes){const p=T.contributes.debuggers;if(p&&p.length>0)for(const b of p)(0,u.isDebuggerMainContribution)(b)&&D.push(b.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(D=>m.push(D)),m}addBreakpoints(m){this.startBreakpoints();const D=m.filter(b=>{const c=b.id;return this._breakpoints.has(c)?!1:(this._breakpoints.set(c,b),!0)});this.fireBreakpointChanges(D,[],[]);const T=[],p=new Map;for(const b of D)if(b instanceof C.SourceBreakpoint){let c=p.get(b.location.uri.toString());c||(c={type:"sourceMulti",uri:b.location.uri,lines:[]},p.set(b.location.uri.toString(),c),T.push(c)),c.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof C.FunctionBreakpoint&&T.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(m){this.startBreakpoints();const D=m.filter(c=>this._breakpoints.delete(c.id));this.fireBreakpointChanges([],D,[]);const T=D.filter(c=>c instanceof C.SourceBreakpoint).map(c=>c.id),p=D.filter(c=>c instanceof C.FunctionBreakpoint).map(c=>c.id),b=D.filter(c=>c instanceof C.DataBreakpoint).map(c=>c.id);return this._debugServiceProxy.$unregisterBreakpoints(T,p,b)}startDebugging(m,D,T){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,D,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI,suppressSaveBeforeStart:T.suppressSaveBeforeStart})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,D,T){if(!D)return new C.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:p,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,T,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,p),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(m,D,T){if(!T)return new C.Disposable(()=>{});if(!this.definesDebugType(m,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:p,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,p),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(m,D){if(!D)return new C.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:T,factory:D}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==D)})}async $runInTerminal(m,D){return Promise.resolve(void 0)}async $substituteVariables(m,D){if(!this._variableResolver){const[b,c]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,c)}let T;const p=await this.getFolder(m);return p&&(T={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,D)}createDebugAdapter(m,D){if(m.type==="implementation")return new a(m.implementation)}createSignService(){}async $startDASession(m,D){const T=this,p=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const c=this.convertToDto(b),F=this.createDebugAdapter(c,p);if(!F)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const O=F;return this._debugAdapters.set(m,O),this.getDebugAdapterTrackers(p).then(V=>(V&&this._debugAdaptersTrackers.set(m,V),O.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const W=K,Q={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(W.arguments.value);Q.body={signature:$},O.sendResponse(Q)}else throw new Error("no signer")}catch($){Q.success=!1,Q.message=$.message,O.sendResponse(Q)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(K),K=(0,u.convertToVSCPaths)(K,!0),T._debugServiceProxy.$acceptDAMessage(m,K)}),O.onError(K=>{V&&V.onError&&V.onError(K),this._debugServiceProxy.$acceptDAError(m,K.name,K.message,K.stack)}),O.onExit(K=>{V&&V.onExit&&V.onExit((0,I.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,I.withNullAsUndefined)(K),void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),O.startSession()))})}$sendDAMessage(m,D){D=(0,u.convertToDAPaths)(D,!1);const T=this._debugAdaptersTrackers.get(m);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(D);const p=this._debugAdapters.get(m);p&&p.sendMessage(D)}$stopDASession(m){const D=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),D&&D.onWillStopSession&&D.onWillStopSession();const T=this._debugAdapters.get(m);return this._debugAdapters.delete(m),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const D=[],T=[],p=[];if(m.added)for(const b of m.added){const c=b.id;if(c&&!this._breakpoints.has(c)){let F;if(b.type==="function")F=new C.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")F=new C.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const O=M.URI.revive(b.uri);F=new C.SourceBreakpoint(new C.Location(O,new C.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}F._id=c,this._breakpoints.set(c,F),D.push(F)}}if(m.removed)for(const b of m.removed){const c=this._breakpoints.get(b);c&&(this._breakpoints.delete(b),T.push(c))}if(m.changed){for(const b of m.changed)if(b.id){const c=this._breakpoints.get(b.id);if(c){if(c instanceof C.FunctionBreakpoint&&b.type==="function"){const F=c;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.functionName=b.functionName}else if(c instanceof C.SourceBreakpoint&&b.type==="source"){const F=c;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.location=new C.Location(M.URI.revive(b.uri),new C.Position(b.line,b.character))}p.push(c)}}}this.fireBreakpointChanges(D,T,p)}$provideDebugConfigurations(m,D,T){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(m);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(D);return p.provideDebugConfigurations(b,T)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(m,D,T,p){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.getFolder(D);return b.resolveDebugConfiguration(c,T,p)})}$resolveDebugConfigurationWithSubstitutedVariables(m,D,T,p){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.getFolder(D);return b.resolveDebugConfigurationWithSubstitutedVariables(c,T,p)})}async $provideDebugAdapter(m,D){const T=this.getAdapterDescriptorFactoryByHandle(m);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(D);return this.getAdapterDescriptor(T,p).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(m){const D=await this.getSession(m);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(m){const D=await this.getSession(m);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,D){const T=await this.getSession(m);T&&T._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(m,D){const p={session:await this.getSession(m),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(m){if(m instanceof C.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof C.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const D=this._adapterFactories.filter(T=>T.type===m);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(m){const D=this._adapterFactories.filter(T=>T.handle===m);if(D.length>0)return D[0].factory}getConfigProviderByHandle(m){const D=this._configProviders.filter(T=>T.handle===m);if(D.length>0)return D[0].provider}definesDebugType(m,D){if(m.contributes){const T=m.contributes.debuggers;if(T&&T.length>0){for(const p of T)if(p.label&&p.type&&p.type===D)return!0}}return!1}getDebugAdapterTrackers(m){const T=m.configuration.type,p=this._trackerFactories.filter(b=>b.type===T||b.type==="*").map(b=>(0,A.asPromise)(()=>b.factory.createDebugAdapterTracker(m)).then(c=>c,c=>null));return Promise.race([Promise.all(p).then(b=>{const c=b.filter(F=>!!F);if(c.length>0)return new r(c)}),new Promise((b,c)=>{const F=setTimeout(()=>{clearTimeout(F),c(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(m,D){const T=D.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new C.DebugAdapterServer(T));if(m){const b=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>m.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,b))).then(c=>{if(c)return c})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,p))}daExecutableFromPackage(m,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,D,T){(m.length>0||D.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:D,changed:T}))}async getSession(m){if(m)if(typeof m=="string"){const D=this._debugSessions.get(m);if(D)return D}else{let D=this._debugSessions.get(m.id);if(!D){const T=await this.getFolder(m.folderUri),p=m.parent?this._debugSessions.get(m.parent):void 0;D=new k(this._debugServiceProxy,m.id,m.type,m.name,T,m.configuration,p),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(m){if(m){const D=M.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};g=Ue([He(0,s.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,_.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class k{constructor(m,D,T,p,b,c,F){this._debugServiceProxy=m,this._id=D,this._type=T,this._name=p,this._workspaceFolder=b,this._configuration=c,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,D)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=k;class i{constructor(m){this.value=Object.freeze({append(D){m.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=i;class l extends n.AbstractVariableResolverService{constructor(m,D,T,p,b){function c(){if(D){const F=D.activeEditor();if(F)return F.document.uri;const O=p.tabs.filter(V=>V.isActive);if(O.length>0){const V=O[0].resource;return V&&(V.primary||V.secondary)?V.primary??V.secondary:O[0].resource}}}super({getFolderUri:F=>{const O=m.filter(V=>V.name===F);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(F,O)=>T.getConfiguration(void 0,F).get(O),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=c();if(F)return d.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const F=c();if(F){const O=b.getWorkspaceFolder(F);if(O)return d.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(D){const F=D.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(D){const F=D.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=l;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(D=>D.onError?D.onError(m):void 0)}onExit(m,D){this.trackers.forEach(T=>T.onExit?T.onExit(m,D):void 0)}}class a extends y.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends g{constructor(m,D,T,p,b,c){super(m,D,T,p,b,c)}createVariableResolver(m,D,T){return new l(m,D,T,this._editorTabs)}};w=Ue([He(0,s.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,_.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],w),e.WorkerExtHostDebugService=w}),define(be[219],Ee([0,1,74,2,5,32,30,25,12,29,4,33,91,15]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(o,g,k,i,l,r,a){this._apiFactory=o,this._extensionRegistry=g,this._instaService=k,this._extHostConfiguration=i,this._extHostExtensionService=l,this._initData=r,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,g,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,g,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let g of o.nodeModuleName)this._factories.set(g,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(g=>o.alternativeModuleName(g))}};u=Ue([He(2,t.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,_.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,h.ILogService)],u),e.RequireInterceptor=u;class s{constructor(o,g,k,i,l){this._apiFactory=o,this._extensionPaths=g,this._extensionRegistry=k,this._configProvider=i,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,g){const k=this._extensionPaths.findSubstr(g.fsPath);if(k){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(k.identifier));return i||(i=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(k.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((l,r)=>i+=`	${r} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(o,g){this.nodeModuleName="keytar";const{environment:k}=g,i=o.getProxy(E.MainContext.MainThreadKeytar);if(k.appRoot){let l=k.appRoot.fsPath;n.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${l}/node_modules.asar/keytar`),this.alternativeNames.add(`${l}/node_modules/keytar`)}this._impl={getPassword:(l,r)=>i.$getPassword(l,r),setPassword:(l,r,a)=>i.$setPassword(l,r,a),deletePassword:(l,r)=>i.$deletePassword(l,r),findPassword:l=>i.$findPassword(l),findCredentials(l){return i.$findCredentials(l)}}}load(o,g){return this._impl}alternativeModuleName(o){const g=o.length;if(g<=7||!this.alternativeNames)return;const k=g-7;if((o.charAt(k)==="/"||o.charAt(k)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};v=Ue([He(0,y.IExtHostRpcService),He(1,P.IExtHostInitDataService)],v);let I=class{constructor(o,g,k){this._extensionPaths=o,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(E.MainContext.MainThreadTelemetry);const i=k.getProxy(E.MainContext.MainThreadWindow);this._impl=(l,r)=>{const a=M.URI.parse(l);return r?this.callOriginal(l,r):a.scheme==="http"||a.scheme==="https"?i.$openUri(a,l,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?i.$openUri(a,l,{}):this.callOriginal(l,r)}}load(o,g,k){const i=this._extensionPaths.findSubstr(g.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=k(o),this._impl}callOriginal(o,g){return this.sendNoForwardTelemetry(),this._original(o,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Ue([He(2,y.IExtHostRpcService)],I)}),define(be[220],Ee([0,1,14,16,74,6,2,5,213,15,57,61,29,144,12,65,33,38]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(g,k,i,l){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new y.RPCProtocol(g,null,l),k=S._transform(k,this._rpcProtocol);const r=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...k}),r.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),r.set(s.IURITransformerService,new s.URITransformerService(l)),r.set(v.IHostUtils,i);const a=new h.InstantiationService(r,!0),w=a.invokeFunction(T=>T.get(I.IExtHostTerminalService));this._disposables.add(w),this._logService=a.invokeFunction(T=>T.get(P.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",k),this._extensionService=a.invokeFunction(T=>T.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(p,b)=>{let c="",F,O;for(const V of b)c+=`
	at ${V.toString()}`,O=V.getFileName(),!F&&O&&(F=T.findSubstr(O));return f.set(p,F),`${p.name||"Error"}: ${p.message||""}${c}`}});const m=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(T=>{const p=M.transformErrorForSerialization(T),b=f.get(T);b?m.$onExtensionRuntimeError(b.identifier,p):D.$onUnexpectedError(p)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const k=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),k]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(g,k){g.extensions.forEach(l=>l.extensionLocation=R.URI.revive(k.transformIncomingURIs(l.extensionLocation))),g.environment.appRoot=R.URI.revive(k.transformIncomingURIs(g.environment.appRoot));const i=g.environment.extensionDevelopmentLocationURI;return i&&(g.environment.extensionDevelopmentLocationURI=i.map(l=>R.URI.revive(k.transformIncomingURIs(l)))),g.environment.extensionTestsLocationURI=R.URI.revive(k.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=R.URI.revive(k.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=R.URI.revive(k.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=R.URI.revive(k.transformIncomingURIs(g.logsLocation)),g.logFile=R.URI.revive(k.transformIncomingURIs(g.logFile)),g.workspace=k.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=S}),define(be[221],Ee([0,1,17,21,56,27,24,194,39]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,h,u){this.config=n,this.provider=h,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const h=this.config.folderQueries||[];return new Promise((u,s)=>{const v=I=>{this.resultCount++,n(I)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const S=I.toString(),o=d.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,o)||this.matchFile(v,{base:I,basename:o})}),Promise.all(h.map(I=>this.searchInFolder(I,v))).then(I=>{u({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{s(new Error((0,E.toErrorMessage)(I)))})})}async searchInFolder(n,h){const u=new M.CancellationTokenSource,s=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),I=new y.QueryGlobTester(this.config,n),S=!I.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(u),o=C.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,u.token),k=o.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(l=>{const r=d.posix.relative(n.folder.path,l.path);if(S){const a=d.basename(l.path);this.matchFile(h,{base:n.folder,relativePath:r,basename:a});return}this.addDirectoryEntries(v,n.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,I,h),{providerTime:k,postProcessTime:i.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(n){const h=(0,y.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),u=(0,y.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:u,includes:h,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},h,u,s){if(u===this.filePattern){const I=d.basename(this.filePattern);this.matchFile(s,{base:h,relativePath:this.filePattern,basename:I})}function v(I){const S=d.basename(I),o=d.dirname(I);let g=n[o];g||(g=n[o]=[],v(o)),g.push({base:h,relativePath:I,basename:S})}v(u)}matchDirectoryTree({rootEntries:n,pathToEntries:h},u,s){const v=this,I=this.filePattern;function S(o){const g=A.hasSiblingFn(()=>o.map(k=>k.basename));for(let k=0,i=o.length;k<i;k++){const l=o[k],{relativePath:r,basename:a}=l;if(!u.includedInQuerySync(r,a,I!==a?g:void 0))continue;const w=h[r];if(w)S(w);else{if(r===I)continue;v.matchFile(s,l)}if(v.isLimitHit)break}}S(n)}matchFile(n,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(h))}}class t{constructor(){this.sessions=new Map}fileSearch(n,h,u,s){const v=this.getSessionTokenSource(n.cacheKey),I=new P(n,h,v&&v.token);let S=0;const o=g=>{S+=g.length,u(g.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(I,t.BATCH_SIZE,o,s).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:g.stats}}))}clearCache(n){const h=this.getSessionTokenSource(n);h&&h.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:R.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,h,u,s){s.onCancellationRequested(()=>{n.cancel()});const v=S=>{S&&(I.push(S),h>0&&I.length>=h&&(u(I),I=[]))};let I=[];return n.search(v).then(S=>(I.length&&u(I),S),S=>(I.length&&u(I),Promise.reject(S)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,13,21,56,27,11,17,24,10,2,39]),function(ie,e,d,M,E,A,R,C,y,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,g,k,i){this.query=o,this.provider=g,this.fileUtils=k,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,g){const k=this.query.folderQueries||[],i=new M.CancellationTokenSource;return g.onCancellationRequested(()=>i.cancel()),new Promise((l,r)=>{this.collector=new u(o);let a=!1;const w=(f,m)=>{if(!a&&!this.isLimitHit){const D=this.resultSize(f);v(f)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,a=!0,i.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const T=this.resultSize(f);this.resultCount+=T,(T>0||!v(f))&&this.collector.add(f,m)}};Promise.all(k.map((f,m)=>this.searchInFolder(f,D=>w(D,m),i.token))).then(f=>{i.dispose(),this.collector.flush();const m=f.some(D=>!!D&&!!D.limitHit);l({limitHit:this.isLimitHit||m,messages:(0,d.flatten)(f.map(D=>D?.message?(0,P.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:this.processType}})},f=>{i.dispose();const m=(0,E.toErrorMessage)(f);r(new Error(m))})})}resultSize(o){return v(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,g){const k=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:k.slice(0,g),preview:{matches:i.slice(0,g),text:o.preview.text},uri:o.uri}}async searchInFolder(o,g,k){const i=new _.QueryGlobTester(this.query,o),l=[],r={report:f=>{if(!this.validateProviderResult(f))return;const m=o.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(f.uri))):void 0,D=y.relativePath(o.folder,f.uri);if(D){const T=i.includedInQuery(D,C.basename(D),m);(0,P.isPromise)(T)?l.push(T.then(p=>{p&&g(f)})):T&&g(f)}}},a=this.getSearchOptionsForFolder(o),w=await this.provider.provideTextSearchResults(h(this.query.contentPattern),a,r,k);return l.length&&await Promise.all(l),w}validateProviderResult(o){if(v(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const g=(0,_.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),k=(0,_.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:k,includes:g,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function h(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class u{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,g=>this.sendItems(g))}add(o,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!y.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(s(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=u;function s(S){return v(S)?{preview:{matches:(0,d.mapArrayOrNot)(S.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:S.preview.text},ranges:(0,d.mapArrayOrNot)(S.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function v(S){return!!S.preview}e.extensionResultIsMatch=v;class I{constructor(o,g){this.maxBatchSize=o,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,g){!o||this.addItemToBatch(o,g)}addItems(o,g){!o||this.addItemsToBatch(o,g)}addItemToBatch(o,g){this.batch.push(o),this.batchSize+=g,this.onUpdate()}addItemsToBatch(o,g){this.batch=this.batch.concat(o),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,12,65,15,2,222]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(s,v,I){this.extHostRpc=s,this._uriTransformer=v,this._logService=I,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,v){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const I=this._handlePool++;return this._textSearchProvider.set(I,v),this._proxy.$registerTextSearchProvider(I,this._transformScheme(s)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(s,v){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const I=this._handlePool++;return this._fileSearchProvider.set(I,v),this._proxy.$registerFileSearchProvider(I,this._transformScheme(s)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(s,v,I,S){const o=n(I),g=this._fileSearchProvider.get(s);if(g)return this._fileSearchManager.fileSearch(o,g,k=>{this._proxy.$handleFileMatch(s,v,k.map(i=>i.resource))},S);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,v,I,S){const o=this._textSearchProvider.get(s);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const g=n(I);return this.createTextSearchManager(g,o).search(i=>this._proxy.$handleTextMatch(s,v,i),S)}$enableExtensionHostSearch(){}createTextSearchManager(s,v){return new t.TextSearchManager(s,v,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};_=Ue([He(0,R.IExtHostRpcService),He(1,C.IURITransformerService),He(2,y.ILogService)],_),e.ExtHostSearch=_;function n(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(h),extraFileResources:u.extraFileResources&&u.extraFileResources.map(s=>P.URI.revive(s))}}e.reviveQuery=n;function h(u){return{...u,folder:P.URI.revive(u.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,184,183,48,185,32,186,187,188,170,189,49,33,190,171,193,195,196,96,173,201,202,203,72,38,205,174,8,7,208,50,97,31,30,51,160,192,86,95,99,100,101,15,65,12,29,197,157,64,70,181,206,156,73,71,211,209,210,182,37,204,207,69,68,87,199,98,200,11,146,198,154,191]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o,g,k,i,l,r,a,w,f,m,D,T,p,b,c,F,O,V,K,W,Q,$,U,H,G,ue,q,le,se,ve,Fe,Me,Ne,Qe,ze,qe,x,Y,ee,ae,j,oe,fe,Ae,xe,$e,we,Ze,z,J,he,Oe,Ve,tt,ut,ht,St,Pt,dt,bt,ft,Et,Ye,Ct,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const ce=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ve.IExtHostFileSystemInfo),me=Z.get(Ze.IExtHostConsumerFileSystem),Ie=Z.get(r.IExtHostExtensionService),Be=Z.get(ue.IExtHostWorkspace),Le=Z.get(Pt.IExtHostTelemetry),je=Z.get(I.IExtHostConfiguration),Xe=Z.get(x.IURITransformerService),ne=Z.get(Y.IExtHostRpcService),pe=Z.get(O.IExtHostStorage),re=Z.get(we.IExtensionStoragePaths),B=Z.get(qe.ILogService),Ce=Z.get(oe.IExtHostTunnelService),Se=Z.get(fe.IExtHostApiDeprecationService),Ge=Z.get(G.IExtHostWindow),We=Z.get(ht.IExtHostSecretState),it=Z.get(St.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogService,B),ne.set(n.ExtHostContext.ExtHostWorkspace,Be),ne.set(n.ExtHostContext.ExtHostConfiguration,je),ne.set(n.ExtHostContext.ExtHostExtensionService,Ie),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,Ce),ne.set(n.ExtHostContext.ExtHostWindow,Ge),ne.set(n.ExtHostContext.ExtHostSecretState,We),ne.set(n.ExtHostContext.ExtHostTelemetry,Le),ne.set(n.ExtHostContext.ExtHostEditorTabs,it);const mt=ne.set(n.ExtHostContext.ExtHostDecorations,Z.get(Me.IExtHostDecorations)),vt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(l.IExtHostDocumentsAndEditors)),nt=ne.set(n.ExtHostContext.ExtHostCommands,Z.get(s.IExtHostCommands)),ot=ne.set(n.ExtHostContext.ExtHostTerminalService,Z.get(V.IExtHostTerminalService)),lt=ne.set(n.ExtHostContext.ExtHostDebugService,Z.get(Qe.IExtHostDebugService)),Rt=ne.set(n.ExtHostContext.ExtHostSearch,Z.get(ze.IExtHostSearch)),_t=ne.set(n.ExtHostContext.ExtHostTask,Z.get(Ne.IExtHostTask)),Ot=ne.set(n.ExtHostContext.ExtHostOutputService,Z.get(T.IExtHostOutputService)),di=ne.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ne)),kt=ne.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ne,vt)),$t=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ne,vt,B)),Zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new k.ExtHostDocumentSaveParticipant(B,kt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ne.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ne,nt,vt,kt,re)),Kt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(B,gt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ct.ExtHostNotebookEditors(B,ne,gt)),ei=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(ne,ce,gt,B)),ti=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new ft.ExtHostNotebookRenderers(ne,gt)),It=ne.set(n.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ne,vt)),Qt=ne.set(n.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),nt,B)),wi=ne.set(n.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),It,ce)),Wt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(ne,B,ge)),Ht=ne.set(n.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(ne,kt,nt.converter)),ct=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(ne,Xe,kt,nt,Wt,B,Se)),ii=ne.set(n.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(ne,ct)),Nt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(ne,B,vt)),xt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,b.createExtHostQuickOpen)(ne,Be,nt)),Yt=ne.set(n.ExtHostContext.ExtHostSCM,new c.ExtHostSCM(ne,nt,B)),bi=ne.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(ne,nt,kt)),hi=ne.set(n.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(ne)),fi=ne.set(n.ExtHostContext.ExtHostTheming,new j.ExtHostTheming(ne)),ni=ne.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ne)),ri=ne.set(n.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(ne,nt)),jt=ne.set(n.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(ne,{remote:ce.remote},Be,B,Se)),si=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(ne,jt,Be)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new J.ExtHostCustomEditors(ne,kt,re,jt,si)),yi=ne.set(n.ExtHostContext.ExtHostWebviewViews,new z.ExtHostWebviewViews(ne,jt)),qt=ne.set(n.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ne,nt)),Jt=ne.set(n.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ne,gt,vt,nt));const Si=(0,le.values)(n.ExtHostContext);ne.assertRegistered(Si);const Di=new Oe.ExtHostBulkEdits(ne,vt),oi=new u.ExtHostClipboard(ne),ai=new D.ExtHostMessageService(ne,B),zt=new o.ExtHostDialogs(ne),Mt=new F.ExtHostStatusBar(ne,nt.converter);return h.ExtHostApiCommands.register(nt),function(Re,Tt,Gt){const pt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(B.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")de(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&de(rt),!Re.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,q.throwProposedApiError)(Re)}return rt}}(),Ci={getSession(X,de,ke){return ke?.forceNewSession&&(0,q.checkProposedApiEnabled)(Re),ni.getSession(Re,X,de,ke)},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,rt){return ni.registerAuthenticationProvider(X,de,ke,rt)}},ki={registerCommand(X,de,ke){return nt.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return nt.registerCommand(!0,X,(...rt)=>{const wt=It.getActiveTextEditor();if(!wt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Dt=>{de.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||B.warn("Edits from command "+X+" were not applied.")},Dt=>{B.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),nt.registerCommand(!0,X,async(...rt)=>{const wt=vt.activeEditor(!0);if(!wt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(wt.id);de.apply(ke,[Dt,...rt])})),executeCommand(X,...de){return nt.executeCommand(X,...de)},getCommands(X=!1){return nt.getCommands(X)}},mi={get machineId(){return ce.telemetryInfo.machineId},get sessionId(){return ce.telemetryInfo.sessionId},get language(){return ce.environment.appLanguage},get appName(){return ce.environment.appName},get appRoot(){return ce.environment.appRoot?.fsPath??""},get appHost(){return ce.environment.appHost},get uriScheme(){return ce.environment.appUriScheme},get clipboard(){return oi.value},get shell(){return ot.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(ce.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return Ge.openUri(X,{allowTunneling:!!ce.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ce.environment.appUriScheme)return di.createAppUri(X);try{return await Ge.asExternalUri(X,{allowTunneling:!!ce.remote.authority})}catch(de){if((0,Ye.matchesScheme)(X,Et.Schemas.http)||(0,Ye.matchesScheme)(X,Et.Schemas.https))return X;throw de}},get remoteName(){return(0,Fe.getRemoteName)(ce.remote.authority)},get remoteAuthority(){return ce.remote.authority},get uiKind(){return ce.uiKind}};ce.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ce.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ii={createTestController(X,de){return qt.createTestController(X,de)},createTestObserver(){return(0,q.checkProposedApiEnabled)(Re),qt.createTestObserver()},runTests(X){return(0,q.checkProposedApiEnabled)(Re),qt.runTests(X)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Re),qt.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Re),qt.results}},Pi={getExtension(X){const de=Tt.getExtensionDescription(X);if(de)return new r.Extension(Ie,Re.identifier,de,gi)},get all(){return Tt.getAllExtensionDescriptions().map(X=>new r.Extension(Ie,Re.identifier,X,gi))},get onDidChange(){return Tt.onDidChange}},li={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,de){return Ht.changeLanguage(X.uri,de)},match(X,de){return(0,t.score)(Q.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return ct.registerCodeActionProvider(Re,pt(X),de,ke)},registerCodeLensProvider(X,de){return ct.registerCodeLensProvider(Re,pt(X),de)},registerDefinitionProvider(X,de){return ct.registerDefinitionProvider(Re,pt(X),de)},registerDeclarationProvider(X,de){return ct.registerDeclarationProvider(Re,pt(X),de)},registerImplementationProvider(X,de){return ct.registerImplementationProvider(Re,pt(X),de)},registerTypeDefinitionProvider(X,de){return ct.registerTypeDefinitionProvider(Re,pt(X),de)},registerHoverProvider(X,de){return ct.registerHoverProvider(Re,pt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return ct.registerEvaluatableExpressionProvider(Re,pt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return ct.registerInlineValuesProvider(Re,pt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return ct.registerDocumentHighlightProvider(Re,pt(X),de)},registerLinkedEditingRangeProvider(X,de){return ct.registerLinkedEditingRangeProvider(Re,pt(X),de)},registerReferenceProvider(X,de){return ct.registerReferenceProvider(Re,pt(X),de)},registerRenameProvider(X,de){return ct.registerRenameProvider(Re,pt(X),de)},registerDocumentSymbolProvider(X,de,ke){return ct.registerDocumentSymbolProvider(Re,pt(X),de,ke)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return ct.registerDocumentFormattingEditProvider(Re,pt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return ct.registerDocumentRangeFormattingEditProvider(Re,pt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...rt){return ct.registerOnTypeFormattingEditProvider(Re,pt(X),de,[ke].concat(rt))},registerDocumentSemanticTokensProvider(X,de,ke){return ct.registerDocumentSemanticTokensProvider(Re,pt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return ct.registerDocumentRangeSemanticTokensProvider(Re,pt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...rt){return typeof ke=="object"?ct.registerSignatureHelpProvider(Re,pt(X),de,ke):ct.registerSignatureHelpProvider(Re,pt(X),de,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(X,de,...ke){return ct.registerCompletionItemProvider(Re,pt(X),de,ke)},registerInlineCompletionItemProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerInlineCompletionsProvider(Re,pt(X),de)},registerDocumentLinkProvider(X,de){return ct.registerDocumentLinkProvider(Re,pt(X),de)},registerColorProvider(X,de){return ct.registerColorProvider(Re,pt(X),de)},registerFoldingRangeProvider(X,de){return ct.registerFoldingRangeProvider(Re,pt(X),de)},registerSelectionRangeProvider(X,de){return ct.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return ct.registerCallHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>ct.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,q.checkProposedApiEnabled)(Re),Ht.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerInlayHintsProvider(Re,X,de)},registerTypeHierarchyProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerTypeHierarchyProvider(Re,X,de)},createLanguageStatusItem(X,de){return(0,q.checkProposedApiEnabled)(Re),Ht.createLanguageStatusItem(Re,X,de)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(X,de,ke){const rt=await(R.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return It.showTextDocument(rt,de,ke)},createTextEditorDecorationType(X){return It.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,de,ke){return It.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return It.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return It.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return It.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return It.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return It.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ot.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ot.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ot.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalDimensions(X,de,ke)},onDidChangeTerminalState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalState(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidWriteTerminalData(X,de,ke)},get state(){return Ge.state},onDidChangeWindowState(X,de,ke){return Ge.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return ai.showMessage(Re,A.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return ai.showMessage(Re,A.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return ai.showMessage(Re,A.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return xt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,de){return xt.showInput(X,de)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,de,ke){let rt,wt,Dt;return typeof X=="string"?(rt=X,wt=de,Dt=ke):(wt=X,Dt=de),Mt.createStatusBarEntry(Re,rt,wt,Dt)},setStatusBarMessage(X,de){return Mt.setStatusBarMessage(X,de)},withScmProgress(X){return Se.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:$.ProgressLocation.SourceControl},(de,ke)=>X({report(rt){}}))},withProgress(X,de){return hi.withProgress(Re,X,de)},createOutputChannel(X){return Ot.createOutputChannel(X,Re)},createWebviewPanel(X,de,ke,rt){return si.createWebviewPanel(Re,X,de,ke,rt)},createWebviewTextEditorInset(X,de,ke,rt){return(0,q.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(X,de,ke,rt,Re)},createTerminal(X,de,ke){return typeof X=="object"?("location"in X&&(0,q.checkProposedApiEnabled)(Re),"pty"in X?ot.createExtensionTerminal(X):ot.createTerminalFromOptions(X)):ot.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ot.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return ot.registerProfileProvider(Re,X,de)},registerTreeDataProvider(X,de){return Qt.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Qt.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>si.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>_i.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return di.registerUriHandler(Re.identifier,X)},createQuickPick(){return xt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return xt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return fi.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return yi.registerWebviewViewProvider(Re,X,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Jt.registerExternalUriOpener(Re.identifier,X,de,ke)},get tabs(){return(0,q.checkProposedApiEnabled)(Re),it.tabs},get activeTab(){return(0,q.checkProposedApiEnabled)(Re),it.activeTab},get onDidChangeTabs(){return(0,q.checkProposedApiEnabled)(Re),it.onDidChangeTabs},get onDidChangeActiveTab(){return(0,q.checkProposedApiEnabled)(Re),it.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,q.checkProposedApiEnabled)(Re),f.InlineCompletionController.get(X)}},pi={get rootPath(){return Se.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return Be.getWorkspaceFolder(X)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(X){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,de,...ke)=>Be.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return Be.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>Be.getRelativePath(X,de),findFiles:(X,de,ke,rt)=>Be.findFiles(Q.GlobPattern.from(X),Q.GlobPattern.from(de),ke,Re.identifier,rt),findTextInFiles:(X,de,ke,rt)=>{let wt,Dt;return typeof de=="object"?(wt=de,Dt=ke):(wt={},Dt=de,rt=ke),Be.findTextInFiles(X,wt||{},Dt,Re.identifier,rt)},saveAll:X=>Be.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,rt)=>Nt.createFileSystemWatcher(Q.GlobPattern.from(X),de,ke,rt),get textDocuments(){return kt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(R.URI.file(X));else if(R.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=kt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>kt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(X,de,ke)=>kt.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>kt.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>kt.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>kt.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>Zt.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let ke;if(R.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=R.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,ke,rt){return gt.registerNotebookSerializer(Re,X,de,ke,Re.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,de,ke,rt)=>((0,q.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,X,de,ke,Re.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,de,ke)=>Gt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Gt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return $t.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Se.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return ii.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return me.value},registerFileSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Rt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Rt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,q.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>Nt.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>Nt.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>Nt.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>Nt.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>Nt.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>Nt.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,q.checkProposedApiEnabled)(Re),Ce.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,q.checkProposedApiEnabled)(Re),Ce.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),Ce.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ce.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),ri.registerTimelineProvider(X,de,Re.identifier,nt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:X=>((0,q.checkProposedApiEnabled)(Re),Be.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,ke)=>Be.onDidGrantWorkspaceTrust(X,de,ke)},Ti={get inputBox(){return Se.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Re)},createSourceControl(X,de,ke){return Yt.createSourceControl(Re,X,de,ke)}},Ri={createCommentController(X,de){return bi.createCommentController(Re,X,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,de,ke){return lt.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return lt.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return lt.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return lt.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return lt.registerDebugConfigurationProvider(X,de,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return lt.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return lt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,de,{parentSession:ke}):lt.startDebugging(X,de,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,de){return lt.asDebugSourceUri(X,de)}},Mi={registerTaskProvider:(X,de)=>_t.registerTaskProvider(Re,X,de),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Re,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,de,ke)=>_t.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>_t.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>_t.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>_t.onDidEndTaskProcess(X,de,ke)},Li={createNotebookController(X,de,ke,rt,wt){return ei.createNotebookController(Re,X,de,ke,rt,Re.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,X,de),get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Re),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,q.checkProposedApiEnabled)(Re),Vt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ti.createRendererMessaging(Re,X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Kt.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(X,de,ke)},onDidChangeNotebookCellExecutionState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),new $e.ExtHostNotebookConcatDocument(gt,kt,X,de)}};return{version:ce.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:li,notebooks:Li,scm:Ti,tasks:Mi,tests:Ii,window:Ai,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:R.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:bt.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(be[224],Ee([0,1,57,96,31,95,32,48,49,38,99,100,101,72,64,70,97,71,37,69,87,68]),function(ie,e,d,M,E,A,R,C,y,P,t,_,n,h,u,s,v,I,S,o,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService),(0,d.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,d.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,d.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,d.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,d.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,d.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,d.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,d.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,14,5,11]),function(ie,e,d,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(u){const s=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...S)=>{S.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=S.slice(0,-1).join(","),g=S.pop().toString();return`(function anonymous(${o}) {
${g}
})`}});function v(...I){return s?self.eval(s.createScript("",...I)):new Function(...I)}u.create=v})(P||(P={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(s,v){for(let I of this._alternatives){let S=I(s);if(S){s=S;break}}if(this._factories.has(s))return this._factories.get(s).load(s,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);h(s,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,v,I){v=v.with({path:n(v.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const S=await fetch(y.FileAccess.asBrowserUri(v).toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),S.status!==200)throw new Error(S.statusText);const o=await S.text(),g=`${v.toString(!0)}#vscode-extension`,k=`${o}
//# sourceURL=${g}`;let i;try{i=P.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(k)??k)}catch(w){throw console.error(s?`Loading code for extension ${s.value} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${v.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}const l={},r={exports:l},a=w=>{const f=this._fakeModules.getModule(w,v);if(f===void 0)throw new Error(`Cannot load module '${w}'`);return f};try{return I.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),i(r,l,a),r.exports!==l?r.exports:l}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(s){}async _waitForDebuggerAttachment(s=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+s;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function n(u,s){return u.endsWith(s)?u:u+s}function h(u,s){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(o,g){const k=console[o];console[o]=function(){u.$logExtensionHostMessage({type:"__$console",severity:g,arguments:S(arguments)}),s&&k.apply(console,arguments)}}const I=1e5;function S(o){const g=[],k=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const l=o[i];l.stack?o[i]=l.stack:o[i]=l.toString()}k.push(o[i])}try{const i=JSON.stringify(k,function(l,r){if(r&&typeof r=="object"){if(g.indexOf(r)!==-1)return"[Circular]";g.push(r)}return r});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,73,225,212]),function(ie,e,d,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.IExtHostExtensionService,R.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,23,3,178,220,214,17,74,11,2,224,226]),function(ie,e,d,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(o,g){return o instanceof Request||/^file:/i.test(String(o))&&(o=P.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),h(o,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,g,k,i,l){return/^file:/i.test(g.toString())&&(g=P.FileAccess.asBrowserUri(t.URI.parse(g.toString())).toString(!0)),super.open(o,g,k??!0,i,l)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:k=>k}),g=self.Worker;Worker=function(k,i){/^file:/i.test(k.toString())&&(k=P.FileAccess.asBrowserUri(t.URI.parse(k.toString())).toString(!0));const r=`(${function(m){function D(c){return typeof c=="string"||c instanceof URL?String(c).replace(/^file:\/\//i,"vscode-file://vscode-app"):c}const T=fetch.bind(self);self.fetch=function(c,F){return c instanceof Request?T(c,F):T(D(c),F)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,F,O,V,K){return super.open(c,D(F),O??!0,V,K)}};const p=importScripts.bind(self);self.importScripts=(...c)=>{p(...c.map(D))};const b=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:c=>c}):void 0;p(b?b.createScriptURL(m):m)}.toString()}('${k}'))`;i=i||{},i.name=i.name||C.basename(k.toString());const a=new Blob([r],{type:"application/javascript"}),w=URL.createObjectURL(a);return new g(o?o.createScriptURL(w):w,i)}}else self.Worker=class extends R.NestedWorker{constructor(o,g){super(n,o,{name:C.basename(o.toString()),...g})}};const u=new class{exit(o){_()}async exists(o){return!0}async realpath(o){return o}};class s{constructor(){const g=new MessageChannel,k=new M.Emitter;let i=!1;n(g.port2,[g.port2]),g.port1.onmessage=l=>{const{data:r}=l;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const a=d.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,E.isMessageOfType)(a,2)){i=!0,I("received terminate message from renderer");return}k.fire(a)},this.protocol={onMessage:k.event,send:l=>{if(!i){const r=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);g.port1.postMessage(r,[r])}}}}}function v(o){return new Promise(g=>{const k=o.onMessage(i=>{k.dispose();const l=JSON.parse(i.toString());o.send((0,E.createMessageOfType)(0)),g({protocol:o,initData:l})});o.send((0,E.createMessageOfType)(1))})}let I=o=>_();function S(){const o=new s;y.mark("code/extHost/willConnectToRenderer"),v(o.protocol).then(g=>{y.mark("code/extHost/didWaitForInitData");const k=new A.ExtensionHostMain(g.protocol,g.initData,u,null);I=i=>k.terminate(i)})}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23cffa27b806f9e1733e15d611ec251dcdba2c42/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
